<div align="center">
    <picture>
        <source media="(prefers-color-scheme: dark)" srcset="https://github.com/JuliaManifolds/ManifoldsBase.jl/raw/master/docs/src/assets/logo-text-readme-dark.png">
      <img alt="ManifoldsBase.jl logo with text on the side" src="https://github.com/JuliaManifolds/ManifoldsBase.jl/raw/master/docs/src/assets/logo-text-readme.png">
    </picture>
</div>

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliamanifolds.github.io/ManifoldsBase.jl/dev/)
[![CI](https://github.com/JuliaManifolds/ManifoldsBase.jl/workflows/CI/badge.svg)](https://github.com/JuliaManifolds/ManifoldsBase.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![codecov](https://codecov.io/gh/JuliaManifolds/ManifoldsBase.jl/graph/badge.svg?token=bQsBUU9knE)](https://codecov.io/gh/JuliaManifolds/ManifoldsBase.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![code style: runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl)

[![ACM TOMS](https://img.shields.io/badge/ACM%20TOMS-10.1145%2F3618296-blue.svg)](http://doi.org/10.1145/3618296)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.5964340.svg)](https://doi.org/10.5281/zenodo.5964340)

## Installation

In Julia you can install this package by typing

```julia
using Pkg; Pkg.add("ManifoldsBase")
```

in the Julia REPL.

Since this package provides an interface, you probably either want to add it as a dependency to your project/package to work on manifold generically or implement a new manifold.
A package that (only) depends on `ManifoldsBase.jl`, see [Manopt.jl](https://manoptjl.org/stable/), which implements optimization algorithms on manifolds using this interface, i.e. they can be used with any manifold based on `ManifoldsBase.jl`. A library of manifolds implemented using this interface is provided see [Manifolds.jl](https://juliamanifolds.github.io/Manifolds.jl/stable/).

Your package is using `ManifoldsBase`?
We would be very interested to hear where you are using the interface or manifolds in general! Give us a note and we add you here.

## Citation

If you use `ManifoldsBase.jl` in your work, please cite the following open access article

```biblatex
@article{AxenBaranBergmannRzecki:2023,
    author = {Axen, Seth D. and Baran, Mateusz and Bergmann, Ronny and Rzecki, Krzysztof},
    articleno = {33},
    doi = {10.1145/3618296},
    journal = {ACM Transactions on Mathematical Software},
    month = {dec},
    number = {4},
    title = {Manifolds.Jl: An Extensible Julia Framework for Data Analysis on Manifolds},
    volume = {49},
    year = {2023},
}
```


To refer to a certain version we recommend to also cite for example

```biblatex
@software{manifoldsbasejl-zenodo-mostrecent,
    AUTHOR    = {Seth D. Axen and Mateusz Baran and Ronny Bergmann},
    TITLE     = {ManifoldsBase.jl},
    DOI       = {10.5281/ZENODO.5964340},
    URL       = {https://zenodo.org/record/5964340},
    PUBLISHER = {Zenodo},
    YEAR      = {2022},
    COPYRIGHT = {MIT License}
}
```

Note that both citations are in [BibLaTeX](https://ctan.org/pkg/biblatex) format.

"""
    FVector(type::VectorSpaceType, data, basis::AbstractBasis)

Decorator indicating that the vector `data` contains coordinates of a vector from a fiber
of a vector bundle of type `type`. `basis` is an object describing the basis of that space
in which the coordinates are given.

Conversion between `FVector` representation and the default representation of an object
(for example a tangent vector) for a manifold should be done using [`get_coordinates`](@ref)
and [`get_vector`](@ref).

# Examples

```julia-repl
julia> using Manifolds

julia> M = Sphere(2)
Sphere(2, ℝ)

julia> p = [1.0, 0.0, 0.0]
3-element Vector{Float64}:
 1.0
 0.0
 0.0

julia> X = [0.0, 2.0, -1.0]
3-element Vector{Float64}:
  0.0
  2.0
 -1.0

julia> B = DefaultOrthonormalBasis()
DefaultOrthonormalBasis(ℝ)

julia> fX = TFVector(get_coordinates(M, p, X, B), B)
TFVector([2.0, -1.0], DefaultOrthonormalBasis(ℝ))

julia> X_back = get_vector(M, p, fX.data, fX.basis)
3-element Vector{Float64}:
 -0.0
  2.0
 -1.0
```
"""
struct FVector{TType <: VectorSpaceType, TData, TBasis <: AbstractBasis}
    type::TType
    data::TData
    basis::TBasis
end

const TFVector = FVector{TangentSpaceType}
const CoTFVector = FVector{CotangentSpaceType}

function TFVector(data, basis::AbstractBasis)
    return TFVector{typeof(data), typeof(basis)}(TangentSpaceType(), data, basis)
end
function CoTFVector(data, basis::AbstractBasis)
    return CoTFVector{typeof(data), typeof(basis)}(CotangentSpaceType(), data, basis)
end

function Base.show(io::IO, fX::TFVector)
    return print(io, "TFVector(", fX.data, ", ", fX.basis, ")")
end
function Base.show(io::IO, fX::CoTFVector)
    return print(io, "CoTFVector(", fX.data, ", ", fX.basis, ")")
end


"""
    AbstractFibreVector{TType<:VectorSpaceType}

Type for a vector from a vector space (fibre of a vector bundle) of type `TType` of a manifold.
While a [`AbstractManifold`](@ref) does not necessarily require this type, for example when it is
implemented for `Vector`s or `Matrix` type elements, this type can be used for more
complicated representations, semantic verification, or even dispatch for different
representations of tangent vectors and their types on a manifold.

You may use macro [`@manifold_vector_forwards`](@ref) to introduce commonly used method
definitions for your subtype of `AbstractFibreVector`.
"""
abstract type AbstractFibreVector{TType <: VectorSpaceType} end

"""
    AbstractTangentVector = AbstractFibreVector{TangentSpaceType}

Type for a tangent vector of a manifold. While a [`AbstractManifold`](@ref) does not necessarily
require this type, for example when it is implemented for `Vector`s or `Matrix` type
elements, this type can be used for more complicated representations, semantic verification,
or even dispatch for different representations of tangent vectors and their types on a
manifold.
"""
const AbstractTangentVector = AbstractFibreVector{TangentSpaceType}

"""
    AbstractCotangentVector = AbstractFibreVector{CotangentSpaceType}

Type for a cotangent vector of a manifold. While a [`AbstractManifold`](@ref) does not necessarily
require this type, for example when it is implemented for `Vector`s or `Matrix` type
elements, this type can be used for more complicated representations, semantic verification,
or even dispatch for different representations of cotangent vectors and their types on a
manifold.
"""
const AbstractCotangentVector = AbstractFibreVector{CotangentSpaceType}


"""
    ZeroVector <: AbstractTangentVector

A type to represent the zero vector. This can be used generically
when it is beneficial to statically dispatch on a zero vector.

!!! note "Technical Note"
    Following our [Design principles](design.md) the dispatch on tangent vectors
    only happens on the most inner (third) layer, providing generic implementations
    with this type is a very manifold-specific task and should be considered carefully.

    Therefore there are also only a few generic implementations available, for example the vector operations `+`, `-` and scaling with real number.
"""
struct ZeroVector <: AbstractTangentVector end

Base.:+(X::FVector, Y::FVector) = FVector(X.type, X.data + Y.data, X.basis)
Base.:+(::ZeroVector, Y) = Y
Base.:+(X, ::ZeroVector) = X
Base.:+(::ZeroVector, ::ZeroVector) = ZeroVector()


Base.:-(X::FVector, Y::FVector) = FVector(X.type, X.data - Y.data, X.basis)
Base.:-(::ZeroVector, Y) = -Y
Base.:-(X, ::ZeroVector) = X
Base.:-(::ZeroVector, ::ZeroVector) = ZeroVector()

Base.:-(X::FVector) = FVector(X.type, -X.data, X.basis)
Base.:-(::ZeroVector) = ZeroVector()

Base.:*(a::Number, X::FVector) = FVector(X.type, a * X.data, X.basis)
Base.:*(::Number, ::ZeroVector) = ZeroVector()

allocate(x::FVector) = FVector(x.type, allocate(x.data), x.basis)
allocate(x::FVector, ::Type{T}) where {T} = FVector(x.type, allocate(x.data, T), x.basis)
allocate(::ZeroVector) = ZeroVector()

copy(::AbstractManifold, p, ::ZeroVector) = ZeroVector()

function Base.copyto!(X::FVector, Y::FVector)
    copyto!(X.data, Y.data)
    return X
end

function number_eltype(
        ::Type{FVector{TType, TData, TBasis}},
    ) where {TType <: VectorSpaceType, TData, TBasis}
    return number_eltype(TData)
end
number_eltype(v::FVector) = number_eltype(v.data)

"""
    vector_space_dimension(M::AbstractManifold, V::VectorSpaceType)

Dimension of the vector space of type `V` on manifold `M`.
"""
vector_space_dimension(::AbstractManifold, ::VectorSpaceType)

function vector_space_dimension(M::AbstractManifold, ::TCoTSpaceType)
    return manifold_dimension(M)
end

"""
    EmbeddedManifold{𝔽, MT <: AbstractManifold, NT <: AbstractManifold} <: AbstractDecoratorManifold{𝔽}

A type to represent an explicit embedding of a [`AbstractManifold`](@ref) `M` of type `MT` embedded
into a manifold `N` of type `NT`.
By default, an embedded manifold is set to be embedded, but neither isometrically embedded
nor a submanifold.

!!! note
    This type is not required if a manifold `M` is to be embedded in one specific manifold `N`.
     One can then just implement [`embed!`](@ref) and [`project!`](@ref).
    You can further pass functions to the embedding, for example, when it is an isometric embedding,
    by using an [`AbstractDecoratorManifold`](@ref).
    Only for a second –maybe considered non-default–
    embedding, this type should be considered in order to dispatch on different embed
    and project methods for different embeddings `N`.

# Fields

* `manifold` the manifold that is an embedded manifold
* `embedding` a second manifold, the first one is embedded into

# Constructor

    EmbeddedManifold(M, N)

Generate the `EmbeddedManifold` of the [`AbstractManifold`](@ref) `M` into the
[`AbstractManifold`](@ref) `N`.
"""
struct EmbeddedManifold{𝔽, MT <: AbstractManifold{𝔽}, NT <: AbstractManifold} <:
    AbstractDecoratorManifold{𝔽}
    manifold::MT
    embedding::NT
end

"""
    get_embedding_type(::EmbeddedManifold)

Specify the type of embedding. This by default returns [`EmbeddedManifoldType`](@ref)`()`.
It can be further specified by dispatching in the parameters of the [`EmbeddedManifold`](@ref).
"""
get_embedding_type(::EmbeddedManifold) = EmbeddedManifoldType()

function allocate_result(M::EmbeddedManifold, f::typeof(project), x...)
    T = allocate_result_type(M, f, x)
    return allocate(M, x[1], T, representation_size(base_manifold(M)))
end

"""
    decorated_manifold(M::EmbeddedManifold, d::Val{N} = Val(-1))

Return the manifold of `M` that is decorated with its embedding. For this specific
type the internally stored enhanced manifold `M.manifold` is returned.

See also [`base_manifold`](@ref), where this is used to (potentially) completely undecorate the manifold.
"""
decorated_manifold(M::EmbeddedManifold) = M.manifold


"""
    get_embedding(M::EmbeddedManifold)

Return the embedding [`EmbeddedManifold`](@ref) `N` of `M`, if it exists.
"""
function get_embedding(M::EmbeddedManifold)
    return M.embedding
end

function project(M::EmbeddedManifold, p)
    q = allocate_result(M, project, p)
    project!(M, q, p)
    return q
end

function show(
        io::IO, M::EmbeddedManifold{𝔽, MT, NT},
    ) where {𝔽, MT <: AbstractManifold{𝔽}, NT <: AbstractManifold}
    return print(io, "EmbeddedManifold($(M.manifold), $(M.embedding))")
end

@doc raw"""
    exp(M::AbstractManifold, p, X)

Compute the exponential map of tangent vector `X` at point `p`
from the manifold [`AbstractManifold`](@ref) `M`, i.e.

```math
\exp_p X = γ_{p,X}(1),
```
where ``γ_{p,X}`` is the unique geodesic starting in ``γ(0)=p`` such that ``\dot γ(0) = X``.

See also [`shortest_geodesic`](@ref), [`retract`](@ref).
"""
function exp(M::AbstractManifold, p, X)
    q = allocate_result(M, exp, p, X)
    exp!(M, q, p, X)
    return q
end

@doc raw"""
    exp_fused(M::AbstractManifold, p, X, t::Number)

Compute the exponential map of tangent vector `X` scaled by `t` at point `p`.
Compared to [`exp`](@ref), this method provides the opportunity to
avoid the allocation when computing `t*X`.
By default, this method allocates the resulting point `q` and passes to [`exp_fused!`](@ref).
"""
function exp_fused(M::AbstractManifold, p, X, t::Number)
    q = allocate_result(M, exp, p, X, t)
    exp_fused!(M, q, p, X, t)
    return q
end

"""
    exp!(M::AbstractManifold, q, p, X)

Compute the exponential map of tangent vector `X`, optionally scaled by `t`,  at point `p`
from the manifold [`AbstractManifold`](@ref) `M`.
The result is saved to `q`.

If you want to implement exponential map for your manifold, you should implement the in-place
method with, that is `exp_fused!(M::MyManifold, q, p, X)`.

See also [`exp`](@ref).
"""
exp!(M::AbstractManifold, q, p, X)

"""
    exp_fused!(M::AbstractManifold, q, p, X, t::Number)

Compute the exponential map of tangent vector `X` scaled by `t` at point `p` in-place of `q`.
Compared to [`exp!`](@ref), this method provides the opportunity to avoid the allocation
when computing `t*X`.
By default, this method performs this operation and passes to [`exp!`](@ref).
"""
exp_fused!(M::AbstractManifold, q, p, X, t::Number) = exp!(M, q, p, t * X)

@doc raw"""
    geodesic(M::AbstractManifold, p, X) -> Function

Get the geodesic with initial point `p` and velocity `X` on the [`AbstractManifold`](@ref) `M`.
A geodesic is a curve of zero acceleration. That is for the curve ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

i.e. the curve is acceleration free with respect to the Riemannian metric.
This yields, that the curve has constant velocity that is locally distance-minimizing.

This function returns a function of (time) `t`.
"""
geodesic(M::AbstractManifold, p, X) = t -> exp_fused(M, p, X, t)

@doc raw"""
    geodesic(M::AbstractManifold, p, X, t::Real)

Evaluate the geodesic ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

at time `t`.
"""
geodesic(M::AbstractManifold, p, X, t::Real) = exp_fused(M, p, X, t)

@doc raw"""
    geodesic(M::AbstractManifold, p, X, T::AbstractVector) -> AbstractVector

Evaluate the geodesic ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

at time points `t` from `T`.
"""
geodesic(M::AbstractManifold, p, X, T::AbstractVector) = map(t -> exp_fused(M, p, X, t), T)

@doc raw"""
    geodesic!(M::AbstractManifold, p, X) -> Function

Get the geodesic with initial point `p` and velocity `X` on the [`AbstractManifold`](@ref) `M`.
A geodesic is a curve of zero acceleration. That is for the curve ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

i.e. the curve is acceleration free with respect to the Riemannian metric.
This yields that the curve has constant velocity and is locally distance-minimizing.

This function returns a function `(q,t)` of (time) `t` that mutates `q``.
"""
geodesic!(M::AbstractManifold, p, X) = (q, t) -> exp_fused!(M, q, p, X, t)
@doc raw"""
    geodesic!(M::AbstractManifold, q, p, X, t::Real)

Get the geodesic with initial point `p` and velocity `X` on the [`AbstractManifold`](@ref) `M`.
A geodesic is a curve of zero acceleration. That is for the curve ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

i.e. the curve is acceleration free with respect to the Riemannian metric.
This function evaluates the geodeic at `t` in place of `q`.
"""
geodesic!(M::AbstractManifold, q, p, X, t::Real) = exp_fused!(M, q, p, X, t)
@doc raw"""
    geodesic!(M::AbstractManifold, Q, p, X, T::AbstractVector) -> AbstractVector

Get the geodesic with initial point `p` and velocity `X` on the [`AbstractManifold`](@ref) `M`.
A geodesic is a curve of zero acceleration. That is for the curve ``γ_{p,X}: I → \mathcal M``,
with ``γ_{p,X}(0) = p`` and ``\dot γ_{p,X}(0) = X`` a geodesic further fulfills

```math
∇_{\dot γ_{p,X}(t)} \dot γ_{p,X}(t) = 0,
```

i.e. the curve is acceleration free with respect to the Riemannian metric.
This function evaluates the geodesic at time points `t` from `T` in place of `Q`.
"""
function geodesic!(M::AbstractManifold, Q, p, X, T::AbstractVector)
    for (q, t) in zip(Q, T)
        exp_fused!(M, q, p, X, t)
    end
    return Q
end

"""
    log(M::AbstractManifold, p, q)

Compute the logarithmic map of point `q` at base point `p` on the [`AbstractManifold`](@ref) `M`.
The logarithmic map is the inverse of the [`exp`](@ref)onential map.
Note that the logarithmic map might not be globally defined.

See also [`inverse_retract`](@ref).
"""
function log(M::AbstractManifold, p, q)
    X = allocate_result(M, log, p, q)
    log!(M, X, p, q)
    return X
end

"""
    log!(M::AbstractManifold, X, p, q)

Compute the logarithmic map of point `q` at base point `p` on the [`AbstractManifold`](@ref) `M`.
The result is saved to `X`.
The logarithmic map is the inverse of the [`exp!`](@ref)onential map.
Note that the logarithmic map might not be globally defined.

see also [`log`](@ref) and [`inverse_retract!`](@ref),
"""
ManifoldsBase.log!(M::AbstractManifold, X, p, q)

@doc raw"""
    shortest_geodesic(M::AbstractManifold, p, q) -> Function

Get a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$.
When there are multiple shortest geodesics, a deterministic choice will be returned.

This function returns a function of time, which may be a `Real` or an `AbstractVector`.
"""
shortest_geodesic(M::AbstractManifold, p, q) = geodesic(M, p, log(M, p, q))
@doc raw"""
    shortest_geodesic(M::AabstractManifold, p, q, t::Real)

Evaluate a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$ at time `t`.
When there are multiple shortest geodesics, a deterministic choice will be returned.
"""
shortest_geodesic(M::AbstractManifold, p, q, t::Real) = geodesic(M, p, log(M, p, q), t)
@doc raw"""
    shortest_geodesic(M::AbstractManifold, p, q, T::AbstractVector) -> AbstractVector

Evaluate a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$ at time points `T`.
When there are multiple shortest geodesics, a deterministic choice will be returned.
"""
function shortest_geodesic(M::AbstractManifold, p, q, T::AbstractVector)
    return geodesic(M, p, log(M, p, q), T)
end


@doc raw"""
    shortest_geodesic!(M::AbstractManifold, p, q) -> Function

Get a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$. When there are
multiple shortest geodesics, a deterministic choice will be returned.

This function returns a function `(r,t) -> ... ` of time `t` which works in place of `r`.

Further variants

    shortest_geodesic!(M::AabstractManifold, r, p, q, t::Real)
    shortest_geodesic!(M::AbstractManifold, R, p, q, T::AbstractVector) -> AbstractVector

mutate (and return) the point `r` and the vector of points `R`, respectively,
returning the point at time `t` or points at times `t` in `T` along the shortest [`geodesic`](@ref).
"""
shortest_geodesic!(M::AbstractManifold, p, q) = geodesic!(M, p, log(M, p, q))
@doc raw"""
    shortest_geodesic!(M::AabstractManifold, r, p, q, t::Real)

Evaluate a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$ at `t` in place of `r`.
When there are multiple shortest geodesics, a deterministic choice will be taken.
"""
function shortest_geodesic!(M::AbstractManifold, r, p, q, t::Real)
    return geodesic!(M, r, p, log(M, p, q), t)
end
@doc raw"""
    shortest_geodesic!(M::AbstractManifold, R, p, q, T::AbstractVector) -> AbstractVector

Evaluate a [`geodesic`](@ref) $γ_{p,q}(t)$ whose length is the shortest path between the
points `p`and `q`, where $γ_{p,q}(0)=p$ and $γ_{p,q}(1)=q$ at all `t` from `T` in place of `R`.
When there are multiple shortest geodesics, a deterministic choice will be taken.
"""
function shortest_geodesic!(M::AbstractManifold, R, p, q, T::AbstractVector)
    return geodesic!(M, R, p, log(M, p, q), T)
end

using ManifoldsBase

using DoubleFloats
using ForwardDiff
using LinearAlgebra
using Random
using ReverseDiff
using StaticArrays
using Test

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

@testset "Testing Default (Euclidean)" begin
    M = ManifoldsBase.DefaultManifold(3)
    types = [
        Vector{Float64},
        SizedVector{3, Float64, Vector{Float64}},
        MVector{3, Float64},
        Vector{Float32},
        SizedVector{3, Float32, Vector{Float32}},
        MVector{3, Float32},
        Vector{Double64},
        MVector{3, Double64},
        SizedVector{3, Double64, Vector{Double64}},
        DefaultPoint{Vector{Float64}},
    ]

    @test repr(M) == "DefaultManifold(3; field = ℝ)"
    @test isa(manifold_dimension(M), Integer)
    @test manifold_dimension(M) ≥ 0
    @test base_manifold(M) == M
    @test has_components(M)
    @test number_system(M) == ManifoldsBase.ℝ
    @test ManifoldsBase.representation_size(M) == (3,)

    p = zeros(3)
    m = PolarRetraction()
    @test injectivity_radius(M) == Inf
    @test injectivity_radius(M, p) == Inf
    @test injectivity_radius(M, m) == Inf
    @test injectivity_radius(M, p, m) == Inf
    @test default_retraction_method(M) == ExponentialRetraction()
    @test default_inverse_retraction_method(M) == LogarithmicInverseRetraction()

    @test is_flat(M)

    rm = ManifoldsBase.ExponentialRetraction()
    irm = ManifoldsBase.LogarithmicInverseRetraction()

    # Representation sizes not equal
    @test ManifoldsBase.check_size(M, zeros(3, 3)) isa DomainError
    @test ManifoldsBase.check_size(M, zeros(3), zeros(3, 3)) isa DomainError
    rm2 = CustomDefinedRetraction()
    rm3 = CustomUndefinedRetraction()

    for T in types
        @testset "Type $T" begin
            pts = convert.(Ref(T), [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]])

            @test injectivity_radius(M, pts[1]) == Inf
            @test injectivity_radius(M, pts[1], rm) == Inf
            @test injectivity_radius(M, rm) == Inf
            @test injectivity_radius(M, rm2) == 10
            @test injectivity_radius(M, pts[1], rm2) == 10
            # ManifoldsBase._injectivity_radius always requires the method to be passed
            # to reduce the number of ambiguities
            @test_throws MethodError ManifoldsBase._injectivity_radius(M, pts[1])

            tv1 = log(M, pts[1], pts[2])

            for pt in pts
                @test is_point(M, pt)
            end
            @test is_vector(M, pts[1], tv1; atol = eps(eltype(pts[1])))

            tv2 = log(M, pts[2], pts[1])
            tv3 = log(M, pts[2], pts[3])
            @test isapprox(M, pts[2], exp(M, pts[1], tv1))
            @test_logs (:info,) !isapprox(M, pts[1], pts[2]; error = :info)
            @test isapprox(M, pts[1], pts[1]; error = :info)
            @test_logs (:info,) !isapprox(
                M,
                pts[1],
                convert(T, [NaN, NaN, NaN]);
                error = :info,
            )
            @test isapprox(M, pts[1], ManifoldsBase.exp_fused(M, pts[1], tv1, 0))
            @test isapprox(M, pts[2], ManifoldsBase.exp_fused(M, pts[1], tv1, 1))
            @test isapprox(M, pts[1], exp(M, pts[2], tv2))
            if T <: Array
                @test_throws ApproximatelyError isapprox(M, pts[1], pts[2]; error = :error)
                @test_throws ApproximatelyError isapprox(
                    M,
                    pts[2],
                    tv2,
                    tv3;
                    error = :error,
                )
            end
            # test lower level fallbacks
            @test ManifoldsBase.check_approx(M, pts[1], pts[2]) isa ApproximatelyError
            @test ManifoldsBase.check_approx(M, pts[1], pts[1]) === nothing
            @test ManifoldsBase.check_approx(M, pts[2], tv2, tv2) === nothing
            @test is_point(M, retract(M, pts[1], tv1))
            @test isapprox(M, pts[1], ManifoldsBase.retract_fused(M, pts[1], tv1, 0))

            @test is_point(M, retract(M, pts[1], tv1, rm))
            @test isapprox(M, pts[1], ManifoldsBase.retract_fused(M, pts[1], tv1, 0, rm))

            new_pt = exp(M, pts[1], tv1)
            retract!(M, new_pt, pts[1], tv1)
            @test is_point(M, new_pt)
            @test !isapprox(M, pts[1], [1, 2, 3], [3, 2, 4]; error = :other)

            @test isapprox(
                M,
                pts[1],
                ManifoldsBase.retract_fused!(
                    M,
                    new_pt,
                    pts[1],
                    tv1,
                    0,
                    ExponentialRetraction(),
                ),
            )
            for p in pts
                X_p_zero = zero_vector(M, p)
                X_p_nan = NaN * X_p_zero
                @test isapprox(M, p, X_p_zero, log(M, p, p); atol = eps(eltype(p)))
                if T <: Array
                    @test_logs (:info,) !isapprox(
                        M, p, X_p_zero, X_p_nan; atol = eps(eltype(p)), error = :info,
                    )
                    @test isapprox(
                        M, p, X_p_zero, log(M, p, p); atol = eps(eltype(p)), error = :info,
                    )
                end
                @test isapprox(
                    M, p, X_p_zero, inverse_retract(M, p, p); atol = eps(eltype(p)),
                )
                @test isapprox(
                    M, p, X_p_zero, inverse_retract(M, p, p, irm); atol = eps(eltype(p)),
                )
            end
            zero_vector!(M, tv1, pts[1])
            @test isapprox(M, pts[1], tv1, zero_vector(M, pts[1]))
            log!(M, tv1, pts[1], pts[2])
            @test norm(M, pts[1], tv1) ≈ sqrt(inner(M, pts[1], tv1, tv1))

            @test isapprox(M, ManifoldsBase.exp_fused(M, pts[1], tv1, 1), pts[2])
            @test isapprox(M, ManifoldsBase.exp_fused(M, pts[1], tv1, 0), pts[1])

            @test distance(M, pts[1], pts[2]) ≈ norm(M, pts[1], tv1)
            @test distance(M, pts[1], pts[2], LogarithmicInverseRetraction()) ≈ norm(M, pts[1], tv1)

            @test mid_point(M, pts[1], pts[2]) == convert(T, [0.5, 0.5, 0.0])
            midp = allocate(pts[1])
            @test mid_point!(M, midp, pts[1], pts[2]) === midp
            @test midp == convert(T, [0.5, 0.5, 0.0])

            @test riemann_tensor(M, pts[1], tv1, tv2, tv1) == zero(tv1)
            tv_rt = allocate(tv1)
            @test riemann_tensor!(M, tv_rt, pts[1], tv1, tv2, tv1) === tv_rt
            @test tv_rt == zero(tv1)

            @test sectional_curvature(M, pts[1], tv1, log(M, pts[1], pts[3])) == 0.0
            @test sectional_curvature_max(M) == 0.0
            @test sectional_curvature_min(M) == 0.0

            q = copy(M, pts[1])
            Ts = [0.0, 1.0 / 2, 1.0]
            @testset "Geodesic interface test" begin
                @test isapprox(M, geodesic(M, pts[1], tv1)(0.0), pts[1])
                @test isapprox(M, geodesic(M, pts[1], tv1)(1.0), pts[2])
                g! = geodesic!(M, pts[1], tv1)
                g!(q, 0.0)
                isapprox(M, q, pts[1])
                g!(q, 0.0)
                isapprox(M, q, pts[2])
                geodesic!(M, q, pts[1], tv1, 1.0 / 2)
                isapprox(M, q, midp)
                @test isapprox(M, geodesic(M, pts[1], tv1, 1.0), pts[2])
                @test isapprox(M, geodesic(M, pts[1], tv1, 1.0 / 2), midp)
                @test isapprox(M, shortest_geodesic(M, pts[1], pts[2])(0.0), pts[1])
                @test isapprox(M, shortest_geodesic(M, pts[1], pts[2])(1.0), pts[2])
                sg! = shortest_geodesic!(M, pts[1], pts[2])
                sg!(q, 0.0)
                isapprox(M, q, pts[1])
                sg!(q, 1.0)
                isapprox(M, q, pts[2])
                @test isapprox(M, shortest_geodesic(M, pts[1], pts[2], 0.0), pts[1])
                @test isapprox(M, shortest_geodesic(M, pts[1], pts[2], 1.0), pts[2])
                shortest_geodesic!(M, q, pts[1], pts[2], 0.5)
                isapprox(M, q, midp)
                @test all(
                    isapprox.(Ref(M), geodesic(M, pts[1], tv1, Ts), [pts[1], midp, pts[2]]),
                )
                @test all(
                    isapprox.(
                        Ref(M), shortest_geodesic(M, pts[1], pts[2], Ts), [pts[1], midp, pts[2]],
                    ),
                )
                Q = [copy(M, q), copy(M, q), copy(M, q)]
                geodesic!(M, Q, pts[1], tv1, Ts)
                @test all(isapprox.(Ref(M), Q, [pts[1], midp, pts[2]]))
                shortest_geodesic!(M, Q, pts[1], pts[2], Ts)
                @test all(isapprox.(Ref(M), Q, [pts[1], midp, pts[2]]))
            end

            @testset "basic linear algebra in tangent space" begin
                @test isapprox(
                    M, pts[1], 0 * tv1, zero_vector(M, pts[1]); atol = eps(eltype(pts[1])),
                )
                @test isapprox(M, pts[1], 2 * tv1, tv1 + tv1)
                @test isapprox(M, pts[1], 0 * tv1, tv1 - tv1)
                @test isapprox(M, pts[1], (-1) * tv1, -tv1)
            end

            @testset "Change Representer and Metric" begin
                G = ManifoldsBase.EuclideanMetric()
                p = pts[1]
                for X in [tv1, tv2, tv3]
                    @test change_representer(M, G, p, X) == X
                    Y = similar(X)
                    change_representer!(M, Y, G, p, X)
                    @test isapprox(M, p, Y, X)
                    @test change_metric(M, G, p, X) == X
                    Z = similar(X)
                    change_metric!(M, Z, G, p, X)
                    @test isapprox(M, p, Z, X)
                end
            end

            @testset "Hat and vee in the tangent space" begin
                X = log(M, pts[1], pts[2])
                a = vee(M, pts[1], X)
                b = similar(a)
                vee!(M, b, pts[1], X)
                Y = hat(M, pts[1], a)
                Z = similar(Y)
                hat!(M, Z, pts[1], a)
                @test a == b
                @test X == Y
                @test Z == X
                @test a == ((T <: DefaultPoint) ? vec(X.value) : vec(X))
            end

            @testset "broadcasted linear algebra in tangent space" begin
                @test isapprox(M, pts[1], 3 * tv1, 2 .* tv1 .+ tv1)
                @test isapprox(M, pts[1], -tv1, tv1 .- 2 .* tv1)
                @test isapprox(M, pts[1], -tv1, .-tv1)
                v = similar(tv1)
                v .= 2 .* tv1 .+ tv1
                @test isapprox(M, pts[1], v, 3 * tv1)
            end

            @testset "project test" begin
                # point
                @test isapprox(M, pts[1], project(M, pts[1]))
                pt = similar(pts[1])
                project!(M, pt, pts[1])
                @test isapprox(M, pt, pts[1])

                @test isapprox(M, pts[1], embed(M, pts[1]))
                pt = similar(pts[1])
                embed!(M, pt, pts[1])
                @test isapprox(M, pt, pts[1])

                # tangents
                @test isapprox(M, pts[1], tv1, project(M, pts[1], tv1))
                tv = similar(tv1)
                project!(M, tv, pts[1], tv1)
                @test isapprox(M, pts[1], tv, tv1)

                @test isapprox(M, pts[1], tv1, embed(M, pts[1], tv1))
                tv = similar(tv1)
                embed!(M, tv, pts[1], tv1)
                @test isapprox(M, pts[1], tv, tv1)
                @test Weingarten(M, pts[1], tv, tv) == zero_vector(M, pts[1])
            end

            @testset "random tests" begin
                Random.seed!(23)
                pr = rand(M)
                @test is_point(M, pr, true)
                Xr = rand(M; vector_at = pr)
                @test is_vector(M, pr, Xr, true)
                rng = MersenneTwister(42)
                P = rand(M, 3)
                @test length(P) == 3
                @test all([is_point(M, pj) for pj in P])
                Xv = rand(M, 3; vector_at = pr)
                @test length(Xv) == 3
                @test all([is_point(M, Xj) for Xj in Xv])
                # and the same again with rng upfront
                rng = MersenneTwister(42)
                pr = rand(rng, M)
                @test is_point(M, pr, true)
                Xr = rand(rng, M; vector_at = pr)
                @test is_vector(M, pr, Xr, true)
                rng = MersenneTwister(42)
                P = rand(rng, M, 3)
                @test length(P) == 3
                @test all([is_point(M, pj) for pj in P])
                Xv = rand(rng, M, 3; vector_at = pr)
                @test length(Xv) == 3
                @test all([is_point(M, Xj) for Xj in Xv])
            end

            @testset "vector transport" begin
                # test constructor
                @test default_vector_transport_method(M) == ParallelTransport()
                X1 = log(M, pts[1], pts[2])
                X2 = log(M, pts[1], pts[3])
                X1t1 = vector_transport_to(M, pts[1], X1, pts[3])
                X1t2 = zero(X1t1)
                vector_transport_to!(M, X1t2, pts[1], X1, X2, ProjectionTransport())
                X1t3 = vector_transport_direction(M, pts[1], X1, X2)
                @test ManifoldsBase.is_vector(M, pts[3], X1t1)
                @test ManifoldsBase.is_vector(M, pts[3], X1t3)
                @test isapprox(M, pts[3], X1t1, X1t3)

                # On Euclidean Space Schild & Pole are identity
                @test vector_transport_to(
                    M, pts[1], X2, pts[2], SchildsLadderTransport(),
                ) == X2
                @test vector_transport_to(M, pts[1], X2, pts[2], PoleLadderTransport()) ==
                    X2
                @test vector_transport_to(
                    M, pts[1], X2, pts[2], ScaledVectorTransport(ParallelTransport()),
                ) == X2

                # along is also the identity
                c = [
                    mid_point(M, pts[1], pts[2]), pts[2], mid_point(M, pts[2], pts[3]), pts[3],
                ]
                # check mutating ones with defaults
                p = allocate(pts[1])
                ManifoldsBase.pole_ladder!(M, p, pts[1], pts[2], pts[3])
                # -log_p3 p == log_p1 p2
                @test isapprox(M, pts[3], -log(M, pts[3], p), log(M, pts[1], pts[2]))
                ManifoldsBase.schilds_ladder!(M, p, pts[1], pts[2], pts[3])
                @test isapprox(M, pts[3], log(M, pts[3], p), log(M, pts[1], pts[2]))

                @test repr(ParallelTransport()) == "ParallelTransport()"
                @test repr(ScaledVectorTransport(ParallelTransport())) ==
                    "ScaledVectorTransport(ParallelTransport())"
            end

            @testset "ForwardDiff support" begin
                exp_f(t) = distance(M, pts[1], exp(M, pts[1], t * tv1))
                d12 = distance(M, pts[1], pts[2])
                for t in 0.1:0.1:0.9
                    @test d12 ≈ ForwardDiff.derivative(exp_f, t)
                end
                retract_f(t) = distance(M, pts[1], retract(M, pts[1], t * tv1))
                for t in 0.1:0.1:0.9
                    @test ForwardDiff.derivative(retract_f, t) ≥ 0
                end
            end

            isa(pts[1], Union{Vector, SizedVector}) && @testset "ReverseDiff support" begin
                exp_f(t) = distance(M, pts[1], exp(M, pts[1], t[1] * tv1))
                d12 = distance(M, pts[1], pts[2])
                for t in 0.1:0.1:0.9
                    @test d12 ≈ ReverseDiff.gradient(exp_f, [t])[1]
                end

                retract_f(t) = distance(M, pts[1], retract(M, pts[1], t[1] * tv1))
                for t in 0.1:0.1:0.9
                    @test ReverseDiff.gradient(retract_f, [t])[1] ≥ 0
                end
            end
        end
    end

    @testset "mid_point on 0-index arrays" begin
        M = ManifoldsBase.DefaultManifold(1)
        p1 = fill(0.0)
        p2 = fill(1.0)
        @test isapprox(M, fill(0.5), mid_point(M, p1, p2))
    end

    @testset "Retraction" begin
        a = NLSolveInverseRetraction(ExponentialRetraction())
        @test a.retraction isa ExponentialRetraction
    end

    @testset "copy of points and vectors" begin
        M = ManifoldsBase.DefaultManifold(2)
        for (p, X) in (
                ([2.0, 3.0], [4.0, 5.0]),
                (DefaultPoint([2.0, 3.0]), DefaultTangentVector([4.0, 5.0])),
            )
            q = similar(p)
            copyto!(M, q, p)
            @test p == q
            r = copy(M, p)
            @test r == p
            Y = similar(X)
            copyto!(M, Y, p, X)
            @test Y == X
            Z = copy(M, p, X)
            @test Z == X
        end

        p1 = DefaultPoint([2.0, 3.0])
        p2 = copy(p1)
        @test (p1 == p2) && (p1 !== p2)
    end

    @testset "further vector and point automatic forwards" begin
        M = ManifoldsBase.DefaultManifold(3)
        p = DefaultPoint([1.0, 0.0, 0.0])
        q = DefaultPoint([0.0, 0.0, 0.0])
        X = DefaultTangentVector([0.0, 1.0, 0.0])
        Y = DefaultTangentVector([1.0, 0.0, 0.0])
        @test angle(M, p, X, Y) ≈ π / 2
        @test inverse_retract(M, p, q, LogarithmicInverseRetraction()) == -Y
        @test retract(M, q, Y, CustomDefinedRetraction()) == p
        @test ManifoldsBase.retract_fused(M, q, Y, 1.0, CustomDefinedRetraction()) == p
        @test retract(M, q, Y, ExponentialRetraction()) == p
        @test ManifoldsBase.retract_fused(M, q, Y, 1.0, ExponentialRetraction()) == p
        # rest not implemented - so they also fall back even onto mutating
        Z = similar(Y)
        r = similar(p)
        # test passthrough using the dummy implementations
        for retr in [
                PolarRetraction(),
                ProjectionRetraction(),
                QRRetraction(),
                SoftmaxRetraction(),
                PadeRetraction(2),
                EmbeddedRetraction(ExponentialRetraction()),
                SasakiRetraction(5),
                ApproximateExponentialRetraction((;)),
            ]
            @test retract(M, q, Y, retr) == DefaultPoint(q.value + Y.value)
            @test ManifoldsBase.retract_fused(M, q, Y, 0.5, retr) ==
                DefaultPoint(q.value + 0.5 * Y.value)
            @test retract!(M, r, q, Y, retr) == DefaultPoint(q.value + Y.value)
            @test ManifoldsBase.retract_fused!(M, r, q, Y, 0.5, retr) ==
                DefaultPoint(q.value + 0.5 * Y.value)
        end

        mRK = RetractionWithKeywords(CustomDefinedKeywordRetraction(); scale = 3.0)
        pRK = allocate(p, eltype(p.value), size(p.value))
        @test retract(M, p, X, mRK) == DefaultPoint(3 * p.value + X.value)
        @test ManifoldsBase.retract_fused(M, p, X, 0.5, mRK) ==
            DefaultPoint(3 * p.value + 0.5 * X.value)
        @test retract!(M, pRK, p, X, mRK) == DefaultPoint(3 * p.value + X.value)
        @test ManifoldsBase.retract_fused!(M, pRK, p, X, 0.5, mRK) ==
            DefaultPoint(3 * p.value + 0.5 * X.value)
        mIRK = InverseRetractionWithKeywords(
            CustomDefinedKeywordInverseRetraction();
            scale = 3.0,
        )
        XIRK = allocate(X, eltype(X.value), size(X.value))
        @test inverse_retract(M, p, pRK, mIRK) ==
            DefaultTangentVector(pRK.value - 3 * p.value)
        @test inverse_retract!(M, XIRK, p, pRK, mIRK) ==
            DefaultTangentVector(pRK.value - 3 * p.value)
        p2 = allocate(p, eltype(p.value), size(p.value))
        @test size(p2.value) == size(p.value)
        X2 = allocate(X, eltype(X.value), size(X.value))
        @test size(X2.value) == size(X.value)
        X3 = ManifoldsBase.allocate_result(M, log, p, q)
        @test log!(M, X3, p, q) == log(M, p, q)
        @test X3 == log(M, p, q)
        @test log!(M, X3, p, q) == log(M, p, q)
        @test X3 == log(M, p, q)
        @test inverse_retract(M, p, q, CustomDefinedInverseRetraction()) == -2 * Y
        @test distance(M, p, q, CustomDefinedInverseRetraction()) == 2.0
        X4 = ManifoldsBase.allocate_result(M, inverse_retract, p, q)
        @test inverse_retract!(M, X4, p, q) == inverse_retract(M, p, q)
        @test X4 == inverse_retract(M, p, q)
        # rest not implemented but check passthrough
        for r in [
                PolarInverseRetraction(),
                ProjectionInverseRetraction(),
                QRInverseRetraction(),
                SoftmaxInverseRetraction(),
                ApproximateLogarithmicInverseRetraction((;)),
            ]
            @test inverse_retract(M, q, p, r) == DefaultTangentVector(p.value - q.value)
            @test inverse_retract!(M, Z, q, p, r) == DefaultTangentVector(p.value - q.value)
        end
        @test inverse_retract(
            M, q, p, EmbeddedInverseRetraction(LogarithmicInverseRetraction()),
        ) == DefaultTangentVector(p.value - q.value)
        @test inverse_retract(M, q, p, NLSolveInverseRetraction(ExponentialRetraction())) ==
            DefaultTangentVector(p.value - q.value)
        @test inverse_retract!(
            M, Z, q, p, EmbeddedInverseRetraction(LogarithmicInverseRetraction()),
        ) == DefaultTangentVector(p.value - q.value)
        @test inverse_retract!(
            M, Z, q, p, NLSolveInverseRetraction(ExponentialRetraction()),
        ) == DefaultTangentVector(p.value - q.value)
        c = ManifoldsBase.allocate_coordinates(M, p, Float64, manifold_dimension(M))
        @test c isa Vector
        @test length(c) == 3
        @test 2.0 \ X == DefaultTangentVector(2.0 \ X.value)
        @test X + Y == DefaultTangentVector(X.value + Y.value)
        @test +X == X
        @test (Y .= X) === Y
        # vector transport pass through
        @test vector_transport_to(M, p, X, q, ProjectionTransport()) == X
        @test vector_transport_direction(M, p, X, X, ProjectionTransport()) == X
        @test vector_transport_to!(M, Y, p, X, q, ProjectionTransport()) == X
        @test vector_transport_direction!(M, Y, p, X, X, ProjectionTransport()) == X
        @test vector_transport_to(M, p, X, :q, ProjectionTransport()) == X
        @test parallel_transport_to(M, p, X, q) == X
        @test parallel_transport_direction(M, p, X, X) == X
        @test parallel_transport_to!(M, Y, p, X, q) == X
        @test parallel_transport_direction!(M, Y, p, X, X) == X

        # convert with manifold
        @test convert(typeof(p), M, p.value) == p
        @test convert(typeof(X), M, p, X.value) == X
    end

    @testset "DefaultManifold and ONB" begin
        M = ManifoldsBase.DefaultManifold(3)
        p = [1.0f0, 0.0f0, 0.0f0]
        CB = get_basis(M, p, DefaultOrthonormalBasis())
        # make sure the right type is propagated
        @test CB.data isa Vector{Vector{Float32}}
        @test CB.data ==
            [[1.0f0, 0.0f0, 0.0f0], [0.0f0, 1.0f0, 0.0f0], [0.0f0, 0.0f0, 1.0f0]]

        # test complex point -> real coordinates
        MC = ManifoldsBase.DefaultManifold(3; field = ManifoldsBase.ℂ)
        p = [1.0im, 2.0im, -1.0im]
        CB = get_basis(MC, p, DefaultOrthonormalBasis(ManifoldsBase.ℂ))
        @test CB.data == [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]]
        @test CB.data isa Vector{Vector{Float64}}
        @test ManifoldsBase.coordinate_eltype(MC, p, ManifoldsBase.ℂ) === ComplexF64
        @test ManifoldsBase.coordinate_eltype(MC, p, ManifoldsBase.ℝ) === Float64
        CBR = get_basis(MC, p, DefaultOrthonormalBasis())
        @test CBR.data == [
            [1.0 + 0.0im, 0.0 + 0.0im, 0.0 + 0.0im],
            [0.0 + 0.0im, 1.0 + 0.0im, 0.0 + 0.0im],
            [0.0 + 0.0im, 0.0 + 0.0im, 1.0 + 0.0im],
            [0.0 + 1.0im, 0.0 + 0.0im, 0.0 + 0.0im],
            [0.0 + 0.0im, 0.0 + 1.0im, 0.0 + 0.0im],
            [0.0 + 0.0im, 0.0 + 0.0im, 0.0 + 1.0im],
        ]
    end

    @testset "Show methods" begin
        @test repr(CayleyRetraction()) == "CayleyRetraction()"
        @test repr(PadeRetraction(2)) == "PadeRetraction(2)"
    end

    @testset "Further TestArrayRepresentation" begin
        M = ManifoldsBase.DefaultManifold(3)
        p = [1.0, 0.0, 0.0]
        X = [1.0, 0.0, 0.0]
        @test is_point(M, p, true)
        @test is_vector(M, p, X, true)
        pF = [1.0, 0.0]
        XF = [0.0, 0.0]
        m = ExponentialRetraction()
        @test_throws DomainError is_point(M, pF, true)
        @test_throws DomainError is_vector(M, p, XF; error = :error)
        @test_throws DomainError is_vector(M, pF, XF, true; error = :error)
        @test injectivity_radius(M) == Inf
        @test injectivity_radius(M, p) == Inf
        @test injectivity_radius(M, p, m) == Inf
        @test injectivity_radius(M, m) == Inf
    end

    @testset "performance" begin
        @allocated isapprox(M, SA[1, 2], SA[3, 4]) == 0
    end

    @testset "scalars" begin
        M = ManifoldsBase.DefaultManifold()
        p = 1.0
        X = 2.0
        @test copy(M, p) === p
        @test copy(M, p, X) === X
    end

    @testset "static (size in type parameter)" begin
        MS = ManifoldsBase.DefaultManifold(3; parameter = :type)
        @test (@inferred representation_size(MS)) == (3,)
        @test repr(MS) == "DefaultManifold(3; field = ℝ, parameter = :type)"
        @test_throws ArgumentError ManifoldsBase.DefaultManifold(3; parameter = :foo)
    end

    @testset "complex vee and hat" begin
        MC = ManifoldsBase.DefaultManifold(3; field = ManifoldsBase.ℂ)
        p = [1im, 2 + 2im, 3.0]
        @test isapprox(vee(MC, p, [1 + 2im, 3 + 4im, 5 + 6im]), [1, 3, 5, 2, 4, 6])
        @test isapprox(hat(MC, p, [1, 3, 5, 2, 4, 6]), [1 + 2im, 3 + 4im, 5 + 6im])
    end

    ManifoldsBase.default_approximation_method(
        ::ManifoldsBase.DefaultManifold,
        ::typeof(exp),
    ) = GradientDescentEstimation()
    @testset "Estimation Method defaults" begin
        M = ManifoldsBase.DefaultManifold(3)
        # Point generic type fallback
        @test default_approximation_method(M, exp, Float64) ==
            default_approximation_method(M, exp)
        # Retraction
        @test default_approximation_method(M, retract) == default_retraction_method(M)
        @test default_approximation_method(M, retract, DefaultPoint) ==
            default_retraction_method(M)
        # Inverse Retraction
        @test default_approximation_method(M, inverse_retract) ==
            default_inverse_retraction_method(M)
        @test default_approximation_method(M, inverse_retract, DefaultPoint) ==
            default_inverse_retraction_method(M)
        # Vector Transports – all 3: to
        @test default_approximation_method(M, vector_transport_to) ==
            default_vector_transport_method(M)
        @test default_approximation_method(M, vector_transport_to, DefaultPoint) ==
            default_vector_transport_method(M)
        @test default_approximation_method(M, vector_transport_direction) ==
            default_vector_transport_method(M)
        @test default_approximation_method(M, vector_transport_direction, DefaultPoint) ==
            default_vector_transport_method(M)
    end

    @test ManifoldsBase.tangent_vector_type(M, DefaultPoint) === DefaultTangentVector
    @test ManifoldsBase.tangent_vector_type(M, Array) === Array

    @testset "Type promotion in allocation" begin
        @test ManifoldsBase.exp_fused(M, [1, 2], [2, 3], 1.0) isa Vector{Float64}
    end
    @testset "Trait forwarding" begin
        @test ManifoldsBase.get_forwarding_type(ManifoldsBase.DefaultManifold(2), Vector{Int}) ==
            ManifoldsBase.StopForwardingType()
    end
    @testset "Error on nonnumeric types on Complex" begin
        Mc = ManifoldsBase.DefaultManifold(3; field = ManifoldsBase.ℂ)
        # Error on nonnumber points and vectors
        @test_throws DomainError is_point(Mc, ["a", "b", "c"]; error = :error)
        @test_throws DomainError is_vector(Mc, zeros(3), ["a", "b", "c"]; error = :error)
        @test_throws DomainError is_vector(Mc, ["a", "b", "c"], zeros(3); error = :error)
    end
end

function parallel_transport_direction!(M::AbstractManifold, Y, p, X, d; kwargs...)
    return parallel_transport_to!(M, Y, p, X, exp(M, p, d); kwargs...)
end

@doc raw"""
    parallel_transport_direction(M::AbstractManifold, p, X, d)

Compute the parallel transport of ``X`` along the curve ``c(t) = γ_{p,X}(t)`` to ``c(1)=q``,
where ``c(t)=γ_{p,X}(t)`` is the the unique geodesic starting from ``γ_{p,d}(0)=p``
into direction ``̇\dot γ_{p,d}(0)=d``.

By default this function calls [`parallel_transport_to`](@ref)`(M, p, X, q)`, where ``q=\exp_pX``.
"""
function parallel_transport_direction(M::AbstractManifold, p, X, d; kwargs...)
    return parallel_transport_to(M, p, X, exp(M, p, d); kwargs...)
end

function parallel_transport_to! end

@doc raw"""
    parallel_transport_to(M::AbstractManifold, p, X, q)

Compute the parallel transport of ``X`` along the curve ``c(t) = γ_{p,q}(t)``,
i.e. the (assumed to be unique) [`geodesic`](@ref) ``γ_{p,q}`` connecting `p` and `q`.
"""
function parallel_transport_to(M::AbstractManifold, p, X, q; kwargs...)
    Y = allocate_result(M, vector_transport_to, X, p, q)
    return parallel_transport_to!(M, Y, p, X, q; kwargs...)
end

using LinearAlgebra, ManifoldsBase, Test

using ManifoldsBase: DefaultManifold, ℝ
#
# A first artificial (not real) manifold that is modelled as a submanifold
# half plane with euclidean metric is not a manifold but should test all things correctly here
#
struct HalfPlaneManifold <: AbstractDecoratorManifold{ℝ} end
struct PosQuadrantManifold <: AbstractDecoratorManifold{ℝ} end

function ManifoldsBase.get_embedding_type(::HalfPlaneManifold)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end
function ManifoldsBase.get_embedding_type(::PosQuadrantManifold)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

ManifoldsBase.get_embedding(::HalfPlaneManifold) = ManifoldsBase.DefaultManifold(1, 3)
ManifoldsBase.decorated_manifold(::HalfPlaneManifold) = ManifoldsBase.DefaultManifold(2)
ManifoldsBase.representation_size(::HalfPlaneManifold) = (1, 3)

ManifoldsBase.get_embedding(::PosQuadrantManifold) = HalfPlaneManifold()
ManifoldsBase.representation_size(::PosQuadrantManifold) = (3,)

function ManifoldsBase.check_point(::HalfPlaneManifold, p)
    return p[1] > 0 ? nothing : DomainError(p[1], "p[1] ≤ 0")
end
function ManifoldsBase.check_vector(::HalfPlaneManifold, p, X)
    return X[1] > 0 ? nothing : DomainError(X[1], "X[1] ≤ 0")
end
function ManifoldsBase.check_point(::PosQuadrantManifold, p)
    return p[2] > 0 ? nothing : DomainError(p[1], "p[2] ≤ 0")
end
function ManifoldsBase.check_vector(::PosQuadrantManifold, p, X)
    return X[2] > 0 ? nothing : DomainError(X[1], "X[2] ≤ 0")
end

ManifoldsBase.embed(::HalfPlaneManifold, p) = reshape(p, 1, :)
ManifoldsBase.embed(::HalfPlaneManifold, p, X) = reshape(X, 1, :)

ManifoldsBase.project!(::HalfPlaneManifold, q, p) = (q .= [p[1] p[2] 0.0])
ManifoldsBase.project!(::HalfPlaneManifold, Y, p, X) = (Y .= [X[1] X[2] 0.0])

function ManifoldsBase.get_coordinates_orthonormal!(
        ::HalfPlaneManifold,
        Y,
        p,
        X,
        ::ManifoldsBase.RealNumbers,
    )
    return (Y .= [X[1], X[2]])
end
function ManifoldsBase.get_vector_orthonormal!(
        ::HalfPlaneManifold,
        Y,
        p,
        c,
        ::ManifoldsBase.RealNumbers,
    )
    return (Y .= [c[1] c[2] 0.0])
end

#
# A second manifold that is modelled as just isometrically embedded but not a submanifold
#
struct AnotherHalfPlaneManifold <: AbstractDecoratorManifold{ℝ} end

ManifoldsBase.get_embedding(::AnotherHalfPlaneManifold) = ManifoldsBase.DefaultManifold(3)
function ManifoldsBase.decorated_manifold(::AnotherHalfPlaneManifold)
    return ManifoldsBase.DefaultManifold(2)
end
ManifoldsBase.representation_size(::AnotherHalfPlaneManifold) = (2,)

function ManifoldsBase.get_embedding_type(::AnotherHalfPlaneManifold)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

ManifoldsBase.has_components(::AnotherHalfPlaneManifold) = true

function ManifoldsBase.embed!(::AnotherHalfPlaneManifold, q, p)
    q[1:2] .= p
    q[3] = 0
    return q
end
function ManifoldsBase.embed!(::AnotherHalfPlaneManifold, Y, p, X)
    Y[1:2] .= X
    Y[3] = 0
    return Y
end
function ManifoldsBase.project!(::AnotherHalfPlaneManifold, q, p)
    return q .= [p[1], p[2]]
end
function ManifoldsBase.project!(::AnotherHalfPlaneManifold, Y, p, X)
    return Y .= [X[1], X[2]]
end
function ManifoldsBase.exp!(::AnotherHalfPlaneManifold, q, p, X)
    return q .= p .+ X
end
#
# Third example - explicitly mention an embedding.
#
function ManifoldsBase.embed!(
        ::EmbeddedManifold{𝔽, DefaultManifold{𝔽, nL}, DefaultManifold{𝔽2, mL}},
        q,
        p,
    ) where {nL, mL, 𝔽, 𝔽2}
    n = size(p)
    ln = length(n)
    m = size(q)
    lm = length(m)
    (length(n) > length(m)) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) is longer than embedding dimension $(m).",
        ),
    )
    any(n .> m[1:ln]) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) has entry larger than embedding dimensions ($(m)).",
        ),
    )
    fill!(q, 0)
    q[map(ind_n -> Base.OneTo(ind_n), n)..., ntuple(_ -> 1, lm - ln)...] .= p
    return q
end

function ManifoldsBase.project!(
        ::EmbeddedManifold{𝔽, DefaultManifold{𝔽, nL}, DefaultManifold{𝔽2, mL}},
        q,
        p,
    ) where {nL, mL, 𝔽, 𝔽2}
    n = size(p)
    ln = length(n)
    m = size(q)
    lm = length(m)
    (length(n) < length(m)) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) is longer than embedding dimension $(m).",
        ),
    )
    any(n .< m[1:ln]) && throw(
        DomainError(
            "Invalid embedding, since Euclidean dimension ($(n)) has entry larger than embedding dimensions ($(m)).",
        ),
    )
    #  fill q with the „top left edge“ of p.
    q .= p[map(i -> Base.OneTo(i), m)..., ntuple(_ -> 1, lm - ln)...]
    return q
end

#
# A manifold that is a submanifold but otherwise has not implementations
#
struct NotImplementedEmbeddedSubManifold <: AbstractDecoratorManifold{ℝ} end
function ManifoldsBase.get_embedding(::NotImplementedEmbeddedSubManifold)
    return ManifoldsBase.DefaultManifold(3)
end
function ManifoldsBase.decorated_manifold(::NotImplementedEmbeddedSubManifold)
    return ManifoldsBase.DefaultManifold(2)
end

function ManifoldsBase.get_embedding_type(::NotImplementedEmbeddedSubManifold)
    return ManifoldsBase.EmbeddedSubmanifoldType()
end

#
# A manifold that is isometrically embedded and `embed` is indicated as not an identity but has no implementations
#
struct NotImplementedIsometricEmbeddedManifoldNE <: AbstractDecoratorManifold{ℝ} end
function ManifoldsBase.get_embedding_type(::NotImplementedIsometricEmbeddedManifoldNE)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

#
# A manifold that is isometrically embedded and `embed` is indicated as an identity but has no implementations
#
struct NotImplementedIsometricEmbeddedManifoldDNE <: AbstractDecoratorManifold{ℝ} end
function ManifoldsBase.get_embedding_type(::NotImplementedIsometricEmbeddedManifoldDNE)
    return ManifoldsBase.IsometricallyEmbeddedManifoldType(ManifoldsBase.IndirectEmbedding())
end

#
# A manifold that is an embedded manifold and `embed` is indicated as not an identity but not isometric and has no other implementation
#
struct NotImplementedEmbeddedManifoldNE <: AbstractDecoratorManifold{ℝ} end
function ManifoldsBase.get_embedding_type(::NotImplementedEmbeddedManifoldNE)
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.DirectEmbedding())
end

#
# A manifold that is an embedded manifold and `embed` is indicated as an identity but not isometric and has no other implementation
#
struct NotImplementedEmbeddedManifoldDNE <: AbstractDecoratorManifold{ℝ} end
function ManifoldsBase.get_embedding_type(::NotImplementedEmbeddedManifoldDNE)
    return ManifoldsBase.EmbeddedManifoldType(ManifoldsBase.IndirectEmbedding())
end

struct SimpleEmbeddedTestManifold <: AbstractDecoratorManifold{ℝ} end
ManifoldsBase.get_embedding(::SimpleEmbeddedTestManifold) = DefaultManifold(3)
function ManifoldsBase.get_forwarding_type(::SimpleEmbeddedTestManifold, ::Any, P::Type = Nothing)
    return ManifoldsBase.EmbeddedForwardingType(ManifoldsBase.DirectEmbedding())
end

struct EmbeddedTestManifold <: AbstractDecoratorManifold{ℝ} end
ManifoldsBase.get_embedding(::EmbeddedTestManifold) = DefaultManifold(3)
function ManifoldsBase.get_forwarding_type(::EmbeddedTestManifold, ::Any, P::Type = Nothing)
    return ManifoldsBase.EmbeddedForwardingType(ManifoldsBase.IndirectEmbedding())
end
ManifoldsBase.embed(::EmbeddedTestManifold, p) = p
ManifoldsBase.embed!(::EmbeddedTestManifold, q, p) = (q .= p)
ManifoldsBase.embed(::EmbeddedTestManifold, p, X) = X
ManifoldsBase.embed!(::EmbeddedTestManifold, Y, p, X) = (Y .= X)
ManifoldsBase.project(::EmbeddedTestManifold, p) = p
ManifoldsBase.project!(::EmbeddedTestManifold, q, p) = (q .= p)
ManifoldsBase.project(::EmbeddedTestManifold, p, X) = X
ManifoldsBase.project!(::EmbeddedTestManifold, Y, p, X) = (Y .= X)

#
# A Manifold with a fallback
#
struct FallbackManifold <: AbstractDecoratorManifold{ℝ} end
ManifoldsBase.decorated_manifold(::FallbackManifold) = DefaultManifold(3)

function ManifoldsBase.get_forwarding_type(::FallbackManifold, ::Any, P::Type = Nothing)
    return ManifoldsBase.SimpleForwardingType()
end

@testset "Embedded Manifolds" begin
    @testset "EmbeddedManifold basic tests" begin
        M = EmbeddedManifold(
            ManifoldsBase.DefaultManifold(2),
            ManifoldsBase.DefaultManifold(3),
        )
        @test repr(M) ==
            "EmbeddedManifold($(sprint(show, M.manifold)), $(sprint(show, M.embedding)))"
        @test base_manifold(M) == ManifoldsBase.DefaultManifold(2)
        @test base_manifold(M, Val(0)) == M
        @test base_manifold(M, Val(1)) == ManifoldsBase.DefaultManifold(2)
        @test base_manifold(M, Val(2)) == ManifoldsBase.DefaultManifold(2)
        @test get_embedding(M) == ManifoldsBase.DefaultManifold(3)
        @test get_embedding(M, Vector{Int}) == ManifoldsBase.DefaultManifold(3)
    end

    @testset "HalfPlaneManifold" begin
        M = HalfPlaneManifold()
        N = PosQuadrantManifold()
        @test repr(M) == "HalfPlaneManifold()"
        @test get_embedding(M) == ManifoldsBase.DefaultManifold(1, 3)
        @test representation_size(M) == (1, 3)
        # Check point checks using embedding
        @test is_point(M, [1 0.1 0.1], true)
        @test !is_point(M, [-1, 0, 0]) #wrong dim (3,1)
        @test_throws ManifoldDomainError is_point(M, [-1, 0, 0], true)
        @test !is_point(M, [-1, 0, 0])
        @test !is_point(M, [1, 0.1]) # size (from embedding)
        @test_throws ManifoldDomainError is_point(M, [1, 0.1], true)
        @test !is_point(M, [1, 0.1])
        @test is_point(M, [1 0 0], true)
        @test !is_point(M, [-1 0 0]) # right size but <0 1st
        @test_throws DomainError is_point(M, [-1 0 0], true) # right size but <0 1st
        @test !is_vector(M, [1 0 0], [1]) # right point, wrong size vector
        @test_throws ManifoldDomainError is_vector(M, [1 0 0], [1]; error = :error)
        @test !is_vector(M, [1 0 0], [1])
        @test_throws DomainError is_vector(M, [1 0 0], [-1 0 0]; error = :error) # right point, vec 1st <0
        @test !is_vector(M, [1 0 0], [-1 0 0])
        @test is_vector(M, [1 0 0], [1 0 1], true)
        @test !is_vector(M, [-1, 0, 0], [0, 0, 0])
        @test_throws ManifoldDomainError is_vector(M, [-1, 0, 0], [0, 0, 0]; error = :error)
        @test_throws ManifoldDomainError is_vector(M, [1, 0, 0], [-1, 0, 0]; error = :error)
        @test !is_vector(M, [-1, 0, 0], [0, 0, 0])
        @test !is_vector(M, [1, 0, 0], [-1, 0, 0])
        # check manifold domain error from embedding to obtain ManifoldDomainErrors
        @test !is_point(N, [0, 0, 0])
        @test_throws ManifoldDomainError is_point(N, [0, 0, 0]; error = :error)
        @test !is_vector(N, [1, 1, 0], [0, 0, 0])
        @test_throws ManifoldDomainError is_vector(N, [1, 1, 0], [0, 0, 0]; error = :error)
        p = [1.0 1.0 0.0]
        q = [1.0 0.0 0.0]
        X = q - p
        @test ManifoldsBase.check_size(M, p) === nothing
        @test ManifoldsBase.check_size(M, p, X) === nothing
        @test ManifoldsBase.check_size(M, [1, 2]) isa ManifoldDomainError
        @test ManifoldsBase.check_size(M, [1 2 3 4]) isa ManifoldDomainError
        @test ManifoldsBase.check_size(M, p, [1, 2]) isa ManifoldDomainError
        @test ManifoldsBase.check_size(M, p, [1 2 3 4]) isa ManifoldDomainError
        @test embed(M, p) == p
        pE = similar(p)
        embed!(M, pE, p)
        @test pE == p
        P = [1.0 1.0 2.0]
        Q = similar(P)
        @test project!(M, Q, P) == project!(M, Q, P)
        @test project!(M, Q, P) == embed_project!(M, Q, P)
        @test project!(M, Q, P) == [1.0 1.0 0.0]
        @test isapprox(M, p, zero_vector(M, p), [0 0 0])
        XZ = similar(X)
        zero_vector!(M, XZ, p)
        @test isapprox(M, p, XZ, [0 0 0])

        XE = similar(X)
        embed!(M, XE, p, X)
        XE2 = embed(M, p, X)
        @test X == XE
        @test XE == XE2

        @test log(M, p, q) == q - p
        Y = similar(p)
        log!(M, Y, p, q)
        @test Y == q - p
        @test exp(M, p, X) == q
        @test ManifoldsBase.exp_fused(M, p, X, 1.0) == q
        r = similar(p)
        exp!(M, r, p, X)
        @test r == q
        ManifoldsBase.exp_fused!(M, r, p, X, 1.0)
        @test r == q
        @test distance(M, p, r) == norm(r - p)

        @test retract(M, p, X) == q
        @test ManifoldsBase.retract_fused(M, p, X, 1.0) == q
        q2 = similar(q)
        @test retract!(M, q2, p, X) == q
        @test ManifoldsBase.retract_fused!(M, q2, p, X, 1.0) == q
        @test q2 == q
        @test inverse_retract(M, p, q) == X
        Y = similar(X)
        @test inverse_retract!(M, Y, p, q) == X
        @test Y == X

        @test parallel_transport_direction(M, p, X, X) == X
        @test parallel_transport_direction!(M, Y, p, X, X) == X
        @test parallel_transport_to(M, p, X, q) == X
        @test parallel_transport_to!(M, Y, p, X, q) == X

        @test get_basis(M, p, DefaultOrthonormalBasis()) isa CachedBasis
        Xc = [X[1], X[2]]
        Yc = similar(Xc)
        @test get_coordinates(M, p, X, DefaultOrthonormalBasis()) == Xc
        @test get_coordinates(M, p, X) == Xc
        @test get_coordinates!(M, Yc, p, X, DefaultOrthonormalBasis()) == Xc
        @test get_coordinates!(M, Yc, p, X) == Xc
        @test get_vector(M, p, Xc, DefaultOrthonormalBasis()) == X
        @test get_vector(M, p, Xc) == X
        @test get_vector!(M, Y, p, Xc, DefaultOrthonormalBasis()) == X
        @test get_vector!(M, Y, p, Xc) == X
    end

    @testset "AnotherHalfPlaneManifold" begin
        M = AnotherHalfPlaneManifold()
        p = [1.0, 2.0]
        pe = embed(M, p)
        @test pe == [1.0, 2.0, 0.0]
        X = [2.0, 3.0]
        Xe = embed(M, pe, X)
        @test Xe == [2.0, 3.0, 0.0]
        @test project(M, pe) == p
        @test embed_project(M, p) == p
        @test embed_project(M, p, X) == X
        Xs = similar(X)
        @test embed_project!(M, Xs, p, X) == X
        @test project(M, pe, Xe) == X
        # injectivity_radius shouldn't pass through
        @test_throws MethodError injectivity_radius(M)
        @test_throws MethodError injectivity_radius(M, p)
        @test_throws MethodError injectivity_radius(M, p, ExponentialRetraction())
        @test_throws MethodError injectivity_radius(M, ExponentialRetraction())

        @test inner(M, p, X, X) ≈ dot(X, X)
        @test norm(M, p, X) ≈ norm(X)

        q = similar(p)
        copyto!(M, q, p)
        @test p == q
        Y = similar(X)
        copyto!(M, Y, p, X)
        @test Y == X
        @test isapprox(M, p, X, Y)
        @test exp(M, p, X) ≈ p + X
        exp!(M, q, p, X)
        @test isapprox(M, q, p + X)

        @test has_components(M)

        # test vector transports in the embedding
        m = EmbeddedVectorTransport(ParallelTransport())
        q = [2.0, 2.0]
        @test vector_transport_to(M, p, X, q, m) == X #since its PT on R^3
        @test vector_transport_direction(M, p, X, q, m) == X
    end

    @testset "Test nonimplemented fallbacks" begin
        @testset "Submanifold Embedding Fallbacks & Error Tests" begin
            M = NotImplementedEmbeddedSubManifold()
            A = zeros(2)
            # for a submanifold quite a lot of functions are passed on
            @test ManifoldsBase.check_point(M, [1, 2]) === nothing
            @test ManifoldsBase.check_vector(M, [1, 2], [3, 4]) === nothing
            @test norm(M, [1, 2], [2, 3]) ≈ sqrt(13)
            @test distance(M, [1, 2], [3, 4]) ≈ sqrt(8)
            @test inner(M, [1, 2], [2, 3], [2, 3]) == 13
            @test manifold_dimension(M) == 2 # since base is defined is defined
            @test_throws MethodError project(M, [1, 2])
            @test_throws MethodError project(M, [1, 2], [2, 3]) == [2, 3]
            @test_throws MethodError project!(M, A, [1, 2], [2, 3])
            @test vector_transport_direction(M, [1, 2], [2, 3], [3, 4]) == [2, 3]
            vector_transport_direction!(M, A, [1, 2], [2, 3], [3, 4])
            @test A == [2, 3]
            @test vector_transport_to(M, [1, 2], [2, 3], [3, 4]) == [2, 3]
            vector_transport_to!(M, A, [1, 2], [2, 3], [3, 4])
            @test A == [2, 3]
            @test @inferred !isapprox(M, [1, 2], [2, 3])
            @test @inferred !isapprox(M, [1, 2], [2, 3], [4, 5])

            @test ManifoldsBase.get_forwarding_type_embedding(ManifoldsBase.EmbeddedSubmanifoldType{ManifoldsBase.DirectEmbedding}(), M, exp) === EmbeddedForwardingType()
        end
        @testset "Isometric Embedding Fallbacks & Error Tests" begin
            for M2 in [NotImplementedIsometricEmbeddedManifoldNE(), NotImplementedIsometricEmbeddedManifoldDNE()]
                @test base_manifold(M2) == M2
                A = zeros(2)
                if M2 isa NotImplementedIsometricEmbeddedManifoldDNE
                    @test_throws MethodError ManifoldsBase.allocate_result(M2, zero_vector, A)
                else
                    @test size(ManifoldsBase.allocate_result(M2, zero_vector, A)) == size(A)
                end
                # Check that all of these report not to be implemented, i.e.
                @test_throws MethodError exp(M2, [1, 2], [2, 3])
                @test_throws MethodError ManifoldsBase.exp_fused(M2, [1, 2], [2, 3], 1.0)
                @test_throws MethodError exp!(M2, A, [1, 2], [2, 3])
                @test_throws MethodError ManifoldsBase.exp_fused!(M2, A, [1, 2], [2, 3], 1.0)
                @test_throws MethodError retract(M2, [1, 2], [2, 3])
                @test_throws MethodError ManifoldsBase.retract_fused(M2, [1, 2], [2, 3], 1.0)
                @test_throws MethodError retract!(M2, A, [1, 2], [2, 3])
                @test_throws MethodError ManifoldsBase.retract_fused!(
                    M2,
                    A,
                    [1, 2],
                    [2, 3],
                    1.0,
                )
                @test_throws MethodError log(M2, [1, 2], [2, 3])
                @test_throws MethodError log!(M2, A, [1, 2], [2, 3])
                @test_throws MethodError inverse_retract(M2, [1, 2], [2, 3])
                @test_throws MethodError inverse_retract!(M2, A, [1, 2], [2, 3])
                @test_throws MethodError distance(M2, [1, 2], [2, 3])
                @test_throws MethodError project(M2, [1, 2])
                @test_throws MethodError project!(M2, A, [1, 2])
                @test_throws MethodError project(M2, [1, 2], [2, 3])
                @test_throws MethodError project!(M2, A, [1, 2], [2, 3])
                @test_throws MethodError vector_transport_direction(M2, [1, 2], [2, 3], [3, 4])
                @test_throws MethodError vector_transport_direction!(
                    M2,
                    A,
                    [1, 2],
                    [2, 3],
                    [3, 4],
                )
                @test_throws MethodError vector_transport_to(M2, [1, 2], [2, 3], [3, 4])
                @test_throws MethodError vector_transport_to!(M2, A, [1, 2], [2, 3], [3, 4])
            end
        end
        @testset "Nonisometric Embedding Fallback Error Tests" begin
            for M3 in [NotImplementedEmbeddedManifoldNE(), NotImplementedEmbeddedManifoldDNE()]
                @test_throws MethodError inner(M3, [1, 2], [2, 3], [2, 3])
                @test_throws MethodError distance(M3, [1, 2], [2, 3])
                @test_throws MethodError norm(M3, [1, 2], [2, 3])
                @test_throws MethodError zero_vector(M3, [1, 2])
            end
        end
    end
    @testset "Explicit Embeddings using EmbeddedManifold" begin
        M = DefaultManifold(3, 3)
        N = DefaultManifold(4, 4)
        O = EmbeddedManifold(M, N)
        # first test with same length of sizes
        p = ones(3, 3)
        q = zeros(4, 4)
        qT = zeros(4, 4)
        qT[1:3, 1:3] .= 1.0
        embed!(O, q, p)
        @test norm(qT - q) == 0
        qM = embed(O, p)
        @test norm(project(O, qM) - p) == 0
        @test norm(qT - qM) == 0
        # test with different sizes, check that it only fills first element
        q2 = zeros(4, 4, 3)
        q2T = zeros(4, 4, 3)
        q2T[1:3, 1:3, 1] .= 1.0
        embed!(O, q2, p)
        @test norm(q2T - q2) == 0
        O2 = EmbeddedManifold(M, DefaultManifold(4, 4, 3))
        q2M = embed(O2, p)
        @test norm(q2T - q2M) == 0
        # wrong size error checks
        @test_throws DomainError embed!(O, zeros(3, 3), zeros(3, 3, 5))
        @test_throws DomainError embed!(O, zeros(3, 3), zeros(4, 4))
        @test_throws DomainError project!(O, zeros(3, 3, 5), zeros(3, 3))
        @test_throws DomainError project!(O, zeros(4, 4), zeros(3, 3))
    end
    @testset "Explicit Fallback" begin
        M = FallbackManifold()
        # test the explicit fallback to DefaultManifold(3)
        @test inner(M, [1, 0, 0], [1, 2, 3], [0, 1, 0]) == 2
        @test is_point(M, [1, 0, 0])
        @test ManifoldsBase.allocate_result(M, exp, [1.0, 0.0, 2.0]) isa Vector
    end
    @testset "SimpleEmbeddedTestManifold" begin
        M = SimpleEmbeddedTestManifold()
        p = [1.0, 2.0, 3.0]
        X = [2.0, 3.0, 4.0]
        vf = [1.0, 2.0, 3.0, 4.0]
        is_point(M, p; error = :error)
        is_vector(M, p, X; error = :error)
        @test_throws ManifoldDomainError is_point(M, vf; error = :error)
        @test_throws ManifoldDomainError is_vector(M, p, vf; error = :error)
        @test_throws ManifoldDomainError is_vector(M, vf, X; error = :error)
        # Triggert actual test in embedding to fail
        @test_throws ManifoldDomainError is_point(M, [1.0, 2.0im, 3.0]; error = :error)
        @test_throws ManifoldDomainError is_vector(M, [1.0, 2.0im, 3.0], X; error = :error)
        @test_throws ManifoldDomainError is_vector(M, p, [1.0, 2.0im, 3.0]; error = :error)
    end
    @testset "EmbeddedTestManifold" begin
        M = EmbeddedTestManifold()
        p = [1.0, 2.0, 3.0]
        X = [2.0, 3.0, 4.0]
        vf = [1.0, 2.0, 3.0, 4.0]
        is_point(M, p; error = :error)
        is_vector(M, p, X; error = :error)
        @test_throws ManifoldDomainError is_point(M, vf; error = :error)
        @test_throws ManifoldDomainError is_vector(M, p, vf; error = :error)
        @test_throws ManifoldDomainError is_vector(M, vf, X; error = :error)
        # Triggert actual test in embedding to fail
        @test_throws ManifoldDomainError is_point(M, [1.0, 2.0im, 3.0]; error = :error)
        @test_throws ManifoldDomainError is_vector(M, [1.0, 2.0im, 3.0], X; error = :error)
        @test_throws ManifoldDomainError is_vector(M, p, [1.0, 2.0im, 3.0]; error = :error)
    end
end

module ManifoldsBaseQuaternionsExt

using ManifoldsBase
using ManifoldsBase: ℍ, QuaternionNumbers
using Quaternions

@inline function ManifoldsBase.allocate_result_type(
        ::AbstractManifold{ℍ},
        f::TF,
        args::Tuple{},
    ) where {TF}
    return QuaternionF64
end

@inline function ManifoldsBase.coordinate_eltype(
        ::AbstractManifold,
        p,
        𝔽::QuaternionNumbers,
    )
    return quat(number_eltype(p))
end

end

#
# Base pass-ons
#
manifold_dimension(M::AbstractDecoratorManifold) = manifold_dimension(base_manifold(M))

#
# Forwarding types


"""
    abstract type AbstractEmbeddingDirectness end

Supertype for [`DirectEmbedding`](@ref) and [`IndirectEmbedding`](@ref) that indicate
whether [`embed`](@ref) on a manifold is an identity or not.
"""
abstract type AbstractEmbeddingDirectness end

"""
    struct DirectEmbedding <: AbstractEmbeddingDirectness end

A struct indicating that `embed` *is* an identity function on a manifold.
"""
struct DirectEmbedding <: AbstractEmbeddingDirectness end

"""
    struct IndirectEmbedding <: AbstractEmbeddingDirectness end

A struct indicating that `embed` *is not* an identity function on a manifold.
"""
struct IndirectEmbedding <: AbstractEmbeddingDirectness end

"""
    AbstractForwardingType

An abstract type to specify the forwarding behaviour of a function for a decorator
manifold or a trait within `ManifoldsBase.jl`.
"""
abstract type AbstractForwardingType end

"""
    AbstractEmbeddedForwardingType

An abstract type to specify the forwarding behaviour of a function when it should forward
to the embedding of a manifold.
"""
abstract type AbstractEmbeddedForwardingType <: AbstractForwardingType end

"""
    StopForwardingType <: AbstractForwardingType


A type that indicates that a function should not forward to a certain other manifold, e.g.
and embedding. This means that the user is asked to implement this function themselfes.
"""
struct StopForwardingType <: AbstractForwardingType end

"""
    SimpleForwardingType <: AbstractForwardingType

A type that indicates forwarding to the wrapped manifold without any changes.
"""
struct SimpleForwardingType <: AbstractForwardingType end

"""
    EmbeddedForwardingType{TED<:AbstractEmbeddingDirectness} <: AbstractEmbeddedForwardingType

A property of an embedded manifold that indicates that [`embed`](@ref) and [`project`](@ref)
are available and that a function using this trait type forwards to the embedding.
The type parameter `TED`, a subtype of [`AbstractEmbeddingDirectness`](@ref), indicates
whether `embed` on points and tangent vectors needs to be called or is an identity and can
be skipped.
"""
struct EmbeddedForwardingType{TED <: AbstractEmbeddingDirectness} <: AbstractEmbeddedForwardingType end

EmbeddedForwardingType(ed::AbstractEmbeddingDirectness = IndirectEmbedding()) = EmbeddedForwardingType{typeof(ed)}()

"""
    get_forwarding_type(M::AbstractManifold, f)
    get_forwarding_type(M::AbstractManifold, f, P::Type)

Get the type of forwarding to manifold wrapped by [`AbstractManifold`](@ref) `M`, for function `f`.
The returned value is an object of a subtype of [`AbstractForwardingType`](@ref).

Point type `P` can be optionally specified if different point types correspond
to different representations of the manifold and hence possibly different embeddings.
"""
get_forwarding_type(::AbstractManifold, f) = StopForwardingType()
get_forwarding_type(M::AbstractManifold, f, P::Type) = get_forwarding_type(M, f)

"""
    AbstractEmbeddingType

Within all [`AbstractEmbeddedForwardingType`](@ref)s this type is used to indicate different kinds of embeddings,
for example the default fallback that [`NotEmbeddedManifoldType`](@ref) a manifold is not embedded,
that is is embedded using [`EmbeddedManifoldType`](@ref) or even specifying further that it is
isometrically embedded using [`IsometricallyEmbeddedManifoldType`](@ref) or as furthermore
a submanifold using [`EmbeddedSubmanifoldType`](@ref).
"""
abstract type AbstractEmbeddingType end

"""
    NotEmbeddedManifoldType <: AbstractEmbeddingType

A property of an embedded manifold that indicates that `embed` and `project` are *not*
available.
"""
struct NotEmbeddedManifoldType <: AbstractEmbeddingType end

"""
    EmbeddedManifoldType <: AbstractEmbeddingType

A property of an embedded manifold that indicates that `embed` and `project` are available.
"""
struct EmbeddedManifoldType{EN <: AbstractEmbeddingDirectness} <: AbstractEmbeddingType end

function EmbeddedManifoldType(en::AbstractEmbeddingDirectness = IndirectEmbedding())
    return EmbeddedManifoldType{typeof(en)}()
end

"""
    IsometricallyEmbeddedManifold <: AbstractEmbeddingType

A property to determine whether an [`AbstractDecoratorManifold`](@ref) `M` is
an isometrically embedded manifold.

Here, additionally, metric related functions like [`inner`](@ref) and [`norm`](@ref) are passed to the embedding
"""
struct IsometricallyEmbeddedManifoldType{EN <: AbstractEmbeddingDirectness} <: AbstractEmbeddingType end

function IsometricallyEmbeddedManifoldType(
        en::AbstractEmbeddingDirectness = IndirectEmbedding(),
    )
    return IsometricallyEmbeddedManifoldType{typeof(en)}()
end

"""
    EmbeddedSubmanifoldType <: AbstractEmbeddingType

A property to determine whether an [`AbstractDecoratorManifold`](@ref) `M` is an embedded submanifold.
It is a special case of the [`IsometricallyEmbeddedManifoldType`](@ref) property, i.e. it has all properties of
this property.

In this property, additionally to the isometric embedded manifold, all retractions, inverse retractions,
and vectors transports, especially [`exp`](@ref), [`log`](@ref), and [`parallel_transport_to`](@ref)
are passed to the embedding.
"""
struct EmbeddedSubmanifoldType{EN <: AbstractEmbeddingDirectness} <: AbstractEmbeddingType end

function EmbeddedSubmanifoldType(en::AbstractEmbeddingDirectness = IndirectEmbedding())
    return EmbeddedSubmanifoldType{typeof(en)}()
end

"""
    get_embedding_type(M::AbstractManifold)
    get_embedding_type(M::AbstractManifold, P::Type)

Get embedding type of [`AbstractManifold`](@ref) `M`.
The returned value is an object of a subtype of [`AbstractEmbeddingType`](@ref), either of:

* [`NotEmbeddedManifoldType`](@ref) (default),
* [`EmbeddedManifoldType`](@ref),
* [`IsometricallyEmbeddedManifoldType`](@ref),
* [`EmbeddedSubmanifoldType`](@ref).

Point type `P` can be optionally specified if different point types correspond to different
embeddings.
"""
get_embedding_type(::AbstractManifold) = NotEmbeddedManifoldType()
get_embedding_type(M::AbstractManifold, ::Type) = get_embedding_type(M)


#
# Generic Decorator functions
@doc raw"""
    decorated_manifold(M::AbstractDecoratorManifold)

For a manifold `M` that is decorated with some properties, this function returns
the manifold without that manifold, i.e. the manifold that _was decorated_.
"""
decorated_manifold(M::AbstractDecoratorManifold)
decorated_manifold(M::AbstractManifold) = M

#
# Implemented Traits
function base_manifold(M::AbstractDecoratorManifold, depth::Val{N} = Val(-1)) where {N}
    # end recursion I: depth is 0
    N == 0 && return M
    # end recursion II: M is equal to its decorated manifold (avoid stack overflow)
    D = decorated_manifold(M)
    M === D && return M
    # indefinite many steps for negative values of M
    N < 0 && return base_manifold(D, depth)
    # reduce depth otherwise
    return base_manifold(D, Val(N - 1))
end

#
# Embedded specific functions.
"""
    get_embedding(M::AbstractDecoratorManifold)
    get_embedding(M::AbstractDecoratorManifold, P::Type)

Specify the embedding of a manifold that has abstract decorators.
The embedding might depend on a point representation type `P`,
where different point representations
are distinguished as subtypes of [`AbstractManifoldPoint`](@ref).
A unique or default representation might also just be an `AbstractArray`.
"""
get_embedding(M::AbstractDecoratorManifold, ::Type) = get_embedding(M)

@inline function allocate_result(
        M::AbstractDecoratorManifold,
        f::TF,
        x::Vararg{Any, N},
    ) where {TF, N}
    return _allocate_result_forwarding(
        get_forwarding_type(M, f, typeof(x[1])),
        M,
        f,
        x...,
    )
end
@inline function allocate_result(M::AbstractDecoratorManifold, f::TF) where {TF}
    return _allocate_result_forwarding(get_forwarding_type(M, f), M, f)
end

@inline function _allocate_result_forwarding(
        ::EmbeddedForwardingType{DirectEmbedding},
        M::AbstractDecoratorManifold,
        f::TF,
        x::Vararg{Any, N},
    ) where {TF, N}
    return allocate_result(get_embedding(M, typeof(x[1])), f, x...)
end
@inline function _allocate_result_forwarding(
        ::SimpleForwardingType,
        M::AbstractDecoratorManifold,
        f::TF,
        x::Vararg{Any, N},
    ) where {TF, N}
    return allocate_result(decorated_manifold(M), f, x...)
end
@inline function _allocate_result_forwarding(
        ::Union{StopForwardingType, EmbeddedForwardingType},
        M::AbstractDecoratorManifold,
        f::TF,
        x::Vararg{Any, N},
    ) where {TF, N}
    return invoke(
        allocate_result,
        Tuple{AbstractManifold, typeof(f), typeof(x).parameters...},
        M,
        f,
        x...,
    )
end

# disambiguation
@invoke_maker 1 AbstractManifold allocate_result(
    M::AbstractDecoratorManifold, f::typeof(get_coordinates), p, X, B::AbstractBasis,
)
@invoke_maker 1 AbstractManifold allocate_result(
    M::AbstractDecoratorManifold, f::typeof(get_vector), p, c,
)

function allocate_result_embedding(
        M::AbstractManifold,
        f::typeof(embed),
        x::Vararg{Any, N},
    ) where {N}
    T = allocate_result_type(get_embedding(M, typeof(x[1])), f, x)
    return allocate(M, x[1], T, representation_size(get_embedding(M, typeof(x[1]))))
end
function allocate_result_embedding(
        M::AbstractManifold,
        f::typeof(project),
        x::Vararg{Any, N},
    ) where {N}
    T = allocate_result_type(M, f, x)
    return allocate(M, x[1], T, representation_size(M))
end

@trait_function change_metric(M::AbstractDecoratorManifold, G::AbstractMetric, X, p)

@trait_function change_metric!(M::AbstractDecoratorManifold, Y, G::AbstractMetric, X, p)

@trait_function change_representer(
    M::AbstractDecoratorManifold,
    G::AbstractMetric,
    X,
    p,
)
@trait_function change_representer!(
    M::AbstractDecoratorManifold,
    Y,
    G::AbstractMetric,
    X,
    p,
)

@trait_function check_size(M::AbstractDecoratorManifold, p) (
    SimpleForwardingType,
    StopForwardingType,
)
function _check_size_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p)
    mpe = check_size(get_embedding(M, typeof(p)), embed(M, p))
    if mpe !== nothing
        return ManifoldDomainError(
            "$p is not a point on $M because it is not a valid point in its embedding.", mpe,
        )
    end
    return nothing
end
function _check_size_forwarding(
        ::EmbeddedForwardingType{DirectEmbedding},
        M::AbstractDecoratorManifold,
        p,
    )
    mpe = check_size(get_embedding(M, typeof(p)), p)
    if mpe !== nothing
        return ManifoldDomainError(
            "$p is not a point on $M because it is not a valid point in its embedding.",
            mpe,
        )
    end
    return nothing
end
@trait_function check_size(M::AbstractDecoratorManifold, p, X) (
    SimpleForwardingType,
    StopForwardingType,
)
function _check_size_forwarding(
        ::EmbeddedForwardingType,
        M::AbstractDecoratorManifold,
        p,
        X,
    )
    mpe = check_size(get_embedding(M, typeof(p)), embed(M, p), embed(M, p, X))
    if mpe !== nothing
        return ManifoldDomainError(
            "$X is not a tangent vector at $p on $M because it is not a valid tangent vector in its embedding.",
            mpe,
        )
    end
    return nothing
end
function _check_size_forwarding(
        ::EmbeddedForwardingType{DirectEmbedding},
        M::AbstractDecoratorManifold,
        p,
        X,
    )
    mpe = check_size(get_embedding(M, typeof(p)), p, X)
    if mpe !== nothing
        return ManifoldDomainError(
            "$X is not a tangent vector at $p on $M because it is not a valid tangent vector in its embedding.",
            mpe,
        )
    end
    return nothing
end
# Introduce Deco Trait | automatic forward | fallback
@trait_function copyto!(M::AbstractDecoratorManifold, q, p)
@trait_function copyto!(M::AbstractDecoratorManifold, Y, p, X)

function _copyto!_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, q, p)
    return copyto!(get_embedding(M, typeof(p)), q, p)
end
function _copyto!_forwarding(
        ::EmbeddedForwardingType,
        M::AbstractDecoratorManifold,
        Y,
        p,
        X,
    )
    return copyto!(get_embedding(M, typeof(p)), Y, p, X)
end

for mf in [inverse_retract, retract]
    @eval @trait_function default_approximation_method(
        M::AbstractDecoratorManifold,
        f::typeof($mf),
    )
end

# Introduce Deco Trait | automatic forward | fallback
@trait_function embed(M::AbstractDecoratorManifold, p)

# Introduce Deco Trait | automatic forward | fallback
@trait_function embed!(M::AbstractDecoratorManifold, q, p)

# Introduce Deco Trait | automatic forward | fallback
@trait_function embed(M::AbstractDecoratorManifold, p, X)

# Introduce Deco Trait | automatic forward | fallback
@trait_function embed!(M::AbstractDecoratorManifold, Y, p, X)

# Introduce Deco Trait | automatic forward | fallback

@trait_function exp(M::AbstractDecoratorManifold, p, X)

@trait_function exp!(M::AbstractDecoratorManifold, q, p, X)

@trait_function exp_fused(M::AbstractDecoratorManifold, p, X, t::Number)

@trait_function exp_fused!(M::AbstractDecoratorManifold, q, p, X, t::Number)

@trait_function get_coordinates(M::AbstractDecoratorManifold, p, X) (
    SimpleForwardingType,
    StopForwardingType,
)

function _get_coordinates_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, X)
    return @invoke get_coordinates(M::AbstractManifold, p, X)
end

@trait_function get_coordinates(M::AbstractDecoratorManifold, p, X, B::AbstractBasis) (
    SimpleForwardingType,
    StopForwardingType,
)

function _get_coordinates_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, X, B::AbstractBasis)
    return @invoke get_coordinates(M::AbstractManifold, p, X, B)
end

@trait_function get_coordinates!(M::AbstractDecoratorManifold, c, p, X) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function get_coordinates!(M::AbstractDecoratorManifold, c, p, X, B::AbstractBasis) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function get_vector(M::AbstractDecoratorManifold, p, c) (
    SimpleForwardingType,
    StopForwardingType,
)

function _get_vector_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, c)
    return @invoke get_vector(M::AbstractManifold, p, c)
end

@trait_function get_vector(M::AbstractDecoratorManifold, p, c, B::AbstractBasis) (
    SimpleForwardingType,
    StopForwardingType,
)

function _get_vector_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, c, B::AbstractBasis)
    return @invoke get_vector(M::AbstractManifold, p, c, B)
end

@trait_function get_vector!(M::AbstractDecoratorManifold, X, p, c) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function get_vector!(M::AbstractDecoratorManifold, X, p, c, B::AbstractBasis) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function has_components(M::AbstractDecoratorManifold)

@trait_function injectivity_radius(M::AbstractDecoratorManifold)

@trait_function injectivity_radius(M::AbstractDecoratorManifold, p)

@trait_function injectivity_radius(
    M::AbstractDecoratorManifold,
    m::AbstractRetractionMethod,
)

@trait_function injectivity_radius(
    M::AbstractDecoratorManifold,
    p,
    m::AbstractRetractionMethod,
)

@trait_function inner(M::AbstractDecoratorManifold, p, X, Y)

function _inner_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, X, Y)
    return inner(get_embedding(M, typeof(p)), embed(M, p), embed(M, p, X), embed(M, p, Y))
end

# Introduce Deco Trait | automatic forward | fallback
@trait_function inverse_retract(
    M::AbstractDecoratorManifold,
    p,
    q,
    m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
)

@trait_function inverse_retract!(
    M::AbstractDecoratorManifold,
    X,
    p,
    q,
    m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
)

@trait_function is_point(M::AbstractDecoratorManifold, p; kwargs...) (
    StopForwardingType,
    SimpleForwardingType,
)

function _is_point_forwarding(
        T::Union{
            EmbeddedForwardingType{D},
            IsometricallyEmbeddedManifoldType{D},
        },
        M::AbstractDecoratorManifold,
        p;
        error::Symbol = :none,
        kwargs...,
    ) where {D <: AbstractEmbeddingDirectness}
    # to be safe check_size first
    es = check_size(M, p)
    if es !== nothing
        (error === :error) && throw(es)
        s = "$(typeof(es)) with $(es)"
        (error === :info) && @info s
        (error === :warn) && @warn s
        return false
    end
    try
        if (D <: IndirectEmbedding)
            pt = is_point(get_embedding(M, typeof(p)), embed(M, p); error = error, kwargs...)
        else
            pt = is_point(get_embedding(M, typeof(p)), p; error = error, kwargs...)
        end
        !pt && return false # no error thrown (deactivated) but returned false -> return false
    catch e
        !(e isa DomainError || e isa AbstractManifoldDomainError) && rethrow(e)
        throw(
            ManifoldDomainError(
                "$p is not a point on $M because it is not a valid point in its embedding.",
                e,
            )
        )
    end
    mpe = check_point(M, p; kwargs...)
    if mpe !== nothing
        (error === :error) && throw(mpe)
        # else: collect and info showerror
        io = IOBuffer()
        showerror(io, mpe)
        s = String(take!(io))
        (error === :info) && @info s
        (error === :warn) && @warn s
        return false
    end
    return true
end

@trait_function is_vector(
    M::AbstractDecoratorManifold,
    p,
    X,
    check_base_point::Bool = true;
    kwargs...,
) (StopForwardingType, SimpleForwardingType)

function _is_vector_forwarding(
        T::Union{
            EmbeddedForwardingType{D},
            IsometricallyEmbeddedManifoldType{D},
        },
        M::AbstractDecoratorManifold,
        p,
        X,
        check_base_point::Bool = true;
        error::Symbol = :none,
        kwargs...,
    ) where {D <: AbstractEmbeddingDirectness}
    es = check_size(M, p, X)
    if es !== nothing
        (error === :error) && throw(es)
        # else: collect and info showerror
        io = IOBuffer()
        showerror(io, es)
        s = String(take!(io))
        (error === :info) && @info s
        (error === :warn) && @warn s
        return false
    end
    if check_base_point
        try
            ep = is_point(M, p; error = error, kwargs...)
            !ep && return false
        catch e
            !(e isa DomainError || e isa AbstractManifoldDomainError) && rethrow(e)
            throw(
                ManifoldDomainError(
                    "$X is not a tangent vector to $p on $M because $p is not a valid point on $M",
                    e,
                )
            )
        end
    end
    try
        if (D <: IndirectEmbedding)
            tv = is_vector(
                get_embedding(M, typeof(p)),
                embed(M, p),
                embed(M, p, X),
                check_base_point;
                error = error,
                kwargs...,
            )
        else
            tv = is_vector(
                get_embedding(M, typeof(p)),
                p,
                X,
                check_base_point;
                error = error,
                kwargs...,
            )
        end
        !tv && return false # no error thrown (deactivated) but returned false -> return false
    catch e
        !(e isa DomainError || e isa AbstractManifoldDomainError) && rethrow(e)
        throw(
            ManifoldDomainError(
                "$X is not a tangent vector to $p on $M because it is not a valid tangent vector in its embedding.",
                e,
            )
        )
    end
    # Check (additional) local stuff
    mXe = check_vector(M, p, X; kwargs...)
    mXe === nothing && return true
    (error === :error) && throw(mXe)
    # else: collect and info showerror
    io = IOBuffer()
    showerror(io, mXe)
    s = String(take!(io))
    (error === :info) && @info s
    (error === :warn) && @warn s
    return false
end

@trait_function _isapprox(M::AbstractDecoratorManifold, p, q; kwargs...)
@trait_function _isapprox(M::AbstractDecoratorManifold, p, X, Y; kwargs...)

function __isapprox_forwarding(
        ::EmbeddedForwardingType,
        M::AbstractDecoratorManifold,
        p,
        q;
        kwargs...,
    )
    return _isapprox(get_embedding(M, typeof(p)), embed(M, p), embed(M, q); kwargs...)
end
function __isapprox_forwarding(
        ::EmbeddedForwardingType,
        M::AbstractDecoratorManifold,
        p,
        X,
        Y;
        kwargs...,
    )
    return _isapprox(
        get_embedding(M, typeof(p)),
        embed(M, p),
        embed(M, p, X),
        embed(M, p, Y);
        kwargs...,
    )
end

@trait_function is_flat(M::AbstractDecoratorManifold)

@trait_function norm(M::AbstractDecoratorManifold, p, X)

function _norm_forwarding(::EmbeddedForwardingType, M::AbstractDecoratorManifold, p, X)
    return norm(get_embedding(M, typeof(p)), embed(M, p), embed(M, p, X))
end

@trait_function log(M::AbstractDecoratorManifold, p, q)

@trait_function log!(M::AbstractDecoratorManifold, X, p, q)

# Introduce Deco Trait | automatic forward | fallback

@trait_function parallel_transport_direction(M::AbstractDecoratorManifold, p, X, d)

@trait_function parallel_transport_direction!(M::AbstractDecoratorManifold, Y, p, X, d)

# Introduce Deco Trait | automatic forward | fallback

@trait_function parallel_transport_to(M::AbstractDecoratorManifold, p, X, q)

@trait_function parallel_transport_to!(M::AbstractDecoratorManifold, Y, p, X, q)

@trait_function project(M::AbstractDecoratorManifold, p) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function project(M::AbstractDecoratorManifold, p, X) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function project!(M::AbstractDecoratorManifold, q, p) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function project!(M::AbstractDecoratorManifold, Y, p, X) (
    SimpleForwardingType,
    StopForwardingType,
)

@trait_function Random.rand(M::AbstractDecoratorManifold; vector_at = nothing, kwargs...)

@trait_function Random.rand!(M::AbstractDecoratorManifold, p; kwargs...)

@trait_function Random.rand(rng::AbstractRNG, M::AbstractDecoratorManifold; kwargs...) (
    EmbeddedForwardingType{DirectEmbedding},
    SimpleForwardingType,
    StopForwardingType,
) 2

@trait_function Random.rand!(
    rng::AbstractRNG,
    M::AbstractDecoratorManifold,
    p;
    kwargs...,
) (EmbeddedForwardingType{DirectEmbedding}, SimpleForwardingType, StopForwardingType) 2

@trait_function representation_size(M::AbstractDecoratorManifold)

# Introduce Deco Trait | automatic forward | fallback
@trait_function retract(
    M::AbstractDecoratorManifold,
    p,
    X,
    m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
)

@trait_function retract_fused(
    M::AbstractDecoratorManifold,
    p,
    X,
    t::Number,
    m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
)

@trait_function retract!(
    M::AbstractDecoratorManifold,
    q,
    p,
    X,
    m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
)

@trait_function retract_fused!(
    M::AbstractDecoratorManifold,
    q,
    p,
    X,
    t::Number,
    m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
)

@trait_function vector_transport_direction(
    M::AbstractDecoratorManifold,
    p,
    X,
    d,
    m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
)

@trait_function vector_transport_direction!(
    M::AbstractDecoratorManifold,
    Y,
    p,
    X,
    d,
    m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
)

@trait_function vector_transport_to(
    M::AbstractDecoratorManifold, p, X, q,
    m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
)

@trait_function vector_transport_to!(
    M::AbstractDecoratorManifold, Y, p, X, q,
    m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
)

@trait_function Weingarten(M::AbstractDecoratorManifold, p, X, V)
@trait_function Weingarten!(M::AbstractDecoratorManifold, Y, p, X, V)

@trait_function zero_vector(M::AbstractDecoratorManifold, p)

@trait_function zero_vector!(M::AbstractDecoratorManifold, X, p)

const forward_functions_embedded = [
    copyto!,
    check_size,
    is_point,
    is_vector,
    _isapprox,
    representation_size,
    zero_vector,
    zero_vector!,
]

const forward_functions_isometric = [inner, norm]

const forward_functions_submanifold = [
    change_metric,
    change_metric!,
    change_representer,
    change_representer!,
    exp,
    exp!,
    exp_fused,
    exp_fused!,
    get_basis,
    get_coordinates,
    get_vector,
    get_vectors,
    injectivity_radius,
    inverse_retract,
    inverse_retract!,
    is_flat,
    log,
    log!,
    mid_point,
    parallel_transport_direction,
    parallel_transport_direction!,
    parallel_transport_to,
    parallel_transport_to!,
    retract,
    retract!,
    retract_fused,
    retract_fused!,
    riemann_tensor,
    vector_transport_direction,
    vector_transport_direction!,
    vector_transport_to,
    vector_transport_to!,
    Weingarten,
    Weingarten!,
]


function get_forwarding_type(M::AbstractDecoratorManifold, f)
    return get_forwarding_type_embedding(get_embedding_type(M), M, f)
end
function get_forwarding_type(M::AbstractDecoratorManifold, f, P::Type)
    return get_forwarding_type_embedding(get_embedding_type(M, P), M, f)
end

function get_forwarding_type_embedding(
        ::Union{
            EmbeddedManifoldType, IsometricallyEmbeddedManifoldType, EmbeddedSubmanifoldType,
            NotEmbeddedManifoldType,
        },
        M::AbstractDecoratorManifold,
        f,
    )
    return StopForwardingType()
end

for mf in vcat(
        forward_functions_submanifold,
        forward_functions_isometric,
        forward_functions_embedded,
    )
    @eval begin
        function get_forwarding_type_embedding(
                ::EmbeddedSubmanifoldType{DirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType()
        end
        function get_forwarding_type_embedding(
                ::EmbeddedSubmanifoldType{IndirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType(DirectEmbedding())
        end
    end
end

for mf in vcat(forward_functions_isometric, forward_functions_embedded)
    @eval begin
        function get_forwarding_type_embedding(
                ::IsometricallyEmbeddedManifoldType{DirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType()
        end
        function get_forwarding_type_embedding(
                ::IsometricallyEmbeddedManifoldType{IndirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType(DirectEmbedding())
        end
    end
end

for mf in forward_functions_embedded
    @eval begin
        function get_forwarding_type_embedding(
                ::EmbeddedManifoldType{DirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType()
        end
        function get_forwarding_type_embedding(
                ::EmbeddedManifoldType{IndirectEmbedding},
                M::AbstractDecoratorManifold, ::typeof($mf),
            )
            return EmbeddedForwardingType(DirectEmbedding())
        end
    end
end

using Test
using ManifoldsBase
@testset "ManifoldsBase" begin
    bound = 8
    # six ambiguities come from possible incorrectly formed calls to `allocate`
    ambiguities = Test.detect_ambiguities(ManifoldsBase)
    num_ambiguities = length(ambiguities)
    #num_ambiguities > 0 && @warn "The number of ambiguities in ManifoldsBase is $(num_ambiguities)."
    if num_ambiguities > bound
        for amb in ambiguities
            println(amb)
        end
    end
    @test num_ambiguities <= bound

    include("decorator_traits.jl")
    include("allocation.jl")
    include("numbers.jl")
    include("bases.jl")
    include("manifold_fallbacks.jl")
    include("empty_manifold.jl")
    include("errors.jl")
    include("default_manifold.jl")
    include("complex_manifold.jl")
    include("validation_manifold.jl")
    include("embedded_manifold.jl")
    include("test_sphere.jl")
    include("product_manifold.jl")
    include("power.jl")
    include("domain_errors.jl")
    include("vector_transport.jl")
    include("metric.jl")
    include("fibers.jl")
    include("numerical_checks.jl")
    include("quotient_manifold.jl")
    include("deprecated.jl")
    include("test_aqua.jl")
end

using LinearAlgebra
using ManifoldsBase
using ManifoldsBase: DefaultManifold, ℝ, ℂ, RealNumbers, ComplexNumbers
using ManifoldsBase: CotangentSpaceType, TangentSpaceType
using ManifoldsBase: FVector
using Test

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

@testset "Bases" begin
    @testset "Projected and arbitrary orthonormal basis" begin
        M = ProjManifold()
        x = [
            sqrt(2) / 2 0.0 0.0
            0.0 sqrt(2) / 2 0.0
        ]

        for pB in
            (ProjectedOrthonormalBasis(:svd), ProjectedOrthonormalBasis(:gram_schmidt))
            if pB isa ProjectedOrthonormalBasis{:gram_schmidt, ℝ}
                pb = @test_logs (
                    :warn,
                    "Input vector 4 lies in the span of the previous ones.",
                ) get_basis(
                    M,
                    x,
                    pB;
                    warn_linearly_dependent = true,
                    skip_linearly_dependent = true,
                ) # skip V4, wich is -V1 after proj.
                @test_throws ErrorException get_basis(M, x, pB) # error
            else
                pb = get_basis(M, x, pB) # skips V4 automatically
            end
            @test number_system(pb) == ℝ
            N = manifold_dimension(M)
            @test isa(pb, CachedBasis)
            @test CachedBasis(pb) === pb
            @test !ManifoldsBase.requires_caching(pb)
            @test length(get_vectors(M, x, pb)) == N
            # test orthonormality
            for i in 1:N
                @test norm(M, x, get_vectors(M, x, pb)[i]) ≈ 1
                for j in (i + 1):N
                    @test inner(M, x, get_vectors(M, x, pb)[i], get_vectors(M, x, pb)[j]) ≈
                        0 atol = 1.0e-15
                end
            end
        end
        aonb = get_basis(M, x, DefaultOrthonormalBasis())
        @test size(get_vectors(M, x, aonb)) == (5,)
        @test get_vectors(M, x, aonb)[1] ≈ [0, 0, 0, 0, 1]

        @testset "Gram-Schmidt" begin
            # for a basis
            M = ManifoldsBase.DefaultManifold(3)
            p = zeros(3)
            V = [[2.0, 0.0, 0.0], [1.1, 2.2, 0.0], [0.0, 3.3, 4.4]]
            b1 = ManifoldsBase.gram_schmidt(M, p, V)
            b2 = ManifoldsBase.gram_schmidt(M, zeros(3), CachedBasis(DefaultBasis(), V))
            @test b1 == get_vectors(M, p, b2)
            # projected gram schmidt
            tm = ProjectionTestManifold()
            bt = ProjectedOrthonormalBasis(:gram_schmidt)
            p = [sqrt(2) / 2, 0.0, sqrt(2) / 2, 0.0, 0.0]
            @test_logs (:warn, "Input only has 5 vectors, but manifold dimension is 100.") (
                @test_throws ErrorException get_basis(
                    tm,
                    p,
                    bt,
                )
            )
            b = @test_logs (
                :warn,
                "Input only has 5 vectors, but manifold dimension is 100.",
            ) get_basis(
                tm,
                p,
                bt;
                return_incomplete_set = true,
                skip_linearly_dependent = true, #skips 3 and 5
            )
            @test length(get_vectors(tm, p, b)) == 3
            @test_logs (:warn, "Input only has 1 vectors, but manifold dimension is 3.") (
                @test_throws ErrorException ManifoldsBase.gram_schmidt(
                    M,
                    p,
                    [V[1]],
                )
            )
            @test_throws ErrorException ManifoldsBase.gram_schmidt(
                M,
                p,
                [V[1], V[1], V[1]];
                skip_linearly_dependent = true,
            )
        end
    end

    @testset "ManifoldsBase.jl stuff" begin

        @testset "Errors" begin
            m = NonManifold()
            onb = DefaultOrthonormalBasis()

            @test_throws MethodError get_basis(m, [0], onb)
            @test_throws MethodError get_basis(m, [0], NonBasis())
            @test_throws MethodError get_coordinates(m, [0], [0], onb)
            @test_throws MethodError get_coordinates!(m, [0], [0], [0], onb)
            @test_throws MethodError get_vector(m, [0], [0], onb)
            @test_throws MethodError get_vector!(m, [0], [0], [0], onb)
            @test_throws MethodError get_vectors(m, [0], NonBasis())
        end

        M = DefaultManifold(3)

        @test sprint(
            show,
            "text/plain",
            CachedBasis(NonBasis(), NonBroadcastBasisThing([])),
        ) == "Cached basis of type NonBasis"

        @testset "Constructors" begin
            @test DefaultBasis{ℂ, TangentSpaceType}() === DefaultBasis(ℂ)
            @test DefaultOrthogonalBasis{ℂ, TangentSpaceType}() === DefaultOrthogonalBasis(ℂ)
            @test DefaultOrthonormalBasis{ℂ, TangentSpaceType}() ===
                DefaultOrthonormalBasis(ℂ)

            @test DefaultBasis{ℂ}(CotangentSpaceType()) ===
                DefaultBasis(ℂ, CotangentSpaceType())
            @test DefaultOrthogonalBasis{ℂ}(CotangentSpaceType()) ===
                DefaultOrthogonalBasis(ℂ, CotangentSpaceType())
            @test DefaultOrthonormalBasis{ℂ}(CotangentSpaceType()) ===
                DefaultOrthonormalBasis(ℂ, CotangentSpaceType())
        end

        _pts = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]]
        @testset "basis representation" for BT in (
                    DefaultBasis,
                    DefaultOrthonormalBasis,
                    DefaultOrthogonalBasis,
                    DiagonalizingBasisProxy,
                ),
                pts in (_pts, map(NonBroadcastBasisThing, _pts))

            if BT == DiagonalizingBasisProxy && pts !== _pts
                continue
            end
            X1 = log(M, pts[1], pts[2])
            @test ManifoldsBase.number_of_coordinates(M, BT()) == 3

            Xb = get_coordinates(M, pts[1], X1, BT())
            @test isa(Xb, AbstractVector)
            Xbi = get_vector(M, pts[1], Xb, BT())
            @test isapprox(M, pts[1], X1, Xbi)

            b = get_basis(M, pts[1], BT())
            if BT != DiagonalizingBasisProxy
                if pts[1] isa Array
                    @test isa(
                        b,
                        CachedBasis{ℝ, BT{ℝ, TangentSpaceType}, Vector{Vector{Float64}}},
                    )
                else
                    @test isa(
                        b,
                        CachedBasis{
                            ℝ,
                            BT{ℝ, TangentSpaceType},
                            Vector{NonBroadcastBasisThing{Vector{Float64}}},
                        },
                    )
                end
            end
            @test get_basis(M, pts[1], b) === b
            N = manifold_dimension(M)
            @test length(get_vectors(M, pts[1], b)) == N
            # check orthonormality
            if BT isa DefaultOrthonormalBasis && pts[1] isa Vector
                for i in 1:N
                    @test norm(M, pts[1], get_vectors(M, pts[1], b)[i]) ≈ 1
                    for j in (i + 1):N
                        @test inner(
                            M,
                            pts[1],
                            get_vectors(M, pts[1], b)[i],
                            get_vectors(M, pts[1], b)[j],
                        ) ≈ 0
                    end
                end
                # check that the coefficients correspond to the basis
                for i in 1:N
                    @test inner(M, pts[1], X1, get_vectors(M, pts[1], b)[i]) ≈ Xb[i]
                end
            end

            if BT != DiagonalizingBasisProxy
                @test get_coordinates(M, pts[1], X1, b) ≈
                    get_coordinates(M, pts[1], X1, BT())
                @test get_vector(M, pts[1], Xb, b) ≈ get_vector(M, pts[1], Xb, BT())
            end

            X1c = Vector{Float64}(undef, 3)
            get_coordinates!(M, X1c, pts[1], X1, b)
            @test X1c ≈ get_coordinates(M, pts[1], X1, b)

            X1cv = allocate(X1)
            get_vector!(M, X1cv, pts[1], X1c, b)
            @test isapprox(M, pts[1], X1, X1cv)
        end

        @testset "Convencience defaults" begin
            p = [1.0, 0.0, 0.0]
            X1 = [2.0, 1.0, -1.0]
            X1c = [2.0, 1.0, -1.0]
            X1cm = similar(X1c)
            X1m = similar(X1)
            @test get_coordinates(M, p, X1) == X1c
            get_coordinates!(M, X1cm, p, X1)
            @test X1cm == X1c
            @test get_vector(M, p, X1c) == X1c
            get_vector!(M, X1m, p, X1c)
            @test X1m == X1
            @test get_vectors(M, p) ==
                get_vectors(M, p, get_basis(M, p, DefaultOrthonormalBasis()))
        end
        @testset "() Manifolds" begin
            M = ManifoldsBase.DefaultManifold()
            ManifoldsBase.allocate_coordinates(M, 1, Float64, 0) == 0.0
            ManifoldsBase.allocate_coordinates(M, 1, Float64, 1) == zeros(Float64, 1)
            ManifoldsBase.allocate_coordinates(M, 1, Float64, 2) == zeros(Float64, 2)
        end
    end

    @testset "Complex DefaultManifold with real and complex Cached Bases" begin
        M = ManifoldsBase.DefaultManifold(3; field = ℂ)
        p = [1.0, 2.0im, 3.0]
        X = [1.2, 2.2im, 2.3im]
        b = [Matrix{Float64}(I, 3, 3)[:, i] for i in 1:3]
        bℂ = [b..., (b .* 1im)...]

        Bℝ = CachedBasis(DefaultOrthonormalBasis{ℂ}(), b)
        aℝ = get_coordinates(M, p, X, Bℝ)
        Yℝ = get_vector(M, p, aℝ, Bℝ)
        @test Yℝ ≈ X
        @test ManifoldsBase.number_of_coordinates(M, Bℝ) == 3

        Bℂ = CachedBasis(DefaultOrthonormalBasis{ℝ}(), bℂ)
        aℂ = get_coordinates(M, p, X, Bℂ)
        Yℂ = get_vector(M, p, aℂ, Bℂ)
        @test Yℂ ≈ X
        @test ManifoldsBase.number_of_coordinates(M, Bℂ) == 6

        @test change_basis(M, p, aℝ, Bℝ, Bℂ) ≈ aℂ
        aℂ_sim = similar(aℂ)
        change_basis!(M, aℂ_sim, p, aℝ, Bℝ, Bℂ)
        @test aℂ_sim ≈ aℂ
    end

    @testset "Basis show methods" begin
        @test sprint(show, DefaultBasis()) == "DefaultBasis(ℝ)"
        @test sprint(show, DefaultOrthogonalBasis()) == "DefaultOrthogonalBasis(ℝ)"
        @test sprint(show, DefaultOrthonormalBasis()) == "DefaultOrthonormalBasis(ℝ)"
        @test sprint(show, DefaultOrthonormalBasis(ℂ)) == "DefaultOrthonormalBasis(ℂ)"
        @test sprint(show, GramSchmidtOrthonormalBasis(ℂ)) ==
            "GramSchmidtOrthonormalBasis(ℂ)"
        @test sprint(show, ProjectedOrthonormalBasis(:svd)) ==
            "ProjectedOrthonormalBasis(:svd, ℝ)"
        @test sprint(show, ProjectedOrthonormalBasis(:gram_schmidt, ℂ)) ==
            "ProjectedOrthonormalBasis(:gram_schmidt, ℂ)"

        diag_onb = DiagonalizingOrthonormalBasis(Float64[1, 2, 3])
        @test sprint(show, "text/plain", diag_onb) == """
            DiagonalizingOrthonormalBasis(ℝ) with eigenvalue 0 in direction:
            3-element $(sprint(show, Vector{Float64})):
              1.0
              2.0
              3.0"""

        M = DefaultManifold(2, 3)
        x = collect(reshape(1.0:6.0, (2, 3)))
        pb = get_basis(M, x, DefaultOrthonormalBasis())
        B2 = DefaultOrthonormalBasis(ManifoldsBase.ℝ, ManifoldsBase.CotangentSpaceType())
        pb2 = get_basis(M, x, B2)

        test_basis_string = """
        Cached basis of type $(sprint(show, typeof(DefaultOrthonormalBasis()))) with 6 basis vectors:
         E1 =
          2×3 $(sprint(show, Matrix{Float64})):
           1.0  0.0  0.0
           0.0  0.0  0.0
         E2 =
          2×3 $(sprint(show, Matrix{Float64})):
           0.0  0.0  0.0
           1.0  0.0  0.0
         ⋮
         E5 =
          2×3 $(sprint(show, Matrix{Float64})):
           0.0  0.0  1.0
           0.0  0.0  0.0
         E6 =
          2×3 $(sprint(show, Matrix{Float64})):
           0.0  0.0  0.0
           0.0  0.0  1.0"""

        @test sprint(show, "text/plain", pb) == test_basis_string
        @test sprint(show, "text/plain", pb2) == test_basis_string

        b = DiagonalizingOrthonormalBasis(get_vectors(M, x, pb)[1])
        dpb = CachedBasis(b, Float64[1, 2, 3, 4, 5, 6], get_vectors(M, x, pb))
        @test sprint(show, "text/plain", dpb) == """
            DiagonalizingOrthonormalBasis(ℝ) with eigenvalue 0 in direction:
             2×3 $(sprint(show, Matrix{Float64})):
               1.0  0.0  0.0
               0.0  0.0  0.0
            and 6 basis vectors.
            Basis vectors:
             E1 =
              2×3 $(sprint(show, Matrix{Float64})):
               1.0  0.0  0.0
               0.0  0.0  0.0
             E2 =
              2×3 $(sprint(show, Matrix{Float64})):
               0.0  0.0  0.0
               1.0  0.0  0.0
             ⋮
             E5 =
              2×3 $(sprint(show, Matrix{Float64})):
               0.0  0.0  1.0
               0.0  0.0  0.0
             E6 =
              2×3 $(sprint(show, Matrix{Float64})):
               0.0  0.0  0.0
               0.0  0.0  1.0
            Eigenvalues:
             6-element $(sprint(show, Vector{Float64})):
              1.0
              2.0
              3.0
              4.0
              5.0
              6.0"""

        M = DefaultManifold(1, 1, 1)
        x = reshape(Float64[1], (1, 1, 1))
        pb = get_basis(M, x, DefaultOrthonormalBasis())
        @test sprint(show, "text/plain", pb) == """
            Cached basis of type $(sprint(show, typeof(DefaultOrthonormalBasis()))) with 1 basis vector:
             E1 =
              1×1×1 $(sprint(show, Array{Float64, 3})):
              [:, :, 1] =
               1.0"""

        dpb = CachedBasis(
            DiagonalizingOrthonormalBasis(get_vectors(M, x, pb)),
            Float64[1],
            get_vectors(M, x, pb),
        )

        @test sprint(show, "text/plain", dpb) == """
            DiagonalizingOrthonormalBasis(ℝ) with eigenvalue 0 in direction:
             1-element $(sprint(show, Vector{Array{Float64, 3}})):
               $(sprint(show, dpb.data.frame_direction[1]))
            and 1 basis vector.
            Basis vectors:
             E1 =
              1×1×1 $(sprint(show, Array{Float64, 3})):
              [:, :, 1] =
               1.0
            Eigenvalues:
             1-element $(sprint(show, Vector{Float64})):
              1.0"""
    end

    @testset "Bases of cotangent spaces" begin
        b1 = DefaultOrthonormalBasis(ℝ, CotangentSpaceType())
        @test b1.vector_space == CotangentSpaceType()

        b2 = DefaultOrthogonalBasis(ℝ, CotangentSpaceType())
        @test b2.vector_space == CotangentSpaceType()

        b3 = DefaultBasis(ℝ, CotangentSpaceType())
        @test b3.vector_space == CotangentSpaceType()

        M = DefaultManifold(2; field = ℂ)
        p = [1.0, 2.0im]
        b1_d = ManifoldsBase.dual_basis(M, p, b1)
        @test b1_d isa DefaultOrthonormalBasis
        @test b1_d.vector_space == TangentSpaceType()

        b1_d_d = ManifoldsBase.dual_basis(M, p, b1_d)
        @test b1_d_d isa DefaultOrthonormalBasis
        @test b1_d_d.vector_space == CotangentSpaceType()
    end

    @testset "Complex Basis - Mutating cases" begin
        Mc = ManifoldsBase.DefaultManifold(2, field = ManifoldsBase.ℂ)
        p = [1.0, 1.0im]
        X = [2.0, 1.0im]
        Bc = DefaultOrthonormalBasis(ManifoldsBase.ℂ)
        CBc = get_basis(Mc, p, Bc)
        @test CBc.data == [[1.0, 0.0], [0.0, 1.0]]
        B = DefaultOrthonormalBasis(ManifoldsBase.ℝ)
        CB = get_basis(Mc, p, B)
        @test CB.data == [[1.0, 0.0], [0.0, 1.0], [1.0im, 0.0], [0.0, 1.0im]]
        @test get_coordinates(Mc, p, X, CB) == [2.0, 0.0, 0.0, 1.0]
        @test get_coordinates(Mc, p, X, CBc) == [2.0, 1.0im]
        # ONB
        cc = zeros(4)
        @test get_coordinates!(Mc, cc, p, X, B) == [2.0, 0.0, 0.0, 1.0]
        @test cc == [2.0, 0.0, 0.0, 1.0]
        c = zeros(ComplexF64, 2)
        @test get_coordinates!(Mc, c, p, X, Bc) == [2.0, 1.0im]
        @test c == [2.0, 1.0im]
        # Cached
        @test get_coordinates!(Mc, cc, p, X, CB) == [2.0, 0.0, 0.0, 1.0]
        @test cc == [2.0, 0.0, 0.0, 1.0]
        @test get_coordinates!(Mc, c, p, X, CBc) == [2.0, 1.0im]
        @test c == [2.0, 1.0im]

    end

    @testset "FVector" begin
        @test sprint(show, TangentSpaceType()) == "TangentSpaceType()"
        @test sprint(show, CotangentSpaceType()) == "CotangentSpaceType()"
        tvs = ([1.0, 0.0, 0.0], [0.0, 1.0, 0.0])
        fv_tvs = map(v -> TFVector(v, DefaultOrthonormalBasis()), tvs)
        fv1 = fv_tvs[1]
        tv1s = allocate(fv_tvs[1])
        @test isa(tv1s, FVector)
        @test tv1s.type == TangentSpaceType()
        @test size(tv1s.data) == size(tvs[1])
        @test number_eltype(tv1s) == number_eltype(tvs[1])
        @test number_eltype(tv1s) == number_eltype(typeof(tv1s))
        @test isa(fv1 + fv1, FVector)
        @test (fv1 + fv1).type == TangentSpaceType()
        @test isa(fv1 - fv1, FVector)
        @test (fv1 - fv1).type == TangentSpaceType()
        @test isa(-fv1, FVector)
        @test (-fv1).type == TangentSpaceType()
        @test isa(2 * fv1, FVector)
        @test (2 * fv1).type == TangentSpaceType()
        tv1s_32 = allocate(fv_tvs[1], Float32)
        @test isa(tv1s, FVector)
        @test eltype(tv1s_32.data) === Float32
        copyto!(tv1s, fv_tvs[2])
        @test isapprox(tv1s.data, fv_tvs[2].data)

        @test sprint(show, fv1) == "TFVector([1.0, 0.0, 0.0], $(fv1.basis))"

        cofv1 = CoTFVector(tvs[1], DefaultOrthonormalBasis(ℝ, CotangentSpaceType()))
        @test cofv1 isa CoTFVector
        @test sprint(show, cofv1) == "CoTFVector([1.0, 0.0, 0.0], $(fv1.basis))"
    end

    @testset "vector_space_dimension" begin
        M = ManifoldsBase.DefaultManifold(3)
        MC = ManifoldsBase.DefaultManifold(3; field = ℂ)
        @test ManifoldsBase.vector_space_dimension(M, TangentSpaceType()) == 3
        @test ManifoldsBase.vector_space_dimension(M, CotangentSpaceType()) == 3
        @test ManifoldsBase.vector_space_dimension(MC, TangentSpaceType()) == 6
        @test ManifoldsBase.vector_space_dimension(MC, CotangentSpaceType()) == 6
    end

    @testset "requires_caching" begin
        @test ManifoldsBase.requires_caching(ProjectedOrthonormalBasis(:svd))
        @test !ManifoldsBase.requires_caching(DefaultBasis())
        @test !ManifoldsBase.requires_caching(DefaultOrthogonalBasis())
        @test !ManifoldsBase.requires_caching(DefaultOrthonormalBasis())
    end
end

@doc raw"""
    AbstractMetric

Abstract type for the pseudo-Riemannian metric tensor ``g``, a family of smoothly
varying inner products on the tangent space. See [`inner`](@ref).

# Functor

    (metric::Metric)(M::AbstractManifold)
    (metric::Metric)(M::MetricManifold)

Generate the `MetricManifold` that wraps the manifold `M` with given `metric`.
This works for both a variable containing the metric as well as a subtype `T<:AbstractMetric`,
where a zero parameter constructor `T()` is available.
If `M` is already a metric manifold, the inner manifold with the new `metric` is returned.
"""
abstract type AbstractMetric end

@doc raw"""
    RiemannianMetric <: AbstractMetric

Abstract type for Riemannian metrics, a family of positive definite inner
products. The positive definite property means that for ``X  ∈ T_p \mathcal M``, the
inner product ``g(X, X) > 0`` whenever ``X`` is not the zero vector.
"""
abstract type RiemannianMetric <: AbstractMetric end

"""
    EuclideanMetric <: RiemannianMetric

A general type for any manifold that employs the Euclidean Metric, for example
the [`Euclidean`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/euclidean.html) manifold itself, or the [`Sphere`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/sphere.html), where every
tangent space (as a plane in the embedding) uses this metric (in the embedding).

Since the metric is independent of the field type, this metric is also used for
the Hermitian metrics, i.e. metrics that are analogous to the `EuclideanMetric`
but where the field type of the manifold is `ℂ`.

This metric is the default metric for example for the [`Euclidean`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/euclidean.html) manifold.
"""
struct EuclideanMetric <: RiemannianMetric end


@doc raw"""
    change_metric(M::AbstractManifold, G2::AbstractMetric, p, X)

On the [`AbstractManifold`](@ref) `M` with implicitly given metric ``g_1``
and a second [`AbstractMetric`](@ref)
``g_2`` this function performs a change of metric in the
sense that it returns the tangent vector ``Z=BX`` such that the linear map ``B`` fulfills

```math
g_2(Y_1,Y_2) = g_1(BY_1,BY_2) \quad \text{for all } Y_1, Y_2 ∈ T_p\mathcal M.
```
"""
function change_metric(M::AbstractManifold, G::AbstractMetric, p, X)
    Y = allocate_result(M, change_metric, X, p) # this way we allocate a tangent
    return change_metric!(M, Y, G, p, X)
end

function change_metric! end

@doc raw"""
    change_metric!(M::AbstractManifold, Y, G2::AbstractMetric, p, X)

Compute the [`change_metric`](@ref) in place of `Y`.
"""
change_metric!(M::AbstractManifold, Y, G::AbstractMetric, p, X)

@doc raw"""
    change_representer(M::AbstractManifold, G2::AbstractMetric, p, X)

Convert the representer `X` of a linear function (in other words a cotangent vector at `p`)
in the tangent space at `p` on the [`AbstractManifold`](@ref) `M` given with respect to the
[`AbstractMetric`](@ref) `G2` into the representer with respect to the (implicit) metric of `M`.

In order to convert `X` into the representer with respect to the (implicitly given) metric ``g_1`` of `M`,
we have to find the conversion function ``c: T_p\mathcal M \to T_p\mathcal M`` such that

```math
    g_2(X,Y) = g_1(c(X),Y)
```
"""
function change_representer(M::AbstractManifold, G::AbstractMetric, p, X)
    Y = allocate_result(M, change_representer, X, p) # this way we allocate a tangent
    return change_representer!(M, Y, G, p, X)
end

function change_representer! end

@doc raw"""
    change_representer!(M::AbstractManifold, Y, G2::AbstractMetric, p, X)

Compute the [`change_metric`](@ref) in place of `Y`.
"""
change_representer!(M::AbstractManifold, Y, G::AbstractMetric, p, X)

# piping syntax for decoration
(metric::AbstractMetric)(M::AbstractManifold) = MetricManifold(M, metric)
(::Type{T})(M::AbstractManifold) where {T <: AbstractMetric} = MetricManifold(M, T())

"""
    DefaultMetric <: AbstractMetric

Indicating that a manifold uses the default metric, that one has implicitly assumed
when defining the manifold
"""
struct DefaultMetric <: AbstractMetric end
metric(::AbstractManifold) = DefaultMetric()

"""
    MetricManifold{𝔽,M<:AbstractManifold{𝔽},G<:AbstractMetric} <: AbstractDecoratorManifold{𝔽}

Equip a [`AbstractManifold`](@ref) explicitly with an
[`AbstractMetric`](@ref) `G`.

If the `AbstractMetric` `G` yields closed form formulae for the exponential map or another
function, you can implement it directly. Otherwise, you can use chart-based solvers, see
for example [`solve_chart_exp_ode`](@extref `Manifolds.solve_chart_exp_ode`).

# Constructor

    MetricManifold(M, G)

Generate the [`AbstractManifold`](@ref) `M` as a manifold with the `AbstractMetric` `G`.
"""
struct MetricManifold{𝔽, M <: AbstractManifold{𝔽}, G <: AbstractMetric} <:
    AbstractDecoratorManifold{𝔽}
    manifold::M
    metric::G
end

# remetricise instead of double-decorating
(metric::AbstractMetric)(M::MetricManifold) = MetricManifold(M.manifold, metric)
(::Type{T})(M::MetricManifold) where {T <: AbstractMetric} = MetricManifold(M.manifold, T())

function Base.convert(::Type{MetricManifold{𝔽, MT, GT}}, M::MT) where {𝔽, MT, GT}
    return _convert_with_default(M, GT, Val(is_default_metric(M, GT())))
end

function _convert_with_default(
        M::MT,
        T::Type{<:AbstractMetric},
        ::Val{true},
    ) where {MT <: AbstractManifold}
    return MetricManifold(M, T())
end
function _convert_with_default(
        M::MT,
        T::Type{<:AbstractMetric},
        ::Val{false},
    ) where {MT <: AbstractManifold}
    return error(
        "Can not convert $(M) to a MetricManifold{$(MT),$(T)}, since $(T) is not the default metric.",
    )
end

decorated_manifold(M::MetricManifold) = M.manifold

default_retraction_method(M::MetricManifold) = default_retraction_method(M.manifold)
function default_retraction_method(M::MetricManifold, t::Type)
    return default_retraction_method(M.manifold, t)
end
function default_inverse_retraction_method(M::MetricManifold)
    return default_inverse_retraction_method(M.manifold)
end
function default_inverse_retraction_method(M::MetricManifold, t::Type)
    return default_inverse_retraction_method(M.manifold, t)
end
function default_vector_transport_method(M::MetricManifold)
    return default_vector_transport_method(M.manifold)
end
function default_vector_transport_method(M::MetricManifold, t::Type)
    return default_vector_transport_method(M.manifold, t)
end

get_embedding(M::MetricManifold) = get_embedding(M.manifold)
get_embedding(M::MetricManifold, T::Type) = get_embedding(M.manifold, T)


function get_basis(M::MetricManifold, p, B::AbstractBasis)
    (metric(M.manifold) === M.metric) && (return get_basis(M.manifold, p, B))
    return invoke(get_basis, Tuple{AbstractManifold, Any, AbstractBasis}, M, p, B)
end

function get_coordinates(M::MetricManifold, p, X, B::AbstractBasis)
    (metric(M.manifold) === M.metric) && (return get_coordinates(M.manifold, p, X, B))
    return invoke(
        get_coordinates, Tuple{AbstractManifold, Any, Any, AbstractBasis},
        M, p, X, B,
    )
end
function get_coordinates!(M::MetricManifold, c, p, X, B::AbstractBasis)
    (metric(M.manifold) === M.metric) && (return get_coordinates!(M.manifold, c, p, X, B))
    return invoke(
        get_coordinates!, Tuple{AbstractManifold, Any, Any, Any, AbstractBasis},
        M, c, p, X, B,
    )
end

function get_forwarding_type(::MetricManifold, ::typeof(embed), P::Type)
    return SimpleForwardingType()
end
function get_forwarding_type(::MetricManifold, ::typeof(embed!), P::Type)
    return SimpleForwardingType()
end
function get_forwarding_type(::MetricManifold, ::typeof(rand))
    return SimpleForwardingType()
end
function get_forwarding_type(::MetricManifold, ::typeof(rand), P::Type)
    return SimpleForwardingType()
end
function get_forwarding_type(::MetricManifold, ::typeof(rand!), P::Type)
    return SimpleForwardingType()
end
function get_forwarding_type(M::MetricManifold, f::typeof(default_approximation_method))
    is_default_metric(M) && (return SimpleForwardingType())
    return invoke(get_forwarding_type, Tuple{AbstractManifold, typeof(f)}, M, f)
end

function get_vector(M::MetricManifold, p, c, B::AbstractBasis)
    (metric(M.manifold) === M.metric) && (return get_vector(M.manifold, p, c, B))
    return invoke(get_vector, Tuple{AbstractManifold, Any, Any, AbstractBasis}, M, p, c, B)
end
function get_vector!(M::MetricManifold, Y, p, c, B::AbstractBasis)
    (metric(M.manifold) === M.metric) && (return get_vector!(M.manifold, Y, p, c, B))
    return invoke(
        get_vector!,
        Tuple{AbstractManifold, Any, Any, Any, AbstractBasis},
        M, Y, p, c, B,
    )
end

function exp(M::MetricManifold, p, X)
    (metric(M.manifold) === M.metric) && (return exp(M.manifold, p, X))
    return invoke(exp, Tuple{AbstractManifold, Any, Any}, M, p, X)
end
function ManifoldsBase.exp_fused(M::MetricManifold, p, X, t::Number)
    (metric(M.manifold) === M.metric) && (return exp_fused(M.manifold, p, X, t))
    return invoke(exp_fused, Tuple{AbstractManifold, Any, Any, Number}, M, p, X, t)
end
function exp!(M::MetricManifold, q, p, X)
    (metric(M.manifold) === M.metric) && (return exp!(M.manifold, q, p, X))
    throw(MethodError(exp!, (M, q, p, X)))
end
function ManifoldsBase.exp_fused!(M::MetricManifold, q, p, X, t::Number)
    (metric(M.manifold) === M.metric) && (return exp_fused!(M.manifold, q, p, X, t))
    return invoke(exp_fused!, Tuple{AbstractManifold, Any, Any, Any, Number}, M, q, p, X, t)
end

injectivity_radius(M::MetricManifold) = injectivity_radius(M.manifold)
function injectivity_radius(M::MetricManifold, m::AbstractRetractionMethod)
    return injectivity_radius(M.manifold, m)
end

@doc raw"""
    inner(N::MetricManifold{M,G}, p, X, Y)

Compute the inner product of `X` and `Y` from the tangent space at `p` on the
[`AbstractManifold`](@ref) `M` using the [`AbstractMetric`](@ref) `G`.

````math
g_p(X, Y) = ⟨X, G_p Y⟩,
````
where ``G_p`` is the local matrix representation of the `AbstractMetric` `G`.
"""
inner(::MetricManifold, ::Any, ::Any, ::Any)

function inner(
        M::MetricManifold{𝔽, TM, G}, p, X, Y,
    ) where {𝔽, G <: AbstractMetric, TM <: AbstractManifold}
    (metric(M.manifold) === M.metric) && (return inner(M.manifold, p, X, Y))
    throw(MethodError(inner, (M, p, X, Y)))
end

# For the inverse retraction, we distinguish two cases: if we have the LogarithmicInverseRetraction
# we do not pass to the inner manifold, since this falls to log by default,
# otherwise we do pass to the inner manifold

@doc raw"""
    inverse_retract(M::MetricManifold, p, q)
    inverse_retract!(M::MetricManifold, X, p, q)

Compute the inverse retraction on the [`MetricManifold`](@ref) `M`.
Since every inverse retraction is an inverse retraction with respect to any logarithmic map (induced by the metric),
this method falls back to calling [`inverse_retract`](@ref) on the base manifold.
The two exceptions are the [`LogarithmicInverseRetraction`](@ref) and [`ShootingInverseRetraction`](@ref),
in which case the method falls back to the default, that is to calling, respectively, [`log(::AbstractManifold, ::Any, ::Any)`](@ref) and
`inverse_retract_shooting!`.
"""
inverse_retract(::MetricManifold, ::Any, ::Any)

function inverse_retract(M::MetricManifold, p, q, m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)))
    (metric(M.manifold) === M.metric) && (return inverse_retract(M.manifold, p, q, m))
    return invoke(inverse_retract, Tuple{AbstractManifold, Any, Any, AbstractInverseRetractionMethod}, M, p, q, m)
end

# note that if the default inverse retraction is the Logarithmic or the shooting one, this indeed still dispatches correctly to the next case
function inverse_retract!(M::MetricManifold, X, p, q, m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)))
    return inverse_retract!(M.manifold, X, p, q, m)
end
function inverse_retract!(M::MetricManifold, X, p, q, ::LogarithmicInverseRetraction)
    (metric(M.manifold) === M.metric) && (return log!(M.manifold, X, p, q))
    return log!(M, X, p, q)
end
function inverse_retract!(M::MetricManifold, X, p, q, m::ShootingInverseRetraction)
    (metric(M.manifold) == M.metric) && (return inverse_retract!(M.manifold, X, p, q, m))
    return inverse_retract_shooting!(M, X, p, q, m)
end

"""
    is_default_metric(M::AbstractManifold, G::AbstractMetric)

Return whether an [`AbstractMetric`](@ref)
is the default metric on the manifold `M` or not.

If `M` is a |`MetricManifold`](@ref) this indicates whether the metric now used is the same as the
default one on the wrapped manifold.
"""
is_default_metric(M::AbstractManifold, G::AbstractMetric)

is_default_metric(M::MetricManifold) = metric(M.manifold) === M.metric
is_default_metric(M::AbstractManifold, G::AbstractMetric) = metric(M) == G

function is_flat(M::MetricManifold{𝔽, TM, G}) where {𝔽, G <: AbstractMetric, TM <: AbstractManifold}
    is_default_metric(M) && (return is_flat(M.manifold))
    return invoke(is_flat, Tuple{AbstractManifold}, M)
end

is_point(M::MetricManifold, p; kwargs...) = is_point(M.manifold, p; kwargs...)

function is_vector(M::MetricManifold, p, X, cbp::Bool = true; kwargs...)
    return is_vector(M.manifold, p, X, cbp; kwargs...)
end

@doc raw"""
    log(N::MetricManifold{M,G}, p, q)

Compute the logarithmic map on the [`AbstractManifold`](@ref) `M` equipped with the
[`AbstractMetric`](@ref) `G`.

If the metric was declared the default metric, this method falls back to `log(M, p, q)`.
Otherwise, you have to provide an implementation for the non-default `AbstractMetric` `G`
metric within its [`MetricManifold`](@ref)`{M,G}`.
"""
log(::MetricManifold, ::Any...)

function log(M::MetricManifold, p, q)
    (metric(M.manifold) === M.metric) && (return log(M.manifold, p, q))
    return invoke(log, Tuple{AbstractManifold, Any, Any}, M, p, q)
end
function log!(M::MetricManifold, X, p, q)
    (metric(M.manifold) === M.metric) && (return log!(M.manifold, X, p, q))
    throw(MethodError(log!, (M, X, p, q)))
end

manifold_dimension(M::MetricManifold) = manifold_dimension(M.manifold)

@doc raw"""
    metric(M::MetricManifold)

Get the metric ``g`` of the [`AbstractManifold`](@ref)`(M)`.
"""
metric(::AbstractManifold)

function metric(M::MetricManifold)
    return M.metric
end
function parallel_transport_to(M::MetricManifold, p, X, q)
    (metric(M.manifold) === M.metric) && (return parallel_transport_to(M.manifold, p, X, q))
    return invoke(parallel_transport_to, Tuple{AbstractManifold, Any, Any, Any}, M, p, X, q)
end
function parallel_transport_to!(M::MetricManifold, Y, p, X, q)
    (metric(M.manifold) === M.metric) &&
        (return parallel_transport_to!(M.manifold, Y, p, X, q))
    throw(MethodError(parallel_transport_to!, (M, Y, p, X, q)))
end

function project(M::MetricManifold, p)
    (metric(M.manifold) === M.metric) && (return project(M.manifold, p))
    return invoke(project, Tuple{AbstractManifold, Any}, M, p)
end
function project!(M::MetricManifold, q, p)
    (metric(M.manifold) === M.metric) && (return project!(M.manifold, q, p))
    return project!(M.manifold, q, p)
end
function project(M::MetricManifold, p, X)
    (metric(M.manifold) === M.metric) && (return project(M.manifold, p, X))
    return invoke(project, Tuple{AbstractManifold, Any, Any}, M, p, X)
end
function project!(M::MetricManifold, Y, p, X)
    (metric(M.manifold) === M.metric) && (return project!(M.manifold, Y, p, X))
    return project!(M.manifold, Y, p, X)
end

representation_size(M::MetricManifold) = representation_size(M.manifold)

@doc raw"""
    retract(M::MetricManifold, p, X)
    retract!(M::MetricManifold, q, p, X)

Compute the retraction on the [`MetricManifold`](@ref) `M`.
Since every retraction is a retraction with respect to any exponential map (here induced by the metric),
this method falls back to calling [`retract`](@ref) on the inner manifold.
The one exception is the [`ExponentialRetraction`](@ref), in which case the method falls back to
the default, i.e. to calling [`exp(::AbstractManifold, ::Any, ::Any)`](@ref) but still on `M`.
"""
retract(::MetricManifold, ::Any, ::Any)

function retract(M::MetricManifold, p, X, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)); kwargs...)
    (metric(M.manifold) === M.metric) && (return retract(M.manifold, p, X, m; kwargs...))
    return invoke(retract, Tuple{AbstractManifold, Any, Any, AbstractRetractionMethod}, M, p, X, m; kwargs...)
end
function retract_fused(M::MetricManifold, p, X, t::Number, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)))
    (metric(M.manifold) === M.metric) && (return retract_fused(M.manifold, p, X, t, m))
    return invoke(retract_fused, Tuple{AbstractManifold, Any, Any, Number, AbstractRetractionMethod}, M, p, X, t, m)
end

# note that if the default retraction is the Exponential, this indeed still dispatches correctly to the next case
function retract!(M::MetricManifold, q, p, X, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)); kwargs...)
    return retract!(M.manifold, q, p, X, m; kwargs...)
end
function retract!(M::MetricManifold, q, p, X, ::ExponentialRetraction)
    (metric(M.manifold) === M.metric) && (return exp!(M.manifold, q, p, X))
    return exp!(M, q, p, X)
end
# note that if the default retraction is the Exponential, this indeed still dispatches correctly to the next case
function retract_fused!(M::MetricManifold, q, p, X, t::Number, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)))
    return retract_fused!(M.manifold, q, p, X, t, m)
end
function retract_fused!(M::MetricManifold, q, p, X, t::Number, ::ExponentialRetraction)
    (metric(M.manifold) === M.metric) && (return exp_fused!(M.manifold, q, p, X, t))
    return exp_fused!(M, q, p, X, t)
end

function Base.show(io::IO, M::MetricManifold)
    return print(io, "MetricManifold($(M.manifold), $(M.metric))")
end

@doc raw"""
    vector_transport_direction(M::MetricManifold, p, X, d)
    vector_transport_direction!(M::MetricManifold, Y, p, X, d)

Compute the vector transport of the tangent vector `X` at point `p` in the direction `d`
on the [`MetricManifold`](@ref) `M`.

Since a vector transport is usually defined with respect to a retraction, cf. e.g. [AbsilMahonySepulchre:2008](@cite),
and the vector transport is closely related to an affine connection, it is to some extent metric dependent.
Therefore, this method only falls back to calling its corresponding method on the base manifold, if the metric is the default one.
"""
vector_transport_direction(::MetricManifold, ::Any, ::Any, ::Any)

function vector_transport_direction(
        M::MetricManifold, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    (metric(M.manifold) === M.metric) && (return vector_transport_direction(M.manifold, p, X, d, m))
    return invoke(
        vector_transport_direction,
        Tuple{AbstractManifold, Any, Any, Any, AbstractVectorTransportMethod},
        M, p, X, d, m,
    )
end
function vector_transport_direction!(
        M::MetricManifold, Y, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    (metric(M.manifold) === M.metric) && (return vector_transport_direction!(M.manifold, Y, p, X, d, m))
    return invoke(
        vector_transport_direction!,
        Tuple{AbstractManifold, Any, Any, Any, Any, AbstractVectorTransportMethod},
        M, Y, p, X, d, m,
    )
end

@doc raw"""
    vector_transport_to(M::MetricManifold, p, X, d)
    vector_transport_to!(M::MetricManifold, Y, p, X, d)

Compute the vector transport of the tangent vector `X` at point `p` to a point `q` on the [`MetricManifold`](@ref) `M`.

Since a vector transport is usually defined with respect to a retraction, cf. e.g. [AbsilMahonySepulchre:2008](@cite),
and the vector transport is closely related to an affine connection, it is to some extent metric dependent.
Therefore, this method only falls back to calling its corresponding method on the base manifold, if the metric is the default one.
"""
vector_transport_to(::MetricManifold, ::Any, ::Any, ::Any)

function vector_transport_to(
        M::MetricManifold,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    (metric(M.manifold) === M.metric) && (return vector_transport_to(M.manifold, p, X, q, m))
    return invoke(
        vector_transport_to,
        Tuple{AbstractManifold, Any, Any, Any, AbstractVectorTransportMethod},
        M, p, X, q, m,
    )
end
function vector_transport_to!(
        M::MetricManifold, Y, p, X, q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    (metric(M.manifold) === M.metric) && (return vector_transport_to!(M.manifold, Y, p, X, q, m))
    return invoke(
        vector_transport_to!,
        Tuple{AbstractManifold, Any, Any, Any, Any, AbstractVectorTransportMethod},
        M, Y, p, X, q, m,
    )
end


function Weingarten(M::MetricManifold, p, X, V)
    (metric(M.manifold) === M.metric) && (return Weingarten(M.manifold, p, X, V))
    return invoke(Weingarten, Tuple{AbstractManifold, Any, Any, Any}, M, p, X, V)
end
function Weingarten!(M::MetricManifold, Y, p, X, V)
    (metric(M.manifold) === M.metric) && (return Weingarten!(M.manifold, Y, p, X, V))
    throw(MethodError(Weingarten!, (M, Y, p, X, V)))
end

zero_vector(M::MetricManifold, p) = zero_vector(M.manifold, p)
zero_vector!(M::MetricManifold, X, p) = zero_vector!(M.manifold, X, p)

is_metric_function(::Any) = false

for mf in [
        change_metric, change_metric!, change_representer, change_representer!,
        exp, exp!, exp_fused, exp_fused!,
        get_basis, get_coordinates, get_coordinates!, get_vector, get_vector!, get_vectors,
        inner, inverse_retract, inverse_retract!,
        log, log!, mid_point, norm,
        parallel_transport_direction, parallel_transport_direction!, parallel_transport_to, parallel_transport_to!,
        retract, retract!, retract_fused, retract_fused!,
        vector_transport_direction, vector_transport_direction!, vector_transport_to, vector_transport_to!,
        Weingarten, Weingarten!,
    ]
    @eval is_metric_function(::typeof($mf)) = true
end

"""
    AbstractManifoldDomainError <: Exception

An absytract Case for Errors when checking validity of points/vectors on mainfolds
"""
abstract type AbstractManifoldDomainError <: Exception end


@doc """
    ApproximatelyError{V,S} <: Exception

Store an error that occurs when two data structures, e.g. points or tangent vectors.

# Fields

* `val` amount the two approximate elements are apart – is set to `NaN` if this is not known
* `msg` a message providing more detail about the performed test and why it failed.

# Constructors

    ApproximatelyError(val::V, msg::S) where {V,S}

Generate an Error with value `val` and message `msg`.

    ApproximatelyError(msg::S) where {S}

Generate a message without a value (using `val=NaN` internally) and message `msg`.

"""
struct ApproximatelyError{V, S} <: Exception
    val::V
    msg::S
end
ApproximatelyError(msg::S) where {S} = ApproximatelyError{Float64, S}(NaN, msg)

function Base.show(io::IO, ex::ApproximatelyError)
    isnan(ex.val) && return print(io, "ApproximatelyError(\"$(ex.msg)\")")
    return print(io, "ApproximatelyError($(ex.val), \"$(ex.msg)\")")
end
function Base.showerror(io::IO, ex::ApproximatelyError)
    isnan(ex.val) && return print(io, "ApproximatelyError\n$(ex.msg)\n")
    return print(io, "ApproximatelyError with $(ex.val)\n$(ex.msg)\n")
end

@doc """
    ComponentError{I,E} <: Exception

Store an error that occurred in a component, where the additional `index` is stored.

# Fields

* `index::I` index where the error occurred`
* `error::E` error that occurred.
"""
struct ComponentManifoldError{I, E} <: AbstractManifoldDomainError where {I, E <: Exception}
    index::I
    error::E
end
function ComponentManifoldError(i::I, e::E) where {I, E <: Exception}
    return ComponentManifoldError{I, E}(i, e)
end

@doc """
    CompositeManifoldError{T} <: Exception

A composite type to collect a set of errors that occurred. Mainly used in conjunction
with [`ComponentManifoldError`](@ref) to store a set of errors that occurred.

# Fields
* `errors` a `Vector` of `<:Exceptions`.
"""
struct CompositeManifoldError{T} <: AbstractManifoldDomainError where {T <: Exception}
    errors::Vector{T}
end
CompositeManifoldError() = CompositeManifoldError{Exception}(Exception[])
function CompositeManifoldError(errors::Vector{T}) where {T <: Exception}
    return CompositeManifoldError{T}(errors)
end

isempty(c::CompositeManifoldError) = isempty(c.errors)
length(c::CompositeManifoldError) = length(c.errors)

function Base.show(io::IO, ex::ComponentManifoldError)
    return print(io, "ComponentManifoldError($(ex.index), $(ex.error))")
end
function Base.show(io::IO, ex::CompositeManifoldError)
    print(io, "CompositeManifoldError(")
    if !isempty(ex)
        print(io, "[")
        start = true
        for e in ex.errors
            show(io, e)
            print(io, ", ")
        end
        print(io, "]")
    end
    return print(io, ")")
end

function Base.showerror(io::IO, ex::ComponentManifoldError)
    print(io, "At #$(ex.index): ")
    return showerror(io, ex.error)
end

function Base.showerror(io::IO, ex::CompositeManifoldError)
    return if !isempty(ex)
        print(io, "CompositeManifoldError: ")
        showerror(io, ex.errors[1])
        remaining = length(ex) - 1
        if remaining > 0
            print(io, string("\n\n...and ", remaining, " more error(s).\n"))
        end
    else
        print(io, "CompositeManifoldError()\n")
    end
end

"""
    OutOfInjectivityRadiusError

An error thrown when a function (for example [`log`](@ref)arithmic map or
[`inverse_retract`](@ref)) is given arguments outside of its [`injectivity_radius`](@ref).
"""
struct OutOfInjectivityRadiusError <: Exception end

"""
    ManifoldDomainError{<:Exception} <: Exception

An error to represent a nested (Domain) error on a manifold, for example
if a point or tangent vector is invalid because its representation in some
embedding is already invalid.
"""
struct ManifoldDomainError{E} <: AbstractManifoldDomainError where {E <: Exception}
    outer_text::String
    error::E
end

function Base.showerror(io::IO, ex::ManifoldDomainError)
    print(io, "ManifoldDomainError: $(ex.outer_text)\n")
    return showerror(io, ex.error)
end

"""
    ManifoldsBaseTestUtils

A small module to collect common definitions and functions used in (several) tests of
`ManifoldsBase.jl`.

* A `TestSphere`
*
"""
module ManifoldsBaseTestUtils

using ManifoldsBase, LinearAlgebra, Random
using ManifoldsBase: ℝ, ℂ, AbstractManifold, DefaultManifold, EuclideanMetric
using ManifoldsBase: AbstractNumbers, RealNumbers, ComplexNumbers
using ManifoldsBase:
    @manifold_element_forwards, @manifold_vector_forwards, @default_manifold_fallbacks
import Base: +, *, -
#
#
# minimal implementation of the sphere – to test a few more involved Riemannian functions
struct TestSphere{N, 𝔽} <: AbstractDecoratorManifold{𝔽} end
TestSphere(N::Int, 𝔽 = ℝ) = TestSphere{N, 𝔽}()

function ManifoldsBase.change_metric!(
        M::TestSphere,
        Y,
        ::ManifoldsBase.EuclideanMetric,
        p,
        X,
    )
    return copyto!(M, Y, p, X)
end
function ManifoldsBase.change_representer!(
        M::TestSphere,
        Y,
        ::ManifoldsBase.EuclideanMetric,
        p,
        X,
    )
    return copyto!(M, Y, p, X)
end
function ManifoldsBase.check_point(M::TestSphere, p; kwargs...)
    if !isapprox(norm(p), 1.0; kwargs...)
        return DomainError(
            norm(p),
            "The point $(p) does not lie on the $(M) since its norm is not 1.",
        )
    end
    return nothing
end
function ManifoldsBase.check_vector(M::TestSphere, p, X; kwargs...)
    if !isapprox(abs(real(dot(p, X))), 0.0; kwargs...)
        return DomainError(
            abs(dot(p, X)),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not orthogonal in the embedding.",
        )
    end
    return nothing
end
function ManifoldsBase.exp!(M::TestSphere, q, p, X)
    return ManifoldsBase.exp_fused!(M, q, p, X, one(number_eltype(X)))
end
function ManifoldsBase.exp_fused!(::TestSphere, q, p, X, t::Number)
    θ = abs(t) * norm(X)
    if θ == 0
        copyto!(q, p)
    else
        X_scale = t * sin(θ) / θ
        q .= p .* cos(θ) .+ X .* X_scale
    end
    return q
end
function ManifoldsBase.get_basis_diagonalizing(
        M::TestSphere{n},
        p,
        B::DiagonalizingOrthonormalBasis{ℝ},
    ) where {n}
    A = zeros(n + 1, n + 1)
    A[1, :] = transpose(p)
    A[2, :] = transpose(B.frame_direction)
    V = nullspace(A)
    κ = ones(n)
    if !iszero(B.frame_direction)
        # if we have a nonzero direction for the geodesic, add it and it gets curvature zero from the tensor
        V = hcat(B.frame_direction / norm(M, p, B.frame_direction), V)
        κ[1] = 0 # no curvature along the geodesic direction, if x!=y
    end
    T = typeof(similar(B.frame_direction))
    Ξ = [convert(T, V[:, i]) for i in 1:n]
    return CachedBasis(B, κ, Ξ)
end
@inline function nzsign(z, absz = abs(z))
    psignz = z / absz
    return ifelse(iszero(absz), one(psignz), psignz)
end
function ManifoldsBase.get_coordinates_orthonormal!(M::TestSphere, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend, Xend = view(p, 2:(n + 1)), view(X, 2:(n + 1))
    factor = λ * X[1] / (1 + cosθ)
    Y .= Xend .- pend .* factor
    return Y
end
function ManifoldsBase.get_embedding(::TestSphere{n, 𝔽}) where {n, 𝔽}
    return DefaultManifold(n + 1; field = 𝔽)
end
function ManifoldsBase.get_vector_orthonormal!(M::TestSphere, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend = view(p, 2:(n + 1))
    pX = dot(pend, X)
    factor = pX / (1 + cosθ)
    Y[1] = -λ * pX
    Y[2:(n + 1)] .= X .- pend .* factor
    return Y
end
ManifoldsBase.injectivity_radius(::TestSphere) = π
ManifoldsBase.inner(::TestSphere, p, X, Y) = dot(X, Y)
function ManifoldsBase.inverse_retract_project!(M::TestSphere, X, p, q)
    X .= q .- p
    project!(M, X, p, X)
    return X
end
ManifoldsBase.is_flat(M::TestSphere) = manifold_dimension(M) == 1
function ManifoldsBase.log!(::TestSphere, X, p, q)
    cosθ = clamp(real(dot(p, q)), -1, 1)
    X .= q .- p .* cosθ
    nrmX = norm(X)
    if nrmX > 0
        X .*= acos(cosθ) / nrmX
    end
    return X
end
ManifoldsBase.manifold_dimension(::TestSphere{N}) where {N} = N
function ManifoldsBase.parallel_transport_to!(::TestSphere, Y, p, X, q)
    m = p .+ q
    mnorm2 = real(dot(m, m))
    factor = 2 * real(dot(X, q)) / mnorm2
    Y .= X .- m .* factor
    return Y
end
function ManifoldsBase.project!(::TestSphere, q, p)
    q .= p ./ norm(p)
    return q
end
function ManifoldsBase.project!(::TestSphere, Y, p, X)
    Y .= X .- p .* real(dot(p, X))
    return Y
end
function Random.rand!(M::TestSphere, pX; vector_at = nothing, σ = one(eltype(pX)))
    return rand!(Random.default_rng(), M, pX; vector_at = vector_at, σ = σ)
end
function Random.rand!(
        rng::AbstractRNG,
        M::TestSphere,
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if vector_at === nothing
        project!(M, pX, randn(rng, eltype(pX), representation_size(M)))
    else
        n = σ * randn(rng, eltype(pX), size(pX)) # Gaussian in embedding
        project!(M, pX, vector_at, n) #project to TpM (keeps Gaussianness)
    end
    return pX
end
ManifoldsBase.representation_size(::TestSphere{N}) where {N} = (N + 1,)
function ManifoldsBase.retract_project_fused!(M::TestSphere, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end
function ManifoldsBase.riemann_tensor!(M::TestSphere, Xresult, p, X, Y, Z)
    innerZX = inner(M, p, Z, X)
    innerZY = inner(M, p, Z, Y)
    Xresult .= innerZY .* X .- innerZX .* Y
    return Xresult
end
function ManifoldsBase.sectional_curvature_max(M::TestSphere)
    return ifelse(manifold_dimension(M) == 1, 0.0, 1.0)
end
function ManifoldsBase.sectional_curvature_min(M::TestSphere)
    return ifelse(manifold_dimension(M) == 1, 0.0, 1.0)
end

# from Absil, Mahony, Trumpf, 2013 https://sites.uclouvain.be/absil/2013-01/Weingarten_07PA_techrep.pdf
function ManifoldsBase.Weingarten!(::TestSphere, Y, p, X, V)
    return Y .= -X * p' * V
end

#
#
# minimal implementation of SPD (for its nontrivial metric conversion)
# ---
struct TestSPD <: AbstractManifold{ℝ}
    n::Int
end
function ManifoldsBase.change_metric!(::TestSPD, Y, ::EuclideanMetric, p, X)
    Y .= p * X
    return Y
end
function ManifoldsBase.change_representer!(::TestSPD, Y, ::EuclideanMetric, p, X)
    Y .= p * X * p
    return Y
end
function ManifoldsBase.inner(::TestSPD, p, X, Y)
    F = cholesky(Symmetric(convert(AbstractMatrix, p)))
    return dot((F \ Symmetric(X)), (Symmetric(Y) / F))
end
function spd_sqrt_and_sqrt_inv(p::AbstractMatrix)
    e = eigen(Symmetric(p))
    U = e.vectors
    S = max.(e.values, floatmin(eltype(e.values)))
    Ssqrt = Diagonal(sqrt.(S))
    SsqrtInv = Diagonal(1 ./ sqrt.(S))
    return (Symmetric(U * Ssqrt * transpose(U)), Symmetric(U * SsqrtInv * transpose(U)))
end
function ManifoldsBase.log!(::TestSPD, X, p, q)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * convert(AbstractMatrix, q) * p_sqrt_inv)
    e2 = eigen(T)
    Se = Diagonal(log.(max.(e2.values, eps())))
    pUe = p_sqrt * e2.vectors
    return mul!(X, pUe, Se * transpose(pUe))
end
ManifoldsBase.representation_size(M::TestSPD) = (M.n, M.n)

#
#
# A simple Manifold based on a projection onto a subspace
struct ProjManifold <: AbstractManifold{ℝ} end

ManifoldsBase.inner(::ProjManifold, p, X, Y) = dot(X, Y)
function ManifoldsBase.project(M::ProjManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
ManifoldsBase.project!(::ProjManifold, Y, p, X) = (Y .= X .- dot(p, X) .* p)
ManifoldsBase.representation_size(::ProjManifold) = (2, 3)
ManifoldsBase.manifold_dimension(::ProjManifold) = 5
ManifoldsBase.get_vector_orthonormal(::ProjManifold, p, X, N) = reverse(X)
#
#
# A second simple Manifold based on a projection onto a subspace
struct ProjectionTestManifold <: AbstractManifold{ℝ} end
ManifoldsBase.inner(::ProjectionTestManifold, ::Any, X, Y) = dot(X, Y)
function ManifoldsBase.project(M::ProjectionTestManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
function ManifoldsBase.project!(::ProjectionTestManifold, Y, p, X)
    Y .= X .- dot(p, X) .* p
    Y[end] = 0
    return Y
end
ManifoldsBase.manifold_dimension(::ProjectionTestManifold) = 100

#
# Thre Non-Things to check for the correct errors in case functions are not implemented
struct NonManifold <: AbstractManifold{ℝ} end
struct NonBasis <: ManifoldsBase.AbstractBasis{ℝ, TangentSpaceType} end
struct NonMPoint <: AbstractManifoldPoint end
struct NonTangentVector <: AbstractTangentVector end
struct NonCotangentVector <: AbstractCotangentVector end
struct NotImplementedRetraction <: AbstractRetractionMethod end
struct NotImplementedInverseRetraction <: AbstractInverseRetractionMethod end
*(t::Float64, X::NonTangentVector) = X

struct NonBroadcastBasisThing{T}
    v::T
end
+(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing) = NonBroadcastBasisThing(a.v + b.v)
*(α, a::NonBroadcastBasisThing) = NonBroadcastBasisThing(α * a.v)
-(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing) = NonBroadcastBasisThing(a.v - b.v)

function ManifoldsBase.isapprox(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing)
    return isapprox(a.v, b.v)
end

function ManifoldsBase.number_eltype(a::NonBroadcastBasisThing)
    return typeof(reduce(+, one(number_eltype(eti)) for eti in a.v))
end

function ManifoldsBase.allocate_on(
        M::AbstractManifold,
        ::TangentSpaceType,
        T::Type{<:NonBroadcastBasisThing},
    )
    return NonBroadcastBasisThing(similar(T.parameters[1], representation_size(M)))
end

ManifoldsBase.allocate(a::NonBroadcastBasisThing) = NonBroadcastBasisThing(allocate(a.v))
function ManifoldsBase.allocate(a::NonBroadcastBasisThing, ::Type{T}) where {T}
    return NonBroadcastBasisThing(allocate(a.v, T))
end
function ManifoldsBase.allocate(::NonBroadcastBasisThing, ::Type{T}, s::Integer) where {T}
    return Vector{T}(undef, s)
end

function Base.copyto!(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing)
    copyto!(a.v, b.v)
    return a
end


function ManifoldsBase.log!(
        ::DefaultManifold,
        X::NonBroadcastBasisThing,
        p::NonBroadcastBasisThing,
        q::NonBroadcastBasisThing,
    )
    return copyto!(X, q - p)
end

function ManifoldsBase.exp!(
        ::DefaultManifold,
        q::NonBroadcastBasisThing,
        p::NonBroadcastBasisThing,
        X::NonBroadcastBasisThing,
    )
    return copyto!(q, p + X)
end

function ManifoldsBase.get_basis_orthonormal(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        𝔽::RealNumbers,
    )
    return CachedBasis(
        DefaultOrthonormalBasis(𝔽),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end
function ManifoldsBase.get_basis_orthogonal(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        𝔽::RealNumbers,
    )
    return CachedBasis(
        DefaultOrthogonalBasis(𝔽),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end
function ManifoldsBase.get_basis_default(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        N::ManifoldsBase.RealNumbers,
    )
    return CachedBasis(
        DefaultBasis(N),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end

function ManifoldsBase.get_coordinates_orthonormal!(
        M::DefaultManifold,
        Y,
        ::NonBroadcastBasisThing,
        X::NonBroadcastBasisThing,
        ::RealNumbers,
    )
    copyto!(Y, reshape(X.v, manifold_dimension(M)))
    return Y
end

function ManifoldsBase.get_vector_orthonormal!(
        M::DefaultManifold,
        Y::NonBroadcastBasisThing,
        ::NonBroadcastBasisThing,
        X,
        ::RealNumbers,
    )
    copyto!(Y.v, reshape(X, representation_size(M)))
    return Y
end

function ManifoldsBase.inner(
        ::DefaultManifold,
        ::NonBroadcastBasisThing,
        X::NonBroadcastBasisThing,
        Y::NonBroadcastBasisThing,
    )
    return dot(X.v, Y.v)
end

ManifoldsBase._get_vector_cache_broadcast(::NonBroadcastBasisThing) = Val(false)

DiagonalizingBasisProxy() = DiagonalizingOrthonormalBasis([1.0, 0.0, 0.0])

#
#
# Vector Space types
struct TestVectorSpaceType <: ManifoldsBase.VectorSpaceType end

struct TestFiberType <: ManifoldsBase.FiberType end

function ManifoldsBase.fiber_dimension(M::AbstractManifold, ::TestFiberType)
    return 2 * manifold_dimension(M)
end

function ManifoldsBase.vector_space_dimension(M::AbstractManifold, ::TestVectorSpaceType)
    return 2 * manifold_dimension(M)
end

#
#
# DefaultManifold with a few artificiual retrations

struct CustomDefinedRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomUndefinedRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomDefinedKeywordRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomDefinedKeywordInverseRetraction <:
    ManifoldsBase.AbstractInverseRetractionMethod end
struct CustomDefinedInverseRetraction <: ManifoldsBase.AbstractInverseRetractionMethod end

struct DefaultPoint{T} <: AbstractManifoldPoint
    value::T
end
Base.convert(::Type{DefaultPoint{T}}, v::T) where {T} = DefaultPoint(v)
Base.eltype(p::DefaultPoint) = eltype(p.value)
Base.length(p::DefaultPoint) = length(p.value)
struct DefaultTangentVector{T} <: AbstractTangentVector
    value::T
end
function Base.convert(::Type{DefaultTangentVector{T}}, ::DefaultPoint, v::T) where {T}
    return DefaultTangentVector(v)
end
Base.eltype(X::DefaultTangentVector) = eltype(X.value)
function Base.fill!(X::DefaultTangentVector, x)
    fill!(X.value, x)
    return X
end
function ManifoldsBase.allocate_result_type(
        ::DefaultManifold,
        ::typeof(log),
        ::Tuple{DefaultPoint, DefaultPoint},
    )
    return DefaultTangentVector
end
function ManifoldsBase.allocate_result_type(
        ::DefaultManifold,
        ::typeof(inverse_retract),
        ::Tuple{DefaultPoint, DefaultPoint},
    )
    return DefaultTangentVector
end

function ManifoldsBase.tangent_vector_type(::DefaultManifold, ::Type{DefaultPoint})
    return DefaultTangentVector
end

ManifoldsBase.@manifold_element_forwards DefaultPoint value
ManifoldsBase.@manifold_vector_forwards DefaultTangentVector value
ManifoldsBase.@default_manifold_fallbacks ManifoldsBase.DefaultManifold DefaultPoint DefaultTangentVector value value

function ManifoldsBase._injectivity_radius(::DefaultManifold, ::CustomDefinedRetraction)
    return 10.0
end
function ManifoldsBase._retract!(
        M::DefaultManifold,
        q,
        p,
        X,
        ::CustomDefinedKeywordRetraction;
        kwargs...,
    )
    return retract_custom_kw!(M, q, p, X; kwargs...)
end
function ManifoldsBase._retract_fused!(
        M::DefaultManifold,
        q,
        p,
        X,
        t::Number,
        ::CustomDefinedKeywordRetraction;
        kwargs...,
    )
    return retract_custom_kw_fused!(M, q, p, X, t; kwargs...)
end
function retract_custom_kw_fused!(
        ::DefaultManifold,
        q::DefaultPoint,
        p::DefaultPoint,
        X::DefaultTangentVector,
        t::Number;
        scale = 2.0,
    )
    q.value .= scale .* p.value .+ t .* X.value
    return q
end
function retract_custom_kw!(
        ::DefaultManifold,
        q::DefaultPoint,
        p::DefaultPoint,
        X::DefaultTangentVector;
        scale = 2.0,
    )
    q.value .= scale .* p.value .+ X.value
    return q
end
function ManifoldsBase._inverse_retract!(
        M::DefaultManifold,
        X,
        p,
        q,
        ::CustomDefinedKeywordInverseRetraction;
        kwargs...,
    )
    return inverse_retract_custom_kw!(M, X, p, q; kwargs...)
end
function inverse_retract_custom_kw!(
        ::DefaultManifold,
        X::DefaultTangentVector,
        p::DefaultPoint,
        q::DefaultPoint;
        scale = 2.0,
    )
    X.value .= q.value - scale * p.value
    return X
end

#
# Test on layer 2 (omiting a layer 3, since we fully qualify all types here already)
function ManifoldsBase._retract!(
        ::DefaultManifold,
        q::DefaultPoint,
        p::DefaultPoint,
        X::DefaultTangentVector,
        ::CustomDefinedRetraction,
    )
    q.value .= 2 .* p.value .+ X.value
    return q
end
function ManifoldsBase._retract_fused!(
        ::DefaultManifold,
        q::DefaultPoint,
        p::DefaultPoint,
        X::DefaultTangentVector,
        t::Number,
        ::CustomDefinedRetraction,
    )
    q.value .= 2 .* p.value .+ t * X.value
    return q
end

function ManifoldsBase._inverse_retract!(
        ::DefaultManifold,
        X::DefaultTangentVector,
        p::DefaultPoint,
        q::DefaultPoint,
        ::CustomDefinedInverseRetraction,
    )
    X.value .= q.value .- 2 .* p.value
    return X
end

struct MatrixVectorTransport{T} <: AbstractVector{T}
    m::Matrix{T}
end
# dummy retractions, inverse retracions for fallback tests - mutating should be enough
function ManifoldsBase.retract_approx!(::DefaultManifold, q, p, X, m::ApproximateExponentialRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_approx_fused!(::DefaultManifold, q, p, X, t::Number, m::ApproximateExponentialRetraction)
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_polar!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_polar_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_project!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_project_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
ManifoldsBase.retract_qr!(::DefaultManifold, q, p, X) = (q .= p .+ X)
ManifoldsBase.retract_qr_fused!(::DefaultManifold, q, p, X, t::Number) = (q .= p .+ t .* X)

function ManifoldsBase.retract_pade!(::DefaultManifold, q, p, X, m::PadeRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_pade_fused!(
        ::DefaultManifold, q, p, X, t::Number, m::PadeRetraction,
    )
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_sasaki!(::DefaultManifold, q, p, X, m::SasakiRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_sasaki_fused!(
        ::DefaultManifold, q, p, X, t::Number, ::SasakiRetraction,
    )
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_softmax!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_softmax_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
ManifoldsBase.inverse_retract_approx!(::DefaultManifold, Y, p, q, m::ApproximateLogarithmicInverseRetraction) = (Y .= q .- p)
ManifoldsBase.inverse_retract_polar!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_project!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_qr!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_softmax!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
function ManifoldsBase.inverse_retract_nlsolve!(
        ::DefaultManifold,
        Y,
        p,
        q,
        m::NLSolveInverseRetraction,
    )
    return (Y .= q .- p)
end
Base.getindex(x::MatrixVectorTransport, i) = x.m[:, i]
Base.size(x::MatrixVectorTransport) = (size(x.m, 2),)

struct TestArrayRepresentation <: AbstractPowerRepresentation end

const TestPowerManifoldMultidimensional =
    AbstractPowerManifold{𝔽, <:AbstractManifold{𝔽}, TestArrayRepresentation} where {𝔽}

export CustomDefinedInverseRetraction, CustomDefinedKeywordInverseRetraction
export CustomDefinedKeywordRetraction, CustomDefinedRetraction, CustomUndefinedRetraction
export DefaultPoint, DefaultTangentVector
export DiagonalizingBasisProxy
export MatrixVectorTransport
export NonManifold, NonBasis, NonBroadcastBasisThing
export NonMPoint, NonTangentVector, NonCotangentVector
export NotImplementedRetraction, NotImplementedInverseRetraction
export ProjManifold, ProjectionTestManifold
export TestSphere, TestSPD
export TestVectorSpaceType, TestFiberType
end

"""
    AbstractPowerRepresentation

An abstract representation type of points and tangent vectors on a power manifold.
"""
abstract type AbstractPowerRepresentation end

"""
    NestedPowerRepresentation

Representation of points and tangent vectors on a power manifold using arrays
of size equal to `TSize` of a [`PowerManifold`](@ref).
Each element of such array stores a single point or tangent vector.

For modifying operations, each element of the outer array is modified in-place, differently
than in [`NestedReplacingPowerRepresentation`](@ref).
"""
struct NestedPowerRepresentation <: AbstractPowerRepresentation end

"""
    NestedReplacingPowerRepresentation

Representation of points and tangent vectors on a power manifold using arrays
of size equal to `TSize` of a [`PowerManifold`](@ref).
Each element of such array stores a single point or tangent vector.

For modifying operations, each element of the outer array is replaced using non-modifying
operations, differently than for [`NestedReplacingPowerRepresentation`](@ref).
"""
struct NestedReplacingPowerRepresentation <: AbstractPowerRepresentation end

@doc raw"""
    AbstractPowerManifold{𝔽,M,TPR} <: AbstractManifold{𝔽}

An abstract [`AbstractManifold`](@ref) to represent manifolds that are build as powers
of another [`AbstractManifold`](@ref) `M` with representation type `TPR`, a subtype of
[`AbstractPowerRepresentation`](@ref).
"""
abstract type AbstractPowerManifold{
    𝔽,
    M <: AbstractManifold{𝔽},
    TPR <: AbstractPowerRepresentation,
} <: AbstractManifold{𝔽} end

@doc raw"""
    PowerManifold{𝔽,TM<:AbstractManifold,TSize,TPR<:AbstractPowerRepresentation} <: AbstractPowerManifold{𝔽,TM}

The power manifold ``\mathcal M^{n_1× n_2 × … × n_d}`` with power geometry.
 `TSize` defines the number of elements along each axis, either statically using
 `TypeParameter` or storing it in a field.

For example, a manifold-valued time series would be represented by a power manifold with
``d`` equal to 1 and ``n_1`` equal to the number of samples. A manifold-valued image
(for example in diffusion tensor imaging) would be represented by a two-axis power
manifold (``d=2``) with ``n_1`` and ``n_2`` equal to width and height of the image.

While the size of the manifold is static, points on the power manifold
would not be represented by statically-sized arrays.

# Constructor

    PowerManifold(M::PowerManifold, N_1, N_2, ..., N_d; parameter::Symbol=:field)
    PowerManifold(M::AbstractManifold, NestedPowerRepresentation(), N_1, N_2, ..., N_d; parameter::Symbol=:field)
    M^(N_1, N_2, ..., N_d)

Generate the power manifold ``M^{N_1 × N_2 × … × N_d}``.
By default, a [`PowerManifold`](@ref) is expanded further, i.e. for `M=PowerManifold(N, 3)`
`PowerManifold(M, 2)` is equivalent to `PowerManifold(N, 3, 2)`. Points are then 3×2 matrices
of points on `N`.
Providing a [`NestedPowerRepresentation`](@ref) as the second argument to the constructor
can be used to nest manifold, i.e. `PowerManifold(M, NestedPowerRepresentation(), 2)`
represents vectors of length 2 whose elements are vectors of length 3 of points on N
in a nested array representation.

The third signature `M^(...)` is equivalent to the first one, and hence either yields
a combination of power manifolds to _one_ larger power manifold, or a power manifold with the default representation.

Since there is no default [`AbstractPowerRepresentation`](@ref) within this interface, the
`^` operator is only available for `PowerManifold`s and concatenates dimensions.

`parameter`: whether a type parameter should be used to store `n`. By default size
is stored in a field. Value can either be `:field` or `:type`.
"""
struct PowerManifold{𝔽, TM <: AbstractManifold{𝔽}, TSize, TPR <: AbstractPowerRepresentation} <:
    AbstractPowerManifold{𝔽, TM, TPR}
    manifold::TM
    size::TSize
end

"""
    _parameter_symbol(M::PowerManifold)

Return `:field` if size of [`PowerManifold`](@ref) `M` is stored in a field and `:type`
if in a `TypeParameter`.
"""
_parameter_symbol(::PowerManifold) = :field
function _parameter_symbol(
        ::PowerManifold{𝔽, <:AbstractManifold{𝔽}, <:TypeParameter},
    ) where {𝔽}
    return :type
end

@aggressive_constprop function PowerManifold(
        M::AbstractManifold{𝔽}, ::TPR, size::Integer...;
        parameter::Symbol = :field,
    ) where {𝔽, TPR <: AbstractPowerRepresentation}
    size_w = wrap_type_parameter(parameter, size)
    return PowerManifold{𝔽, typeof(M), typeof(size_w), TPR}(M, size_w)
end
@aggressive_constprop function PowerManifold(
        M::PowerManifold{𝔽, TM, TSize, TPR}, size::Integer...;
        parameter::Symbol = _parameter_symbol(M),
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize, TPR <: AbstractPowerRepresentation}
    size_w = wrap_type_parameter(parameter, (get_parameter(M.size)..., size...))
    return PowerManifold{𝔽, TM, typeof(size_w), TPR}(M.manifold, size_w)
end
@aggressive_constprop function PowerManifold(
        M::PowerManifold{𝔽, TM}, ::TPR, size::Integer...;
        parameter::Symbol = _parameter_symbol(M),
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TPR <: AbstractPowerRepresentation}
    size_w = wrap_type_parameter(parameter, (get_parameter(M.size)..., size...))
    return PowerManifold{𝔽, TM, typeof(size_w), TPR}(M.manifold, size_w)
end
function PowerManifold(
        M::PowerManifold{𝔽}, ::TPR, size::Integer...;
        parameter::Symbol = _parameter_symbol(M),
    ) where {𝔽, TPR <: Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation}}
    size_w = wrap_type_parameter(parameter, size)
    return PowerManifold{𝔽, typeof(M), typeof(size_w), TPR}(M, size_w)
end

"""
    PowerBasisData{TB<:AbstractArray}

Data storage for an array of basis data.
"""
struct PowerBasisData{TB <: AbstractArray}
    bases::TB
end

const PowerManifoldNested =
    AbstractPowerManifold{𝔽, <:AbstractManifold{𝔽}, NestedPowerRepresentation} where {𝔽}

const PowerManifoldNestedReplacing = AbstractPowerManifold{
    𝔽,
    <:AbstractManifold{𝔽},
    NestedReplacingPowerRepresentation,
} where {𝔽}

# _access_nested(::AbstractManifold, x, i::Tuple) can be overloaded to achieve
# manifold-specific nested element access (for example to `Identity` on power manifolds).
@inline _access_nested(M::AbstractManifold, x, i::Int) = _access_nested(M, x, (i,))
@inline _access_nested(::AbstractManifold, x, i::Tuple) = _access_nested(x, i)
@inline _access_nested(x, i::Tuple) = x[i...]

function Base.:^(
        M::PowerManifold{
            𝔽, TM, TSize, <:Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation},
        }, size::Integer...,
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize}
    return PowerManifold(M, size...)
end

function allocate_on(
        M::PowerManifold{
            𝔽, TM, TSize, <:Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation},
        },
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize}
    return [allocate_on(M.manifold) for _ in get_iterator(M)]
end
function allocate_on(
        M::PowerManifold{
            𝔽, TM, TSize, <:Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation},
        },
        ::Type{<:Array{U}},
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize, U}
    return [allocate_on(M.manifold, U) for _ in get_iterator(M)]
end

function allocate_on(
        M::PowerManifold{
            𝔽, TM, TSize, <:Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation},
        },
        ft::TangentSpaceType,
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize}
    return [allocate_on(M.manifold, ft) for _ in get_iterator(M)]
end
function allocate_on(
        M::PowerManifold{
            𝔽, TM, TSize, <:Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation},
        },
        ft::TangentSpaceType,
        ::Type{<:Array{U}},
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize, U}
    return [allocate_on(M.manifold, ft, U) for _ in get_iterator(M)]
end

"""
    _allocate_access_nested(M::PowerManifoldNested, y, i)

Helper function for `allocate_result` on `PowerManifoldNested`. In allocation `y` can be
a number in which case `_access_nested` wouldn't work.
"""
_allocate_access_nested(M::PowerManifoldNested, y, i) = _access_nested(M, y, i)
_allocate_access_nested(::PowerManifoldNested, y::Number, i) = y

function allocate_result(M::PowerManifoldNested, f, x...)
    if representation_size(M.manifold) === () && length(x) > 0
        return allocate(M, x[1])
    else
        return [
            allocate_result(
                    M.manifold, f, map(y -> _allocate_access_nested(M, y, i), x)...,
                ) for i in get_iterator(M)
        ]
    end
end

function allocate_result_embedding(M::PowerManifoldNested, f::typeof(project), x...)
    if representation_size(M.manifold) === () && length(x) > 0
        return allocate(M, x[1])
    else
        return [
            allocate_result_embedding(
                    M.manifold,
                    f,
                    map(y -> _allocate_access_nested(M, y, i), x)...,
                ) for i in get_iterator(M)
        ]
    end
end
# avoid ambiguities - though usually not used
function allocate_result(
        M::PowerManifoldNested, f::typeof(get_coordinates), p, X, B::AbstractBasis,
    )
    return invoke(
        allocate_result,
        Tuple{AbstractManifold, typeof(get_coordinates), Any, Any, AbstractBasis},
        M, f, p, X, B,
    )
end
function allocate_result(M::PowerManifoldNestedReplacing, f, x...)
    if length(x) == 0
        return [allocate_result(M.manifold, f) for _ in get_iterator(M)]
    else
        return copy(x[1])
    end
end
function allocate_result_embedding(
        ::PowerManifoldNestedReplacing,
        ::typeof(project),
        x,
        args...
    )
    return copy(x)
end
# the following is not used but necessary to avoid ambiguities
function allocate_result(
        M::PowerManifoldNestedReplacing, f::typeof(get_coordinates), p, X, B::AbstractBasis,
    )
    return invoke(
        allocate_result,
        Tuple{AbstractManifold, typeof(get_coordinates), Any, Any, AbstractBasis},
        M, f, p, X, B,
    )
end
function allocate_result(M::PowerManifoldNested, f::typeof(get_vector), p, X)
    return [
        allocate_result(M.manifold, f, _access_nested(M, p, i)) for i in get_iterator(M)
    ]
end
function allocate_result(::PowerManifoldNestedReplacing, ::typeof(get_vector), p, X)
    return copy(p)
end
function allocation_promotion_function(M::AbstractPowerManifold, f, args::Tuple)
    return allocation_promotion_function(M.manifold, f, args)
end

"""
    change_representer(M::AbstractPowerManifold, ::AbstractMetric, p, X)

Since the metric on a power manifold decouples, the change of a representer can be done elementwise
"""
change_representer(::AbstractPowerManifold, ::AbstractMetric, ::Any, ::Any)

function change_representer!(M::AbstractPowerManifold, Y, G::AbstractMetric, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        change_representer!(
            M.manifold, _write(M, rep_size, Y, i), G, _read(M, rep_size, p, i), _read(M, rep_size, X, i),
        )
    end
    return Y
end

"""
    change_metric(M::AbstractPowerManifold, ::AbstractMetric, p, X)

Since the metric on a power manifold decouples, the change of metric can be done elementwise.
"""
change_metric(M::AbstractPowerManifold, ::AbstractMetric, ::Any, ::Any)

function change_metric!(M::AbstractPowerManifold, Y, G::AbstractMetric, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        change_metric!(
            M.manifold, _write(M, rep_size, Y, i), G, _read(M, rep_size, p, i), _read(M, rep_size, X, i),
        )
    end
    return Y
end

"""
    check_point(M::AbstractPowerManifold, p; kwargs...)

Check whether `p` is a valid point on an [`AbstractPowerManifold`](@ref) `M`,
i.e. each element of `p` has to be a valid point on the base manifold.
If `p` is not a point on `M` a [`CompositeManifoldError`](@ref) consisting of all error messages of the
components, for which the tests fail is returned.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(M::AbstractPowerManifold, p; kwargs...)
    rep_size = representation_size(M.manifold)
    e = [
        (i, check_point(M.manifold, _read(M, rep_size, p, i); kwargs...)) for
            i in get_iterator(M)
    ]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

"""
    check_power_size(M, p)
    check_power_size(M, p, X)

Check whether `p`` has the right size to represent points on `M`` generically, i.e. just
checking the overall sizes, not the individual ones per manifold.
"""
function check_power_size(M::AbstractPowerManifold, p)
    d = prod(representation_size(M.manifold)) * prod(power_dimensions(M))
    (d != length(p)) && return DomainError(
        length(p),
        "The point $p can not be a point on $M, since its number of elements does not match the required overall representation size ($d)",
    )
    return nothing
end
function check_power_size(M::Union{PowerManifoldNested, PowerManifoldNestedReplacing}, p)
    d = prod(power_dimensions(M))
    (d != length(p)) && return DomainError(
        length(p),
        "The point $p can not be a point on $M, since its number of elements does not match the power dimensions ($d)",
    )
    return nothing
end

function check_power_size(M::AbstractPowerManifold, p, X)
    d = prod(representation_size(M.manifold)) * prod(power_dimensions(M))
    (d != length(X)) && return DomainError(
        length(X),
        "The tangent vector $X can not belong to a trangent space at on $M, since its number of elements does not match the required overall representation size ($d)",
    )
    return nothing
end
function check_power_size(M::Union{PowerManifoldNested, PowerManifoldNestedReplacing}, p, X)
    d = prod(power_dimensions(M))
    (d != length(X)) && return DomainError(
        length(X),
        "The point $p can not be a point on $M, since its number of elements does not match the power dimensions ($d)",
    )
    return nothing
end

function check_size(M::AbstractPowerManifold, p)
    cps = check_power_size(M, p)
    (cps === nothing) || return cps
    rep_size = representation_size(M.manifold)
    e = [(i, check_size(M.manifold, _read(M, rep_size, p, i))) for i in get_iterator(M)]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

function check_size(M::AbstractPowerManifold, p, X)
    cps = check_power_size(M, p, X)
    (cps === nothing) || return cps
    rep_size = representation_size(M.manifold)
    e = [
        (i, check_size(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i))) for i in get_iterator(M)
    ]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

"""
    check_vector(M::AbstractPowerManifold, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` an the [`AbstractPowerManifold`](@ref)
`M`, i.e. after [`check_point`](@ref)`(M, p)`, and all projections to
base manifolds must be respective tangent vectors.
If `X` is not a tangent vector to `p` on `M` a [`CompositeManifoldError`](@ref) consisting of all error
messages of the components, for which the tests fail is returned.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(M::AbstractPowerManifold, p, X; kwargs...)
    rep_size = representation_size(M.manifold)
    e = [
        (
                i, check_vector(
                    M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i);
                    kwargs...,
                ),
            ) for i in get_iterator(M)
    ]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

@doc raw"""
    copyto!(M::PowerManifoldNested, q, p)

Copy the values elementwise, i.e. call `copyto!(M.manifold, b, a)` for all elements `a` and
`b` of `p` and `q`, respectively.
"""
function copyto!(M::PowerManifoldNested, q, p)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        copyto!(M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p, i))
    end
    return q
end

@doc raw"""
    copyto!(M::PowerManifoldNested, Y, p, X)

Copy the values elementwise, i.e. call `copyto!(M.manifold, B, a, A)` for all elements
`A`, `a` and `B` of `X`, `p`, and `Y`, respectively.
"""
function copyto!(M::PowerManifoldNested, Y, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        copyto!(
            M.manifold, _write(M, rep_size, Y, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i),
        )
    end
    return Y
end

@doc raw"""
    default_retraction_method(M::PowerManifold)

Use the default retraction method of the internal `M.manifold` also in defaults of
functions defined for the power manifold, meaning that this is used elementwise.
"""
function default_retraction_method(M::PowerManifold)
    return default_retraction_method(M.manifold)
end
function default_retraction_method(M::PowerManifold, t::Type)
    return default_retraction_method(M.manifold, eltype(t))
end

@doc raw"""
    default_inverse_retraction_method(M::PowerManifold)

Use the default inverse retraction method of the internal `M.manifold` also in defaults of
functions defined for the power manifold, meaning that this is used elementwise.
"""
function default_inverse_retraction_method(M::PowerManifold)
    return default_inverse_retraction_method(M.manifold)
end
function default_inverse_retraction_method(M::PowerManifold, t::Type)
    return default_inverse_retraction_method(M.manifold, eltype(t))
end

@doc raw"""
    default_vector_transport_method(M::PowerManifold)

Use the default vector transport method of the internal `M.manifold` also in defaults of
functions defined for the power manifold, meaning that this is used elementwise.
"""
function default_vector_transport_method(M::PowerManifold)
    return default_vector_transport_method(M.manifold)
end
function default_vector_transport_method(M::PowerManifold, t::Type)
    return default_vector_transport_method(M.manifold, eltype(t))
end

_doc_distance_pow = """
    distance(M::AbstractPowerManifold, p, q, r::Real=2)
    distance(M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod=LogarithmicInverseRetraction(), r::Real=2)

Compute the distance between `q` and `p` on an [`AbstractPowerManifold`](@ref).

First, the componentwise distances are computed using the Riemannian distance function
on `M.manifold`. These can be approximated using the
`norm` of an [`AbstractInverseRetractionMethod`](@ref) `m`.
This yields an array of distance values.

Second, we compute the `r`-norm on this array of distances.
This is also the only place, there the `r` is used.
"""

function distance(M::AbstractPowerManifold, p, q)
    return _distance_r(M, p, q, 2)
end

@doc "$(_doc_distance_pow)"
function distance(M::AbstractPowerManifold, p, q, r::Real)
    (isinf(r) && r > 0) && return _distance_max(M, p, q)
    (isinf(r) && r < 0) && return _distance_min(M, p, q)
    (r == 1) && return _distance_1(M, p, q)
    return _distance_r(M, p, q, r)
end
function distance(
        M::AbstractPowerManifold, p, q, ::LogarithmicInverseRetraction, r::Real = 2,
    )
    return distance(M, p, q, r)
end

@doc "$(_doc_distance_pow)"
function distance(
        M::AbstractPowerManifold,
        p, q, m::AbstractInverseRetractionMethod, r::Real = 2,
    )
    (isinf(r) && r > 0) && return _distance_max(M, p, q, m)
    (isinf(r) && r < 0) && return _distance_min(M, p, q, m)
    (r == 1) && return _distance_1(M, p, q, m)
    return _distance_r(M, p, q, m, r)
end
#
#
# The three special cases
function _distance_r(
        M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod, r::Real,
    )
    rep_size = representation_size(M.manifold)
    values = [
        distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i), m) for
            i in get_iterator(M)
    ]
    return norm(values, r)
end
function _distance_r(M::AbstractPowerManifold, p, q, r::Real)
    rep_size = representation_size(M.manifold)
    values = [
        distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i)) for
            i in get_iterator(M)
    ]
    return norm(values, r)
end
function _distance_1(M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod)
    s = zero(number_eltype(p))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        s += distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i), m)
    end
    return s
end
function _distance_1(M::AbstractPowerManifold, p, q)
    s = zero(number_eltype(p))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        s += distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i))
    end
    return s
end
function _distance_max(M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod)
    d = float(zero(number_eltype(p)))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i), m)
        d = (v > d) ? v : d
    end
    return d
end
function _distance_max(M::AbstractPowerManifold, p, q)
    d = float(zero(number_eltype(p)))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i))
        d = (v > d) ? v : d
    end
    return d
end
function _distance_min(M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod)
    d = Inf
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i), m)
        d = (v < d) ? v : d
    end
    return d
end
function _distance_min(M::AbstractPowerManifold, p, q)
    d = Inf
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = distance(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i))
        d = (v < d) ? v : d
    end
    return d
end
@doc raw"""
    exp(M::AbstractPowerManifold, p, X)

Compute the exponential map from `p` in direction `X` on the [`AbstractPowerManifold`](@ref) `M`,
which can be computed using the base manifolds exponential map element-wise.
"""
exp(::AbstractPowerManifold, ::Any, ::Any)

function exp!(M::AbstractPowerManifold, q, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        exp!(
            M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i),
        )
    end
    return q
end
function exp!(M::PowerManifoldNestedReplacing, q, p, X)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] = exp(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i))
    end
    return q
end

@doc raw"""
    fill(p, M::AbstractPowerManifold)

Create a point on the [`AbstractPowerManifold`](@ref) `M`, where every entry is set to the
point `p`.

!!! note
    while usually the manifold is a first argument in all functions in `ManifoldsBase.jl`,
    we follow the signature of `fill`, where the power manifold serves are the size information.
"""
function fill(p, M::AbstractPowerManifold)
    P = allocate_result(M, rand) # rand finds the right way to allocate our point usually
    return fill!(P, p, M)
end

@doc raw"""
    fill!(P, p, M::AbstractPowerManifold)

Fill a point `P` on the [`AbstractPowerManifold`](@ref) `M`, setting every entry to `p`.

!!! note
    while usually the manifold is the first argument in all functions in `ManifoldsBase.jl`,
    we follow the signature of `fill!`, where the power manifold serves are the size information.
"""
function fill!(P, p, M::PowerManifoldNestedReplacing)
    for i in get_iterator(M)
        P[M, i] = p
    end
    return P
end
function fill!(P, p, M::AbstractPowerManifold)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        copyto!(M.manifold, _write(M, rep_size, P, i), p)
    end
    return P
end


function get_basis(M::AbstractPowerManifold, p, B::AbstractBasis)
    rep_size = representation_size(M.manifold)
    vs = [get_basis(M.manifold, _read(M, rep_size, p, i), B) for i in get_iterator(M)]
    return CachedBasis(B, PowerBasisData(vs))
end
function get_basis(M::AbstractPowerManifold, p, B::DiagonalizingOrthonormalBasis)
    rep_size = representation_size(M.manifold)
    vs = [
        get_basis(
                M.manifold, _read(M, rep_size, p, i), DiagonalizingOrthonormalBasis(_read(M, rep_size, B.frame_direction, i)),
            ) for i in get_iterator(M)
    ]
    return CachedBasis(B, PowerBasisData(vs))
end

"""
    get_component(M::AbstractPowerManifold, p, idx...)

Get the component of a point `p` on an [`AbstractPowerManifold`](@ref) `M` at index `idx`.
"""
function get_component(M::AbstractPowerManifold, p, idx...)
    rep_size = representation_size(M.manifold)
    return _read(M, rep_size, p, idx)
end

function get_coordinates(M::AbstractPowerManifold, p, X, B::AbstractBasis)
    rep_size = representation_size(M.manifold)
    vs = [
        get_coordinates(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), B) for i in get_iterator(M)
    ]
    return reduce(vcat, reshape(vs, length(vs)))
end
function get_coordinates(
        M::AbstractPowerManifold, p, X, B::CachedBasis{𝔽, <:AbstractBasis, <:PowerBasisData},
    ) where {𝔽}
    rep_size = representation_size(M.manifold)
    vs = [
        get_coordinates(
                M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _access_nested(M, B.data.bases, i),
            ) for i in get_iterator(M)
    ]
    return reduce(vcat, reshape(vs, length(vs)))
end

function get_coordinates!(M::AbstractPowerManifold, c, p, X, B::AbstractBasis)
    rep_size = representation_size(M.manifold)
    dim = manifold_dimension(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        # TODO: this view is really suboptimal when `dim` can be statically determined
        get_coordinates!(
            M.manifold, view(c, v_iter:(v_iter + dim - 1)), _read(M, rep_size, p, i), _read(M, rep_size, X, i), B,
        )
        v_iter += dim
    end
    return c
end
function get_coordinates!(
        M::AbstractPowerManifold, c, p, X, B::CachedBasis{𝔽, <:AbstractBasis, <:PowerBasisData},
    ) where {𝔽}
    rep_size = representation_size(M.manifold)
    dim = manifold_dimension(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        # TODO: this view is really suboptimal when `dim` can be statically determined
        get_coordinates!(
            M.manifold, view(c, v_iter:(v_iter + dim - 1)), _read(M, rep_size, p, i), _read(M, rep_size, X, i), _access_nested(M, B.data.bases, i),
        )
        v_iter += dim
    end
    return c
end

_get_field(::AbstractManifold{𝔽}) where {𝔽} = 𝔽

function get_embedding(
        M::PowerManifold{𝔽, TM, TSW, TPR},
        P::Type,
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSW, TPR <: Union{NestedPowerRepresentation, NestedReplacingPowerRepresentation}}
    ME = get_embedding(M.manifold, eltype(P))
    return PowerManifold{_get_field(ME), typeof(ME), TSW, TPR}(ME, M.size)
end
function get_embedding(
        M::PowerManifold{𝔽, TM, TSW, TPR}
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSW, TPR <: AbstractPowerRepresentation}
    ME = get_embedding(M.manifold)
    return PowerManifold{_get_field(ME), typeof(ME), TSW, TPR}(ME, M.size)
end

function get_iterator(
        ::PowerManifold{𝔽, <:AbstractManifold{𝔽}, TypeParameter{Tuple{N}}},
    ) where {𝔽, N}
    return Base.OneTo(N)
end
function get_iterator(M::PowerManifold{𝔽, <:AbstractManifold{𝔽}, Tuple{Int}}) where {𝔽}
    return Base.OneTo(M.size[1])
end
@generated function get_iterator(
        ::PowerManifold{𝔽, <:AbstractManifold{𝔽}, TypeParameter{SizeTuple}},
    ) where {𝔽, SizeTuple}
    size_tuple = size_to_tuple(SizeTuple)
    return Base.product(map(Base.OneTo, size_tuple)...)
end
function get_iterator(M::PowerManifold{𝔽, <:AbstractManifold{𝔽}, NTuple{N, Int}}) where {𝔽, N}
    size_tuple = M.size
    return Base.product(map(Base.OneTo, size_tuple)...)
end

function get_vector(
        M::AbstractPowerManifold, p, c, B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:PowerBasisData},
    ) where {𝔽}
    Y = allocate_result(M, get_vector, p, c)
    return get_vector!(M, Y, p, c, B)
end
function get_vector!(
        M::AbstractPowerManifold, Y, p, c, B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:PowerBasisData},
    ) where {𝔽}
    dim = manifold_dimension(M.manifold)
    rep_size = representation_size(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        get_vector!(
            M.manifold, _write(M, rep_size, Y, i), _read(M, rep_size, p, i),
            view(c, v_iter:(v_iter + dim - 1)), _access_nested(M, B.data.bases, i),
        )
        v_iter += dim
    end
    return Y
end
function get_vector!(
        M::PowerManifoldNestedReplacing, Y, p, c, B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:PowerBasisData},
    ) where {𝔽}
    dim = manifold_dimension(M.manifold)
    rep_size = representation_size(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        Y[i...] = get_vector(
            M.manifold, _read(M, rep_size, p, i), view(c, v_iter:(v_iter + dim - 1)),
            _access_nested(M, B.data.bases, i),
        )
        v_iter += dim
    end
    return Y
end
function get_vector(M::AbstractPowerManifold, p, c, B::AbstractBasis)
    Y = allocate_result(M, get_vector, p, c)
    return get_vector!(M, Y, p, c, B)
end
function get_vector!(M::AbstractPowerManifold, Y, p, c, B::AbstractBasis)
    dim = manifold_dimension(M.manifold)
    rep_size = representation_size(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        get_vector!(
            M.manifold, _write(M, rep_size, Y, i), _read(M, rep_size, p, i),
            view(c, v_iter:(v_iter + dim - 1)), B,
        )
        v_iter += dim
    end
    return Y
end
function get_vector!(M::PowerManifoldNestedReplacing, Y, p, c, B::AbstractBasis)
    dim = manifold_dimension(M.manifold)
    rep_size = representation_size(M.manifold)
    v_iter = 1
    for i in get_iterator(M)
        Y[i...] = get_vector(
            M.manifold, _read(M, rep_size, p, i), view(c, v_iter:(v_iter + dim - 1)), B,
        )
        v_iter += dim
    end
    return Y
end

function _get_vectors(
        M::PowerManifoldNested, p, B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:PowerBasisData},
    ) where {𝔽}
    zero_tv = zero_vector(M, p)
    rep_size = representation_size(M.manifold)
    vs = typeof(zero_tv)[]
    for i in get_iterator(M)
        b_i = _access_nested(M, B.data.bases, i)
        p_i = _read(M, rep_size, p, i)
        for v in get_vectors(M.manifold, p_i, b_i) #a bit safer than just b_i.data
            new_v = copy(M, p, zero_tv)
            copyto!(M.manifold, _write(M, rep_size, new_v, i), p_i, v)
            push!(vs, new_v)
        end
    end
    return vs
end
function _get_vectors(
        M::PowerManifoldNestedReplacing, p, B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:PowerBasisData},
    ) where {𝔽}
    zero_tv = zero_vector(M, p)
    vs = typeof(zero_tv)[]
    for i in get_iterator(M)
        b_i = _access_nested(M, B.data.bases, i)
        for v in b_i.data
            new_v = copy(M, p, zero_tv)
            new_v[i...] = v
            push!(vs, new_v)
        end
    end
    return vs
end

"""
    getindex(p, M::AbstractPowerManifold, i::Union{Integer,Colon,AbstractVector}...)
    p[M::AbstractPowerManifold, i...]

Access the element(s) at index `[i...]` of a point `p` on an [`AbstractPowerManifold`](@ref)
`M` by linear or multidimensional indexing.
See also [Array Indexing](https://docs.julialang.org/en/v1/manual/arrays/#man-array-indexing-1) in Julia.
"""
Base.@propagate_inbounds function Base.getindex(
        p::AbstractArray, M::AbstractPowerManifold, I::Union{Integer, Colon, AbstractVector}...,
    )
    return get_component(M, p, I...)
end

"""
    getindex(M::TangentSpace{𝔽, AbstractPowerManifold}, i...)
    TpM[i...]

Access the `i`th manifold component from an [`AbstractPowerManifold`](@ref)s' tangent space `TpM`.
"""
function Base.getindex(
        TpM::TangentSpace{𝔽, <:AbstractPowerManifold}, I::Union{Integer, Colon, AbstractVector}...,
    ) where {𝔽}
    M = base_manifold(TpM)
    p = base_point(TpM)
    return TangentSpace(M.manifold, p[M, I...])
end

"""
    has_components(::AbstractPowerManifold)

Return `true`, since points on an [`AbstractPowerManifold`](@ref) consist of components.
"""
has_components(::AbstractPowerManifold) = true

@doc raw"""
    injectivity_radius(M::AbstractPowerManifold[, p])

the injectivity radius on an [`AbstractPowerManifold`](@ref) is for the global case
equal to the one of its base manifold. For a given point `p` it's equal to the
minimum of all radii in the array entries.
"""
function injectivity_radius(M::AbstractPowerManifold, p)
    radius = 0.0
    initialized = false
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        cur_rad = injectivity_radius(M.manifold, _read(M, rep_size, p, i))
        if initialized
            radius = min(cur_rad, radius)
        else
            radius = cur_rad
            initialized = true
        end
    end
    return radius
end
injectivity_radius(M::AbstractPowerManifold) = injectivity_radius(M.manifold)
function injectivity_radius(M::AbstractPowerManifold, ::AbstractRetractionMethod)
    return injectivity_radius(M)
end

@doc raw"""
    inner(M::AbstractPowerManifold, p, X, Y)

Compute the inner product of `X` and `Y` from the tangent space at `p` on an
[`AbstractPowerManifold`](@ref) `M`, i.e. for each arrays entry the tangent
vector entries from `X` and `Y` are in the tangent space of the corresponding
element from `p`.
The inner product is then the sum of the elementwise inner products.
"""
function inner(M::AbstractPowerManifold, p, X, Y)
    result = zero(number_eltype(X))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        result += inner(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, Y, i),
        )
    end
    return result
end

"""
    is_flat(M::AbstractPowerManifold)

Return true if [`AbstractPowerManifold`](@ref) is flat. It is flat if and only if the
wrapped manifold is flat.
"""
is_flat(M::AbstractPowerManifold) = is_flat(M.manifold)

function _isapprox(M::AbstractPowerManifold, p, q; kwargs...)
    result = true
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        result &= isapprox(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i);
            kwargs...,
        )
    end
    return result
end
function _isapprox(M::AbstractPowerManifold, p, X, Y; kwargs...)
    result = true
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        result &= isapprox(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, Y, i);
            kwargs...,
        )
    end
    return result
end

@doc raw"""
    inverse_retract(M::AbstractPowerManifold, p, q, m::AbstractInverseRetractionMethod)

Compute the inverse retraction from `p` with respect to `q` on an [`AbstractPowerManifold`](@ref) `M`
using an [`AbstractInverseRetractionMethod`](@ref).
Then this method is performed elementwise, so the inverse
retraction method has to be one that is available on the base [`AbstractManifold`](@ref).
"""
inverse_retract(::AbstractPowerManifold, ::Any...)

function inverse_retract(
        M::AbstractPowerManifold, p, q,
        m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
    )
    X = allocate_result(M, inverse_retract, p, q)
    return inverse_retract!(M, X, p, q, m)
end

function inverse_retract!(
        M::AbstractPowerManifold, X, p, q,
        m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        inverse_retract!(
            M.manifold, _write(M, rep_size, X, i), _read(M, rep_size, p, i), _read(M, rep_size, q, i), m,
        )
    end
    return X
end
function inverse_retract!(
        M::PowerManifoldNestedReplacing, X, p, q,
        m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        X[i...] = inverse_retract(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i), m,
        )
    end
    return X
end

@doc raw"""
    log(M::AbstractPowerManifold, p, q)

Compute the logarithmic map from `p` to `q` on the [`AbstractPowerManifold`](@ref) `M`,
which can be computed using the base manifolds logarithmic map elementwise.
"""
log(::AbstractPowerManifold, ::Any...)

function log!(M::AbstractPowerManifold, X, p, q)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        log!(
            M.manifold, _write(M, rep_size, X, i), _read(M, rep_size, p, i), _read(M, rep_size, q, i),
        )
    end
    return X
end
function log!(M::PowerManifoldNestedReplacing, X, p, q)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        X[i...] = log(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, q, i))
    end
    return X
end

@doc raw"""
    manifold_dimension(M::PowerManifold)

Returns the manifold-dimension of an [`PowerManifold`](@ref) `M`
``=\mathcal N = (\mathcal M)^{n_1,…,n_d}``, i.e. with ``n=(n_1,…,n_d)`` the array
size of the power manifold and ``d_{\mathcal M}`` the dimension of the base manifold
``\mathcal M``, the manifold is of dimension

````math
\dim(\mathcal N) = \dim(\mathcal M)\prod_{i=1}^d n_i = n_1n_2⋅…⋅ n_d \dim(\mathcal M).
````
"""
function manifold_dimension(M::PowerManifold)
    size = get_parameter(M.size)
    return manifold_dimension(M.manifold) * prod(size)
end

function mid_point!(M::AbstractPowerManifold, q, p1, p2)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        mid_point!(
            M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p1, i), _read(M, rep_size, p2, i),
        )
    end
    return q
end
function mid_point!(M::PowerManifoldNestedReplacing, q, p1, p2)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] =
            mid_point(M.manifold, _read(M, rep_size, p1, i), _read(M, rep_size, p2, i))
    end
    return q
end

@doc raw"""
    norm(M::AbstractPowerManifold, p, X, r::Real=2)

Compute the norm of `X` from the tangent space of `p` on an
[`AbstractPowerManifold`](@ref) `M`, i.e. from the element wise norms `r`-norm is computed,
where the default `r=2` yields the Frobenius norm is computed.
"""
function LinearAlgebra.norm(M::AbstractPowerManifold, p, X, r::Real = 2)
    (isinf(r) && r > 0) && return _norm_max(M, p, X)
    (isinf(r) && r < 0) && return _norm_min(M, p, X)
    (r == 1) && return _norm_1(M, p, X)
    return _norm_r(M, p, X, r)
end
function _norm_r(M::AbstractPowerManifold, p, X, r::Real)
    rep_size = representation_size(M.manifold)
    values = [
        norm(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i)) for
            i in get_iterator(M)
    ]
    return norm(values, r)
end
function _norm_1(M::AbstractPowerManifold, p, X)
    s = zero(number_eltype(p))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        s += norm(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i))
    end
    return s
end
function _norm_max(M::AbstractPowerManifold, p, X)
    d = 0.0
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = norm(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i))
        d = (v > d) ? v : d
    end
    return d
end
function _norm_min(M::AbstractPowerManifold, p, X)
    d = Inf
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        v = norm(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i))
        d = (v < d) ? v : d
    end
    return d
end


function parallel_transport_direction!(M::AbstractPowerManifold, Y, p, X, d)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        parallel_transport_direction!(
            M.manifold, _write(M, rep_size, Y, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i),
        )
    end
    return Y
end
function parallel_transport_direction(M::AbstractPowerManifold, p, X, d)
    Y = allocate_result(M, vector_transport_direction, p, X, d)
    return parallel_transport_direction!(M, Y, p, X, d)
end

function parallel_transport_direction!(M::PowerManifoldNestedReplacing, Y, p, X, d)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = parallel_transport_direction(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i),
        )
    end
    return Y
end
function parallel_transport_direction(M::PowerManifoldNestedReplacing, p, X, d)
    Y = allocate_result(M, parallel_transport_direction, p, X, d)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = parallel_transport_direction(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i),
        )
    end
    return Y
end

function parallel_transport_to(M::AbstractPowerManifold, p, X, q)
    Y = allocate_result(M, vector_transport_to, p, X)
    return parallel_transport_to!(M, Y, p, X, q)
end
function parallel_transport_to!(M::AbstractPowerManifold, Y, p, X, q)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        vector_transport_to!(
            M.manifold, _write(M, rep_size, Y, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, q, i),
        )
    end
    return Y
end
function parallel_transport_to!(M::PowerManifoldNestedReplacing, Y, p, X, q)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = parallel_transport_to(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, q, i),
        )
    end
    return Y
end

@doc raw"""
    power_dimensions(M::PowerManifold)

return the power of `M`,
"""
function power_dimensions(M::PowerManifold)
    return get_parameter(M.size)
end

@doc raw"""
    project(M::AbstractPowerManifold, p)

Project the point `p` from the embedding onto the [`AbstractPowerManifold`](@ref) `M`
by projecting all components.
"""
project(::AbstractPowerManifold, ::Any)

function project!(M::AbstractPowerManifold, q, p)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        project!(M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p, i))
    end
    return q
end
function project!(M::PowerManifoldNestedReplacing, q, p)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] = project(M.manifold, _read(M, rep_size, p, i))
    end
    return q
end

@doc raw"""
    project(M::AbstractPowerManifold, p, X)

Project the point `X` onto the tangent space at `p` on the
[`AbstractPowerManifold`](@ref) `M` by projecting all components.
"""
project(::AbstractPowerManifold, ::Any, ::Any)

function project!(M::AbstractPowerManifold, Z, q, Y)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        project!(
            M.manifold, _write(M, rep_size, Z, i), _read(M, rep_size, q, i), _read(M, rep_size, Y, i),
        )
    end
    return Z
end
function project!(M::PowerManifoldNestedReplacing, Z, q, Y)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] = project(M.manifold, _read(M, rep_size, q, i), _read(M, rep_size, Y, i))
    end
    return Z
end

function Random.rand!(M::AbstractPowerManifold, pX; vector_at = nothing, kwargs...)
    rep_size = representation_size(M.manifold)
    if vector_at === nothing
        for i in get_iterator(M)
            rand!(M.manifold, _write(M, rep_size, pX, i); kwargs...)
        end
    else
        for i in get_iterator(M)
            rand!(
                M.manifold, _write(M, rep_size, pX, i);
                vector_at = _read(M, rep_size, vector_at, i), kwargs...,
            )
        end
    end
    return pX
end
function Random.rand!(
        rng::AbstractRNG, M::AbstractPowerManifold, pX;
        vector_at = nothing, kwargs...,
    )
    rep_size = representation_size(M.manifold)
    if vector_at === nothing
        for i in get_iterator(M)
            rand!(rng, M.manifold, _write(M, rep_size, pX, i); kwargs...)
        end
    else
        for i in get_iterator(M)
            rand!(
                rng, M.manifold, _write(M, rep_size, pX, i);
                vector_at = _read(M, rep_size, vector_at, i), kwargs...,
            )
        end
    end
    return pX
end
function Random.rand!(M::PowerManifoldNestedReplacing, pX; vector_at = nothing, kwargs...)
    if vector_at === nothing
        for i in get_iterator(M)
            pX[i...] = rand(M.manifold; kwargs...)
        end
    else
        for i in get_iterator(M)
            pX[i...] = rand(M.manifold; vector_at = vector_at[i...], kwargs...)
        end
    end
    return pX
end
function Random.rand!(
        rng::AbstractRNG, M::PowerManifoldNestedReplacing, pX;
        vector_at = nothing, kwargs...,
    )
    if vector_at === nothing
        for i in get_iterator(M)
            pX[i...] = rand(rng, M.manifold; kwargs...)
        end
    else
        for i in get_iterator(M)
            pX[i...] = rand(rng, M.manifold; vector_at = vector_at[i...], kwargs...)
        end
    end
    return pX
end

Base.@propagate_inbounds @inline function _read(
        M::AbstractPowerManifold, rep_size::Union{Tuple, Nothing}, x::AbstractArray, i::Int,
    )
    return _read(M, rep_size, x, (i,))
end

Base.@propagate_inbounds @inline function _read(
        ::Union{PowerManifoldNested, PowerManifoldNestedReplacing}, rep_size::Union{Tuple, Nothing}, x::AbstractArray, i::Tuple,
    )
    return x[i...]
end

@generated function rep_size_to_colons(rep_size::Tuple)
    N = length(rep_size.parameters)
    return ntuple(i -> Colon(), N)
end


@doc raw"""
    retract(M::AbstractPowerManifold, p, X, method::AbstractRetractionMethod)

Compute the retraction from `p` with tangent vector `X` on an [`AbstractPowerManifold`](@ref) `M`
using a [`AbstractRetractionMethod`](@ref).
Then this method is performed elementwise, so the retraction
method has to be one that is available on the base [`AbstractManifold`](@ref).
"""
retract(::AbstractPowerManifold, ::Any...)

function retract(
        M::AbstractPowerManifold, p, X, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    q = allocate_result(M, retract, p, X)
    return retract!(M, q, p, X, m)
end

function retract!(
        M::AbstractPowerManifold, q, p, X,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        retract!(
            M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i), m,
        )
    end
    return q
end
function retract!(
        M::PowerManifoldNestedReplacing, q, p, X, m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] = retract(M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), m)
    end
    return q
end

function retract_fused!(
        M::AbstractPowerManifold, q, p, X, t::Number,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        retract_fused!(
            M.manifold, _write(M, rep_size, q, i), _read(M, rep_size, p, i), _read(M, rep_size, X, i), t, m,
        )
    end
    return q
end
function retract_fused!(
        M::PowerManifoldNestedReplacing, q, p, X, t::Number,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        q[i...] = retract_fused(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), t, m,
        )
    end
    return q
end

@doc raw"""
    riemann_tensor(M::AbstractPowerManifold, p, X, Y, Z)

Compute the Riemann tensor at point from `p` with tangent vectors `X`, `Y` and `Z` on
the [`AbstractPowerManifold`](@ref) `M`.
"""
riemann_tensor(M::AbstractPowerManifold, p, X, Y, Z)

function riemann_tensor!(M::AbstractPowerManifold, Xresult, p, X, Y, Z)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        riemann_tensor!(
            M.manifold, _write(M, rep_size, Xresult, i),
            _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, Y, i), _read(M, rep_size, Z, i),
        )
    end
    return Xresult
end
function riemann_tensor!(M::PowerManifoldNestedReplacing, Xresult, p, X, Y, Z)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Xresult[i...] = riemann_tensor(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, Y, i), _read(M, rep_size, Z, i),
        )
    end
    return Xresult
end

@doc raw"""
    sectional_curvature(M::AbstractPowerManifold, p, X, Y)

Compute the sectional curvature of a power manifold manifold ``\mathcal M`` at a point
``p \in \mathcal M`` on two linearly independent tangent vectors at ``p``. It may be 0 for
 if projections of `X` and `Y` on subspaces corresponding to component manifolds
are not linearly independent.
"""
function sectional_curvature(M::AbstractPowerManifold, p, X, Y)
    curvature = zero(number_eltype(X))
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        p_i = _read(M, rep_size, p, i)
        X_i = _read(M, rep_size, X, i)
        Y_i = _read(M, rep_size, Y, i)
        if are_linearly_independent(M.manifold, p_i, X_i, Y_i)
            curvature += sectional_curvature(M.manifold, p_i, X_i, Y_i)
        end
    end
    return curvature
end

@doc raw"""
    sectional_curvature_max(M::AbstractPowerManifold)

Upper bound on sectional curvature of [`AbstractPowerManifold`](@ref) `M`. It is the maximum
of sectional curvature of the wrapped manifold and 0 in case there are two or more component
manifolds, as the sectional curvature corresponding to the plane spanned by vectors
`(X_1, 0, ... 0)` and `(0, X_2, 0, ..., 0)` is 0.
"""
function sectional_curvature_max(M::AbstractPowerManifold)
    d = prod(power_dimensions(M))
    mscm = sectional_curvature_max(M.manifold)
    if d > 1
        return max(mscm, zero(mscm))
    else
        return mscm
    end
end

@doc raw"""
    sectional_curvature_min(M::AbstractPowerManifold)

Lower bound on sectional curvature of [`AbstractPowerManifold`](@ref) `M`. It is the minimum
of sectional curvature of the wrapped manifold and 0 in case there are two or more component
manifolds, as the sectional curvature corresponding to the plane spanned by vectors
`(X_1, 0, ... 0)` and `(0, X_2, 0, ..., 0)` is 0.
"""
function sectional_curvature_min(M::AbstractPowerManifold)
    d = prod(power_dimensions(M))
    mscm = sectional_curvature_max(M.manifold)
    if d > 1
        return min(mscm, zero(mscm))
    else
        return mscm
    end
end

"""
    set_component!(M::AbstractPowerManifold, q, p, idx...)

Set the component of a point `q` on an [`AbstractPowerManifold`](@ref) `M` at index `idx`
to `p`, which itself is a point on the [`AbstractManifold`](@ref) the power manifold is build on.
"""
function set_component!(M::AbstractPowerManifold, q, p, idx...)
    rep_size = representation_size(M.manifold)
    return copyto!(_write(M, rep_size, q, idx), p)
end
function set_component!(::PowerManifoldNestedReplacing, q, p, idx...)
    return q[idx...] = p
end
"""
    setindex!(q, p, M::AbstractPowerManifold, i::Union{Integer,Colon,AbstractVector}...)
    q[M::AbstractPowerManifold, i...] = p

Set the element(s) at index `[i...]` of a point `q` on an [`AbstractPowerManifold`](@ref)
`M` by linear or multidimensional indexing to `q`.
See also [Array Indexing](https://docs.julialang.org/en/v1/manual/arrays/#man-array-indexing-1) in Julia.
"""
Base.@propagate_inbounds function Base.setindex!(
        q::AbstractArray, p, M::AbstractPowerManifold, I::Union{Integer, Colon, AbstractVector}...,
    )
    return set_component!(M, q, p, I...)
end

function Base.show(
        io::IO,
        M::PowerManifold{𝔽, TM, TSize, TPR},
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize, TPR <: AbstractPowerRepresentation}
    size = get_parameter(M.size)
    return print(io, "PowerManifold($(M.manifold), $(TPR()), $(join(size, ", ")))")
end
function Base.show(
        io::IO, M::PowerManifold{𝔽, TM, TypeParameter{TSize}, TPR},
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSize, TPR <: AbstractPowerRepresentation}
    size = get_parameter(M.size)
    return print(
        io,
        "PowerManifold($(M.manifold), $(TPR()), $(join(size, ", ")); parameter=:type)",
    )
end

function Base.show(
        io::IO, mime::MIME"text/plain", B::CachedBasis{𝔽, T, D},
    ) where {T <: AbstractBasis, D <: PowerBasisData, 𝔽}
    println(io, "$(T()) for a power manifold")
    for i in Base.product(map(Base.OneTo, size(B.data.bases))...)
        println(io, "Basis for component $i:")
        show(io, mime, _access_nested(B.data.bases, i))
        println(io)
    end
    return nothing
end

function vector_transport_direction!(
        M::AbstractPowerManifold, Y, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        vector_transport_direction!(
            M.manifold, _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i), m,
        )
    end
    return Y
end
function vector_transport_direction(
        M::AbstractPowerManifold, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    Y = allocate_result(M, vector_transport_direction, p, X, d)
    return vector_transport_direction!(M, Y, p, X, d, m)
end

function vector_transport_direction!(
        M::PowerManifoldNestedReplacing, Y, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = vector_transport_direction(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i), m,
        )
    end
    return Y
end
function vector_transport_direction(
        M::PowerManifoldNestedReplacing, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    Y = allocate_result(M, vector_transport_direction, p, X, d)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = vector_transport_direction(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, d, i), m,
        )
    end
    return Y
end

@doc raw"""
    vector_transport_to(M::AbstractPowerManifold, p, X, q, method::AbstractVectorTransportMethod)

Compute the vector transport the tangent vector `X`at `p` to `q` on the
[`PowerManifold`](@ref) `M` using an [`AbstractVectorTransportMethod`](@ref) `m`.
This method is performed elementwise, i.e. the method `m` has to be implemented on the
base manifold.
"""
vector_transport_to(
    ::AbstractPowerManifold,
    ::Any,
    ::Any,
    ::Any,
    ::AbstractVectorTransportMethod,
)
function vector_transport_to(
        M::AbstractPowerManifold, p, X, q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    Y = allocate_result(M, vector_transport_to, p, X)
    return vector_transport_to!(M, Y, p, X, q, m)
end
function vector_transport_to!(
        M::AbstractPowerManifold, Y, p, X, q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        vector_transport_to!(
            M.manifold, _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, q, i), m,
        )
    end
    return Y
end
function vector_transport_to!(
        M::PowerManifoldNestedReplacing, Y, p, X, q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Y[i...] = vector_transport_to(
            M.manifold, _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, q, i), m,
        )
    end
    return Y
end

"""
    view(p, M::PowerManifoldNested, i::Union{Integer,Colon,AbstractVector}...)

Get the view of the element(s) at index `[i...]` of a point `p` on an
[`AbstractPowerManifold`](@ref) `M` by linear or multidimensional indexing.
"""
function Base.view(
        p::AbstractArray, M::PowerManifoldNested, I::Union{Integer, Colon, AbstractVector}...,
    )
    rep_size = representation_size(M.manifold)
    return view(p[I...], rep_size_to_colons(rep_size)...)
end

@doc raw"""
    Y = Weingarten(M::AbstractPowerManifold, p, X, V)
    Weingarten!(M::AbstractPowerManifold, Y, p, X, V)

Since the metric decouples, also the computation of the Weingarten map
``\mathcal W_p`` can be computed elementwise on the single elements of the [`PowerManifold`](@ref) `M`.
"""
Weingarten(::AbstractPowerManifold, p, X, V)

function Weingarten!(M::AbstractPowerManifold, Y, p, X, V)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        Weingarten!(
            M.manifold, _write(M, rep_size, Y, i),
            _read(M, rep_size, p, i), _read(M, rep_size, X, i), _read(M, rep_size, V, i),
        )
    end
    return Y
end

@inline function _write(
        M::AbstractPowerManifold, rep_size::Union{Tuple, Nothing}, x::AbstractArray, i::Int,
    )
    return _write(M, rep_size, x, (i,))
end

@inline function _is_nested_write_getindex(::PowerManifoldNested, x)
    return !isbitstype(eltype(x))
end

@inline function _write(
        M::PowerManifoldNested, ::Union{Tuple, Nothing}, x::AbstractArray, i::Tuple,
    )
    if _is_nested_write_getindex(M, x)
        return x[i...]
    else
        return view(x, i...)
    end
end

function zero_vector!(M::AbstractPowerManifold, X, p)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        zero_vector!(M.manifold, _write(M, rep_size, X, i), _read(M, rep_size, p, i))
    end
    return X
end
function zero_vector!(M::PowerManifoldNestedReplacing, X, p)
    rep_size = representation_size(M.manifold)
    for i in get_iterator(M)
        X[i...] = zero_vector(M.manifold, _read(M, rep_size, p, i))
    end
    return X
end

using ManifoldsBase
using Test
using ManifoldsBase:
    combine_allocation_promotion_functions, allocation_promotion_function, ℝ, ℂ, ℍ
using Quaternions

struct AllocManifold{𝔽} <: AbstractManifold{𝔽} end
AllocManifold() = AllocManifold{ℝ}()

function ManifoldsBase.exp!(::AllocManifold, v, x, y)
    v[1] .= x[1] .+ y[1]
    v[2] .= x[2] .+ y[2]
    v[3] .= x[3] .+ y[3]
    return v
end

struct AllocManifold2 <: AbstractManifold{ℝ} end
ManifoldsBase.representation_size(::AllocManifold2) = (2, 3)

struct AllocManifold3 <: AbstractManifold{ℂ} end
ManifoldsBase.representation_size(::AllocManifold3) = (2, 3)

struct AllocManifold4 <: AbstractManifold{ℍ} end
ManifoldsBase.representation_size(::AllocManifold4) = (2, 3)

@testset "Allocation" begin
    a = [[1.0], [2.0], [3.0]]
    b = [[2.0], [3.0], [-3.0]]
    M = AllocManifold()
    v = exp(M, a, b)
    @test v ≈ [[3.0], [5.0], [0.0]]
    @test allocate(([1.0], [2.0])) isa Tuple{Vector{Float64}, Vector{Float64}}
    @test allocate(([1.0], [2.0]), Int) isa Tuple{Vector{Int}, Vector{Int}}
    @test allocate([[1.0], [2.0]]) isa Vector{Vector{Float64}}
    @test allocate([[1.0], [2.0]], Int) isa Vector{Vector{Int}}
    @test allocate(M, a, 5) isa Vector{Vector{Float64}}
    @test length(allocate(M, a, 5)) == 5
    @test allocate(M, a, (5,)) isa Vector{Vector{Float64}}
    @test length(allocate(M, a, (5,))) == 5
    @test allocate(M, a, Int, (5,)) isa Vector{Int}
    @test length(allocate(M, a, Int, (5,))) == 5
    @test allocate(M, a, Int, 5) isa Vector{Int}
    @test length(allocate(M, a, Int, 5)) == 5

    @test typeof(allocate([1])) == typeof(allocate([1], nothing))
    @test typeof(allocate(M, [1])) == typeof(allocate(M, [1], nothing))
    @test typeof(allocate([1], Int)) == typeof(allocate([1], Int, nothing))

    a1 = allocate([1], 2, 3)
    @test a1 isa Matrix{Int}
    @test size(a1) == (2, 3)
    a2 = allocate([1], (2, 3))
    @test a2 isa Matrix{Int}
    @test size(a2) == (2, 3)
    a3 = allocate([1], Float64, 2, 3)
    @test a3 isa Matrix{Float64}
    @test size(a3) == (2, 3)
    a4 = allocate([1], Float64, (2, 3))
    @test a4 isa Matrix{Float64}
    @test size(a4) == (2, 3)

    @test allocate(1) isa Array{Int, 0}
    @test allocate(1, Float64) isa Array{Float64, 0}

    @test allocation_promotion_function(M, exp, (a, b)) === identity
    @test combine_allocation_promotion_functions(identity, identity) === identity
    @test combine_allocation_promotion_functions(identity, complex) === complex
    @test combine_allocation_promotion_functions(complex, identity) === complex
    @test combine_allocation_promotion_functions(complex, complex) === complex

    @test number_eltype([2.0]) === Float64
    @test number_eltype([[2.0], [3]]) === Float64
    @test number_eltype([[2], [3.0]]) === Float64
    @test number_eltype([[2], [3]]) === Int
    @test number_eltype(([2.0], [3])) === Float64
    @test number_eltype(([2], [3.0])) === Float64
    @test number_eltype(([2], [3])) === Int
    @test number_eltype(Any[[2.0], [3.0]]) === Float64
    @test number_eltype(typeof([[1.0, 2.0]])) === Float64

    M2 = AllocManifold2()
    alloc2 = ManifoldsBase.allocate_result(M2, rand)
    @test alloc2 isa Matrix{Float64}
    @test size(alloc2) == representation_size(M2)

    @test ManifoldsBase.allocate_result(AllocManifold3(), rand) isa Matrix{ComplexF64}
    @test ManifoldsBase.allocate_result(AllocManifold4(), rand) isa Matrix{QuaternionF64}

    an = allocate_on(M2)
    @test an isa Matrix{Float64}
    @test size(an) == representation_size(M2)
    an = allocate_on(M2, Array{Float32})
    @test an isa Matrix{Float32}
    @test size(an) == representation_size(M2)

    an = allocate_on(M2, TangentSpaceType())
    @test an isa Matrix{Float64}
    @test size(an) == representation_size(M2)
    an = allocate_on(M2, TangentSpaceType(), Array{Float32})
    @test an isa Matrix{Float32}
    @test size(an) == representation_size(M2)

    @test default_type(M2) === Matrix{Float64}
    @test default_type(M2, TangentSpaceType()) === Matrix{Float64}

    @test ManifoldsBase.coordinate_eltype(M, fill(true, 2, 3), ℝ) === Float64
    @test ManifoldsBase.coordinate_eltype(AllocManifold4(), a4, ℍ) === QuaternionF64
end

using Test
using ManifoldsBase
using ManifoldsBase: AbstractNumbers, ℝ, ℂ, ℍ, _unify_number_systems

struct NotImplementedNumbers <: ManifoldsBase.AbstractNumbers end

@testset "Number systems" begin
    @test_throws ErrorException real_dimension(NotImplementedNumbers())

    @test ℝ isa ManifoldsBase.RealNumbers
    @test ManifoldsBase.RealNumbers() === ℝ
    @test real_dimension(ℝ) == 1
    @test repr(ℝ) == "ℝ"

    @test ℂ isa ManifoldsBase.ComplexNumbers
    @test ManifoldsBase.ComplexNumbers() === ℂ
    @test real_dimension(ℂ) == 2
    @test repr(ℂ) == "ℂ"

    @test ℍ isa ManifoldsBase.QuaternionNumbers
    @test ManifoldsBase.QuaternionNumbers() === ℍ
    @test real_dimension(ℍ) == 4
    @test repr(ℍ) == "ℍ"

    @test (@inferred _unify_number_systems(ℝ)) === ℝ
    @test (@inferred _unify_number_systems(ℂ)) === ℂ
    @test (@inferred _unify_number_systems(ℍ)) === ℍ
    @test (@inferred _unify_number_systems(ℝ, ℝ)) === ℝ
    @test (@inferred _unify_number_systems(ℝ, ℂ)) === ℂ
    @test (@inferred _unify_number_systems(ℝ, ℍ)) === ℍ
    @test (@inferred _unify_number_systems(ℂ, ℝ)) === ℂ
    @test (@inferred _unify_number_systems(ℂ, ℂ)) === ℂ
    @test (@inferred _unify_number_systems(ℂ, ℍ)) === ℍ
    @test (@inferred _unify_number_systems(ℍ, ℝ)) === ℍ
    @test (@inferred _unify_number_systems(ℍ, ℂ)) === ℍ
    @test (@inferred _unify_number_systems(ℍ, ℍ)) === ℍ
    @test (@inferred _unify_number_systems(ℝ, ℂ, ℝ)) === ℂ
    @test (@inferred _unify_number_systems(ℝ, ℝ, ℝ)) === ℝ
end

using Test
using ManifoldsBase
using ManifoldsBase:
    AbstractNumbers,
    ℝ,
    ℂ,
    NestedReplacingPowerRepresentation,
    VectorSpaceType,
    DefaultManifold
using StaticArrays
using LinearAlgebra
using Random
using RecursiveArrayTools

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

power_array_wrapper(::Type{NestedPowerRepresentation}, ::Int) = identity
power_array_wrapper(::Type{NestedReplacingPowerRepresentation}, i::Int) = SVector{i}

function ManifoldsBase.allocate(
        ::ManifoldsBase.PowerManifoldNestedReplacing,
        x::AbstractArray{<:SArray},
    )
    return similar(x)
end

function ManifoldsBase.representation_size(
        M::ManifoldsBaseTestUtils.TestPowerManifoldMultidimensional,
    )
    return (representation_size(M.manifold)..., ManifoldsBase.get_parameter(M.size)...)
end

@inline function ManifoldsBase._write(
        ::ManifoldsBaseTestUtils.TestPowerManifoldMultidimensional,
        rep_size::Tuple,
        x::AbstractArray,
        i::Tuple,
    )
    return view(x, ManifoldsBase.rep_size_to_colons(rep_size)..., i...)
end

function ManifoldsBase.get_embedding(
        M::PowerManifold{𝔽, TM, TSW, ManifoldsBaseTestUtils.TestArrayRepresentation},
        P::Type,
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSW}
    ME = get_embedding(M.manifold, P)
    return PowerManifold{ManifoldsBase._get_field(ME), typeof(ME), TSW, ManifoldsBaseTestUtils.TestArrayRepresentation}(ME, M.size)
end

@testset "Power Manifold" begin

    @testset "Power Manifold with a test representation" begin
        M = ManifoldsBase.DefaultManifold(3)
        N = PowerManifold(M, ManifoldsBaseTestUtils.TestArrayRepresentation(), 2)
        O = PowerManifold(N, ManifoldsBaseTestUtils.TestArrayRepresentation(), 3) # joins instead of nesting.
        @test repr(O) ==
            "PowerManifold(DefaultManifold(3; field = ℝ), ManifoldsBaseTestUtils.TestArrayRepresentation(), 2, 3)"
        p = zeros(6)
        X = zeros(6)
        @test has_components(N)
        @test has_components(O)
        @test ManifoldsBase.check_power_size(N, p) === nothing
        @test ManifoldsBase.check_power_size(O, p) isa DomainError
        @test ManifoldsBase.check_power_size(N, p, X) === nothing
        @test ManifoldsBase.check_power_size(O, p, X) isa DomainError
        @test default_inverse_retraction_method(M) == default_inverse_retraction_method(N)
        @test default_retraction_method(M) == default_retraction_method(N)
        @test default_vector_transport_method(M) == default_vector_transport_method(N)
        @test get_embedding(N, typeof(p)) === N
    end

    @testset "PowerManifold and allocation with empty representation size" begin
        M = ManifoldsBase.DefaultManifold()
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        p = [1, 1]
        X = [2, 2]
        # check - though only because this function exists for avoiding ambiguities.
        cm = ManifoldsBase.allocate_result(N, get_coordinates, p, X, DefaultBasis())
        @test size(X) == size(cm)
        @test project(N, p) == p
    end

    @testset "PowerManifoldNested with mutable element" begin
        M = ManifoldsBase.DefaultManifold(2, 2)
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        p = [UpperTriangular([1 2; 2 1]), UpperTriangular([1 2; 2 1])]
        q = [UpperTriangular([2 3; 3 2]), UpperTriangular([1 2; 2 1])]
        @test typeof(log(N, p, q)) === typeof(p)
        # DefaultManifold is always its own embedding independent of the point type, so
        @test get_embedding(N) == get_embedding(N, typeof(p))
    end

    @testset "PowerManifoldNestedReplacing with SArray element" begin
        M = ManifoldsBase.DefaultManifold(2, 2)
        N = PowerManifold(M, NestedReplacingPowerRepresentation(), 2)
        p = [SMatrix{2, 2, Float64}([i i + 1; i - 1 i - 2]) for i in 1:2]
        allocate(M, p) isa Vector{SMatrix{2, 2, Float64, 4}}
        # DefaultManifold is always its own embedding independent of the point type, so
        @test get_embedding(N) == get_embedding(N, typeof(p))
    end

    @testset "allocate_on" begin
        M = ManifoldsBase.DefaultManifold(2, 2)
        N = PowerManifold(M, NestedReplacingPowerRepresentation(), 2)
        p = allocate_on(N)
        @test p isa Vector{Matrix{Float64}}
        @test size(p) == (2,)

        p = allocate_on(N, Vector{Matrix{Float32}})
        @test p isa Vector{Matrix{Float32}}
        @test size(p) == (2,)

        X = allocate_on(N, TangentSpaceType())
        @test X isa Vector{Matrix{Float64}}
        @test size(X) == (2,)

        X = allocate_on(N, TangentSpaceType(), Vector{Matrix{Float32}})
        @test X isa Vector{Matrix{Float32}}
        @test size(X) == (2,)

        @test project(N, p) isa typeof(p)
    end

    for PowerRepr in [NestedPowerRepresentation, NestedReplacingPowerRepresentation]
        @testset "PowerManifold with $(PowerRepr)" begin
            M = ManifoldsBase.DefaultManifold(3)
            for pow_size in ((2,), (2, 3))
                pow_cart = CartesianIndices(pow_size)
                N = PowerManifold(M, PowerRepr(), pow_size...)
                wrapper_2 = power_array_wrapper(PowerRepr, 2)
                wrapper_3 = power_array_wrapper(PowerRepr, 3)

                p = wrapper_3.([i[1] == 1 ? zeros(3) : ones(3) for i in pow_cart])
                q = wrapper_3.([i[1] == 1 ? ones(3) : zeros(3) for i in pow_cart])

                pow_string = join(pow_size, ", ")

                @testset "Constructors" begin
                    @test repr(N) ==
                        "PowerManifold(DefaultManifold(3; field = ℝ), $(PowerRepr)(), $pow_string)"
                    # add to type
                    @test repr(N^3) ==
                        "PowerManifold(DefaultManifold(3; field = ℝ), $(PowerRepr)(), $pow_string, 3)"
                    # add to type
                    @test repr(PowerManifold(N, 3)) ==
                        "PowerManifold(DefaultManifold(3; field = ℝ), $(PowerRepr)(), $pow_string, 3)"
                    # nest
                    @test repr(PowerManifold(N, PowerRepr(), 3)) ==
                        "PowerManifold(PowerManifold(DefaultManifold(3; field = ℝ), $(PowerRepr)(), $pow_string), $(PowerRepr)(), 3)"
                end

                @test N^3 == PowerManifold(M, PowerRepr(), pow_size..., 3)

                if pow_size == (2,)

                    @test ManifoldsBase.get_iterator(N^3) ==
                        Base.product(Base.OneTo(2), Base.OneTo(3))
                    @testset "point/tangent checks" begin
                        pE1 = [wrapper_3(zeros(3)), wrapper_2(ones(2))] # one component wrong
                        pE2 = wrapper_2.([zeros(2), ones(2)]) # both wrong
                        @test is_point(N, p)
                        @test is_point(N, p, true)
                        @test !is_point(N, pE1)
                        @test !is_point(N, pE2)
                        @test_throws ComponentManifoldError is_point(N, pE1, true)
                        @test_throws CompositeManifoldError is_point(N, pE2, true)
                        # tangent - test base
                        @test is_vector(N, p, p)
                        @test is_vector(N, p, p, true)
                        @test !is_vector(N, pE1, p)
                        @test !is_vector(N, pE2, p)
                        # tangents - with proper base
                        @test is_vector(N, p, p, true)
                        @test !is_vector(N, p, pE1)
                        @test !is_vector(N, p, pE2)
                        @test_throws ComponentManifoldError is_vector(
                            N,
                            p,
                            pE1;
                            error = :error,
                        )
                        @test_throws CompositeManifoldError is_vector(
                            N,
                            p,
                            pE2;
                            error = :error,
                        )
                    end
                end
                @testset "specific functions" begin
                    nsq = sqrt(sum(distance.(Ref(M), p, q) .^ 2))
                    @test distance(N, p, q) == nsq
                    @test distance(N, p, q, LogarithmicInverseRetraction(), 2) == nsq
                    @test distance(N, p, q, 2) == sqrt(sum(distance.(Ref(M), p, q) .^ 2))
                    absn = sum(distance.(Ref(M), p, q))
                    @test distance(N, p, q, 1) == absn
                    @test distance(N, p, q, LogarithmicInverseRetraction(), 1) == absn
                    Infn = maximum(distance.(Ref(M), p, q))
                    @test distance(N, p, q, Inf) == Infn
                    @test distance(N, p, q, LogarithmicInverseRetraction(), Inf) == Infn
                    @test exp(N, p, q) == p .+ q
                    @test ManifoldsBase.exp_fused(N, p, q, 2) == p .+ 2 .* q

                    @test retract(N, p, q) == p .+ q
                    @test retract(N, p, q, ExponentialRetraction()) == p .+ q
                    r = allocate(p)
                    @test retract!(N, r, p, q, ExponentialRetraction()) == p .+ q
                    @test ManifoldsBase.retract_fused(N, p, q, 1.0) == p .+ q
                    @test ManifoldsBase.retract_fused(
                        N,
                        p,
                        q,
                        1.0,
                        ExponentialRetraction(),
                    ) == p .+ q
                    r = allocate(p)
                    @test ManifoldsBase.retract_fused!(
                        N,
                        r,
                        p,
                        q,
                        1.0,
                        ExponentialRetraction(),
                    ) == p .+ q
                    @test r == p .+ q
                    @test inverse_retract(N, p, r) == q
                    @test inverse_retract(N, p, r, LogarithmicInverseRetraction()) == q
                    X = allocate(p)
                    @test inverse_retract!(N, X, p, r, LogarithmicInverseRetraction()) == q
                    @test X == q

                    if pow_size == (2,)
                        @test ManifoldsBase.get_iterator(N) == Base.OneTo(2)
                    else
                        @test ManifoldsBase.get_iterator(N) ==
                            Base.product(Base.OneTo(2), Base.OneTo(3))
                    end
                    @test injectivity_radius(N) == injectivity_radius(M)
                    @test injectivity_radius(N, ExponentialRetraction()) ==
                        injectivity_radius(M)
                    @test injectivity_radius(N, p) == injectivity_radius(M, p)
                    @test is_flat(N)
                    p2 = allocate(p)
                    copyto!(N, p2, p)
                    @test !(p === p2)
                    @test p == p2
                    q2 = allocate(q)
                    copyto!(N, q2, p, q)
                    @test !(q === q2)
                    @test q == q2
                    @test inner(N, p, q, q) == sum(inner.(Ref(M), p, q, q))
                    @test isapprox(N, p, q) == (all(isapprox.(Ref(M), p, q)))
                    @test isapprox(N, p, p) == (all(isapprox.(Ref(M), p, p)))
                    @test isapprox(N, p, q, p) == (all(isapprox.(Ref(M), p, q, p)))
                    @test isapprox(N, p, p, p) == (all(isapprox.(Ref(M), p, p, p)))
                    @test log(N, p, q) == q .- p
                    @test inverse_retract(N, p, q) == q .- p
                    @test manifold_dimension(N) == prod(pow_size) * manifold_dimension(M)
                    @test mid_point(N, p, q) == mid_point.(Ref(M), p, q)
                    @test sqrt(inner(N, p, q, q)) ≈ norm(N, p, q)
                    norms = norm.(Ref(M), p, q)
                    @test norm(N, p, q, 1) == sum(norms)
                    @test norm(N, p, q, 2) == sqrt(sum(norms .^ 2))
                    @test norm(N, p, q, Inf) == maximum(norms)
                    @test project(N, p) == p
                    @test project(N, p, q) == q
                    @test power_dimensions(N) == pow_size
                    @test power_dimensions(N^3) == (pow_size..., 3)
                    m = ParallelTransport()
                    @test vector_transport_to(N, p, p, q) == p
                    @test vector_transport_to(N, p, p, q, m) == p
                    @test parallel_transport_to(N, p, p, q) == p
                    q2 = [zeros(3) for _ in pow_cart]
                    vector_transport_to!(N, q2, p, q, p)
                    @test q2 == q
                    q2 = [zeros(3) for _ in pow_cart]
                    parallel_transport_to!(N, q2, p, q, p)
                    @test q2 == q
                    @test vector_transport_direction(N, p, p, q) == p
                    @test vector_transport_direction(N, p, p, q, m) == p
                    @test parallel_transport_direction(N, p, p, q) == p
                    q2 = [zeros(3) for _ in pow_cart]
                    vector_transport_direction!(N, q2, p, q, p)
                    @test q2 == q
                    q2 = [zeros(3) for _ in pow_cart]
                    parallel_transport_direction!(N, q2, p, q, p)
                    @test q2 == q
                    if pow_size == (2,)
                        @test p[N, 1] == p[1]
                        p[N, 1] = 2 .* ones(3)
                        @test p[N, 1] == 2 .* ones(3)
                        @test p[N, [2, 1]] == [p[2], p[1]]
                        if PowerRepr == NestedPowerRepresentation
                            @test view(p, N, 2) isa SubArray
                            @test view(p, N, 2) == p[2]
                        end
                    end

                    @test isapprox(
                        N,
                        p,
                        riemann_tensor(N, p, X, X, X),
                        zero_vector(N, p);
                        atol = eps(),
                    )
                    Xresult = allocate(X)
                    riemann_tensor!(N, Xresult, p, X, X, X)
                    @test isapprox(N, p, Xresult, zero_vector(N, p); atol = eps())
                end
                @testset "Basis, coordinates & vector" begin
                    v = get_coordinates(N, p, q, DefaultBasis())
                    @test v == reduce(vcat, q)
                    @test get_vector(N, p, v, DefaultBasis()) == q
                    B = get_basis(N, p, DefaultBasis())
                    @test get_coordinates(N, p, q, B) == v
                    # the method tested below should not be used but it prevents ambiguities from occurring
                    # and the test is here to make coverage happy
                    @test ManifoldsBase.allocate_result(N, get_coordinates, p, q, B) isa
                        Vector
                    v2 = similar(v)
                    get_coordinates!(N, v2, p, q, B)
                    @test v2 == v
                    @test get_coordinates(N, p, q, DefaultOrthonormalBasis()) == v
                    v3 = similar(v2)
                    @test get_coordinates!(N, v3, p, q, DefaultOrthonormalBasis()) == v
                    @test v3 == v
                    @test B.data.bases[1].data == get_basis(M, p[1], DefaultBasis()).data
                    @test B.data.bases[2].data == get_basis(M, p[2], DefaultBasis()).data
                    @test get_vector(N, p, v, B) == q
                    q2 = similar.(q)
                    @test get_vector!(N, q2, p, v, B) == q
                    @test q2 == q
                    q3 = similar.(q)
                    @test get_vector(N, p, v, DefaultOrthonormalBasis()) == q
                    @test get_vector!(N, q3, p, v, DefaultOrthonormalBasis()) == q
                    @test q3 == q
                    @test zero_vector(N, p) == [zeros(3) for _ in pow_cart]
                    B2 = DiagonalizingOrthonormalBasis([ones(3) for _ in pow_cart])
                    B3 = get_basis(N, p, B2)
                    if pow_size == (2,)
                        @test sprint(show, "text/plain", B) ==
                            """$(DefaultBasis()) for a power manifold
                            Basis for component (1,):
                            $(sprint(show, "text/plain", B.data.bases[1]))
                            Basis for component (2,):
                            $(sprint(show, "text/plain", B.data.bases[2]))
                            """
                    end

                    bv = get_vectors(N, p, B)
                    @test length(bv) == number_of_coordinates(N, B)
                    for i in 1:number_of_coordinates(N, B)
                        @test bv[i] == get_vector(
                            N,
                            p,
                            ManifoldsBase._euclidean_basis_vector(v, i),
                            B,
                        )
                    end
                end
                @testset "zero argument allocation" begin
                    @test size(ManifoldsBase.allocate_result(N, rand)) == size(p)
                end
            end

            @testset "Zero index manifold" begin
                Mzero = ManifoldsBase.DefaultManifold()
                N = PowerManifold(Mzero, PowerRepr(), 3)
                p = [1.0, 2.0, 3.0]

                @test p[N, 1] == 1.0
                @test zero_vector(N, p) == zero(p)
            end
        end
    end

    @testset "Power RNG" begin
        M = ManifoldsBase.DefaultManifold(3)
        for rep in [NestedPowerRepresentation(), NestedReplacingPowerRepresentation()]
            N = PowerManifold(M, rep, 2)
            @test is_point(N, rand(N))
            @test is_point(N, rand(MersenneTwister(123), N))
            @test rand(MersenneTwister(123), N) == rand(MersenneTwister(123), N)
            p = rand(N)
            @test is_vector(N, p, rand(N; vector_at = p); atol = 1.0e-15)
            @test is_vector(
                N,
                p,
                rand(MersenneTwister(123), N; vector_at = p);
                atol = 1.0e-15,
            )
            @test rand(MersenneTwister(123), N; vector_at = p) ==
                rand(MersenneTwister(123), N; vector_at = p)
        end
    end

    @testset "metric conversion" begin
        M = TestSPD(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        e = ManifoldsBase.EuclideanMetric()
        p = [1.0 0.0 0.0; 0.0 1.0 0.0; 0.0 0.0 1]
        q = [2.0 0.0 0.0; 0.0 2.0 0.0; 0.0 0.0 1]
        P = [p, q]
        X = [log(M, p, q), log(M, q, p)]
        Y = change_metric(N, e, P, X)
        Yc = [change_metric(M, e, p, log(M, p, q)), change_metric(M, e, q, log(M, q, p))]
        @test norm(N, P, Y .- Yc) ≈ 0
        Z = change_representer(N, e, P, X)
        Zc = [
            change_representer(M, e, p, log(M, p, q)),
            change_representer(M, e, q, log(M, q, p)),
        ]
        @test norm(N, P, Z .- Zc) ≈ 0
    end

    @testset "Curvature" begin
        M1 = TestSphere(2)
        @testset "Weingarten" begin
            Mpr = PowerManifold(M1, NestedPowerRepresentation(), 2)
            p = [1.0, 0.0, 0.0]
            X = [0.0, 0.2, 0.0]
            V = [0.1, 0.0, 0.0] #orthogonal to TpM -> parallel to p
            @test isapprox(
                Mpr,
                Weingarten(Mpr, [p, p], [X, X], [V, V]),
                [-0.1 * X, -0.1 * X],
            )
        end

        @testset "sectional curvature" begin
            Mpr = PowerManifold(M1, NestedPowerRepresentation(), 2)
            @test sectional_curvature_max(Mpr) == 1.0
            @test sectional_curvature_min(Mpr) == 0.0

            p = [[0.0, 1.0, 0.0], [0.0, 1.0, 0.0]]
            X1 = [[1.0, 0.0, 0.0], [0.0, 0.0, 0.0]]
            X2 = [[0.0, 0.0, 1.0], [0.0, 0.0, 0.0]]
            X3 = [[0.0, 0.0, 0.0], [0.0, 0.0, 1.0]]

            @test sectional_curvature(Mpr, p, X1, X2) == 1.0
            @test sectional_curvature(Mpr, p, X1, X3) == 0.0

            Mss = PowerManifold(M1, NestedPowerRepresentation(), 1)
            @test sectional_curvature_max(Mss) == 1.0
            @test sectional_curvature_min(Mss) == 1.0
        end
    end

    @testset "Type size" begin
        M = ManifoldsBase.DefaultManifold(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2; parameter = :type)
        p = [[1, 2, 3], [3, 4, 5]]
        @test zero_vector(N, p) == 0 .* p
        @test PowerManifold(N, 3) isa PowerManifold{
            ℝ,
            <:DefaultManifold,
            ManifoldsBase.TypeParameter{Tuple{2, 3}},
            NestedPowerRepresentation,
        }
        @test PowerManifold(N, 3; parameter = :field) isa
            PowerManifold{ℝ, <:DefaultManifold, Tuple{Int, Int}, NestedPowerRepresentation}
        @test repr(N) ==
            "PowerManifold(DefaultManifold(3; field = ℝ), NestedPowerRepresentation(), 2; parameter=:type)"

        M = ManifoldsBase.DefaultManifold(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2, 3; parameter = :type)
        p = rand(N)
        @test zero_vector(N, p) == 0 .* p
    end

    @testset "TangentSpace" begin
        M = ManifoldsBase.DefaultManifold(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        p = [[1.0, 2.0, 3.0], [4.0, 5.0, 6.0]]
        TpN = TangentSpace(N, p)
        Tp1M = TpN[1]
        @test base_point(Tp1M) === p[N, 1]
        @test base_manifold(Tp1M) === M
    end

    @testset "fill" begin
        M = ManifoldsBase.DefaultManifold(3)
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        p = [1.0, 2.0, 3.0]
        P1 = fill(p, N)
        @test P1[N, 1] == p
        @test P1[N, 2] == p
        P2 = [zeros(3), zeros(3)]
        fill!(P2, p, N)
        @test P2[N, 1] == p
        @test P2[N, 2] == p

        M = ManifoldsBase.DefaultManifold(3)
        NR = PowerManifold(M, NestedReplacingPowerRepresentation(), 2)
        P1 = fill(p, NR)
        @test P1[NR, 1] === p
        @test P1[NR, 2] === p
        P2 = [zeros(3), zeros(3)]
        fill!(P2, p, NR)
        @test P2[NR, 1] === p
        @test P2[NR, 2] === p

        NAR = PowerManifold(M, ManifoldsBaseTestUtils.TestArrayRepresentation(), 2)
        P1 = fill(p, NAR)
        @test P1 isa Matrix{Float64}
        @test P1 == [1.0 1.0; 2.0 2.0; 3.0 3.0]

        P2 = similar(P1)
        fill!(P2, p, NAR)
        @test P2 == [1.0 1.0; 2.0 2.0; 3.0 3.0]
    end

    @testset "get vectors on Power of product" begin
        N = ManifoldsBase.DefaultManifold(1) × ManifoldsBase.DefaultManifold(1)
        M = PowerManifold(N, NestedPowerRepresentation(), 2)
        p = [ArrayPartition([1.0], [2.0]), ArrayPartition([3.0], [4.0])]
        B = get_basis(M, p, DefaultOrthonormalBasis())
        V = get_vectors(M, p, B)
        for v in V
            @test is_vector(M, p, v)
            @test norm(M, p, v) == 1
        end
    end

    @testset "r-norm with an inverse retraction" begin
        M = ManifoldsBaseTestUtils.TestSphere(2)
        m = ProjectionInverseRetraction()
        N = PowerManifold(M, NestedPowerRepresentation(), 2)
        p1 = [1 / sqrt(2) .* [1.0, 1.0, 0.0], [1.0, 0.0, 0.0]]
        p2 = [[0.0, 1.0, 0.0], 1 / sqrt(2) .* [1.0, 0.0, 1.0]]
        X = log(N, p1, p2)
        Xns = norm.(Ref(M), p1, X)
        dRns = norm.(Ref(M), p1, inverse_retract.(Ref(M), p1, p2, Ref(m)))
        @test distance(N, p1, p2) == norm(Xns)
        @test distance(N, p1, p2, 1) == norm(Xns, 1)
        @test distance(N, p1, p2, Inf) == norm(Xns, Inf)
        @test distance(N, p1, p2, -Inf) == norm(Xns, -Inf)
        @test distance(N, p1, p2, m) == norm(dRns)
        @test distance(N, p1, p2, m, 1) == norm(dRns, 1)
        @test distance(N, p1, p2, m, Inf) == norm(dRns, Inf)
        @test distance(N, p1, p2, m, -Inf) == norm(dRns, -Inf)

        @test norm(N, p1, X) == norm(Xns)
        @test norm(N, p1, X, 1) == norm(Xns, 1)
        @test norm(N, p1, X, Inf) == norm(Xns, Inf)
        @test norm(N, p1, X, -Inf) == norm(Xns, -Inf)
    end
end

module ManifoldsBaseStatisticsExt

using Statistics
using ManifoldsBase
import ManifoldsBase: find_best_slope_window

function ManifoldsBase.find_best_slope_window(
        X,
        Y,
        window = nothing;
        slope::Real = 2.0,
        slope_tol::Real = 0.1,
    )
    n = length(X)
    if window !== nothing && (any(window .> n))
        error(
            "One of the window sizes ($(window)) is larger than the length of the signal (n=$n).",
        )
    end
    a_best = 0
    b_best = -Inf
    i_best = 0
    j_best = 0
    r_best = 0 # longest interval
    for w in (window === nothing ? (2:n) : [window...])
        for j in 1:(n - w + 1)
            x = X[j:(j + w - 1)]
            y = Y[j:(j + w - 1)]
            # fit a line a + bx
            c = cor(x, y)
            b = std(y) / std(x) * c
            a = mean(y) - b * mean(x)
            # look for the largest interval where b is within slope tolerance
            r = (maximum(x) - minimum(x))
            if (r > r_best) && abs(b - slope) < slope_tol #longer interval found.
                r_best = r
                a_best = a
                b_best = b
                i_best = j
                j_best = j + w - 1 #last index (see x and y from before)
            end
            # not best interval - maybe it is still the (first) best slope?
            if r_best == 0 && abs(b - slope) < abs(b_best - slope)
                # but do not update `r` since this indicates only a best r
                a_best = a
                b_best = b
                i_best = j
                j_best = j + w - 1 #last index (see x and y from before)
            end
        end
    end
    return (a_best, b_best, i_best, j_best)
end
end

using Test
using ManifoldsBase

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

@testset "NotImplemented Errors" begin
    M = NonManifold()
    p = [1.0]
    q = similar(p)
    X = [2.0]
    Y = similar(X)
    for B in [
            VeeOrthogonalBasis(),
            DefaultBasis(),
            DefaultOrthogonalBasis(),
            DefaultOrthonormalBasis(),
            DiagonalizingOrthonormalBasis(X),
            CachedBasis(DefaultBasis(), X),
        ]
        if !(B isa CachedBasis)
            @test_throws MethodError get_basis(M, p, B)
            @test_throws MethodError get_vector(M, p, X, B)
            @test_throws MethodError get_vector!(M, Y, p, X, B)
        else
            @test get_basis(M, p, B) == B
            @test get_vector(M, p, X, B) == 4 # since we have 1 vector
            @test get_vector!(M, Y, p, X, B) == [4] # since Y is a vector
        end
        @test_throws MethodError get_coordinates(M, p, X, B)
        @test_throws MethodError get_coordinates!(M, Y, p, X, B)
    end
    @test_throws MethodError inverse_retract(M, p, q)
    @test_throws MethodError inverse_retract!(M, Y, p, q)
    @test_throws ErrorException PadeInverseRetraction(0)
    for IR in [
            CayleyInverseRetraction(),
            EmbeddedInverseRetraction(ProjectionInverseRetraction()),
            LogarithmicInverseRetraction(),
            PadeInverseRetraction(2),
            PolarInverseRetraction(),
            ProjectionInverseRetraction(),
            QRInverseRetraction(),
            NLSolveInverseRetraction(ExponentialRetraction()),
            SoftmaxInverseRetraction(),
        ]
        @test_throws MethodError inverse_retract(M, p, q, IR)
        @test_throws MethodError inverse_retract!(M, Y, p, q, IR)
    end
    @test_throws MethodError retract(M, p, X)
    @test_throws MethodError retract!(M, q, p, X)
    @test_throws ErrorException PadeRetraction(0)
    for R in [
            CayleyRetraction(),
            EmbeddedRetraction(ProjectionRetraction()),
            ExponentialRetraction(),
            PadeRetraction(2),
            PolarRetraction(),
            ProjectionRetraction(),
            QRRetraction(),
            SoftmaxRetraction(),
            CayleyRetraction(),
            PadeRetraction(2),
        ]
        @test_throws MethodError retract(M, p, X, R)
        @test_throws MethodError ManifoldsBase.retract_fused(M, p, X, 1.0, R)
        @test_throws MethodError retract!(M, q, p, X, R)
        @test_throws MethodError ManifoldsBase.retract_fused!(M, q, p, X, 1.0, R)
    end
    for VT in [
            DifferentiatedRetractionVectorTransport(ExponentialRetraction()),
            ProjectionTransport(),
            ParallelTransport(),
        ]
        @test_throws MethodError vector_transport_direction(M, p, X, X, VT)
        @test_throws MethodError vector_transport_direction!(M, Y, p, X, X, VT)
        @test_throws MethodError vector_transport_to(M, p, X, q, VT)
        @test_throws MethodError vector_transport_to!(M, Y, p, X, q, VT)
    end
end

@testset "Default Fallbacks and Error Messages" begin
    M = ManifoldsBase.DefaultManifold(3)
    p = [1.0, 0.0, 0.0]
    @test number_of_coordinates(M, ManifoldsBase.ℝ) == 3
    @test_throws ErrorException PadeRetraction(0)
end

@testset "Approximation errors" begin
    @test_throws DomainError GeodesicInterpolationWithinRadius(-1)
end

module ManifoldsBaseRecursiveArrayToolsExt

using ManifoldsBase
using RecursiveArrayTools
using ManifoldsBase: AbstractBasis, ProductBasisData, TangentSpaceType
using ManifoldsBase: number_of_components
using Random

import ManifoldsBase:
    allocate,
    allocate_on,
    allocate_result,
    default_inverse_retraction_method,
    default_retraction_method,
    default_vector_transport_method,
    _get_dim_ranges,
    get_vector,
    get_vectors,
    inverse_retract,
    parallel_transport_direction,
    parallel_transport_to,
    project,
    riemann_tensor,
    submanifold_component,
    submanifold_components,
    vector_transport_direction,
    _vector_transport_direction,
    _vector_transport_to,
    vector_transport_to,
    ziptuples
import Base: copyto!, getindex, setindex!, view

include("ProductManifoldRecursiveArrayToolsExt.jl")

end

using ManifoldsBase, Test

@testset "ZeroVector" begin
    X = ZeroVector()
    Y = [1.0, 2.0, 3.0]
    @test X + Y == Y
    @test Y + X == Y
    @test X + X == X
    @test X - Y == -Y
    @test Y - X == Y
    @test X - X == X
    @test -X == X
    @test allocate(X) == ZeroVector()
    @test 1.0 * X == X
    @test 0.1 * X == X

    M = ManifoldsBase.DefaultManifold(3)
    p = [0.0, 1.0, 2.0]
    @test copy(M, p, X) == X
end

@doc raw"""
    ProductManifold{𝔽,TM<:Tuple} <: AbstractManifold{𝔽}

Product manifold $M_1 × M_2 × …  × M_n$ with product geometry.

# Constructor

    ProductManifold(M_1, M_2, ..., M_n)

generates the product manifold $M_1 × M_2 × … × M_n$.
Alternatively, the same manifold can be constructed using the `×` operator:
`M_1 × M_2 × M_3`.
"""
struct ProductManifold{𝔽, TM <: Tuple} <: AbstractDecoratorManifold{𝔽}
    manifolds::TM
end

function ProductManifold(manifolds::AbstractManifold...)
    𝔽 = ManifoldsBase._unify_number_systems((number_system.(manifolds))...)
    return ProductManifold{𝔽, typeof(manifolds)}(manifolds)
end

"""
    getindex(M::ProductManifold, i)
    M[i]

access the `i`th manifold component from the [`ProductManifold`](@ref) `M`.
"""
@inline Base.getindex(M::ProductManifold, i::Integer) = M.manifolds[i]

"""
    getindex(M::TangentSpace{𝔽,<:ProductManifold}, i::Integer)
    TpM[i]

Access the `i`th manifold component from a [`ProductManifold`](@ref)s' tangent space `TpM`.
"""
function Base.getindex(TpM::TangentSpace{𝔽, <:ProductManifold}, i::Integer) where {𝔽}
    M = base_manifold(TpM)
    return TangentSpace(M[i], base_point(TpM)[M, i])
end

ProductManifold() = throw(MethodError("No method matching ProductManifold()."))

const PRODUCT_BASIS_LIST = [
    VeeOrthogonalBasis,
    DefaultBasis,
    DefaultBasis{<:Any, TangentSpaceType},
    DefaultOrthogonalBasis,
    DefaultOrthogonalBasis{<:Any, TangentSpaceType},
    DefaultOrthonormalBasis,
    DefaultOrthonormalBasis{<:Any, TangentSpaceType},
    ProjectedOrthonormalBasis{:gram_schmidt, ℝ},
    ProjectedOrthonormalBasis{:svd, ℝ},
]

"""
    ProductBasisData

A typed tuple to store tuples of data of stored/precomputed bases for a [`ProductManifold`](@ref).
"""
struct ProductBasisData{T <: Tuple}
    parts::T
end

const PRODUCT_BASIS_LIST_CACHED = [CachedBasis]

"""
    ProductMetric <: AbstractMetric

A type to represent the product of metrics for a [`ProductManifold`](@ref).
"""
struct ProductMetric <: AbstractMetric end

"""
    ProductRetraction(retractions::AbstractRetractionMethod...)

Product retraction of `retractions`. Works on [`ProductManifold`](@ref).
"""
struct ProductRetraction{TR <: Tuple} <: AbstractRetractionMethod
    retractions::TR
end

function ProductRetraction(retractions::AbstractRetractionMethod...)
    return ProductRetraction{typeof(retractions)}(retractions)
end

"""
    InverseProductRetraction(retractions::AbstractInverseRetractionMethod...)

Product inverse retraction of `inverse retractions`. Works on [`ProductManifold`](@ref).
"""
struct InverseProductRetraction{TR <: Tuple} <: AbstractInverseRetractionMethod
    inverse_retractions::TR
end

function InverseProductRetraction(inverse_retractions::AbstractInverseRetractionMethod...)
    return InverseProductRetraction{typeof(inverse_retractions)}(inverse_retractions)
end

function allocation_promotion_function(M::ProductManifold, f, args::Tuple)
    apfs = map(MM -> allocation_promotion_function(MM, f, args), M.manifolds)
    return reduce(combine_allocation_promotion_functions, apfs)
end

"""
    ProductVectorTransport(methods::AbstractVectorTransportMethod...)

Product vector transport type of `methods`. Works on [`ProductManifold`](@ref).
"""
struct ProductVectorTransport{TR <: Tuple} <: AbstractVectorTransportMethod
    methods::TR
end

function ProductVectorTransport(methods::AbstractVectorTransportMethod...)
    return ProductVectorTransport{typeof(methods)}(methods)
end

"""
    change_representer(M::ProductManifold, ::AbstractMetric, p, X)

Since the metric on a product manifold decouples, the change of a representer can be done elementwise
"""
change_representer(::ProductManifold, ::AbstractMetric, ::Any, ::Any)

function change_representer!(M::ProductManifold, Y, G::AbstractMetric, p, X)
    map(
        (m, y, P, x) -> change_representer!(m, y, G, P, x),
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return Y
end

"""
    change_metric(M::ProductManifold, ::AbstractMetric, p, X)

Since the metric on a product manifold decouples, the change of metric can be done elementwise.
"""
change_metric(::ProductManifold, ::AbstractMetric, ::Any, ::Any)

function change_metric!(M::ProductManifold, Y, G::AbstractMetric, p, X)
    map(
        (m, y, P, x) -> change_metric!(m, y, G, P, x),
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return Y
end

"""
    check_point(M::ProductManifold, p; kwargs...)

Check whether `p` is a valid point on the [`ProductManifold`](@ref) `M`.
If `p` is not a point on `M` a [`CompositeManifoldError`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#ManifoldsBase.CompositeManifoldError).consisting of all error messages of the
components, for which the tests fail is returned.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_point(M::ProductManifold, p; kwargs...)
    try
        submanifold_components(M, p)
    catch e
        return DomainError("Point $p does not support submanifold_components")
    end
    ts = ziptuples(Tuple(1:length(M.manifolds)), M.manifolds, submanifold_components(M, p))
    e = [(t[1], check_point(t[2:end]...; kwargs...)) for t in ts]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

"""
    check_size(M::ProductManifold, p; kwargs...)

Check whether `p` is of valid size on the [`ProductManifold`](@ref) `M`.
If `p` has components of wrong size a [`CompositeManifoldError`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#ManifoldsBase.CompositeManifoldError).consisting of all error messages of the
components, for which the tests fail is returned.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_size(M::ProductManifold, p)
    try
        submanifold_components(M, p)
    catch e
        return DomainError("Point $p does not support submanifold_components")
    end
    ts = ziptuples(Tuple(1:length(M.manifolds)), M.manifolds, submanifold_components(M, p))
    e = [(t[1], check_size(t[2:end]...)) for t in ts]
    errors = filter((x) -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

function check_size(M::ProductManifold, p, X)
    try
        submanifold_components(M, X)
    catch e
        return DomainError("Vector $X does not support submanifold_components")
    end
    ts = ziptuples(
        Tuple(1:length(M.manifolds)),
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    e = [(t[1], check_size(t[2:end]...)) for t in ts]
    errors = filter(x -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end
"""
    check_vector(M::ProductManifold, p, X; kwargs... )

Check whether `X` is a tangent vector to `p` on the [`ProductManifold`](@ref)
`M`, i.e. all projections to base manifolds must be respective tangent vectors.
If `X` is not a tangent vector to `p` on `M` a [`CompositeManifoldError`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/functions.html#ManifoldsBase.CompositeManifoldError).consisting
of all error messages of the components, for which the tests fail is returned.

The tolerance for the last test can be set using the `kwargs...`.
"""
function check_vector(M::ProductManifold, p, X; kwargs...)
    try
        submanifold_components(M, X)
    catch e
        return DomainError("Vector $X does not support submanifold_components")
    end
    ts = ziptuples(
        Tuple(1:length(M.manifolds)),
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    e = [(t[1], check_vector(t[2:end]...; kwargs...)) for t in ts]
    errors = filter(x -> !(x[2] === nothing), e)
    cerr = [ComponentManifoldError(er...) for er in errors]
    (length(errors) > 1) && return CompositeManifoldError(cerr)
    (length(errors) == 1) && return cerr[1]
    return nothing
end

@doc raw"""
    ×(M, N)
    cross(M, N)
    cross(M1, M2, M3,...)

Return the [`ProductManifold`](@ref) For two `AbstractManifold`s `M` and `N`,
where for the case that one of them is a [`ProductManifold`](@ref) itself,
the other is either prepended (if `N` is a product) or appenden (if `M`) is.
If both are product manifold, they are combined into one product manifold,
keeping the order.

For the case that more than one is a product manifold of these is build with the
same approach as above
"""
cross(::AbstractManifold...)
LinearAlgebra.cross(M::AbstractManifold, N::AbstractManifold) = ProductManifold(M, N)
function LinearAlgebra.cross(M::ProductManifold, N::AbstractManifold)
    return ProductManifold(M.manifolds..., N)
end
function LinearAlgebra.cross(M::AbstractManifold, N::ProductManifold)
    return ProductManifold(M, N.manifolds...)
end
function LinearAlgebra.cross(M::ProductManifold, N::ProductManifold)
    return ProductManifold(M.manifolds..., N.manifolds...)
end


@doc raw"""
    ×(m, n)
    cross(m, n)
    cross(m1, m2, m3,...)

Return the [`ProductRetraction`](@ref) For two or more [`AbstractRetractionMethod`](@ref)s,
where for the case that one of them is a [`ProductRetraction`](@ref) itself,
the other is either prepended (if `m` is a product) or appenden (if `n`) is.
If both [`ProductRetraction`](@ref)s, they are combined into one keeping the order.
"""
cross(::AbstractRetractionMethod...)
function LinearAlgebra.cross(m::AbstractRetractionMethod, n::AbstractRetractionMethod)
    return ProductRetraction(m, n)
end
function LinearAlgebra.cross(m::ProductRetraction, n::AbstractRetractionMethod)
    return ProductRetraction(m.retractions..., n)
end
function LinearAlgebra.cross(m::AbstractRetractionMethod, n::ProductRetraction)
    return ProductRetraction(m, n.retractions...)
end
function LinearAlgebra.cross(m::ProductRetraction, n::ProductRetraction)
    return ProductRetraction(m.retractions..., n.retractions...)
end

@doc raw"""
    ×(m, n)
    cross(m, n)
    cross(m1, m2, m3,...)

Return the [`InverseProductRetraction`](@ref) For two or more [`AbstractInverseRetractionMethod`](@ref)s,
where for the case that one of them is a [`InverseProductRetraction`](@ref) itself,
the other is either prepended (if `r` is a product) or appenden (if `s`) is.
If both [`InverseProductRetraction`](@ref)s, they are combined into one keeping the order.
"""
cross(::AbstractInverseRetractionMethod...)
function LinearAlgebra.cross(
        m::AbstractInverseRetractionMethod,
        n::AbstractInverseRetractionMethod,
    )
    return InverseProductRetraction(m, n)
end
function LinearAlgebra.cross(
        m::InverseProductRetraction,
        n::AbstractInverseRetractionMethod,
    )
    return InverseProductRetraction(m.inverse_retractions..., n)
end
function LinearAlgebra.cross(
        m::AbstractInverseRetractionMethod,
        n::InverseProductRetraction,
    )
    return InverseProductRetraction(m, n.inverse_retractions...)
end
function LinearAlgebra.cross(m::InverseProductRetraction, n::InverseProductRetraction)
    return InverseProductRetraction(m.inverse_retractions..., n.inverse_retractions...)
end


@doc raw"""
    ×(m, n)
    cross(m, n)
    cross(m1, m2, m3,...)

Return the [`ProductVectorTransport`](@ref) For two or more [`AbstractVectorTransportMethod`](@ref)s,
where for the case that one of them is a [`ProductVectorTransport`](@ref) itself,
the other is either prepended (if `r` is a product) or appenden (if `s`) is.
If both [`ProductVectorTransport`](@ref)s, they are combined into one keeping the order.
"""
cross(::AbstractVectorTransportMethod...)
function LinearAlgebra.cross(
        m::AbstractVectorTransportMethod,
        n::AbstractVectorTransportMethod,
    )
    return ProductVectorTransport(m, n)
end
function LinearAlgebra.cross(m::ProductVectorTransport, n::AbstractVectorTransportMethod)
    return ProductVectorTransport(m.methods..., n)
end
function LinearAlgebra.cross(m::AbstractVectorTransportMethod, n::ProductVectorTransport)
    return ProductVectorTransport(m, n.methods...)
end
function LinearAlgebra.cross(m::ProductVectorTransport, n::ProductVectorTransport)
    return ProductVectorTransport(m.methods..., n.methods...)
end

function default_retraction_method(M::ProductManifold)
    return ProductRetraction(map(default_retraction_method, M.manifolds)...)
end

function default_inverse_retraction_method(M::ProductManifold)
    return InverseProductRetraction(map(default_inverse_retraction_method, M.manifolds)...)
end

function default_vector_transport_method(M::ProductManifold)
    return ProductVectorTransport(map(default_vector_transport_method, M.manifolds)...)
end

_doc_distance_prod = """
    distance(M::ProductManifold, p, q, r::Real=2)
    distance(M::ProductManifold, p, q, m::AbstractInverseRetractionMethod=LogarithmicInverseRetraction(), r::Real=2)

Compute the distance between `q` and `p` on an [`ProductManifold`](@ref).

First, the componentwise distances are computed. These can be approximated using the
`norm` of an [`AbstractInverseRetractionMethod`](@ref) `m`.
Then, the `r`-norm of the tuple of these elements is computed.
"""

@doc "$(_doc_distance_prod)"
function distance(M::ProductManifold, p, q, r::Real = 2)
    return norm(
        map(
            distance,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
        ),
        r,
    )
end
function distance(M::ProductManifold, p, q, ::LogarithmicInverseRetraction, r::Real = 2)
    return distance(M, p, q, r)
end

@doc "$(_doc_distance_prod)"
function distance(M::ProductManifold, p, q, m::AbstractInverseRetractionMethod, r::Real = 2)
    return norm(
        map(
            (M, p, q) -> distance(M, p, q, m),
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
        ),
        r,
    )
end
function distance(M::ProductManifold, p, q, method::InverseProductRetraction, r::Real = 2)
    return norm(
        map(
            (M, p, q, m) -> distance(M, p, q, m),
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
            method.inverse_retractions,
        ),
        r,
    )
end
@doc raw"""
    exp(M::ProductManifold, p, X)

compute the exponential map from `p` in the direction of `X` on the [`ProductManifold`](@ref) `M`,
which is the elementwise exponential map on the internal manifolds that build `M`.
"""
exp(::ProductManifold, ::Any, ::Any)

function exp!(M::ProductManifold, q, p, X)
    map(
        exp!,
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return q
end
function exp_fused!(M::ProductManifold, q, p, X, t::Number)
    map(
        (N, qc, pc, Xc) -> exp_fused!(N, qc, pc, Xc, t),
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return q
end

function get_basis(M::ProductManifold, p, B::AbstractBasis)
    parts = map(t -> get_basis(t..., B), ziptuples(M.manifolds, submanifold_components(p)))
    return CachedBasis(B, ProductBasisData(parts))
end
function get_basis(M::ProductManifold, p, B::CachedBasis)
    return invoke(get_basis, Tuple{AbstractManifold, Any, CachedBasis}, M, p, B)
end
function get_basis(M::ProductManifold, p, B::DiagonalizingOrthonormalBasis)
    vs = map(
        ziptuples(
            M.manifolds,
            submanifold_components(p),
            submanifold_components(B.frame_direction),
        ),
    ) do t
        return get_basis(t[1], t[2], DiagonalizingOrthonormalBasis(t[3]))
    end
    return CachedBasis(B, ProductBasisData(vs))
end

"""
    get_component(M::ProductManifold, p, i)

Get the `i`th component of a point `p` on a [`ProductManifold`](@ref) `M`.
"""
@inline function get_component(M::ProductManifold, p, i)
    return submanifold_component(M, p, i)
end

function get_coordinates(M::ProductManifold, p, X, B::AbstractBasis)
    reps = map(
        t -> get_coordinates(t..., B),
        ziptuples(M.manifolds, submanifold_components(M, p), submanifold_components(M, X)),
    )
    return vcat(reps...)
end
function get_coordinates(
        M::ProductManifold,
        p,
        X,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:ProductBasisData},
    ) where {𝔽}
    reps = map(
        get_coordinates,
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
        B.data.parts,
    )
    return vcat(reps...)
end

function get_coordinates!(M::ProductManifold, Xⁱ, p, X, B::AbstractBasis)
    dim = manifold_dimension(M)
    @assert length(Xⁱ) == dim
    i = one(dim)
    ts = ziptuples(M.manifolds, submanifold_components(M, p), submanifold_components(M, X))
    for t in ts
        SM = first(t)
        dim = manifold_dimension(SM)
        tXⁱ = @inbounds view(Xⁱ, i:(i + dim - 1))
        get_coordinates!(SM, tXⁱ, Base.tail(t)..., B)
        i += dim
    end
    return Xⁱ
end
function get_coordinates!(
        M::ProductManifold,
        Xⁱ,
        p,
        X,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:ProductBasisData},
    ) where {𝔽}
    dim = manifold_dimension(M)
    @assert length(Xⁱ) == dim
    i = one(dim)
    ts = ziptuples(
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
        B.data.parts,
    )
    for t in ts
        SM = first(t)
        dim = manifold_dimension(SM)
        tXⁱ = @inbounds view(Xⁱ, i:(i + dim - 1))
        get_coordinates!(SM, tXⁱ, Base.tail(t)...)
        i += dim
    end
    return Xⁱ
end

function _get_dim_ranges(dims::NTuple{N, Any}) where {N}
    dims_acc = accumulate(+, (1, dims...))
    return ntuple(i -> (dims_acc[i]:(dims_acc[i] + dims[i] - 1)), Val(N))
end

function get_vector!(M::ProductManifold, X, p, Xⁱ, B::AbstractBasis)
    dims = map(manifold_dimension, M.manifolds)
    @assert length(Xⁱ) == sum(dims)
    dim_ranges = _get_dim_ranges(dims)
    tXⁱ = map(dr -> (@inbounds view(Xⁱ, dr)), dim_ranges)
    ts = ziptuples(
        M.manifolds,
        submanifold_components(M, X),
        submanifold_components(M, p),
        tXⁱ,
    )
    map(ts) do t
        return get_vector!(t..., B)
    end
    return X
end
function get_vector!(
        M::ProductManifold,
        X,
        p,
        Xⁱ,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:ProductBasisData},
    ) where {𝔽}
    dims = map(manifold_dimension, M.manifolds)
    @assert length(Xⁱ) == sum(dims)
    dim_ranges = _get_dim_ranges(dims)
    tXⁱ = map(dr -> (@inbounds view(Xⁱ, dr)), dim_ranges)
    ts = ziptuples(
        M.manifolds,
        submanifold_components(M, X),
        submanifold_components(M, p),
        tXⁱ,
        B.data.parts,
    )
    map(ts) do t
        return get_vector!(t...)
    end
    return X
end

"""
    has_components(::ProductManifold)

Return `true` since points on an [`ProductManifold`](@ref) consist of components.
"""
has_components(::ProductManifold) = true

@doc raw"""
    injectivity_radius(M::ProductManifold)
    injectivity_radius(M::ProductManifold, x)

Compute the injectivity radius on the [`ProductManifold`](@ref), which is the
minimum of the factor manifolds.
"""
injectivity_radius(::ProductManifold, ::Any...)
function injectivity_radius(M::ProductManifold, p)
    return min(map(injectivity_radius, M.manifolds, submanifold_components(M, p))...)
end
function injectivity_radius(M::ProductManifold, p, m::AbstractRetractionMethod)
    return min(
        map(
            (lM, lp) -> injectivity_radius(lM, lp, m),
            M.manifolds,
            submanifold_components(M, p),
        )...,
    )
end
function injectivity_radius(M::ProductManifold, p, m::ProductRetraction)
    return min(
        map(
            (lM, lp, lm) -> injectivity_radius(lM, lp, lm),
            M.manifolds,
            submanifold_components(M, p),
            m.retractions,
        )...,
    )
end
injectivity_radius(M::ProductManifold) = min(map(injectivity_radius, M.manifolds)...)
function injectivity_radius(M::ProductManifold, m::AbstractRetractionMethod)
    return min(map(manif -> injectivity_radius(manif, m), M.manifolds)...)
end
function injectivity_radius(M::ProductManifold, m::ProductRetraction)
    return min(map((lM, lm) -> injectivity_radius(lM, lm), M.manifolds, m.retractions)...)
end

@doc raw"""
    inner(M::ProductManifold, p, X, Y)

compute the inner product of two tangent vectors `X`, `Y` from the tangent space
at `p` on the [`ProductManifold`](@ref) `M`, which is just the sum of the
internal manifolds that build `M`.
"""
function inner(M::ProductManifold, p, X, Y)
    subproducts = map(
        inner,
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, Y),
    )
    return sum(subproducts)
end

@doc raw"""
    inverse_retract(M::ProductManifold, p, q, m::InverseProductRetraction)

Compute the inverse retraction from `p` with respect to `q` on the [`ProductManifold`](@ref)
`M` using an [`InverseProductRetraction`](@ref), which by default encapsulates a inverse
retraction for each manifold of the product. Then this method is performed elementwise,
so the encapsulated inverse retraction methods have to be available per factor.
"""
inverse_retract(::ProductManifold, ::Any, ::Any, ::Any, ::InverseProductRetraction)

@doc raw"""
    inverse_retract(M::ProductManifold, p, q, m::AbstractInverseRetractionMethod)

Compute the inverse retraction from `p` with respect to `q` on the [`ProductManifold`](@ref)
`M` using an [`AbstractInverseRetractionMethod`](@ref), which is used on each manifold of
the product.
"""
inverse_retract(::ProductManifold, ::Any, ::Any, ::Any, ::AbstractInverseRetractionMethod)

function inverse_retract!(M::ProductManifold, Y, p, q, method::InverseProductRetraction)
    map(
        (iM, iY, ip, iq, im) -> inverse_retract!(iM, iY, ip, iq, im),
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, q),
        method.inverse_retractions,
    )
    return Y
end
function inverse_retract!(
        M::ProductManifold,
        Y,
        p,
        q,
        method::IRM,
    ) where {IRM <: AbstractInverseRetractionMethod}
    map(
        (iM, iY, ip, iq) -> inverse_retract!(iM, iY, ip, iq, method),
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, q),
    )
    return Y
end
function _isapprox(M::ProductManifold, p, q; kwargs...)
    return all(
        t -> isapprox(t...; kwargs...),
        ziptuples(M.manifolds, submanifold_components(M, p), submanifold_components(M, q)),
    )
end
function _isapprox(M::ProductManifold, p, X, Y; kwargs...)
    return all(
        t -> isapprox(t...; kwargs...),
        ziptuples(
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, Y),
        ),
    )
end

"""
    is_flat(::ProductManifold)

Return true if and only if all component manifolds of [`ProductManifold`](@ref) `M` are flat.
"""
function is_flat(M::ProductManifold)
    return all(is_flat, M.manifolds)
end

@doc raw"""
    log(M::ProductManifold, p, q)

Compute the logarithmic map from `p` to `q` on the [`ProductManifold`](@ref) `M`,
which can be computed using the logarithmic maps of the manifolds elementwise.
"""
log(::ProductManifold, ::Any...)

function log!(M::ProductManifold, X, p, q)
    map(
        log!,
        M.manifolds,
        submanifold_components(M, X),
        submanifold_components(M, p),
        submanifold_components(M, q),
    )
    return X
end

@doc raw"""
    manifold_dimension(M::ProductManifold)

Return the manifold dimension of the [`ProductManifold`](@ref), which is the sum of the
manifold dimensions the product is made of.
"""
manifold_dimension(M::ProductManifold) = mapreduce(manifold_dimension, +, M.manifolds)

function mid_point!(M::ProductManifold, q, p1, p2)
    map(
        mid_point!,
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p1),
        submanifold_components(M, p2),
    )
    return q
end

@doc raw"""
    norm(M::ProductManifold, p, X, r::Real=2)

Compute the (`r`-)norm of `X` from the tangent space of `p` on the [`ProductManifold`](@ref),
i.e. from the element wise norms the 2-norm is computed.
"""
function LinearAlgebra.norm(M::ProductManifold, p, X, r::Real = 2)
    norms =
        (map(norm, M.manifolds, submanifold_components(M, p), submanifold_components(M, X)))
    return norm(norms, r)
end

"""
    number_of_components(M::ProductManifold{<:NTuple{N,Any}}) where {N}

Calculate the number of manifolds multiplied in the given [`ProductManifold`](@ref) `M`.
"""
number_of_components(::ProductManifold{𝔽, <:NTuple{N, Any}}) where {𝔽, N} = N

function parallel_transport_direction!(M::ProductManifold, Y, p, X, d)
    map(
        parallel_transport_direction!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, d),
    )
    return Y
end

function parallel_transport_to!(M::ProductManifold, Y, p, X, q)
    map(
        parallel_transport_to!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, q),
    )
    return Y
end

function project!(M::ProductManifold, q, p)
    map(project!, M.manifolds, submanifold_components(M, q), submanifold_components(M, p))
    return q
end

function project!(M::ProductManifold, Y, p, X)
    map(
        project!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return Y
end

function Random.rand!(
        M::ProductManifold,
        pX;
        vector_at = nothing,
        parts_kwargs = map(_ -> (;), M.manifolds),
    )
    return rand!(
        Random.default_rng(),
        M,
        pX;
        vector_at = vector_at,
        parts_kwargs = parts_kwargs,
    )
end
function Random.rand!(
        rng::AbstractRNG,
        M::ProductManifold,
        pX;
        vector_at = nothing,
        parts_kwargs = map(_ -> (;), M.manifolds),
    )
    if vector_at === nothing
        map(
            (N, q, kwargs) -> rand!(rng, N, q; kwargs...),
            M.manifolds,
            submanifold_components(M, pX),
            parts_kwargs,
        )
    else
        map(
            (N, X, p, kwargs) -> rand!(rng, N, X; vector_at = p, kwargs...),
            M.manifolds,
            submanifold_components(M, pX),
            submanifold_components(M, vector_at),
            parts_kwargs,
        )
    end
    return pX
end

@doc raw"""
    retract(M::ProductManifold, p, X, m::ProductRetraction)

Compute the retraction from `p` with tangent vector `X` on the [`ProductManifold`](@ref) `M`
using an [`ProductRetraction`](@ref), which by default encapsulates retractions of the
base manifolds. Then this method is performed elementwise, so the encapsulated retractions
method has to be one that is available on the manifolds.
"""
retract(::ProductManifold, ::Any, ::Any, ::ProductRetraction)

@doc raw"""
    retract(M::ProductManifold, p, X, m::AbstractRetractionMethod)

Compute the retraction from `p` with tangent vector `X` on the [`ProductManifold`](@ref) `M`
using the [`AbstractRetractionMethod`](@ref) `m` on every manifold.
"""
retract(::ProductManifold, ::Any, ::Any, ::AbstractRetractionMethod)

function retract!(M::ProductManifold, q, p, X, method::ProductRetraction)
    map(
        (N, qc, pc, Xc, rm) -> retract!(N, qc, pc, Xc, rm),
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
        method.retractions,
    )
    return q
end
function retract!(
        M::ProductManifold,
        q,
        p,
        X,
        method::RTM,
    ) where {RTM <: AbstractRetractionMethod}
    map(
        (N, qc, pc, Xc) -> retract!(N, qc, pc, Xc, method),
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return q
end

function retract_fused!(M::ProductManifold, q, p, X, t::Number, method::ProductRetraction)
    map(
        (N, qc, pc, Xc, rm) -> retract_fused!(N, qc, pc, Xc, t, rm),
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
        method.retractions,
    )
    return q
end
function retract_fused!(
        M::ProductManifold,
        q,
        p,
        X,
        t::Number,
        method::RTM,
    ) where {RTM <: AbstractRetractionMethod}
    map(
        (N, qc, pc, Xc) -> retract_fused!(N, qc, pc, Xc, t, method),
        M.manifolds,
        submanifold_components(M, q),
        submanifold_components(M, p),
        submanifold_components(M, X),
    )
    return q
end

function representation_size(::ProductManifold)
    return nothing
end

@doc raw"""
    riemann_tensor(M::ProductManifold, p, X, Y, Z)

Compute the Riemann tensor at point from `p` with tangent vectors `X`, `Y` and `Z` on
the [`ProductManifold`](@ref) `M`.
"""
riemann_tensor(M::ProductManifold, p, X, Y, X)

function riemann_tensor!(M::ProductManifold, Xresult, p, X, Y, Z)
    map(
        riemann_tensor!,
        M.manifolds,
        submanifold_components(M, Xresult),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, Y),
        submanifold_components(M, Z),
    )
    return Xresult
end

@doc raw"""
    sectional_curvature(M::ProductManifold, p, X, Y)

Compute the sectional curvature of a manifold ``\mathcal M`` at a point ``p \in \mathcal M``
on two linearly independent tangent vectors at ``p``. It may be 0 for a product of non-flat
manifolds if projections of `X` and `Y` on subspaces corresponding to component manifolds
are not linearly independent.
"""
function sectional_curvature(M::ProductManifold, p, X, Y)
    curvature = zero(number_eltype(X))
    map(
        M.manifolds,
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, Y),
    ) do M_i, p_i, X_i, Y_i
        if are_linearly_independent(M_i, p_i, X_i, Y_i)
            curvature += sectional_curvature(M_i, p_i, X_i, Y_i)
        end
    end
    return curvature
end

@doc raw"""
    sectional_curvature_max(M::ProductManifold)

Upper bound on sectional curvature of [`ProductManifold`](@ref) `M`. It is the maximum of
sectional curvatures of component manifolds and 0 in case there are two or more component
manifolds, as the sectional curvature corresponding to the plane spanned by vectors
`(X_1, 0)` and `(0, X_2)` is 0.
"""
function sectional_curvature_max(M::ProductManifold)
    max_sc = mapreduce(sectional_curvature_max, max, M.manifolds)
    if length(M.manifolds) > 1
        return max(max_sc, zero(max_sc))
    else
        return max_sc
    end
end

@doc raw"""
    sectional_curvature_min(M::ProductManifold)

Lower bound on sectional curvature of [`ProductManifold`](@ref) `M`. It is the minimum of
sectional curvatures of component manifolds and 0 in case there are two or more component
manifolds, as the sectional curvature corresponding to the plane spanned by vectors
`(X_1, 0)` and `(0, X_2)` is 0.
"""
function sectional_curvature_min(M::ProductManifold)
    min_sc = mapreduce(sectional_curvature_min, min, M.manifolds)
    if length(M.manifolds) > 1
        return min(min_sc, zero(min_sc))
    else
        return min_sc
    end
end

"""
    select_from_tuple(t::NTuple{N, Any}, positions::Val{P})

Selects elements of tuple `t` at positions specified by the second argument.
For example `select_from_tuple(("a", "b", "c"), Val((3, 1, 1)))` returns
`("c", "a", "a")`.
"""
@generated function select_from_tuple(t::NTuple{N, Any}, positions::Val{P}) where {N, P}
    for k in P
        (k < 0 || k > N) && error("positions must be between 1 and $N")
    end
    return Expr(:tuple, [Expr(:ref, :t, k) for k in P]...)
end

"""
    set_component!(M::ProductManifold, q, p, i)

Set the `i`th component of a point `q` on a [`ProductManifold`](@ref) `M` to `p`, where `p` is a point on the [`AbstractManifold`](https://juliamanifolds.github.io/ManifoldsBase.jl/stable/types.html#ManifoldsBase.AbstractManifold)  this factor of the product manifold consists of.
"""
function set_component!(M::ProductManifold, q, p, i)
    return copyto!(submanifold_component(M, q, i), p)
end

function _show_submanifold(io::IO, M::AbstractManifold; pre = "")
    sx = sprint(show, "text/plain", M, context = io, sizehint = 0)
    if occursin('\n', sx)
        sx = sprint(show, M, context = io, sizehint = 0)
    end
    sx = replace(sx, '\n' => "\n$(pre)")
    print(io, pre, sx)
    return nothing
end

function _show_submanifold_range(io::IO, Ms, range; pre = "")
    for i in range
        M = Ms[i]
        print(io, '\n')
        _show_submanifold(io, M; pre = pre)
    end
    return nothing
end

function _show_product_manifold_no_header(io::IO, M)
    n = length(M.manifolds)
    sz = displaysize(io)
    screen_height, screen_width = sz[1] - 4, sz[2]
    half_height = div(screen_height, 2)
    inds = 1:n
    pre = " "
    if n > screen_height
        inds = [1:half_height; (n - div(screen_height - 1, 2) + 1):n]
    end
    if n ≤ screen_height
        _show_submanifold_range(io, M.manifolds, 1:n; pre = pre)
    else
        _show_submanifold_range(io, M.manifolds, 1:half_height; pre = pre)
        print(io, "\n$(pre)⋮")
        _show_submanifold_range(
            io,
            M.manifolds,
            (n - div(screen_height - 1, 2) + 1):n;
            pre = pre,
        )
    end
    return nothing
end

function Base.show(io::IO, ::MIME"text/plain", M::ProductManifold)
    n = length(M.manifolds)
    print(io, "ProductManifold with $(n) submanifold$(n == 1 ? "" : "s"):")
    return _show_product_manifold_no_header(io, M)
end

function Base.show(io::IO, M::ProductManifold)
    return print(io, "ProductManifold(", join(M.manifolds, ", "), ")")
end

function Base.show(io::IO, m::ProductRetraction)
    return print(io, "ProductRetraction(", join(m.retractions, ", "), ")")
end

function Base.show(io::IO, m::InverseProductRetraction)
    return print(io, "InverseProductRetraction(", join(m.inverse_retractions, ", "), ")")
end

function Base.show(io::IO, m::ProductVectorTransport)
    return print(io, "ProductVectorTransport(", join(m.methods, ", "), ")")
end


function Base.show(
        io::IO,
        mime::MIME"text/plain",
        B::CachedBasis{𝔽, T, D},
    ) where {𝔽, T <: AbstractBasis{𝔽}, D <: ProductBasisData}
    println(io, "$(T) for a product manifold")
    for (i, cb) in enumerate(B.data.parts)
        println(io, "Basis for component $i:")
        show(io, mime, cb)
        println(io)
    end
    return nothing
end

"""
    submanifold(M::ProductManifold, i::Integer)

Extract the `i`th factor of the product manifold `M`.
"""
submanifold(M::ProductManifold, i::Integer) = M.manifolds[i]

"""
    submanifold(M::ProductManifold, i::Val)
    submanifold(M::ProductManifold, i::AbstractVector)

Extract the factor of the product manifold `M` indicated by indices in `i`.
For example, for `i` equal to `Val((1, 3))` the product manifold constructed
from the first and the third factor is returned.

The version with `AbstractVector` is not type-stable, for better performance use `Val`.
"""
function submanifold(M::ProductManifold, i::Val)
    return ProductManifold(select_from_tuple(M.manifolds, i)...)
end
submanifold(M::ProductManifold, i::AbstractVector) = submanifold(M, Val(tuple(i...)))

function vector_transport_direction!(
        M::ProductManifold,
        Y,
        p,
        X,
        d,
        m::ProductVectorTransport,
    )
    map(
        vector_transport_direction!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, d),
        m.methods,
    )
    return Y
end
function vector_transport_direction!(
        M::ProductManifold,
        Y,
        p,
        X,
        d,
        m::VTM,
    ) where {VTM <: AbstractVectorTransportMethod}
    map(
        (iM, iY, ip, iX, id) -> vector_transport_direction!(iM, iY, ip, iX, id, m),
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, d),
    )
    return Y
end

@doc raw"""
    vector_transport_to(M::ProductManifold, p, X, q, m::ProductVectorTransport)

Compute the vector transport the tangent vector `X` at `p` to `q` on the
[`ProductManifold`](@ref) `M` using a [`ProductVectorTransport`](@ref) `m`.
"""
vector_transport_to(::ProductManifold, ::Any, ::Any, ::Any, ::ProductVectorTransport)

@doc raw"""
    vector_transport_to(M::ProductManifold, p, X, q, m::AbstractVectorTransportMethod)

Compute the vector transport the tangent vector `X` at `p` to `q` on the
[`ProductManifold`](@ref) `M` using an [`AbstractVectorTransportMethod`](@ref) `m`
on each manifold.
"""
vector_transport_to(::ProductManifold, ::Any, ::Any, ::Any, ::AbstractVectorTransportMethod)


function vector_transport_to!(M::ProductManifold, Y, p, X, q, m::ProductVectorTransport)
    map(
        vector_transport_to!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, q),
        m.methods,
    )
    return Y
end
function vector_transport_to!(
        M::ProductManifold,
        Y,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod,
    )
    return map(
            (iM, iY, ip, iX, iq) -> vector_transport_to!(iM, iY, ip, iX, iq, m),
            M.manifolds,
            submanifold_components(M, Y),
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, q),
        ),
        return Y
end

@doc raw"""
    Y = Weingarten(M::ProductManifold, p, X, V)
    Weingarten!(M::ProductManifold, Y, p, X, V)

Since the metric decouples, also the computation of the Weingarten map
``\mathcal W_p`` can be computed elementwise on the single elements of the [`ProductManifold`](@ref) `M`.
"""
Weingarten(::ProductManifold, p, X, V)

function Weingarten!(M::ProductManifold, Y, p, X, V)
    map(
        Weingarten!,
        M.manifolds,
        submanifold_components(M, Y),
        submanifold_components(M, p),
        submanifold_components(M, X),
        submanifold_components(M, V),
    )
    return Y
end

function zero_vector!(M::ProductManifold, X, p)
    map(
        zero_vector!,
        M.manifolds,
        submanifold_components(M, X),
        submanifold_components(M, p),
    )
    return X
end


@doc raw"""
    submanifold_component(M::AbstractManifold, p, i::Integer)
    submanifold_component(M::AbstractManifold, p, ::Val{i}) where {i}
    submanifold_component(p, i::Integer)
    submanifold_component(p, ::Val{i}) where {i}

Project the product array `p` on `M` to its `i`th component. A new array is returned.
"""
submanifold_component(::Any...)
@inline function submanifold_component(M::AbstractManifold, p, i::Integer)
    return submanifold_component(M, p, Val(i))
end
@inline submanifold_component(M::AbstractManifold, p, i::Val) = submanifold_component(p, i)
@inline submanifold_component(p, i::Integer) = submanifold_component(p, Val(i))

@doc raw"""
    submanifold_components(M::AbstractManifold, p)
    submanifold_components(p)

Get the projected components of `p` on the submanifolds of `M`. The components are returned in a Tuple.
"""
submanifold_components(::Any...)
@inline submanifold_components(::AbstractManifold, p) = submanifold_components(p)

"""
    ziptuples(a, b[, c[, d[, e]]])

Zips tuples `a`, `b`, and remaining in a fast, type-stable way. If they have different
lengths, the result is trimmed to the length of the shorter tuple.
"""
@generated function ziptuples(a::NTuple{N, Any}, b::NTuple{M, Any}) where {N, M}
    ex = Expr(:tuple)
    for i in 1:min(N, M)
        push!(ex.args, :((a[$i], b[$i])))
    end
    return ex
end
@generated function ziptuples(
        a::NTuple{N, Any},
        b::NTuple{M, Any},
        c::NTuple{L, Any},
    ) where {N, M, L}
    ex = Expr(:tuple)
    for i in 1:min(N, M, L)
        push!(ex.args, :((a[$i], b[$i], c[$i])))
    end
    return ex
end
@generated function ziptuples(
        a::NTuple{N, Any},
        b::NTuple{M, Any},
        c::NTuple{L, Any},
        d::NTuple{K, Any},
    ) where {N, M, L, K}
    ex = Expr(:tuple)
    for i in 1:min(N, M, L, K)
        push!(ex.args, :((a[$i], b[$i], c[$i], d[$i])))
    end
    return ex
end
@generated function ziptuples(
        a::NTuple{N, Any},
        b::NTuple{M, Any},
        c::NTuple{L, Any},
        d::NTuple{K, Any},
        e::NTuple{J, Any},
    ) where {N, M, L, K, J}
    ex = Expr(:tuple)
    for i in 1:min(N, M, L, K, J)
        push!(ex.args, :((a[$i], b[$i], c[$i], d[$i], e[$i])))
    end
    return ex
end

allocate(a::AbstractArray{<:ArrayPartition}) = map(allocate, a)
allocate(x::ArrayPartition) = ArrayPartition(map(allocate, x.x)...)
function allocate(x::ArrayPartition, T::Type)
    return ArrayPartition(map(t -> allocate(t, T), submanifold_components(x))...)
end

allocate_on(M::ProductManifold) = ArrayPartition(map(N -> allocate_on(N), M.manifolds)...)
function allocate_on(M::ProductManifold, ::Type{ArrayPartition})
    return ArrayPartition(map(N -> allocate_on(N), M.manifolds)...)
end
function allocate_on(M::ProductManifold, ::Type{ArrayPartition{T, U}}) where {T, U}
    return ArrayPartition(map((N, V) -> allocate_on(N, V), M.manifolds, U.parameters)...)
end
function allocate_on(M::ProductManifold, ft::TangentSpaceType)
    return ArrayPartition(map(N -> allocate_on(N, ft), M.manifolds)...)
end
function allocate_on(M::ProductManifold, ft::TangentSpaceType, ::Type{ArrayPartition})
    return ArrayPartition(map(N -> allocate_on(N, ft), M.manifolds)...)
end
function allocate_on(
        M::ProductManifold,
        ft::TangentSpaceType,
        ::Type{ArrayPartition{T, U}},
    ) where {T, U}
    return ArrayPartition(
        map((N, V) -> allocate_on(N, ft, V), M.manifolds, U.parameters)...,
    )
end

@inline function allocate_result(M::ProductManifold, f)
    return ArrayPartition(map(N -> allocate_result(N, f), M.manifolds))
end

function copyto!(M::ProductManifold, q::ArrayPartition, p::ArrayPartition)
    map(copyto!, M.manifolds, submanifold_components(q), submanifold_components(p))
    return q
end
function copyto!(
        M::ProductManifold,
        Y::ArrayPartition,
        p::ArrayPartition,
        X::ArrayPartition,
    )
    map(
        copyto!,
        M.manifolds,
        submanifold_components(Y),
        submanifold_components(p),
        submanifold_components(X),
    )
    return Y
end


function default_retraction_method(M::ProductManifold, ::Type{T}) where {T <: ArrayPartition}
    return ProductRetraction(
        map(default_retraction_method, M.manifolds, T.parameters[2].parameters)...,
    )
end

function default_inverse_retraction_method(
        M::ProductManifold,
        ::Type{T},
    ) where {T <: ArrayPartition}
    return InverseProductRetraction(
        map(default_inverse_retraction_method, M.manifolds, T.parameters[2].parameters)...,
    )
end

function default_vector_transport_method(
        M::ProductManifold,
        ::Type{T},
    ) where {T <: ArrayPartition}
    return ProductVectorTransport(
        map(default_vector_transport_method, M.manifolds, T.parameters[2].parameters)...,
    )
end

function Base.exp(M::ProductManifold, p::ArrayPartition, X::ArrayPartition)
    return ArrayPartition(
        map(
            exp,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
        )...,
    )
end
function ManifoldsBase.exp_fused(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        t::Number,
    )
    return ArrayPartition(
        map(
            (N, pc, Xc) -> ManifoldsBase.exp_fused(N, pc, Xc, t),
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
        )...,
    )
end

function get_vector(
        M::ProductManifold,
        p::ArrayPartition,
        Xⁱ,
        B::AbstractBasis{𝔽, TangentSpaceType},
    ) where {𝔽}
    dims = map(manifold_dimension, M.manifolds)
    @assert length(Xⁱ) == sum(dims)
    dim_ranges = _get_dim_ranges(dims)
    tXⁱ = map(dr -> (@inbounds view(Xⁱ, dr)), dim_ranges)
    ts = ziptuples(M.manifolds, submanifold_components(M, p), tXⁱ)
    return ArrayPartition(map((@inline t -> get_vector(t..., B)), ts))
end
function get_vector(
        M::ProductManifold,
        p::ArrayPartition,
        Xⁱ,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:ProductBasisData},
    ) where {𝔽}
    dims = map(manifold_dimension, M.manifolds)
    @assert length(Xⁱ) == sum(dims)
    dim_ranges = _get_dim_ranges(dims)
    tXⁱ = map(dr -> (@inbounds view(Xⁱ, dr)), dim_ranges)
    ts = ziptuples(M.manifolds, submanifold_components(M, p), tXⁱ, B.data.parts)
    return ArrayPartition(map((@inline t -> get_vector(t...)), ts))
end

function get_vectors(
        M::ProductManifold,
        p::ArrayPartition,
        B::CachedBasis{𝔽, <:AbstractBasis{𝔽}, <:ProductBasisData},
    ) where {𝔽}
    N = number_of_components(M)
    xparts = submanifold_components(p)
    BVs = map(t -> get_vectors(t...), ziptuples(M.manifolds, xparts, B.data.parts))
    zero_tvs = map(t -> zero_vector(t...), ziptuples(M.manifolds, xparts))
    vs = typeof(ArrayPartition(zero_tvs...))[]
    for i in 1:N, k in 1:length(BVs[i])
        push!(
            vs,
            ArrayPartition(zero_tvs[1:(i - 1)]..., BVs[i][k], zero_tvs[(i + 1):end]...),
        )
    end
    return vs
end

ManifoldsBase._get_vector_cache_broadcast(::ArrayPartition) = Val(false)

"""
    getindex(p, M::ProductManifold, i::Union{Integer,Colon,AbstractVector})
    p[M::ProductManifold, i]

Access the element(s) at index `i` of a point `p` on a [`ProductManifold`](@ref) `M` by
linear indexing.
See also [Array Indexing](https://docs.julialang.org/en/v1/manual/arrays/#man-array-indexing-1) in Julia.
"""
@inline Base.@propagate_inbounds function Base.getindex(
        p::ArrayPartition,
        M::ProductManifold,
        i::Union{Integer, Colon, AbstractVector, Val},
    )
    return get_component(M, p, i)
end

function inverse_retract(
        M::ProductManifold,
        p::ArrayPartition,
        q::ArrayPartition,
        method::InverseProductRetraction,
    )
    return ArrayPartition(
        map(
            inverse_retract,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
            method.inverse_retractions,
        ),
    )
end

function Base.log(M::ProductManifold, p::ArrayPartition, q::ArrayPartition)
    return ArrayPartition(
        map(
            log,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, q),
        )...,
    )
end

function parallel_transport_direction(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        d::ArrayPartition,
    )
    return ArrayPartition(
        map(
            parallel_transport_direction,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, d),
        ),
    )
end

function parallel_transport_to(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        q::ArrayPartition,
    )
    return ArrayPartition(
        map(
            parallel_transport_to,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, q),
        ),
    )
end

function project(M::ProductManifold, p::ArrayPartition)
    return ArrayPartition(map(project, M.manifolds, submanifold_components(M, p))...)
end
function project(M::ProductManifold, p::ArrayPartition, X::ArrayPartition)
    return ArrayPartition(
        map(
            project,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
        )...,
    )
end

@doc raw"""
    rand(M::ProductManifold; parts_kwargs = map(_ -> (;), M.manifolds))

Return a random point on [`ProductManifold`](@ref)  `M`. `parts_kwargs` is
a tuple of keyword arguments for `rand` on each manifold in `M.manifolds`.
"""
function Random.rand(
        M::ProductManifold;
        vector_at = nothing,
        parts_kwargs = map(_ -> (;), M.manifolds),
    )
    if vector_at === nothing
        return ArrayPartition(
            map((N, kwargs) -> rand(N; kwargs...), M.manifolds, parts_kwargs)...,
        )
    else
        return ArrayPartition(
            map(
                (N, p, kwargs) -> rand(N; vector_at = p, kwargs...),
                M.manifolds,
                submanifold_components(M, vector_at),
                parts_kwargs,
            )...,
        )
    end
end
function Random.rand(
        rng::AbstractRNG,
        M::ProductManifold;
        vector_at = nothing,
        parts_kwargs = map(_ -> (;), M.manifolds),
    )
    if vector_at === nothing
        return ArrayPartition(
            map((N, kwargs) -> rand(rng, N; kwargs...), M.manifolds, parts_kwargs)...,
        )
    else
        return ArrayPartition(
            map(
                (N, p, kwargs) -> rand(rng, N; vector_at = p, kwargs...),
                M.manifolds,
                submanifold_components(M, vector_at),
                parts_kwargs,
            )...,
        )
    end
end

function riemann_tensor(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        Y::ArrayPartition,
        Z::ArrayPartition,
    )
    return ArrayPartition(
        map(
            riemann_tensor,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, Y),
            submanifold_components(M, Z),
        ),
    )
end

"""
    setindex!(q, p, M::ProductManifold, i::Union{Integer,Colon,AbstractVector})
    q[M::ProductManifold,i...] = p

set the element `[i...]` of a point `q` on a [`ProductManifold`](@ref) by linear indexing to `q`.
See also [Array Indexing](https://docs.julialang.org/en/v1/manual/arrays/#man-array-indexing-1) in Julia.
"""
Base.@propagate_inbounds function Base.setindex!(
        q::ArrayPartition,
        p,
        M::ProductManifold,
        i::Union{Integer, Colon, AbstractVector, Val},
    )
    return set_component!(M, q, p, i)
end

@inline submanifold_component(p::ArrayPartition, ::Val{I}) where {I} = p.x[I]
@inline submanifold_components(p::ArrayPartition) = p.x

function vector_transport_direction(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        d::ArrayPartition,
        m::ProductVectorTransport,
    )
    return ArrayPartition(
        map(
            vector_transport_direction,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, d),
            m.methods,
        ),
    )
end

function vector_transport_to(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        q::ArrayPartition,
        m::ProductVectorTransport,
    )
    return ArrayPartition(
        map(
            vector_transport_to,
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, q),
            m.methods,
        ),
    )
end
function vector_transport_to(
        M::ProductManifold,
        p::ArrayPartition,
        X::ArrayPartition,
        q::ArrayPartition,
        m::ParallelTransport,
    )
    return ArrayPartition(
        map(
            (iM, ip, iX, id) -> vector_transport_to(iM, ip, iX, id, m),
            M.manifolds,
            submanifold_components(M, p),
            submanifold_components(M, X),
            submanifold_components(M, q),
        ),
    )
end

"""
    AbstractInverseRetractionMethod <: AbstractApproximationMethod

Abstract type for methods for inverting a retraction (see [`inverse_retract`](@ref)).
"""
abstract type AbstractInverseRetractionMethod <: AbstractApproximationMethod end

"""
    AbstractRetractionMethod <: AbstractApproximationMethod

Abstract type for methods for [`retract`](@ref)ing a tangent vector to a manifold.
"""
abstract type AbstractRetractionMethod <: AbstractApproximationMethod end

"""
    ApproximateInverseRetraction <: AbstractInverseRetractionMethod

An abstract type for representing approximate inverse retraction methods.

"""
abstract type ApproximateInverseRetraction <: AbstractInverseRetractionMethod end

"""
    ApproximateRetraction <: AbstractRetractionMethod

An abstract type for representing approximate retraction methods.
"""
abstract type ApproximateRetraction <: AbstractRetractionMethod end


"""
    ApproximateExponentialRetraction{N <: NamedTuple} <: ApproximateRetraction

Retraction using an algorithm with certain parameters to approximate the exponential map.

The intended implementation should use [`solve_chart_exp_ode`](@extref `Manifolds.solve_chart_exp_ode`).

# Fields

* `keyword_arguments` – a named tuple containing the parameters meant to be the keywords
  for the approximation algorithm

# Constructor

    ApproximateExponentialRetraction(keyword_arguments::NamedTuple)
"""
struct ApproximateExponentialRetraction{N <: NamedTuple} <: ApproximateRetraction
    keyword_arguments::N
end

@doc raw"""
    EmbeddedRetraction{T<:AbstractRetractionMethod} <: AbstractRetractionMethod

Compute a retraction by using the retraction of type `T` in the embedding and projecting the result.

# Constructor

    EmbeddedRetraction(r::AbstractRetractionMethod)

Generate the retraction with retraction `r` to use in the embedding.
"""
struct EmbeddedRetraction{T <: AbstractRetractionMethod} <: AbstractRetractionMethod
    retraction::T
end

"""
    ExponentialRetraction <: AbstractRetractionMethod

Retraction using the exponential map.
"""
struct ExponentialRetraction <: AbstractRetractionMethod end

"""
    PolarRetraction <: AbstractRetractionMethod

Retractions that are based on singular value decompositions of the matrix / matrices
for point and tangent vectors.

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, PolarRetraction())`,
    to implement a polar retraction, define [`retract_polar!`](@ref)`(M, q, p, X, t)`
    for your manifold `M`.
"""
struct PolarRetraction <: AbstractRetractionMethod end

"""
    ProjectionRetraction <: AbstractRetractionMethod

Retractions that are based on projection and usually addition in the embedding.

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, ProjectionRetraction())`,
    to implement a projection retraction, define [`retract_project!`](@ref)`(M, q, p, X, t)` for your manifold `M`.
"""
struct ProjectionRetraction <: AbstractRetractionMethod end

"""
    QRRetraction <: AbstractRetractionMethod

Retractions that are based on a QR decomposition of the
matrix / matrices for point and tangent vector on a [`AbstractManifold`](@ref)

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, QRRetraction())`,
    to implement a QR retraction, define [`retract_qr!`](@ref)`(M, q, p, X, t)` for your manifold `M`.
"""
struct QRRetraction <: AbstractRetractionMethod end

"""
    RetractionWithKeywords{R<:AbstractRetractionMethod,K} <: AbstractRetractionMethod

Since retractions might have keywords, this type is a way to set them as an own type to be
used as a specific retraction.
Another reason for this type is that we dispatch on the retraction first and only the
last layer would be implemented with keywords, so this way they can be passed down.

## Fields

* `retraction` the retraction that is decorated with keywords
* `kwargs` the keyword arguments

Note that you can nest this type. Then the most outer specification of a keyword is used.

## Constructor

    RetractionWithKeywords(m::T; kwargs...) where {T <: AbstractRetractionMethod}

Specify the subtype `T <: `[`AbstractRetractionMethod`](@ref) to have keywords `kwargs...`.
"""
struct RetractionWithKeywords{T <: AbstractRetractionMethod, K} <: AbstractRetractionMethod
    retraction::T
    kwargs::K
end
function RetractionWithKeywords(m::T; kwargs...) where {T <: AbstractRetractionMethod}
    return RetractionWithKeywords{T, typeof(kwargs)}(m, kwargs)
end

@doc raw"""
    struct SasakiRetraction <: AbstractRetractionMethod end

Exponential map on [`TangentBundle`](https://juliamanifolds.github.io/Manifolds.jl/stable/manifolds/vector_bundle.html#Manifolds.TangentBundle) computed via Euler integration as described
in [MuralidharanFletcher:2012](@cite). The system of equations for ``\gamma : ℝ \to T\mathcal M`` such that
``γ(1) = \exp_{p,X}(X_M, X_F)`` and ``γ(0)=(p, X)`` reads

```math
\dot{γ}(t) = (\dot{p}(t), \dot{X}(t)) = (R(X(t), \dot{X}(t))\dot{p}(t), 0)
```

where ``R`` is the Riemann curvature tensor (see [`riemann_tensor`](@ref)).

# Constructor

    SasakiRetraction(L::Int)

In this constructor `L` is the number of integration steps.
"""
struct SasakiRetraction <: AbstractRetractionMethod
    L::Int
end

"""
    SoftmaxRetraction <: AbstractRetractionMethod

Describes a retraction that is based on the softmax function.

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, SoftmaxRetraction())`,
    to implement a softmax retraction, define [`retract_softmax!`](@ref)`(M, q, p, X, t)` for your manifold `M`.
"""
struct SoftmaxRetraction <: AbstractRetractionMethod end


"""
    StabilizedRetraction <: AbstractRetractionMethod

A retraction wraps another retraction and projects the resulting point onto the manifold
for numerical stability.

# Constructor

    StabilizedRetraction(::AbstractRetractionMethod=ExponentialRetraction())

# See also
[`ExponentialRetraction`](@ref), [`embed_project!`](@ref)
"""
struct StabilizedRetraction{TRM <: AbstractRetractionMethod} <: AbstractRetractionMethod
    retraction::TRM
end
StabilizedRetraction() = StabilizedRetraction(ExponentialRetraction())

@doc raw"""
    PadeRetraction{m} <: AbstractRetractionMethod

A retraction based on the Padé approximation of order ``m``

# Constructor
    PadeRetraction(m::Int)

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, PadeRetraction(m))`,
    to implement a Padé retraction, define [`retract_pade!`](@ref)`(M, q, p, X, t, m)` for your manifold `M`.
"""
struct PadeRetraction{m} <: AbstractRetractionMethod end

function PadeRetraction(m::Int)
    (m < 1) && error(
        "The Padé based retraction is only available for positive orders, not for order $m.",
    )
    return PadeRetraction{m}()
end
@doc raw"""
    CayleyRetraction <: AbstractRetractionMethod

A retraction based on the Cayley transform, which is realized by using the
[`PadeRetraction`](@ref)`{1}`.

!!! note "Technical Note"
    Though you would call e.g. [`retract`](@ref)`(M, p, X, CayleyRetraction())`,
    to implement a Cayley retraction, define [`retract_cayley!`](@ref)`(M, q, p, X, t)` for your manifold `M`.
    By default both these functions fall back to calling a [`PadeRetraction`](@ref)`(1)`.
"""
const CayleyRetraction = PadeRetraction{1}

"""
    ApproximateLogarithmicInverseRetraction{N <: NamedTuple} <: ApproximateInverseRetraction

Inverse retraction using an algorithm with certain parameters to approximate the logarithmic map.

The intended implementation should use [`solve_chart_log_bvp`](@extref `Manifolds.solve_chart_log_bvp`).

# Fields

* `keyword_arguments` – a named tuple containing the parameters meant to be the keywords
  for the approximation algorithm

# Constructor

    ApproximateLogarithmicInverseRetraction(keyword_arguments::NamedTuple)
"""
struct ApproximateLogarithmicInverseRetraction{N <: NamedTuple} <: ApproximateInverseRetraction
    keyword_arguments::N
end


@doc raw"""
   EmbeddedInverseRetraction{T<:AbstractInverseRetractionMethod} <: AbstractInverseRetractionMethod

Compute an inverse retraction by using the inverse retraction of type `T` in the embedding and projecting the result

# Constructor

    EmbeddedInverseRetraction(r::AbstractInverseRetractionMethod)

Generate the inverse retraction with inverse retraction `r` to use in the embedding.
"""
struct EmbeddedInverseRetraction{T <: AbstractInverseRetractionMethod} <:
    AbstractInverseRetractionMethod
    inverse_retraction::T
end


"""
    LogarithmicInverseRetraction <: AbstractInverseRetractionMethod

Inverse retraction using the [`log`](@ref)arithmic map.
"""
struct LogarithmicInverseRetraction <: AbstractInverseRetractionMethod end


@doc raw"""
    PadeInverseRetraction{m} <: AbstractInverseRetractionMethod

An inverse retraction based on the Padé approximation of order ``m`` for the retraction.

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, PadeInverseRetraction(m))`,
    to implement an inverse Padé retraction, define [`inverse_retract_pade!`](@ref)`(M, X, p, q, m)` for your manifold `M`.
"""
struct PadeInverseRetraction{m} <: AbstractInverseRetractionMethod end

function PadeInverseRetraction(m::Int)
    (m < 1) && error(
        "The Padé based inverse retraction is only available for positive orders, not for order $m.",
    )
    return PadeInverseRetraction{m}()
end

@doc raw"""
    CayleyInverseRetraction <: AbstractInverseRetractionMethod

A retraction based on the Cayley transform, which is realized by using the
[`PadeRetraction`](@ref)`{1}`.

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, CayleyInverseRetraction())`,
    to implement an inverse Cayley retraction, define [`inverse_retract_cayley!`](@ref)`(M, X, p, q)` for your manifold `M`.
    By default both these functions fall back to calling a [`PadeInverseRetraction`](@ref)`(1)`.
"""
const CayleyInverseRetraction = PadeInverseRetraction{1}

"""
    PolarInverseRetraction <: AbstractInverseRetractionMethod

Inverse retractions that are based on a singular value decomposition of the
matrix / matrices for point and tangent vector on a [`AbstractManifold`](@ref)

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, PolarInverseRetraction())`,
    to implement an inverse polar retraction, define [`inverse_retract_polar!`](@ref)`(M, X, p, q)` for your manifold `M`.
"""
struct PolarInverseRetraction <: AbstractInverseRetractionMethod end

"""
    ProjectionInverseRetraction <: AbstractInverseRetractionMethod

Inverse retractions that are based on a projection (or its inversion).

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, ProjectionInverseRetraction())`,
    to implement an inverse projection retraction, define [`inverse_retract_project!`](@ref)`(M, X, p, q)` for your manifold `M`.
"""
struct ProjectionInverseRetraction <: AbstractInverseRetractionMethod end

"""
    QRInverseRetraction <: AbstractInverseRetractionMethod

Inverse retractions that are based on a QR decomposition of the
matrix / matrices for point and tangent vector on a [`AbstractManifold`](@ref)

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, QRInverseRetraction())`,
    to implement an inverse QR retraction, define [`inverse_retract_qr!`](@ref)`(M, X, p, q)` for your manifold `M`.
"""
struct QRInverseRetraction <: AbstractInverseRetractionMethod end

"""
    NLSolveInverseRetraction{T<:AbstractRetractionMethod,TV,TK} <:
        ApproximateInverseRetraction

An inverse retraction method for approximating the inverse of a retraction using `NLsolve`.

# Constructor

    NLSolveInverseRetraction(
        method::AbstractRetractionMethod[, X0];
        project_tangent=false,
        project_point=false,
        nlsolve_kwargs...,
    )

Constructs an approximate inverse retraction for the retraction `method` with initial guess
`X0`, defaulting to the zero vector. If `project_tangent` is `true`, then the tangent
vector is projected before the retraction using `project`. If `project_point` is `true`,
then the resulting point is projected after the retraction. `nlsolve_kwargs` are keyword
arguments passed to `NLsolve.nlsolve`.
"""
struct NLSolveInverseRetraction{TR <: AbstractRetractionMethod, TV, TK} <:
    ApproximateInverseRetraction
    retraction::TR
    X0::TV
    project_tangent::Bool
    project_point::Bool
    nlsolve_kwargs::TK
    function NLSolveInverseRetraction(m, X0, project_point, project_tangent, nlsolve_kwargs)
        return new{typeof(m), typeof(X0), typeof(nlsolve_kwargs)}(
            m, X0, project_point, project_tangent, nlsolve_kwargs,
        )
    end
end
function NLSolveInverseRetraction(
        m, X0 = nothing; project_tangent::Bool = false, project_point::Bool = false, nlsolve_kwargs...,
    )
    return NLSolveInverseRetraction(m, X0, project_point, project_tangent, nlsolve_kwargs)
end


"""
    InverseRetractionWithKeywords{R<:AbstractRetractionMethod,K} <: AbstractInverseRetractionMethod

Since inverse retractions might have keywords, this type is a way to set them as an own type to be
used as a specific inverse retraction.
Another reason for this type is that we dispatch on the inverse retraction first and only the
last layer would be implemented with keywords, so this way they can be passed down.

## Fields

* `inverse_retraction` the inverse retraction that is decorated with keywords
* `kwargs` the keyword arguments

Note that you can nest this type. Then the most outer specification of a keyword is used.

## Constructor

    InverseRetractionWithKeywords(m::T; kwargs...) where {T <: AbstractInverseRetractionMethod}

Specify the subtype `T <: `[`AbstractInverseRetractionMethod`](@ref) to have keywords `kwargs...`.
"""
struct InverseRetractionWithKeywords{T <: AbstractInverseRetractionMethod, K} <:
    AbstractInverseRetractionMethod
    inverse_retraction::T
    kwargs::K
end
function InverseRetractionWithKeywords(
        m::T;
        kwargs...,
    ) where {T <: AbstractInverseRetractionMethod}
    return InverseRetractionWithKeywords{T, typeof(kwargs)}(m, kwargs)
end

"""
    SoftmaxInverseRetraction <: AbstractInverseRetractionMethod

Describes an inverse retraction that is based on the softmax function.

!!! note "Technical Note"
    Though you would call e.g. [`inverse_retract`](@ref)`(M, p, q, SoftmaxInverseRetraction())`,
    to implement an inverse softmax retraction, define [`inverse_retract_softmax!`](@ref)`(M, X, p, q)` for your manifold `M`.
"""
struct SoftmaxInverseRetraction <: AbstractInverseRetractionMethod end

"""
    StabilizedInveerseRetraction <: AbstractInverseRetractionMethod

An inverse retraction wraps another inverse retraction and projects
the resulting tangent vector onto the corresponding tangent space for numerical stability.

# Constructor

    StabilizedInverseRetraction(::AbstractInverseRetractionMethod=LogarithmicInverseRetraction())

# See also
[`LogarithmicInverseRetraction`](@ref), [`embed_project!`](@ref)
"""
struct StabilizedInverseRetraction{TRM <: AbstractInverseRetractionMethod} <: AbstractInverseRetractionMethod
    inverse_retraction::TRM
end
StabilizedInverseRetraction() = StabilizedInverseRetraction(LogarithmicInverseRetraction())

"""
    default_inverse_retraction_method(M::AbstractManifold)
    default_inverse_retraction_method(M::AbstractManifold, ::Type{T}) where {T}

The [`AbstractInverseRetractionMethod`](@ref) that is used when calling
[`inverse_retract`](@ref) without specifying the inverse retraction method.
By default, this is the [`LogarithmicInverseRetraction`](@ref).

This method can also be specified more precisely with a point type `T`, for the case
that on a `M` there are two different representations of points, which provide
different inverse retraction methods.
"""
default_inverse_retraction_method(::AbstractManifold) = LogarithmicInverseRetraction()
function default_inverse_retraction_method(M::AbstractManifold, ::Type{T}) where {T}
    return default_inverse_retraction_method(M)
end

"""
    default_retraction_method(M::AbstractManifold)
    default_retraction_method(M::AbstractManifold, ::Type{T}) where {T}

The [`AbstractRetractionMethod`](@ref) that is used when calling [`retract`](@ref) without
specifying the retraction method. By default, this is the [`ExponentialRetraction`](@ref).

This method can also be specified more precisely with a point type `T`, for the case
that on a `M` there are two different representations of points, which provide
different retraction methods.
"""
default_retraction_method(::AbstractManifold) = ExponentialRetraction()
function default_retraction_method(M::AbstractManifold, ::Type{T}) where {T}
    return default_retraction_method(M)
end

"""
    inverse_retract(M::AbstractManifold, p, q)
    inverse_retract(M::AbstractManifold, p, q, method::AbstractInverseRetractionMethod

Compute the inverse retraction, a cheaper, approximate version of the
[`log`](@ref)arithmic map), of points `p` and `q` on the [`AbstractManifold`](@ref) `M`.

Inverse retraction method can be specified by the last argument, defaulting to
[`default_inverse_retraction_method`](@ref)`(M)`.
For available inverse retractions on certain manifolds see the documentation on the
corresponding manifold.

See also [`retract`](@ref).
"""
function inverse_retract(
        M::AbstractManifold, p, q,
        m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
    )
    return _inverse_retract(M, p, q, m)
end
function _inverse_retract(M::AbstractManifold, p, q, ::LogarithmicInverseRetraction)
    return log(M, p, q)
end
function _inverse_retract(M::AbstractManifold, p, q, m::AbstractInverseRetractionMethod)
    X = allocate_result(M, inverse_retract, p, q)
    return inverse_retract!(M, X, p, q, m)
end

"""
    inverse_retract!(M::AbstractManifold, X, p, q[, method::AbstractInverseRetractionMethod])

Compute the inverse retraction, a cheaper, approximate version of the
[`log`](@ref)arithmic map), of points `p` and `q` on the [`AbstractManifold`](@ref) `M`.
Result is saved to `X`.

Inverse retraction method can be specified by the last argument, defaulting to
[`default_inverse_retraction_method`](@ref)`(M)`. See the documentation of respective manifolds for
available methods.

See also [`retract!`](@ref).
"""
function inverse_retract!(
        M::AbstractManifold, X, p, q,
        m::AbstractInverseRetractionMethod = default_inverse_retraction_method(M, typeof(p)),
    )
    return _inverse_retract!(M, X, p, q, m)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, ::LogarithmicInverseRetraction; kwargs...,
    )
    return log!(M, X, p, q; kwargs...)
end

#
# dispatch to lower level
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::ApproximateLogarithmicInverseRetraction; kwargs...,
    )
    return inverse_retract_approx!(M, X, p, q, m; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, ::CayleyInverseRetraction; kwargs...,
    )
    return inverse_retract_cayley!(M, X, p, q; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::EmbeddedInverseRetraction; kwargs...,
    )
    return inverse_retract_embedded!(M, X, p, q, m.inverse_retraction; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::NLSolveInverseRetraction; kwargs...,
    )
    return inverse_retract_nlsolve!(M, X, p, q, m; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::PadeInverseRetraction; kwargs...,
    )
    return inverse_retract_pade!(M, X, p, q, m; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, ::PolarInverseRetraction; kwargs...,
    )
    return inverse_retract_polar!(M, X, p, q; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, ::ProjectionInverseRetraction; kwargs...,
    )
    return inverse_retract_project!(M, X, p, q; kwargs...)
end
function _inverse_retract!(M::AbstractManifold, X, p, q, ::QRInverseRetraction; kwargs...)
    return inverse_retract_qr!(M, X, p, q; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::InverseRetractionWithKeywords; kwargs...,
    )
    return _inverse_retract!(M, X, p, q, m.inverse_retraction; kwargs..., m.kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, ::SoftmaxInverseRetraction; kwargs...,
    )
    return inverse_retract_softmax!(M, X, p, q; kwargs...)
end
function _inverse_retract!(
        M::AbstractManifold, X, p, q, m::StabilizedInverseRetraction; kwargs...,
    )
    return inverse_retract_stabilized!(M, X, p, q, m; kwargs...)
end

"""
    inverse_retract_approx!(M::AbstractManifold, p, q, m::ApproximateLogarithmicInverseRetraction)

Compute the in-place variant of the [`ApproximateLogarithmicInverseRetraction`](@ref) `m`.
"""
inverse_retract_approx!(M::AbstractManifold, p, q, m::ApproximateLogarithmicInverseRetraction)

function inverse_retract_approx! end

"""
    inverse_retract_embedded!(M::AbstractManifold, X, p, q, m::AbstractInverseRetractionMethod)

Compute the in-place variant of the [`EmbeddedInverseRetraction`](@ref) using
the [`AbstractInverseRetractionMethod`](@ref) `m` in the embedding (see [`get_embedding`](@ref))
and projecting the result back.
"""
function inverse_retract_embedded!(
        M::AbstractManifold, X, p::P, q, m::AbstractInverseRetractionMethod,
    ) where {P}
    return project!(
        M, X, p,
        inverse_retract(
            get_embedding(M, P), embed(get_embedding(M, P), p), embed(get_embedding(M, P), q), m,
        ),
    )
end

"""
    inverse_retract_cayley!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`CayleyInverseRetraction`](@ref),
which by default calls the first order [`PadeInverseRetraction`§(@ref).
"""
function inverse_retract_cayley!(M::AbstractManifold, X, p, q; kwargs...)
    return inverse_retract_pade!(M, X, p, q, 1; kwargs...)
end

"""
    inverse_retract_pade!(M::AbstractManifold, p, q, n)

Compute the in-place variant of the [`PadeInverseRetraction`](@ref)`(n)`,
"""
inverse_retract_pade!(M::AbstractManifold, p, q, n)

function inverse_retract_pade! end

"""
    inverse_retract_qr!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`QRInverseRetraction`](@ref).
"""
inverse_retract_qr!(M::AbstractManifold, X, p, q)

function inverse_retract_qr! end

"""
    inverse_retract_project!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`ProjectionInverseRetraction`](@ref).
"""
inverse_retract_project!(M::AbstractManifold, X, p, q)

function inverse_retract_project! end

"""
    inverse_retract_polar!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`PolarInverseRetraction`](@ref).
"""
inverse_retract_polar!(M::AbstractManifold, X, p, q)

function inverse_retract_polar! end

"""
    inverse_retract_nlsolve!(M::AbstractManifold, X, p, q, m::NLSolveInverseRetraction)

Compute the in-place variant of the [`NLSolveInverseRetraction`](@ref) `m`.
"""
inverse_retract_nlsolve!(M::AbstractManifold, X, p, q, m::NLSolveInverseRetraction)

function inverse_retract_nlsolve! end

"""
    inverse_retract_softmax!(M::AbstractManifold, X, p, q)

Compute the in-place variant of the [`SoftmaxInverseRetraction`](@ref).
"""
inverse_retract_softmax!(M::AbstractManifold, X, p, q)

function inverse_retract_softmax! end

function inverse_retract_stabilized!(M::AbstractManifold, X, p, q, m::StabilizedInverseRetraction; kwargs...)
    inverse_retract!(M, X, p, q, m.inverse_retraction; kwargs...)
    embed_project!(M, X, p, X)
    return X
end

_doc_retract = raw"""
    retract(M::AbstractManifold, p, X, method::AbstractRetractionMethod=default_retraction_method(M, typeof(p)))
    retract!(M::AbstractManifold, q, p, X, method::AbstractRetractionMethod=default_retraction_method(M, typeof(p)))

Compute a retraction, an approximate version of the [`exp`](@ref)onential map,
from `p` into direction `X`, scaled by `t`, on the [`AbstractManifold`](@ref) `M`.
This can be computed in-place of `q`.

A retraction ``\operatorname{retr}_p: T_p\mathcal M → \mathcal M`` is a smooth map that fulfils

1. ``\operatorname{retr}_p(0) = p``
2. ``D\operatorname{retr}_p(0): T_p\mathcal M → T_p\mathcal M`` is the identity map,
i.e. ``D\operatorname{retr}_p(0)[X]=X`` holds for all ``X∈ T_p\mathcal M``,

where ``D\operatorname{retr}_p`` denotes the differential of the retraction

The retraction is called of second order if for all ``X`` the curves ``c(t) = R_p(tX)``
have a zero acceleration at ``t=0``, i.e. ``c''(0) = 0``.

Retraction method can be specified by the last argument, defaulting to
[`default_retraction_method`](@ref)`(M)`. For further available retractions see the documentation of respective manifolds.

Locally, the retraction is invertible. For the inverse operation, see [`inverse_retract`](@ref).
"""

@doc "$(_doc_retract)"
function retract(
        M::AbstractManifold, p, X,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p));
        kwargs...
    )
    return _retract(M, p, X, m; kwargs...)
end
# Layer 2 – dispatch on the method
function _retract(M::AbstractManifold, p, X, ::ExponentialRetraction; kwargs...)
    return exp(M, p, X; kwargs...)
end
function _retract(M::AbstractManifold, p, X, m::AbstractRetractionMethod; kwargs...)
    q = allocate_result(M, retract, p, X)
    return retract!(M, q, p, X, m; kwargs...)
end

@doc "$(_doc_retract)"
function retract!(
        M::AbstractManifold, q, p, X,
        method::AbstractRetractionMethod = default_retraction_method(M, typeof(p));
        kwargs...
    )
    return _retract!(M, q, p, X, method; kwargs...)
end

# Retract Layer 2 – dispatch on the method
function _retract!(M::AbstractManifold, q, p, X, m::ApproximateExponentialRetraction; kwargs...)
    return retract_approx!(M, q, p, X, m; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, ::CayleyRetraction; kwargs...)
    return retract_cayley!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, m::EmbeddedRetraction; kwargs...)
    return retract_embedded!(M, q, p, X, m.retraction; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, ::ExponentialRetraction; kwargs...)
    return exp!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, ::PolarRetraction; kwargs...)
    return retract_polar!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, ::ProjectionRetraction; kwargs...)
    return retract_project!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, ::QRRetraction; kwargs...)
    return retract_qr!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, m::SasakiRetraction)
    return retract_sasaki!(M, q, p, X, m)
end
function _retract!(M::AbstractManifold, q, p, X, ::SoftmaxRetraction; kwargs...)
    return retract_softmax!(M, q, p, X; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, m::StabilizedRetraction; kwargs...)
    return retract_stabilized!(M, q, p, X, m; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, m::PadeRetraction; kwargs...)
    return retract_pade!(M, q, p, X, m; kwargs...)
end
function _retract!(M::AbstractManifold, q, p, X, m::RetractionWithKeywords; kwargs...)
    return _retract!(M, q, p, X, m.retraction; kwargs..., m.kwargs...)
end

_doc_retract_fused = """
    retract_fused(M::AbstractManifold, p, X, t::Number, method::AbstractRetractionMethod=default_retraction_method(M, typeof(p)))
    retract_fused!(M::AbstractManifold, q, p, X, t::Number, method::AbstractRetractionMethod=default_retraction_method(M, typeof(p)))

A variant of [`retract`](@ref) that performs retraction on the vector `X` scaled by `t`.
This can be faster in some cases compared to multiplying `X` by `t`, especially when
performing this for multiple values of `t`.
This can be computed in-place of `q`.

By default, this falls back to calling [`retract`](@ref) with `t*X`.

!!! note "Technical Note"
    This fallback is happening on the in-place variant in [Layer 3](@ref design-layer3).
    Hence implementing this performant variant requires to implement the corresponding
    third layer fused function, like for example `retract_polar_fused!`.
    The “non-fused” variant always also has to be implemented, but can then be just spefied
    to fallback to the fused variant. for example
    ```
    retract_polar!(M, q, p, X) = retract_polar_fused!(M, q, p, X, one(eltype(p)))
    ```
"""

@doc "$(_doc_retract_fused)"
function retract_fused(
        M::AbstractManifold, p, X, t::Number,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p)),
    )
    return _retract_fused(M, p, X, t, m)
end

function _retract_fused(M::AbstractManifold, p, X, t::Number, ::ExponentialRetraction)
    return exp_fused(M, p, X, t)
end
function _retract_fused(M::AbstractManifold, p, X, t::Number, m::AbstractRetractionMethod)
    q = allocate_result(M, retract, p, X)
    return retract_fused!(M, q, p, X, t, m)
end

@doc "$(_doc_retract_fused)"
function retract_fused!(
        M::AbstractManifold, q, p, X, t::Number,
        m::AbstractRetractionMethod = default_retraction_method(M, typeof(p));
        kwargs...
    )
    return _retract_fused!(M, q, p, X, t, m; kwargs...)
end
# Retract fused Layer 2
# Retract Layer 2 – dispatch on the method
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, m::ApproximateExponentialRetraction; kwargs...,
    )
    return retract_approx_fused!(M, q, p, X, t, m; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, ::CayleyRetraction; kwargs...,
    )
    return retract_cayley_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, m::EmbeddedRetraction; kwargs...,
    )
    return retract_embedded_fused!(M, q, p, X, t, m.retraction; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, ::ExponentialRetraction; kwargs...,
    )
    return exp_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, ::PolarRetraction; kwargs...,
    )
    return retract_polar_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, ::ProjectionRetraction; kwargs...,
    )
    return retract_project_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(M::AbstractManifold, q, p, X, t::Number, ::QRRetraction; kwargs...)
    return retract_qr_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(M::AbstractManifold, q, p, X, t::Number, m::SasakiRetraction)
    return retract_sasaki_fused!(M, q, p, X, t, m)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, ::SoftmaxRetraction; kwargs...,
    )
    return retract_softmax_fused!(M, q, p, X, t; kwargs...)
end
function _retract_fused!(M::AbstractManifold, q, p, X, t::Number, m::StabilizedRetraction; kwargs...)
    return retract_stabilized_fused!(M, q, p, X, t, m; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, m::PadeRetraction; kwargs...,
    )
    return retract_pade_fused!(M, q, p, X, t, m; kwargs...)
end
function _retract_fused!(
        M::AbstractManifold, q, p, X, t::Number, m::RetractionWithKeywords; kwargs...,
    )
    return _retract_fused!(M, q, p, X, t, m.retraction; kwargs..., m.kwargs...)
end

#
#
# retract and retract_fused layer 3

function retract_approx! end
"""
    retract_approx!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`ApproximateExponentialRetraction`](@ref) `m`.
"""
retract_approx!(M::AbstractManifold, q, p, X, m::ApproximateExponentialRetraction)

function retract_approx_fused! end

"""
    retract_embedded!(M::AbstractManifold, q, p, X, m::AbstractRetractionMethod)

Compute the in-place variant of the [`EmbeddedRetraction`](@ref) using
the [`AbstractRetractionMethod`](@ref) `m` in the embedding (see [`get_embedding`](@ref))
and projecting the result back.
"""
function retract_embedded!(
        M::AbstractManifold, q, p::P, X, m::AbstractRetractionMethod; kwargs...,
    ) where {P}
    return project!(
        M,
        q,
        retract(
            get_embedding(M, P), embed(get_embedding(M, P), p), embed(get_embedding(M, P), p, X), m;
            kwargs...,
        ),
    )
end

"""
    retract_embedded_fused!(M::AbstractManifold, q, p, X, t::Number, m::AbstractRetractionMethod)

Compute the scaled variant of `retract_embedded!`.
"""
function retract_embedded_fused!(
        M::AbstractManifold, q, p::P, X, t::Number, m::AbstractRetractionMethod; kwargs...,
    ) where {P}
    return project!(
        M,
        q,
        retract_fused(
            get_embedding(M, P), embed(get_embedding(M, P), p), embed(get_embedding(M, P), p, X), t, m; kwargs...,
        ),
    )
end

"""
    retract_cayley!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`CayleyRetraction`](@ref),
which by default falls back to calling the first order [`PadeRetraction`](@ref).
"""
function retract_cayley!(M::AbstractManifold, q, p, X; kwargs...)
    return retract_pade!(M, q, p, X, PadeRetraction(1); kwargs...)
end

function retract_cayley_fused!(M::AbstractManifold, q, p, X, t::Number; kwargs...)
    return retract_cayley!(M, q, p, t * X; kwargs...)
end

function retract_pade! end
"""
    retract_pade!(M::AbstractManifold, q, p, X, m::PadeRetraction)

Compute the in-place variant of the [`PadeRetraction`](@ref) `m`.
"""
retract_pade!(M::AbstractManifold, q, p, X, m::PadeRetraction)

function retract_pade_fused!(M::AbstractManifold, q, p, X, t::Number, m::PadeRetraction)
    return retract_pade!(M, q, p, t * X, m)
end


function retract_project! end
"""
    retract_project!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`ProjectionRetraction`](@ref).
"""
retract_project!(M::AbstractManifold, q, p, X)

"""
    retract_project_fused!(M::AbstractManifold, q, p, X, t::Number)

Compute the in-place variant of the [`ProjectionRetraction`](@ref).
"""
function retract_project_fused!(M::AbstractManifold, q, p, X, t::Number)
    return retract_project!(M, q, p, t * X)
end


function retract_polar! end
"""
    retract_polar!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`PolarRetraction`](@ref).
"""
retract_polar!(M::AbstractManifold, q, p, X)

function retract_polar_fused!(M::AbstractManifold, q, p, X, t::Number)
    return retract_polar!(M, q, p, t * X)
end

function retract_qr! end
"""
    retract_qr!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`QRRetraction`](@ref).
"""
retract_qr!(M::AbstractManifold, q, p, X)

function retract_qr_fused!(M::AbstractManifold, q, p, X, t::Number)
    return retract_qr!(M, q, p, t * X)
end

function retract_softmax! end
"""
    retract_softmax!(M::AbstractManifold, q, p, X)

Compute the in-place variant of the [`SoftmaxRetraction`](@ref).
"""
retract_softmax!(M::AbstractManifold, q, p, X)

function retract_softmax_fused!(M::AbstractManifold, q, p, X, t::Number)
    return retract_softmax!(M, q, p, t * X)
end

function retract_sasaki! end
"""
    retract_sasaki!(M::AbstractManifold, q, p, X, m::SasakiRetraction)

Compute the in-place variant of the [`SasakiRetraction`](@ref) `m`.
"""
retract_sasaki!(M::AbstractManifold, q, p, X, m::SasakiRetraction)

function retract_sasaki_fused!(M::AbstractManifold, q, p, X, t::Number, m::SasakiRetraction)
    return retract_sasaki!(M, q, p, t * X, m)
end

function retract_stabilized!(M::AbstractManifold, q, p, X, m::StabilizedRetraction)
    retract!(M, q, p, X, m.retraction)
    return embed_project!(M, q, q)
end

function retract_stabilized_fused!(
        M::AbstractManifold, q, p, X, t::Number, m::StabilizedRetraction,
    )
    retract_fused!(M, q, p, X, t, m.retraction)
    return embed_project!(M, q, q)
end

Base.show(io::IO, ::CayleyRetraction) = print(io, "CayleyRetraction()")
Base.show(io::IO, ::PadeRetraction{m}) where {m} = print(io, "PadeRetraction($m)")
function Base.show(io::IO, s::StabilizedRetraction)
    r = s.retraction isa ExponentialRetraction ? "" : "$(s.retraction)"
    return print(io, "StabilizedRetraction($r)")
end
function Base.show(io::IO, s::StabilizedInverseRetraction)
    r = s.inverse_retraction isa LogarithmicInverseRetraction ? "" : "$(s.inverse_retraction)"
    return print(io, "StabilizedInverseRetraction($r)")
end

#
# default estimation methods pass down with and without the point type
function default_approximation_method(M::AbstractManifold, ::typeof(inverse_retract))
    return default_inverse_retraction_method(M)
end
function default_approximation_method(M::AbstractManifold, ::typeof(inverse_retract), T)
    return default_inverse_retraction_method(M, T)
end
function default_approximation_method(M::AbstractManifold, ::typeof(retract))
    return default_retraction_method(M)
end
function default_approximation_method(M::AbstractManifold, ::typeof(retract), T)
    return default_retraction_method(M, T)
end

"""
    ManifoldsBase.Test

The module `ManifoldsBase.Test` contains functions and dummy types for the manifolds interface
provided in `ManifoldsBase.jl`.
"""
module Test
using ..ManifoldsBase

struct CustomValidationManifoldRetraction <: ManifoldsBase.AbstractRetractionMethod end

function ManifoldsBase.injectivity_radius(
        ::ManifoldsBase.DefaultManifold, ::CustomValidationManifoldRetraction,
    )
    return 10.0
end
function ManifoldsBase.injectivity_radius(
        ::ManifoldsBase.DefaultManifold, p, ::CustomValidationManifoldRetraction,
    )
    return 11.0
end

struct ValidationDummyManifold <: ManifoldsBase.AbstractManifold{ℝ} end
ManifoldsBase.check_point(::ValidationDummyManifold, p) = nothing
ManifoldsBase.check_vector(::ValidationDummyManifold, p, X) = nothing
function ManifoldsBase.project(M::ValidationDummyManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
ManifoldsBase.project!(::ValidationDummyManifold, Y, p, X) = (Y .= 2 .* X)
function ManifoldsBase.project(M::ValidationDummyManifold, p)
    q = similar(p)
    project!(M, q, p)
    return q
end
ManifoldsBase.project!(::ValidationDummyManifold, q, p) = (q .= 2 .* p)
ManifoldsBase.distance(::ValidationDummyManifold, p, q) = -1.0
ManifoldsBase.norm(::ValidationDummyManifold, p, v) = -1.0
ManifoldsBase.get_embedding(::ValidationDummyManifold) = ManifoldsBase.DefaultManifold(3)

using ManifoldsBase, LinearAlgebra, Random
using ManifoldsBase: ℝ, ℂ, AbstractManifold, DefaultManifold, EuclideanMetric
using ManifoldsBase: AbstractNumbers, RealNumbers, ComplexNumbers
using ManifoldsBase:
    @manifold_element_forwards, @manifold_vector_forwards, @default_manifold_fallbacks
import Base: +, *, -
#
#
# minimal implementation of the sphere – to test a few more involved Riemannian functions
struct TestSphere{N, 𝔽} <: AbstractDecoratorManifold{𝔽} end
TestSphere(N::Int, 𝔽 = ℝ) = TestSphere{N, 𝔽}()

function ManifoldsBase.change_metric!(
        M::TestSphere, Y, ::ManifoldsBase.EuclideanMetric, p, X,
    )
    return copyto!(M, Y, p, X)
end
function ManifoldsBase.change_representer!(
        M::TestSphere, Y, ::ManifoldsBase.EuclideanMetric, p, X,
    )
    return copyto!(M, Y, p, X)
end
function ManifoldsBase.check_point(M::TestSphere, p; kwargs...)
    if !isapprox(norm(p), 1.0; kwargs...)
        return DomainError(
            norm(p),
            "The point $(p) does not lie on the $(M) since its norm is not 1.",
        )
    end
    return nothing
end
function ManifoldsBase.check_vector(M::TestSphere, p, X; kwargs...)
    if !isapprox(abs(real(dot(p, X))), 0.0; kwargs...)
        return DomainError(
            abs(dot(p, X)),
            "The vector $(X) is not a tangent vector to $(p) on $(M), since it is not orthogonal in the embedding.",
        )
    end
    return nothing
end
function ManifoldsBase.exp!(M::TestSphere, q, p, X)
    return ManifoldsBase.exp_fused!(M, q, p, X, one(number_eltype(X)))
end
function ManifoldsBase.exp_fused!(::TestSphere, q, p, X, t::Number)
    θ = abs(t) * norm(X)
    if θ == 0
        copyto!(q, p)
    else
        X_scale = t * sin(θ) / θ
        q .= p .* cos(θ) .+ X .* X_scale
    end
    return q
end
function ManifoldsBase.get_basis_diagonalizing(
        M::TestSphere{n},
        p,
        B::DiagonalizingOrthonormalBasis{ℝ},
    ) where {n}
    A = zeros(n + 1, n + 1)
    A[1, :] = transpose(p)
    A[2, :] = transpose(B.frame_direction)
    V = nullspace(A)
    κ = ones(n)
    if !iszero(B.frame_direction)
        # if we have a nonzero direction for the geodesic, add it and it gets curvature zero from the tensor
        V = hcat(B.frame_direction / norm(M, p, B.frame_direction), V)
        κ[1] = 0 # no curvature along the geodesic direction, if x!=y
    end
    T = typeof(similar(B.frame_direction))
    Ξ = [convert(T, V[:, i]) for i in 1:n]
    return CachedBasis(B, κ, Ξ)
end
@inline function nzsign(z, absz = abs(z))
    psignz = z / absz
    return ifelse(iszero(absz), one(psignz), psignz)
end
function ManifoldsBase.get_coordinates_orthonormal!(M::TestSphere, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend, Xend = view(p, 2:(n + 1)), view(X, 2:(n + 1))
    factor = λ * X[1] / (1 + cosθ)
    Y .= Xend .- pend .* factor
    return Y
end
function ManifoldsBase.get_embedding(::TestSphere{n, 𝔽}) where {n, 𝔽}
    return DefaultManifold(n + 1; field = 𝔽)
end
function ManifoldsBase.get_vector_orthonormal!(M::TestSphere, Y, p, X, ::RealNumbers)
    n = manifold_dimension(M)
    p1 = p[1]
    cosθ = abs(p1)
    λ = nzsign(p1, cosθ)
    pend = view(p, 2:(n + 1))
    pX = dot(pend, X)
    factor = pX / (1 + cosθ)
    Y[1] = -λ * pX
    Y[2:(n + 1)] .= X .- pend .* factor
    return Y
end
ManifoldsBase.injectivity_radius(::TestSphere) = π
ManifoldsBase.inner(::TestSphere, p, X, Y) = dot(X, Y)
function ManifoldsBase.inverse_retract_project!(M::TestSphere, X, p, q)
    X .= q .- p
    project!(M, X, p, X)
    return X
end
ManifoldsBase.is_flat(M::TestSphere) = manifold_dimension(M) == 1
function ManifoldsBase.log!(::TestSphere, X, p, q)
    cosθ = clamp(real(dot(p, q)), -1, 1)
    X .= q .- p .* cosθ
    nrmX = norm(X)
    if nrmX > 0
        X .*= acos(cosθ) / nrmX
    end
    return X
end
ManifoldsBase.manifold_dimension(::TestSphere{N}) where {N} = N
function ManifoldsBase.parallel_transport_to!(::TestSphere, Y, p, X, q)
    m = p .+ q
    mnorm2 = real(dot(m, m))
    factor = 2 * real(dot(X, q)) / mnorm2
    Y .= X .- m .* factor
    return Y
end
function ManifoldsBase.project!(::TestSphere, q, p)
    q .= p ./ norm(p)
    return q
end
function ManifoldsBase.project!(::TestSphere, Y, p, X)
    Y .= X .- p .* real(dot(p, X))
    return Y
end
function Random.rand!(M::TestSphere, pX; vector_at = nothing, σ = one(eltype(pX)))
    return rand!(Random.default_rng(), M, pX; vector_at = vector_at, σ = σ)
end
function Random.rand!(
        rng::AbstractRNG,
        M::TestSphere,
        pX;
        vector_at = nothing,
        σ = one(eltype(pX)),
    )
    if vector_at === nothing
        project!(M, pX, randn(rng, eltype(pX), representation_size(M)))
    else
        n = σ * randn(rng, eltype(pX), size(pX)) # Gaussian in embedding
        project!(M, pX, vector_at, n) #project to TpM (keeps Gaussianness)
    end
    return pX
end
ManifoldsBase.representation_size(::TestSphere{N}) where {N} = (N + 1,)
function ManifoldsBase.retract_project_fused!(M::TestSphere, q, p, X, t::Number)
    q .= p .+ t .* X
    project!(M, q, q)
    return q
end
function ManifoldsBase.riemann_tensor!(M::TestSphere, Xresult, p, X, Y, Z)
    innerZX = inner(M, p, Z, X)
    innerZY = inner(M, p, Z, Y)
    Xresult .= innerZY .* X .- innerZX .* Y
    return Xresult
end
function ManifoldsBase.sectional_curvature_max(M::TestSphere)
    return ifelse(manifold_dimension(M) == 1, 0.0, 1.0)
end
function ManifoldsBase.sectional_curvature_min(M::TestSphere)
    return ifelse(manifold_dimension(M) == 1, 0.0, 1.0)
end

# from Absil, Mahony, Trumpf, 2013 https://sites.uclouvain.be/absil/2013-01/Weingarten_07PA_techrep.pdf
function ManifoldsBase.Weingarten!(::TestSphere, Y, p, X, V)
    return Y .= -X * p' * V
end

#
#
# minimal implementation of SPD (for its nontrivial metric conversion)
# ---
struct TestSPD <: AbstractManifold{ℝ}
    n::Int
end
function ManifoldsBase.change_metric!(::TestSPD, Y, ::EuclideanMetric, p, X)
    Y .= p * X
    return Y
end
function ManifoldsBase.change_representer!(::TestSPD, Y, ::EuclideanMetric, p, X)
    Y .= p * X * p
    return Y
end
function ManifoldsBase.inner(::TestSPD, p, X, Y)
    F = cholesky(Symmetric(convert(AbstractMatrix, p)))
    return dot((F \ Symmetric(X)), (Symmetric(Y) / F))
end
function spd_sqrt_and_sqrt_inv(p::AbstractMatrix)
    e = eigen(Symmetric(p))
    U = e.vectors
    S = max.(e.values, floatmin(eltype(e.values)))
    Ssqrt = Diagonal(sqrt.(S))
    SsqrtInv = Diagonal(1 ./ sqrt.(S))
    return (Symmetric(U * Ssqrt * transpose(U)), Symmetric(U * SsqrtInv * transpose(U)))
end
function ManifoldsBase.log!(::TestSPD, X, p, q)
    (p_sqrt, p_sqrt_inv) = spd_sqrt_and_sqrt_inv(p)
    T = Symmetric(p_sqrt_inv * convert(AbstractMatrix, q) * p_sqrt_inv)
    e2 = eigen(T)
    Se = Diagonal(log.(max.(e2.values, eps())))
    pU_e = p_sqrt * e2.vectors
    return mul!(X, pU_e, Se * transpose(pU_e))
end
ManifoldsBase.representation_size(M::TestSPD) = (M.n, M.n)

#
#
# A simple Manifold based on a projection onto a subspace
struct ProjManifold <: AbstractManifold{ℝ} end

ManifoldsBase.inner(::ProjManifold, p, X, Y) = dot(X, Y)
function ManifoldsBase.project(M::ProjManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
ManifoldsBase.project!(::ProjManifold, Y, p, X) = (Y .= X .- dot(p, X) .* p)
ManifoldsBase.representation_size(::ProjManifold) = (2, 3)
ManifoldsBase.manifold_dimension(::ProjManifold) = 5
ManifoldsBase.get_vector_orthonormal(::ProjManifold, p, X, N) = reverse(X)
#
#
# A second simple Manifold based on a projection onto a subspace
struct ProjectionTestManifold <: AbstractManifold{ℝ} end
ManifoldsBase.inner(::ProjectionTestManifold, ::Any, X, Y) = dot(X, Y)
function ManifoldsBase.project(M::ProjectionTestManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
function ManifoldsBase.project!(::ProjectionTestManifold, Y, p, X)
    Y .= X .- dot(p, X) .* p
    Y[end] = 0
    return Y
end
ManifoldsBase.manifold_dimension(::ProjectionTestManifold) = 100

#
# Three Non-Things to check for the correct errors in case functions are not implemented
struct NonManifold <: AbstractManifold{ℝ} end
struct NonBasis <: ManifoldsBase.AbstractBasis{ℝ, TangentSpaceType} end
struct NonMPoint <: AbstractManifoldPoint end
struct NonTangentVector <: AbstractTangentVector end
struct NonCotangentVector <: AbstractCotangentVector end
struct NotImplementedRetraction <: AbstractRetractionMethod end
struct NotImplementedInverseRetraction <: AbstractInverseRetractionMethod end
*(t::Float64, X::NonTangentVector) = X

struct NonBroadcastBasisThing{T}
    v::T
end
+(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing) = NonBroadcastBasisThing(a.v + b.v)
*(α, a::NonBroadcastBasisThing) = NonBroadcastBasisThing(α * a.v)
-(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing) = NonBroadcastBasisThing(a.v - b.v)

function ManifoldsBase.isapprox(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing)
    return isapprox(a.v, b.v)
end

function ManifoldsBase.number_eltype(a::NonBroadcastBasisThing)
    return typeof(reduce(+, one(number_eltype(eti)) for eti in a.v))
end

function ManifoldsBase.allocate_on(
        M::AbstractManifold,
        ::TangentSpaceType,
        T::Type{<:NonBroadcastBasisThing},
    )
    return NonBroadcastBasisThing(similar(T.parameters[1], representation_size(M)))
end

ManifoldsBase.allocate(a::NonBroadcastBasisThing) = NonBroadcastBasisThing(allocate(a.v))
function ManifoldsBase.allocate(a::NonBroadcastBasisThing, ::Type{T}) where {T}
    return NonBroadcastBasisThing(allocate(a.v, T))
end
function ManifoldsBase.allocate(::NonBroadcastBasisThing, ::Type{T}, s::Integer) where {T}
    return Vector{T}(undef, s)
end

function Base.copyto!(a::NonBroadcastBasisThing, b::NonBroadcastBasisThing)
    copyto!(a.v, b.v)
    return a
end


function ManifoldsBase.log!(
        ::DefaultManifold,
        X::NonBroadcastBasisThing,
        p::NonBroadcastBasisThing,
        q::NonBroadcastBasisThing,
    )
    return copyto!(X, q - p)
end

function ManifoldsBase.exp!(
        ::DefaultManifold,
        q::NonBroadcastBasisThing,
        p::NonBroadcastBasisThing,
        X::NonBroadcastBasisThing,
    )
    return copyto!(q, p + X)
end

function ManifoldsBase.get_basis_orthonormal(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        𝔽::RealNumbers,
    )
    return CachedBasis(
        DefaultOrthonormalBasis(𝔽),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end
function ManifoldsBase.get_basis_orthogonal(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        𝔽::RealNumbers,
    )
    return CachedBasis(
        DefaultOrthogonalBasis(𝔽),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end
function ManifoldsBase.get_basis_default(
        ::DefaultManifold{ℝ},
        p::NonBroadcastBasisThing,
        N::ManifoldsBase.RealNumbers,
    )
    return CachedBasis(
        DefaultBasis(N),
        [
            NonBroadcastBasisThing(ManifoldsBase._euclidean_basis_vector(p.v, i)) for
                i in eachindex(p.v)
        ],
    )
end

function ManifoldsBase.get_coordinates_orthonormal!(
        M::DefaultManifold{ℝ}, Y, ::NonBroadcastBasisThing, X::NonBroadcastBasisThing, ::RealNumbers,
    )
    copyto!(Y, reshape(X.v, manifold_dimension(M)))
    return Y
end

function ManifoldsBase.get_vector_orthonormal!(
        M::DefaultManifold{ℝ}, Y::NonBroadcastBasisThing, ::NonBroadcastBasisThing, X, ::RealNumbers,
    )
    copyto!(Y.v, reshape(X, representation_size(M)))
    return Y
end

function ManifoldsBase.inner(
        ::DefaultManifold,
        ::NonBroadcastBasisThing,
        X::NonBroadcastBasisThing,
        Y::NonBroadcastBasisThing,
    )
    return dot(X.v, Y.v)
end

ManifoldsBase._get_vector_cache_broadcast(::NonBroadcastBasisThing) = Val(false)

DiagonalizingBasisProxy() = DiagonalizingOrthonormalBasis([1.0, 0.0, 0.0])

#
#
# Vector Space types
struct TestVectorSpaceType <: ManifoldsBase.VectorSpaceType end

struct TestFiberType <: ManifoldsBase.FiberType end

function ManifoldsBase.fiber_dimension(M::AbstractManifold, ::TestFiberType)
    return 2 * manifold_dimension(M)
end

function ManifoldsBase.vector_space_dimension(M::AbstractManifold, ::TestVectorSpaceType)
    return 2 * manifold_dimension(M)
end

#
#
# DefaultManifold with a few artificiual retrations

struct CustomDefinedRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomUndefinedRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomDefinedKeywordRetraction <: ManifoldsBase.AbstractRetractionMethod end
struct CustomDefinedKeywordInverseRetraction <:
    ManifoldsBase.AbstractInverseRetractionMethod end
struct CustomDefinedInverseRetraction <: ManifoldsBase.AbstractInverseRetractionMethod end

struct DefaultPoint{T} <: AbstractManifoldPoint
    value::T
end
Base.convert(::Type{DefaultPoint{T}}, v::T) where {T} = DefaultPoint(v)
Base.eltype(p::DefaultPoint) = eltype(p.value)
Base.length(p::DefaultPoint) = length(p.value)
struct DefaultTangentVector{T} <: AbstractTangentVector
    value::T
end
function Base.convert(::Type{DefaultTangentVector{T}}, ::DefaultPoint, v::T) where {T}
    return DefaultTangentVector(v)
end
Base.eltype(X::DefaultTangentVector) = eltype(X.value)
function Base.fill!(X::DefaultTangentVector, x)
    fill!(X.value, x)
    return X
end
function ManifoldsBase.allocate_result(::DefaultManifold, ::typeof(zero_vector), p::DefaultPoint)
    return DefaultTangentVector(allocate(p.value))
end
function ManifoldsBase.allocate_result_type(
        ::DefaultManifold,
        ::typeof(log),
        ::Tuple{DefaultPoint, DefaultPoint},
    )
    return DefaultTangentVector
end
function ManifoldsBase.allocate_result_type(
        ::DefaultManifold,
        ::typeof(inverse_retract),
        ::Tuple{DefaultPoint, DefaultPoint},
    )
    return DefaultTangentVector
end

function ManifoldsBase.tangent_vector_type(::DefaultManifold, ::Type{DefaultPoint})
    return DefaultTangentVector
end

ManifoldsBase.@manifold_element_forwards DefaultPoint value
ManifoldsBase.@manifold_vector_forwards DefaultTangentVector value
ManifoldsBase.@default_manifold_fallbacks ManifoldsBase.DefaultManifold{ℝ} DefaultPoint DefaultTangentVector value value

function ManifoldsBase._injectivity_radius(::DefaultManifold, ::CustomDefinedRetraction)
    return 10.0
end
function ManifoldsBase._retract!(
        M::DefaultManifold, q, p, X, ::CustomDefinedKeywordRetraction; kwargs...,
    )
    return retract_custom_kw!(M, q, p, X; kwargs...)
end
function ManifoldsBase._retract_fused!(
        M::DefaultManifold, q, p, X, t::Number, ::CustomDefinedKeywordRetraction; kwargs...,
    )
    return retract_custom_kw_fused!(M, q, p, X, t; kwargs...)
end
function retract_custom_kw_fused!(
        ::DefaultManifold, q::DefaultPoint, p::DefaultPoint, X::DefaultTangentVector, t::Number;
        scale = 2.0,
    )
    q.value .= scale .* p.value .+ t .* X.value
    return q
end
function retract_custom_kw!(
        ::DefaultManifold, q::DefaultPoint, p::DefaultPoint, X::DefaultTangentVector; scale = 2.0,
    )
    q.value .= scale .* p.value .+ X.value
    return q
end
function ManifoldsBase._inverse_retract!(
        M::DefaultManifold, X, p, q, ::CustomDefinedKeywordInverseRetraction; kwargs...,
    )
    return inverse_retract_custom_kw!(M, X, p, q; kwargs...)
end
function inverse_retract_custom_kw!(
        ::DefaultManifold, X::DefaultTangentVector, p::DefaultPoint, q::DefaultPoint; scale = 2.0,
    )
    X.value .= q.value - scale * p.value
    return X
end

#
# Test on layer 2 (omitting a layer 3, since we fully qualify all types here already)
function ManifoldsBase._retract!(
        ::DefaultManifold, q::DefaultPoint, p::DefaultPoint, X::DefaultTangentVector, ::CustomDefinedRetraction,
    )
    q.value .= 2 .* p.value .+ X.value
    return q
end
function ManifoldsBase._retract_fused!(
        ::DefaultManifold, q::DefaultPoint, p::DefaultPoint, X::DefaultTangentVector, t::Number, ::CustomDefinedRetraction,
    )
    q.value .= 2 .* p.value .+ t * X.value
    return q
end

function ManifoldsBase._inverse_retract!(
        ::DefaultManifold, X::DefaultTangentVector, p::DefaultPoint, q::DefaultPoint, ::CustomDefinedInverseRetraction,
    )
    X.value .= q.value .- 2 .* p.value
    return X
end

struct MatrixVectorTransport{T} <: AbstractVector{T}
    m::Matrix{T}
end
# dummy retractions, inverse retracions for fallback tests - mutating should be enough
function ManifoldsBase.retract_approx!(::DefaultManifold, q, p, X, m::ApproximateExponentialRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_approx_fused!(::DefaultManifold, q, p, X, t::Number, m::ApproximateExponentialRetraction)
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_polar!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_polar_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_project!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_project_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
ManifoldsBase.retract_qr!(::DefaultManifold, q, p, X) = (q .= p .+ X)
ManifoldsBase.retract_qr_fused!(::DefaultManifold, q, p, X, t::Number) = (q .= p .+ t .* X)

function ManifoldsBase.retract_pade!(::DefaultManifold, q, p, X, m::PadeRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_pade_fused!(
        ::DefaultManifold, q, p, X, t::Number, m::PadeRetraction,
    )
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_sasaki!(::DefaultManifold, q, p, X, m::SasakiRetraction)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_sasaki_fused!(
        ::DefaultManifold, q, p, X, t::Number, ::SasakiRetraction,
    )
    return (q .= p .+ t .* X)
end
function ManifoldsBase.retract_softmax!(::DefaultManifold, q, p, X)
    return (q .= p .+ X)
end
function ManifoldsBase.retract_softmax_fused!(::DefaultManifold, q, p, X, t::Number)
    return (q .= p .+ t .* X)
end
ManifoldsBase.inverse_retract_approx!(::DefaultManifold, Y, p, q, m::ApproximateLogarithmicInverseRetraction) = (Y .= q .- p)
ManifoldsBase.inverse_retract_polar!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_project!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_qr!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
ManifoldsBase.inverse_retract_softmax!(::DefaultManifold, Y, p, q) = (Y .= q .- p)
function ManifoldsBase.inverse_retract_nlsolve!(
        ::DefaultManifold, Y, p, q, m::NLSolveInverseRetraction,
    )
    return (Y .= q .- p)
end
Base.getindex(x::MatrixVectorTransport, i::Int) = x.m[:, i]
Base.size(x::MatrixVectorTransport) = (size(x.m, 2),)

struct TestArrayRepresentation <: AbstractPowerRepresentation end

const TestPowerManifoldMultidimensional = AbstractPowerManifold{𝔽, <:AbstractManifold{𝔽}, TestArrayRepresentation} where {𝔽}

function ManifoldsBase.representation_size(
        M::TestPowerManifoldMultidimensional,
    )
    return (representation_size(M.manifold)..., ManifoldsBase.get_parameter(M.size)...)
end

@inline function ManifoldsBase._write(
        ::TestPowerManifoldMultidimensional,
        rep_size::Tuple, x::AbstractArray, i::Tuple,
    )
    return view(x, ManifoldsBase.rep_size_to_colons(rep_size)..., i...)
end

function ManifoldsBase.get_embedding(
        M::PowerManifold{𝔽, TM, TSW, TestArrayRepresentation}, P::Type,
    ) where {𝔽, TM <: AbstractManifold{𝔽}, TSW}
    ME = get_embedding(M.manifold, P)
    return PowerManifold{ManifoldsBase._get_field(ME), typeof(ME), TSW, TestArrayRepresentation}(ME, M.size)
end

end

using RecursiveArrayTools, ManifoldsBase, Test
using Random
using ManifoldsBase: DefaultManifold, VectorSpaceType, ℝ, Fiber

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

@testset "vector space fibers" begin
    M = DefaultManifold(3)

    p = [1.0, 0.0, 0.0]

    TpM = TangentSpace(M, p)
    @test is_flat(TpM)

    @test ManifoldsBase.fiber_dimension(M, CotangentSpaceType()) == 3

    @test ManifoldsBase.fiber_dimension(M, ManifoldsBase.TangentSpaceType()) == 3

    @testset "spaces at point" begin
        p = [1.0, 0.0, 0.0]
        q = [0.0, 2.0, 0.0]
        t_p = TangentSpace(M, p)
        t_ps = sprint(show, "text/plain", t_p)
        sp = sprint(show, "text/plain", p)
        sp = replace(sp, '\n' => "\n ")
        t_ps_test = "Tangent space to the manifold $(M) at point:\n $(sp)"
        @test t_ps == t_ps_test
        ct_p = CotangentSpace(M, p)
        ct_ps = sprint(show, "text/plain", ct_p)
        ct_ps_test = "Cotangent space to the manifold $(M) at point:\n $(sp)"
        @test ct_ps == ct_ps_test
        @test base_manifold(t_p) == M
        @test manifold_dimension(t_p) == 3
        @test t_p.manifold == M
        @test t_p.fiber_type == TangentSpaceType()
        @test t_p.point == p
        @test injectivity_radius(t_p) == Inf
        @test representation_size(t_p) == representation_size(M)
        X = [0.0, 0.0, 1.0]
        Y = [0.0, 2.0, -1.0]
        @test embed(t_p, X) == X
        @test embed(t_p, X, X) == X
        @test distance(t_p, p, q) ≈ sqrt(5)
        @test isapprox(t_p, exp(t_p, X, X), 2 * X)
        @test isapprox(t_p, log(t_p, X, Y), [0.0, 2.0, -2.0])
        @test isapprox(t_p, X, log(t_p, X, Y), [0.0, 2.0, -2.0])
        @test inner(t_p, X, X, X) ≈ 1.0
        @test norm(t_p, X) ≈ 1.0
        @test norm(t_p, X) ≈ 1.0
        @test parallel_transport_to(t_p, X, Y, X) ≈ Y
        @test vector_transport_to(t_p, X, Y, X) ≈ Y
        @test vector_transport_to(t_p, X, Y, X, ProjectionTransport()) ≈ Y
        Z = similar(X)
        @test vector_transport_to!(t_p, Z, X, Y, X, ProjectionTransport()) ≈ Y
        @test project(t_p, X, Y) ≈ Y
        @test project(t_p, Y) ≈ Y
        @test rand(t_p) isa Vector{Float64}
        @test rand(t_p; vector_at = X) isa Vector{Float64}
        @test rand(Random.default_rng(), t_p) isa Vector{Float64}
        @test rand(Random.default_rng(), t_p; vector_at = X) isa Vector{Float64}
        # generic vector space at
        X_p = Fiber(M, p, TestVectorSpaceType())
        X_ps = sprint(show, "text/plain", X_p)
        X_ps_test = "VectorSpaceFiber{ℝ, DefaultManifold{ℝ, Tuple{Int64}}, TestVectorSpaceType, Vector{Float64}}\nFiber:\n TestVectorSpaceType()DefaultManifold(3; field = ℝ)\nBase point:\n $(sp)"
        @test X_ps == X_ps_test

        for basis in
            [DefaultOrthonormalBasis(), get_basis(t_p, p, DefaultOrthonormalBasis())]
            @test length(get_vectors(t_p, p, get_basis(t_p, p, basis))) == 3
            X1c = get_coordinates(t_p, p, X, basis)
            @test isapprox(X1c, [0.0, 0.0, 1.0])
            Y1c = similar(X1c)
            get_coordinates!(t_p, Y1c, p, X, basis)
            @test isapprox(X1c, Y1c)
            @test isapprox(get_vector(t_p, p, X1c, basis), X)
            Z1 = similar(X)
            get_vector!(t_p, Z1, p, X1c, basis)
            @test isapprox(Z1, X)
        end

        @testset "scalar fiber" begin
            Ms = DefaultManifold()
            p = 1.0
            t_p = TangentSpace(Ms, p)
            @test norm(t_p, 2.0) == 2.0
        end
    end

    @testset "Weingarten Map" begin
        p0 = [1.0, 0.0, 0.0]
        M = TangentSpace(M, p0)
        p = [0.0, 1.0, 1.0]
        X = [0.0, 1.0, 0.0]
        V = [1.0, 0.0, 0.0]
        @test Weingarten(M, p, X, V) == zero_vector(M, p)
    end
end

"""
    project(M::AbstractManifold, p)

Project point `p` from the ambient space of the [`AbstractManifold`](@ref) `M` to `M`.
This method is only available for manifolds where implicitly an embedding or ambient space
is given. Additionally, the projection includes changing data representation, if applicable,
i.e. if the points on `M` are not represented in the same array data, the data is changed
accordingly.

See also: [`EmbeddedManifold`](@ref), [`embed`](@ref embed(M::AbstractManifold, p))
"""
function project(M::AbstractManifold, p)
    q = allocate_result_embedding(M, project, p)
    project!(M, q, p)
    return q
end

"""
    project!(M::AbstractManifold, q, p)

Project point `p` from the ambient space onto the [`AbstractManifold`](@ref) `M`. The result is
stored in `q`.
This method is only available for manifolds where implicitly an embedding or ambient space
is given. Additionally, the projection includes changing data representation, if applicable,
i.e. if the points on `M` are not represented in the same array data, the data is changed
accordingly.

See also: [`EmbeddedManifold`](@ref), [`embed!`](@ref embed!(M::AbstractManifold, q, p))
"""
project!(::AbstractManifold, q, p)

"""
    project(M::AbstractManifold, p, X)

Project ambient space representation of a vector `X` to a tangent vector at point `p` on
the [`AbstractManifold`](@ref) `M`.
This method is only available for manifolds where implicitly an embedding or ambient space
is given.
Additionally, `project` includes changing data representation, if applicable, i.e.
if the tangents on `M` are not represented in the same way as points on the embedding,
the representation is changed accordingly. This is the case for example for Lie groups,
when tangent vectors are represented in the Lie algebra. after projection the change to the
Lie algebra is performed, too.
If you do not want to change the data representation, you should use [`embed_project`](@ref embed_project(M::AbstractManifold, p, X)) instead.

See also: [`EmbeddedManifold`](@ref), [`embed`](@ref embed(M::AbstractManifold, p, X)),
[`embed_project`](@ref embed_project(M::AbstractManifold, p, X)).
"""
function project(M::AbstractManifold, p, X)
    # Note that the order is switched,
    # since the allocation by default takes the type of the first.
    Y = allocate_result_embedding(M, project, X, p)
    project!(M, Y, p, X)
    return Y
end

"""
    project!(M::AbstractManifold, Y, p, X)

Project ambient space representation of a vector `X` to a tangent vector at point `p` on
the [`AbstractManifold`](@ref) `M`. The result is saved in vector `Y`.
This method is only available for manifolds where implicitly an embedding or ambient space
is given.
Additionally, `project!` includes changing data representation, if applicable, i.e.
if the tangents on `M` are not represented in the same way as points on the embedding,
the representation is changed accordingly. This is the case for example for Lie groups,
when tangent vectors are represented in the Lie algebra. after projection the change to the
Lie algebra is performed, too.
If you do not want to change the data representation, you should use [`embed_project!`](@ref embed_project!(M::AbstractManifold, Y, p, X)) instead.

See also: [`EmbeddedManifold`](@ref), [`embed!`](@ref embed!(M::AbstractManifold, Y, p, X)),
[`embed_project!`](@ref embed_project!(M::AbstractManifold, Y, p, X)).
"""
project!(::AbstractManifold, Y, p, X)

"""
    abstract type FiberType end

An abstract type for fiber types that can be used within [`Fiber`](@ref).
"""
abstract type FiberType end

@doc raw"""
    Fiber{𝔽,TFiber<:FiberType,TM<:AbstractManifold,TX} <: AbstractManifold{𝔽}

A fiber of a fiber bundle at a point `p` on the manifold.

This fiber itself is also a `manifold`. For vector fibers it's by default flat and hence
isometric to the [`Euclidean`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/euclidean.html) manifold.

# Fields

* `manifold`    – base space of the fiber bundle
* `point`       – a point ``p`` from the base space; the fiber corresponds to the preimage
                  by bundle projection ``\pi^{-1}(\{p\})``.


# Constructor

    Fiber(M::AbstractManifold, p, fiber_type::FiberType)

A fiber of type `fiber_type` at point `p` from the manifold `manifold`.
"""
struct Fiber{𝔽, TFiber <: FiberType, TM <: AbstractManifold, TX} <: AbstractManifold{𝔽}
    manifold::TM
    point::TX
    fiber_type::TFiber
end

function Fiber(
        manifold::TM,
        point::TX,
        fiber_type::TFiber;
        field::AbstractNumbers = ℝ,
    ) where {TM <: AbstractManifold, TX, TFiber <: FiberType}
    return Fiber{field, TFiber, TM, TX}(manifold, point, fiber_type)
end

base_manifold(B::Fiber) = B.manifold

function Base.show(io::IO, ::MIME"text/plain", vs::Fiber)
    summary(io, vs)
    println(io, "\nFiber:")
    pre = " "
    sf = sprint(show, "text/plain", vs.fiber_type; context = io, sizehint = 0)
    sf = replace(sf, '\n' => "\n$(pre)")
    sm = sprint(show, "text/plain", vs.manifold; context = io, sizehint = 0)
    sm = replace(sm, '\n' => "\n$(pre)")
    println(io, pre, sf, sm)
    println(io, "Base point:")
    sp = sprint(show, "text/plain", vs.point; context = io, sizehint = 0)
    sp = replace(sp, '\n' => "\n$(pre)")
    return print(io, pre, sp)
end

module ManifoldsBaseMakieExt

using ManifoldsBase
using Makie
using Printf: @sprintf
import ManifoldsBase: plot_slope, plot_check_geodesic

function ManifoldsBase.plot_slope(
        ::Val{:Makie}, x, y;
        slope = 2, line_base = 0, a = 0, b = 2.0, i = 1, j = length(x),
    )
    fig = Makie.Figure()
    # Setup the log log plot
    ax = Makie.Axis(
        fig[1, 1];
        xscale = log10, yscale = log10, xlabel = "t", ylabel = L"E(t)", title = "Slope plot",
    )
    # Main error data
    Makie.lines!(ax, x, y; label = L"E(t)", linewidth = 3, color = :lightblue)
    # Reference slope
    s_line = [exp10(line_base + t * slope) for t in log10.(x)]
    Makie.lines!(
        ax, x, s_line; label = "slope s=$slope",
        linestyle = :dash, color = :black, linewidth = 2
    )

    # Best-fit slope segment if i and j are provided
    if (i != 0) && (j != 0)
        best_line = [exp10(a + t * b) for t in log10.(x[i:j])]
        Makie.lines!(
            ax, x[i:j], best_line;
            label = "best slope $(@sprintf("%.4f", b))",
            color = :blue, linestyle = :dot, linewidth = 2,
        )
    end
    Makie.axislegend(ax; position = :lt)
    return fig
end
function ManifoldsBase.plot_check_geodesic(::Val{:Makie}, T, N, e_norm, e_pt, e_alpha)
    fig = Figure()
    ax = Axis(
        fig[1, 1];
        xlabel = "t", ylabel = "error magnitude", title = "Geodesic checks",
    )
    # Speed deviation: |‖Xᵢ‖ − mean‖X‖|
    Makie.lines!(
        ax, T[1:(N - 1)], e_norm;
        label = L"|\|X_i\| - \overline{\|X\|}|", linewidth = 3, color = :lightblue
    )
    # Parallel-transport mismatch (norm): ‖Xᵢ − PT_{i+1→i}(X_{i+1})‖
    lines!(
        ax, T[1:(N - 2)], e_pt;
        label = "PT difference (norm)", linewidth = 3, color = :blue
    )
    # Parallel-transport mismatch (angle): |1 − cos∠(Xᵢ, PT_{i+1→i}X_{i+1})|
    lines!(
        ax, T[1:(N - 2)], e_alpha;
        label = "PT difference (angle)", linewidth = 3, color = :green
    )
    axislegend(ax; position = :rt)
    return fig
end
end

@doc raw"""
    TangentSpace{𝔽,M} = Fiber{𝔽,TangentSpaceType,M} where {𝔽,M<:AbstractManifold}

A manifold for the tangent space ``T_p\mathcal M`` at a point ``p\in\mathcal M``.
This is modelled as an alias for [`VectorSpaceFiber`](@ref) corresponding to
[`TangentSpaceType`](@ref).

# Constructor

    TangentSpace(M::AbstractManifold, p)

Return the manifold (vector space) representing the tangent space ``T_p\mathcal M``
at point `p`, ``p\in\mathcal M``.
"""
const TangentSpace{𝔽, M} = Fiber{𝔽, TangentSpaceType, M} where {𝔽, M <: AbstractManifold}

TangentSpace(M::AbstractManifold, p) = Fiber(M, p, TangentSpaceType())

@doc raw"""
    CotangentSpace{𝔽,M} = Fiber{𝔽,CotangentSpaceType,M} where {𝔽,M<:AbstractManifold}

A manifold for the Cotangent space ``T^*_p\mathcal M`` at a point ``p\in\mathcal M``.
This is modelled as an alias for [`VectorSpaceFiber`](@ref) corresponding to
[`CotangentSpaceType`](@ref).

# Constructor

    CotangentSpace(M::AbstractManifold, p)

Return the manifold (vector space) representing the cotangent space ``T^*_p\mathcal M``
at point `p`, ``p\in\mathcal M``.
"""
const CotangentSpace{𝔽, M} = Fiber{𝔽, CotangentSpaceType, M} where {𝔽, M <: AbstractManifold}

CotangentSpace(M::AbstractManifold, p) = Fiber(M, p, CotangentSpaceType())


function allocate_result(M::TangentSpace, ::typeof(rand))
    return zero_vector(M.manifold, M.point)
end

@doc raw"""
    base_point(TpM::TangentSpace)

Return the base point of the [`TangentSpace`](@ref).
"""
base_point(TpM::TangentSpace) = TpM.point

# forward both point checks to tangent vector checks
function check_point(TpM::TangentSpace, p; kwargs...)
    return check_vector(TpM.manifold, TpM.point, p; kwargs...)
end
function check_size(TpM::TangentSpace, p; kwargs...)
    return check_size(TpM.manifold, TpM.point, p; kwargs...)
end
# fix tangent vector checks to use the right base point
function check_vector(TpM::TangentSpace, p, X; kwargs...)
    return check_vector(TpM.manifold, TpM.point, X; kwargs...)
end
function check_size(TpM::TangentSpace, p, X; kwargs...)
    return check_size(TpM.manifold, TpM.point, X; kwargs...)
end


"""
    distance(M::TangentSpace, X, Y)

Distance between vectors `X` and `Y` from the [`TangentSpace`](@ref) `TpM`.
It is calculated as the [`norm`](@ref) (induced by the metric on `TpM`) of their difference.
"""
function distance(TpM::TangentSpace, X, Y)
    return norm(TpM.manifold, TpM.point, Y - X)
end

function embed!(TpM::TangentSpace, Y, X)
    return embed!(TpM.manifold, Y, TpM.point, X)
end
function embed!(TpM::TangentSpace, W, X, V)
    return embed!(TpM.manifold, W, TpM.point, V)
end

@doc raw"""
    exp(TpM::TangentSpace, X, V)

Exponential map of tangent vectors `X` from `TpM` and a direction `V`,
which is also from the [`TangentSpace`](@ref) `TpM` since we identify the tangent space of `TpM` with `TpM`.
The exponential map then simplifies to the sum `X+V`.
"""
exp(::TangentSpace, ::Any, ::Any)

function exp!(TpM::TangentSpace, Y, X, V)
    copyto!(TpM.manifold, Y, TpM.point, X + V)
    return Y
end

fiber_dimension(M::AbstractManifold, ::CotangentSpaceType) = manifold_dimension(M)
fiber_dimension(M::AbstractManifold, ::TangentSpaceType) = manifold_dimension(M)

function get_basis(TpM::TangentSpace, X, B::CachedBasis)
    return invoke(
        get_basis,
        Tuple{AbstractManifold, Any, CachedBasis},
        TpM.manifold,
        TpM.point,
        B,
    )
end
function get_basis(TpM::TangentSpace, X, B::AbstractBasis{<:Any, TangentSpaceType})
    return get_basis(TpM.manifold, TpM.point, B)
end

function get_coordinates(TpM::TangentSpace, X, V, B::AbstractBasis)
    return get_coordinates(TpM.manifold, TpM.point, V, B)
end

function get_coordinates!(TpM::TangentSpace, c, X, V, B::AbstractBasis)
    return get_coordinates!(TpM.manifold, c, TpM.point, V, B)
end

function get_embedding(TpM::TangentSpace)
    return TangentSpace(
        get_embedding(TpM.manifold, typeof(TpM.point)),
        embed(TpM.manifold, TpM.point),
    )
end

function get_vector(TpM::TangentSpace, X, c, B::AbstractBasis)
    return get_vector(TpM.manifold, TpM.point, c, B)
end

function get_vector!(TpM::TangentSpace, V, X, c, B::AbstractBasis)
    return get_vector!(TpM.manifold, V, TpM.point, c, B)
end

function get_vectors(TpM::TangentSpace, X, B::CachedBasis)
    return get_vectors(TpM.manifold, TpM.point, B)
end

@doc raw"""
    injectivity_radius(TpM::TangentSpace)

Return the injectivity radius on the [`TangentSpace`](@ref) `TpM`, which is $∞$.
"""
injectivity_radius(::TangentSpace) = Inf

@doc raw"""
    inner(M::TangentSpace, X, V, W)

For any ``X ∈ T_p\mathcal M`` we identify the tangent space ``T_X(T_p\mathcal M)``
with ``T_p\mathcal M`` again. Hence an inner product of ``V,W`` is just the inner product of
the tangent space itself. ``⟨V,W⟩_X = ⟨V,W⟩_p``.
"""
function inner(TpM::TangentSpace, X, V, W)
    return inner(TpM.manifold, TpM.point, V, W)
end

"""
    is_flat(::TangentSpace)

The [`TangentSpace`](@ref) is a flat manifold, so this returns `true`.
"""
is_flat(::TangentSpace) = true

function _isapprox(TpM::TangentSpace, X, Y; kwargs...)
    return isapprox(TpM.manifold, TpM.point, X, Y; kwargs...)
end

function _isapprox(TpM::TangentSpace, X, V, W; kwargs...)
    return isapprox(TpM.manifold, TpM.point, V, W; kwargs...)
end

"""
    log(TpM::TangentSpace, X, Y)

Logarithmic map on the [`TangentSpace`](@ref) `TpM`, calculated as the difference of tangent
vectors `q` and `p` from `TpM`.
"""
log(::TangentSpace, ::Any...)
function log!(TpM::TangentSpace, V, X, Y)
    copyto!(TpM, V, TpM.point, Y - X)
    return V
end

@doc raw"""
    manifold_dimension(TpM::TangentSpace)

Return the dimension of the [`TangentSpace`](@ref) ``T_p\mathcal M`` at ``p∈\mathcal M``,
which is the same as the dimension of the manifold ``\mathcal M``.
"""
function manifold_dimension(TpM::TangentSpace)
    return manifold_dimension(TpM.manifold)
end

@doc raw"""
    parallel_transport_to(::TangentSpace, X, V, Y)

Transport the tangent vector ``Z ∈ T_X(T_p\mathcal M)`` from `X` to `Y`.
Since we identify ``T_X(T_p\mathcal M) = T_p\mathcal M`` and the tangent space is a vector space,
parallel transport simplifies to the identity, so this function yields ``V`` as a result.
"""
parallel_transport_to(TpM::TangentSpace, X, V, Y)

function parallel_transport_to!(TpM::TangentSpace, W, X, V, Y)
    return copyto!(TpM.manifold, W, TpM.point, V)
end

@doc raw"""
    project(TpM::TangentSpace, X)

Project the point `X` from embedding of the [`TangentSpace`](@ref) `TpM` onto `TpM`.
"""
project(::TangentSpace, ::Any)

function project!(TpM::TangentSpace, Y, X)
    return project!(TpM.manifold, Y, TpM.point, X)
end

@doc raw"""
    project(TpM::TangentSpace, X, V)

Project the vector `V` from the embedding of the tangent space `TpM` (identified with ``T_X(T_p\mathcal M)``),
that is project the vector `V` onto the tangent space at `TpM.point`.
"""
project(::TangentSpace, ::Any, ::Any)

function project!(TpM::TangentSpace, W, X, V)
    return project!(TpM.manifold, W, TpM.point, V)
end

function Random.rand!(TpM::TangentSpace, X; vector_at = nothing)
    rand!(TpM.manifold, X; vector_at = TpM.point)
    return X
end
function Random.rand!(rng::AbstractRNG, TpM::TangentSpace, X; vector_at = nothing)
    rand!(rng, TpM.manifold, X; vector_at = TpM.point)
    return X
end

representation_size(TpM::TangentSpace) = representation_size(TpM.manifold)

function Base.show(io::IO, ::MIME"text/plain", TpM::TangentSpace)
    println(io, "Tangent space to the manifold $(base_manifold(TpM)) at point:")
    pre = " "
    sp = sprint(show, "text/plain", TpM.point; context = io, sizehint = 0)
    sp = replace(sp, '\n' => "\n$(pre)")
    return print(io, pre, sp)
end


function Base.show(io::IO, ::MIME"text/plain", cTpM::CotangentSpace)
    println(io, "Cotangent space to the manifold $(base_manifold(cTpM)) at point:")
    pre = " "
    sp = sprint(show, "text/plain", cTpM.point; context = io, sizehint = 0)
    sp = replace(sp, '\n' => "\n$(pre)")
    return print(io, pre, sp)
end

@doc raw"""
    Y = Weingarten(TpM::TangentSpace, X, V, A)
    Weingarten!(TpM::TangentSpace, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_X`` at `X` on the [`TangentSpace`](@ref) `TpM` with respect to the
tangent vector ``V \in T_p\mathcal M`` and the normal vector ``A \in N_p\mathcal M``.

Since this a flat space by itself, the result is always the zero tangent vector.
"""
Weingarten(::TangentSpace, ::Any, ::Any, ::Any)

Weingarten!(::TangentSpace, W, X, V, A) = fill!(W, 0)

@doc raw"""
    zero_vector(TpM::TangentSpace)

Zero tangent vector in the [`TangentSpace`](@ref) `TpM`,
that is the zero tangent vector at point `TpM.point`.
"""
zero_vector(TpM::TangentSpace) = zero_vector(TpM.manifold, TpM.point)

@doc raw"""
    zero_vector(TpM::TangentSpace, X)

Zero tangent vector at point `X` from the [`TangentSpace`](@ref) `TpM`,
that is the zero tangent vector at point `TpM.point`,
since we identify the tangent space ``T_X(T_p\mathcal M)`` with ``T_p\mathcal M``.
"""
zero_vector(::TangentSpace, ::Any...)

function zero_vector!(M::TangentSpace, V, X)
    return zero_vector!(M.manifold, V, M.point)
end

"""
    ValidationManifold{𝔽,M<:AbstractManifold{𝔽}} <: AbstractDecoratorManifold{𝔽}

A manifold to add tests to input and output values of functions defined in the interface.

Additionally the points and tangent vectors can also be encapsulated, cf.
[`ValidationMPoint`](@ref), [`ValidationTangentVector`](@ref), and [`ValidationCotangentVector`](@ref).
These types can be used to see where some data is assumed to be from, when working on
manifolds where both points and tangent vectors are represented as (plain) arrays.

Using the `ignore_contexts` keyword allows to specify a single `Symbol` or a vector of `Symbols`
Of which contexts to ignore.

Current contexts are
* `:All`: disable all checks
* `:Point`: checks for points
* `:Vector`: checks for vectors
* `:Output`: checks for output
* `:Input`: checks for input variables

Using the `ignore_functions` keyword (dictionary) allows to disable/ignore certain checks
within single functions for this manifold.
The `key` of the dictionary has to be the `Function` to exclude something in.
The `value` is either a single symbol or a vector of symbols with the same meaning as the
`ignore_contexts` keyword, but limited to this function

# Examples
* `exp => :All` disables _all_ checks in the [`exp`](@ref) function
* `exp => :Point` excludes point checks in the [`exp`](@ref) function
* `exp => [:Point, :Vector]` excludes point and vector checks in the [`exp`](@ref) function

This manifold is a decorator for a manifold, i.e. it decorates a [`AbstractManifold`](@ref) `M`
with types points, vectors, and covectors.

# Fields

* `manifold::M`: The manifold to be decorated
* `mode::Symbol`: The mode to be used for error handling, either `:error` or `:warn`
* `ignore_contexts::AbstractVector{Symbol}`: store contexts to be ignored of validation.
* `ignore_functions::Dict{<:Function,<:Union{Symbol,<:AbstractVector{Symbol}}`:
  store contexts to be ignored with in a function or its mutating variant.

# Constructors

    ValidationManifold(M::AbstractManifold; kwargs...)

Generate the Validation manifold

    ValidationManifold(M::AbstractManifold, V::ValidationManifold; kwargs...)

Generate the Validation manifold for `M` with the default values of `V`.


## Keyword arguments

* `error::Symbol=:error`: specify how errors in the validation should be reported.
  this is passed to [`is_point`](@ref) and [`is_vector`](@ref) as the `error` keyword argument.
  Available values are `:error`, `:warn`, `:info`, and `:none`. Every other value is treated as `:none`.
* `store_base_point::Bool=false`: specify whether or not to store the point `p` a tangent or cotangent vector
  is associated with. This can be useful for debugging purposes.
* `ignore_contexts = Vector{Symbol}()` a vector to indicate which validation contexts should not be performed.
* `ignore_functions=Dict{Function,Union{Symbol,Vector{Symbol}}}()` a dictionary to disable certain contexts within functions.
  The key here is the non-mutating function variant (if it exists). The contexts are three same as in `ignore_contexts`.
"""
struct ValidationManifold{
        𝔽,
        M <: AbstractManifold{𝔽},
        D <: Dict{<:Function, <:Union{Symbol, <:AbstractVector{Symbol}}},
        V <: AbstractVector{Symbol},
    } <: AbstractDecoratorManifold{𝔽}
    manifold::M
    mode::Symbol
    store_base_point::Bool
    ignore_functions::D
    ignore_contexts::V
end
function ValidationManifold(
        M::AbstractManifold;
        error::Symbol = :error,
        store_base_point::Bool = false,
        ignore_functions::D = Dict{Function, Union{Symbol, <:Vector{Symbol}}}(),
        ignore_contexts::V = Vector{Symbol}(),
    ) where {
        D <: Dict{<:Function, <:Union{Symbol, <:AbstractVector{Symbol}}},
        V <: AbstractVector{Symbol},
    }
    return ValidationManifold(M, error, store_base_point, ignore_functions, ignore_contexts)
end
function ValidationManifold(M::AbstractManifold, V::ValidationManifold; kwargs...)
    return ValidationManifold(
        M;
        error = V.mode,
        ignore_contexts = V.ignore_contexts,
        ignore_functions = V.ignore_functions,
        store_base_point = V.store_base_point,
        kwargs...,
    )
end

"""
    _vMc(M::ValidationManifold, f::Function, context::Symbol)
    _vMc(M::ValidationManifold, f::Function, context::NTuple{N,Symbol}) where {N}

Return whether a check should be performed within `f` and the `context`(`s`) provided.

This function returns false and hence indicates not to check, when
* (one of the) `context`(`s`) is in the ignore list for `f` within `ignore_functions`
* (one of the) `context`(`s`) is in the `ignore_contexts` list

Otherwise the test is active.

!!! Note
   This function is internal and used very often, co it has a very short name;
    `_vMc` stands for "`ValidationManifold` check".
"""
function _vMc end

function _vMc(M::ValidationManifold, ::Nothing, context::Symbol)
    # Similarly for the global contexts
    (:All ∈ M.ignore_contexts) && return false
    (context ∈ M.ignore_contexts) && return false
    return true
end
function _vMc(M::ValidationManifold, f::Function, context::Symbol)
    if haskey(M.ignore_functions, f)
        # If :All is present -> deactivate
        !_vMc(M.ignore_functions[f], :All) && return false
        # If any of the provided contexts is present -> deactivate
        !_vMc(M.ignore_functions[f], context) && return false
    end
    !_vMc(M, nothing, context) && return false
    return true
end
function _vMc(M::ValidationManifold, f, contexts::NTuple{N, Symbol}) where {N}
    for c in contexts
        !_vMc(M, f, c) && return false
    end
    return true
end
# Sub tests: is any of a in b? Then return false – b is from before always a symbol already
# If a and b are symbols, equality is checked
_vMc(a::Symbol, b::Symbol) = !(a === b)
# If a is a vector multiple, then return false if b appears in a
_vMc(a::Union{<:NTuple{N, Symbol} where {N}, <:AbstractVector{Symbol}}, b::Symbol) = !(b ∈ a)

"""
    ValidationMPoint{P} <: AbstractManifoldPoint

Represent a point on an [`ValidationManifold`](@ref). The point is stored internally.

# Fields
* ` value::P`: the internally stored point on a manifold

# Constructor

        ValidationMPoint(value)

Create a point on the manifold with the value `value`.
"""
struct ValidationMPoint{P} <: AbstractManifoldPoint
    value::P
end

"""
    ValidationFibreVector{TType<:VectorSpaceType,V,P} <: AbstractFibreVector{TType}

Represent a tangent vector to a point on an [`ValidationManifold`](@ref).
The original vector of the manifold is stored internally. The corresponding base point
of the fibre can be stored as well.

The `TType` indicates the type of fibre, for example [`TangentSpaceType`](@ref) or [`CotangentSpaceType`](@ref).

# Fields

* `value::V`: the internally stored vector on the fibre
* `point::P`: the point the vector is associated with

# Constructor

        ValidationFibreVector{TType}(value, point=nothing)

"""
struct ValidationFibreVector{TType <: VectorSpaceType, V, P} <: AbstractFibreVector{TType}
    value::V
    point::P
end
function ValidationFibreVector{TType}(value::V, point::P = nothing) where {TType, V, P}
    return ValidationFibreVector{TType, V, P}(value, point)
end

"""
    ValidationTangentVector = ValidationFibreVector{TangentSpaceType}

Represent a tangent vector to a point on an [`ValidationManifold`](@ref), i.e. on a manifold
where data can be represented by arrays. The array is stored internally and semantically.
This distinguished the value from [`ValidationMPoint`](@ref)s vectors of other types.
"""
const ValidationTangentVector = ValidationFibreVector{TangentSpaceType}

"""
    ValidationCotangentVector = ValidationFibreVector{CotangentSpaceType}

Represent a cotangent vector to a point on an [`ValidationManifold`](@ref), i.e. on a manifold
where data can be represented by arrays. The array is stored internally and semantically.
This distinguished the value from [`ValidationMPoint`](@ref)s vectors of other types.
"""
const ValidationCotangentVector = ValidationFibreVector{CotangentSpaceType}

@eval @manifold_vector_forwards ValidationFibreVector{TType} TType value

@eval @manifold_element_forwards ValidationMPoint value

"""
    internal_value(p)

Return the internal value of an [`ValidationMPoint`](@ref), [`ValidationTangentVector`](@ref), or
[`ValidationCotangentVector`](@ref) if the value `p` is encapsulated as such.
Return `p` if it is already an a (plain) value on a manifold.
"""
internal_value(p) = p
internal_value(p::ValidationMPoint) = p.value
internal_value(X::ValidationFibreVector) = X.value

_update_basepoint!(::ValidationManifold, X, p) = X
function _update_basepoint!(
        ::ValidationManifold,
        X::ValidationTangentVector{P, Nothing},
        p,
    ) where {P}
    return X
end
function _update_basepoint!(
        M::ValidationManifold,
        X::ValidationTangentVector{P, V},
        p,
    ) where {P, V}
    copyto!(M.manifold, X.point, p)
    return X
end


"""
    _msg(str; error=:None, within::Union{Nothing,<:Function} = nothing,
    context::Union{NTuple{N,Symbol} where N} = NTuple{0,Symbol}())

issue a message `str` according to the mode `mode` (as `@error`, `@warn`, `@info`).
"""
function _msg(
        M::ValidationManifold,
        str;
        error = M.mode,
        within::Union{Nothing, <:Function} = nothing,
        context::Union{NTuple{N, Symbol} where {N}} = NTuple{0, Symbol}(),
    )
    !_vMc(M, within, context) && return nothing
    (error === :error) && (throw(ErrorException(str)))
    (error === :warn) && (@warn str)
    (error === :info) && (@info str)
    return nothing
end
function _msg(
        M::ValidationManifold,
        err::Union{DomainError, ArgumentError, ErrorException};
        error = M.mode,
        within::Union{Nothing, <:Function} = nothing,
        context::Union{NTuple{N, Symbol} where {N}} = NTuple{0, Symbol}(),
    )
    !_vMc(M, within, context) && return nothing
    (error === :error) && (throw(err))
    (error === :warn) && (@warn "$err")
    (error === :info) && (@info "$err")
    return nothing
end

convert(::Type{M}, m::ValidationManifold{𝔽, M}) where {𝔽, M <: AbstractManifold{𝔽}} = m.manifold
function convert(::Type{<:ValidationManifold{𝔽, M}}, m::M) where {𝔽, M <: AbstractManifold{𝔽}}
    return ValidationManifold(m)
end
function convert(
        ::Type{V},
        p::ValidationMPoint{V},
    ) where {V <: Union{AbstractArray, AbstractManifoldPoint}}
    return p.value
end
function convert(::Type{ValidationMPoint{V}}, x::V) where {V <: AbstractArray}
    return ValidationMPoint{V}(x)
end

function convert(
        ::Type{V},
        X::ValidationFibreVector{TType, V, Nothing},
    ) where {TType, V <: Union{AbstractArray, AbstractFibreVector}}
    return X.value
end
function convert(::Type{ValidationFibreVector{TType, V, Nothing}}, X::V) where {TType, V}
    return ValidationFibreVector{TType}(X)
end

function copyto!(M::ValidationManifold, q::ValidationMPoint, p::ValidationMPoint; kwargs...)
    is_point(M, p; within = copyto!, context = (:Input,), kwargs...)
    copyto!(M.manifold, q.value, p.value)
    is_point(M, q; within = copyto!, context = (:Input,), kwargs...)
    return q
end
function copyto!(
        M::ValidationManifold,
        Y::ValidationFibreVector{TType},
        p::ValidationMPoint,
        X::ValidationFibreVector{TType};
        kwargs...,
    ) where {TType}
    is_point(M, p; within = copyto!, context = (:Input,), kwargs...)
    copyto!(M.manifold, Y.value, p.value, X.value)
    return p
end

decorated_manifold(M::ValidationManifold) = M.manifold

function distance(M::ValidationManifold, p, q; kwargs...)
    is_point(M, p; within = distance, context = (:Input,), kwargs...)
    is_point(M, q; within = distance, context = (:Input,), kwargs...)
    d = distance(M.manifold, internal_value(p), internal_value(q))
    (d < 0) && _msg(
        M,
        DomainError(d, "Distance is negative.");
        within = distance,
        context = (:Output,),
    )
    return d
end

function embed(M::ValidationManifold, p::P; kwargs...) where {P}
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    q = embed(M.manifold, internal_value(p))
    MEV = ValidationManifold(get_embedding(M.manifold, P), M)
    is_point(MEV, q; error = MEV.mode, within = embed, context = (:Output,), kwargs...)
    return ValidationMPoint(q)
end
function embed(M::ValidationManifold, p::P, X; kwargs...) where {P}
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = embed, context = (:Input,), kwargs...)
    Y = embed(M.manifold, internal_value(p), internal_value(X))
    MEV = ValidationManifold(get_embedding(M.manifold, P), M)
    q = embed(M.manifold, internal_value(p))
    is_vector(MEV, q, Y; within = embed, context = (:Output,), kwargs...)
    return ValidationTangentVector(Y, M.store_base_point ? q : nothing)
end

function embed!(M::ValidationManifold, q, p::P; kwargs...) where {P}
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    embed!(M.manifold, internal_value(q), internal_value(p))
    MEV = ValidationManifold(get_embedding(M.manifold, P), M)
    is_point(MEV, q; error = MEV.mode, within = embed, context = (:Output,), kwargs...)
    return q
end
function embed!(M::ValidationManifold, Y, p::P, X; kwargs...) where {P}
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = embed, context = (:Input,), kwargs...)
    embed!(M.manifold, internal_value(Y), internal_value(p), internal_value(X))
    MEV = ValidationManifold(get_embedding(M.manifold, P), M)
    q = embed(M.manifold, internal_value(p))
    _update_basepoint!(M, Y, q)
    is_vector(MEV, q, Y; within = embed, context = (:Output,), kwargs...)
    return Y
end

function embed_project(M::ValidationManifold, p; kwargs...)
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    q = embed_project(M.manifold, internal_value(p))
    is_point(M, q; within = embed, context = (:Output,), kwargs...)
    return ValidationMPoint(q)
end
function embed_project(M::ValidationManifold, p, X; kwargs...)
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = embed, context = (:Input,), kwargs...)
    Y = embed_project(M.manifold, internal_value(p), internal_value(X))
    is_vector(M, p, Y; within = embed, context = (:Output,), kwargs...)
    return ValidationTangentVector(Y, M.store_base_point ? copy(M, p) : nothing)
end

function embed_project!(M::ValidationManifold, q, p; kwargs...)
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    embed_project!(M.manifold, internal_value(q), internal_value(p))
    is_point(M, q; within = embed, context = (:Output,), kwargs...)
    return q
end
function embed_project!(M::ValidationManifold, Y, p, X; kwargs...)
    is_point(M, p; within = embed, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = embed, context = (:Input,), kwargs...)
    embed_project!(M.manifold, internal_value(Y), internal_value(p), internal_value(X))
    _update_basepoint!(M, Y, p)
    is_vector(M, p, Y; within = embed, context = (:Output,), kwargs...)
    return Y
end

function exp(M::ValidationManifold, p, X; kwargs...)
    is_point(M, p; within = exp, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = exp, context = (:Input,), kwargs...)
    y = exp(M.manifold, internal_value(p), internal_value(X))
    is_point(M, y; within = exp, context = (:Output,), kwargs...)
    return ValidationMPoint(y)
end

function exp!(M::ValidationManifold, q, p, X; kwargs...)
    is_point(M, p; within = exp, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = exp, context = (:Input,), kwargs...)
    exp!(M.manifold, internal_value(q), internal_value(p), internal_value(X))
    is_point(M, q; within = exp, context = (:Output,), kwargs...)
    return q
end

function get_basis(M::ValidationManifold, p, B::AbstractBasis; kwargs...)
    is_point(M, p; within = get_basis, context = (:Input,), kwargs...)
    Ξ = get_basis(M.manifold, internal_value(p), B)
    bvectors = get_vectors(M, p, Ξ)
    N = length(bvectors)
    if N != manifold_dimension(M.manifold)
        _msg(
            M,
            "For a basis of the tangent space at $(p) of $(M.manifold), $(manifold_dimension(M)) vectors are required, but get_basis $(B) computed $(N)";
            within = get_basis,
            context = (:Output,),
        )
    end
    # check that the vectors are linearly independent\
    bv_rank = rank(reduce(hcat, bvectors))
    if N != bv_rank
        _msg(
            M,
            "For a basis of the tangent space at $(p) of $(M.manifold), $(manifold_dimension(M)) linearly independent vectors are required, but get_basis $(B) computed $(bv_rank)";
            within = get_basis,
            context = (:Output,),
        )
    end
    map(
        X -> is_vector(M, p, X; within = get_basis, context = (:Output,), kwargs...),
        bvectors,
    )
    return Ξ
end
function get_basis(
        M::ValidationManifold,
        p,
        B::Union{AbstractOrthogonalBasis, CachedBasis{𝔽, <:AbstractOrthogonalBasis{𝔽}} where {𝔽}};
        kwargs...,
    )
    is_point(M, p; within = get_basis, context = (:Input,), kwargs...)
    Ξ = invoke(get_basis, Tuple{ValidationManifold, Any, AbstractBasis}, M, p, B; kwargs...)
    bvectors = get_vectors(M, p, Ξ)
    N = length(bvectors)
    for i in 1:N
        for j in (i + 1):N
            dot_val = real(inner(M, p, bvectors[i], bvectors[j]))
            if !isapprox(dot_val, 0; atol = eps(eltype(p)))
                _msg(
                    M,
                    ArgumentError(
                        "vectors number $i and $j are not orthonormal (inner product = $dot_val)",
                    );
                    within = get_basis,
                    context = (:Output,),
                )
            end
        end
    end
    return Ξ
end
function get_basis(
        M::ValidationManifold,
        p,
        B::Union{
            AbstractOrthonormalBasis,
            <:CachedBasis{𝔽, <:AbstractOrthonormalBasis{𝔽}} where {𝔽},
        };
        kwargs...,
    )
    is_point(M, p; within = get_basis, context = (:Input,), kwargs...)
    get_basis_invoke_types = Tuple{
        ValidationManifold,
        Any,
        Union{
            AbstractOrthogonalBasis,
            CachedBasis{𝔽2, <:AbstractOrthogonalBasis{𝔽2}},
        } where {𝔽2},
    }
    Ξ = invoke(get_basis, get_basis_invoke_types, M, p, B; kwargs...)
    bvectors = get_vectors(M, p, Ξ)
    N = length(bvectors)
    for i in 1:N
        Xi_norm = norm(M, p, bvectors[i])
        if !isapprox(Xi_norm, 1)
            _msg(
                M,
                ArgumentError("vector number $i is not normalized (norm = $Xi_norm)");
                within = get_basis,
                context = (:Output,),
            )
        end
    end
    return Ξ
end

function get_coordinates(M::ValidationManifold, p, X, B::AbstractBasis; kwargs...)
    is_point(M, p; error = :error, within = get_coordinates, context = (:Input,), kwargs...)
    is_vector(
        M,
        p,
        X;
        error = :error,
        within = get_coordinates,
        context = (:Input,),
        kwargs...,
    )
    return get_coordinates(M.manifold, p, X, B)
end

function get_coordinates!(M::ValidationManifold, c, p, X, B::AbstractBasis; kwargs...)
    is_vector(M, p, X; within = get_coordinates, context = (:Input,), kwargs...)
    get_coordinates!(M.manifold, c, internal_value(p), internal_value(X), B)
    return c
end

function get_vector(M::ValidationManifold, p, c, B::AbstractBasis; kwargs...)
    is_point(M, p; within = get_vector, context = (:Input,), kwargs...)
    if size(c) !== (manifold_dimension(M),)
        _msg(
            M,
            ArgumentError(
                "Incorrect size of coefficient vector X ($(size(c))), expected $(manifold_dimension(M)).",
            );
            within = get_vector,
            context = (:Input,),
        )
    end
    Y = get_vector(M.manifold, internal_value(p), internal_value(c), B)
    is_vector(M, p, Y; within = get_vector, context = (:Output,), kwargs...)
    return Y
end

function get_vector!(M::ValidationManifold, Y, p, c, B::AbstractBasis; kwargs...)
    is_point(M, p; within = get_vector, context = (:Input,), kwargs...)
    if size(c) !== (manifold_dimension(M),)
        _msg(
            M,
            ArgumentError(
                "Incorrect size of coefficient vector X ($(size(c))), expected $(manifold_dimension(M)).",
            );
            within = get_vector,
            context = (:Input,),
        )
    end
    get_vector!(M.manifold, internal_value(Y), internal_value(p), internal_value(c), B)
    _update_basepoint!(M, Y, p)
    is_vector(M, p, Y; within = get_vector, context = (:Output,), kwargs...)
    return Y
end

injectivity_radius(M::ValidationManifold) = injectivity_radius(M.manifold)
function injectivity_radius(M::ValidationManifold, method::AbstractRetractionMethod)
    return injectivity_radius(M.manifold, method)
end
function injectivity_radius(M::ValidationManifold, p; kwargs...)
    is_point(M, p; within = injectivity_radius, context = (:Input,), kwargs...)
    return injectivity_radius(M.manifold, internal_value(p))
end
function injectivity_radius(
        M::ValidationManifold,
        p,
        method::AbstractRetractionMethod;
        kwargs...,
    )
    is_point(M, p; within = injectivity_radius, context = (:Input,), kwargs...)
    return injectivity_radius(M.manifold, internal_value(p), method)
end

function inner(M::ValidationManifold, p, X, Y; kwargs...)
    is_point(M, p; within = inner, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = inner, context = (:Input,), kwargs...)
    is_vector(M, p, Y; within = inner, context = (:Input,), kwargs...)
    return inner(M.manifold, internal_value(p), internal_value(X), internal_value(Y))
end

"""
    is_point(M::ValidationManifold, p; kwargs...)

Perform [`is_point`](@ref) on a [`ValidationManifold`](@ref),
where two additional keywords can be used

* `within=nothing` to specify a function from within which this call was issued
* `context::NTuple{N,Symbol} where N=()` to specify one or more contexts, this
  call was issued in. The context `:Point` is added before checking whether the test
  should be performed

all other keywords are passed on.
"""
function is_point(
        M::ValidationManifold,
        p;
        error::Symbol = M.mode,
        within::Union{Nothing, Function} = nothing,
        context::NTuple{N, Symbol} where {N} = (),
        kwargs...,
    )
    !_vMc(M, within, (:Point, context...)) && return true
    return is_point(M.manifold, internal_value(p); error = error, kwargs...)
end

"""
    is_vector(M::ValidationManifold, p, X, cbp=true; kwargs...)

perform [`is_vector`](@ref) on a [`ValidationManifold`](@ref),
where two additional keywords can be used

* `within=nothing` to specify a function from within which this call was issued
* `context::NTuple{N,Symbol} where N=()` to specify one or more contexts, this
  call was issued in. The context `:Point` is added before checking whether the test
  should be performed

all other keywords are passed on.
"""
function is_vector(
        M::ValidationManifold,
        p,
        X,
        cbp::Bool = true;
        error::Symbol = M.mode,
        within::Union{Nothing, Function} = nothing,
        context::NTuple{N, Symbol} where {N} = (),
        kwargs...,
    )
    !_vMc(M, within, (:Vector, context...)) && return true
    return is_vector(
        M.manifold,
        internal_value(p),
        internal_value(X),
        cbp;
        error = error,
        kwargs...,
    )
end

function isapprox(M::ValidationManifold, p, q; kwargs...)
    is_point(M, p; within = isapprox, context = (:Input,), kwargs...)
    is_point(M, q; within = isapprox, context = (:Input,), kwargs...)
    return isapprox(M.manifold, internal_value(p), internal_value(q); kwargs...)
end
function isapprox(M::ValidationManifold, p, X, Y; kwargs...)
    is_point(M, p; within = isapprox, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = isapprox, context = (:Input,), kwargs...)
    is_vector(M, p, Y; within = isapprox, context = (:Input,), kwargs...)
    return isapprox(
        M.manifold,
        internal_value(p),
        internal_value(X),
        internal_value(Y);
        kwargs...,
    )
end

function log(M::ValidationManifold, p, q; kwargs...)
    is_point(M, p; within = log, context = (:Input,), kwargs...)
    is_point(M, q; within = log, context = (:Input,), kwargs...)
    X = log(M.manifold, internal_value(p), internal_value(q))
    is_vector(M, p, X; within = log, context = (:Output,), kwargs...)
    return ValidationTangentVector(X, M.store_base_point ? copy(M, p) : nothing)
end

function log!(M::ValidationManifold, X, p, q; kwargs...)
    is_point(M, p; within = log, context = (:Input,), kwargs...)
    is_point(M, q; within = log, context = (:Input,), kwargs...)
    log!(M.manifold, internal_value(X), internal_value(p), internal_value(q))
    _update_basepoint!(M, X, p)
    is_vector(M, p, X; within = log, context = (:Output,), kwargs...)
    return X
end

function mid_point(M::ValidationManifold, p1, p2; kwargs...)
    is_point(M, p1; within = mid_point, context = (:Input,), kwargs...)
    is_point(M, p2; within = mid_point, context = (:Input,), kwargs...)
    q = mid_point(M.manifold, internal_value(p1), internal_value(p2))
    is_point(M, q; within = mid_point, context = (:Output,), kwargs...)
    return q
end

function mid_point!(M::ValidationManifold, q, p1, p2; kwargs...)
    is_point(M, p1; within = mid_point, context = (:Input,), kwargs...)
    is_point(M, p2; within = mid_point, context = (:Input,), kwargs...)
    mid_point!(M.manifold, internal_value(q), internal_value(p1), internal_value(p2))
    is_point(M, q; within = mid_point, context = (:Output,), kwargs...)
    return q
end

function norm(M::ValidationManifold, p, X; kwargs...)
    is_point(M, p; within = norm, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = norm, context = (:Input,), kwargs...)
    n = norm(M.manifold, internal_value(p), internal_value(X))
    (n < 0) &&
        _msg(M, DomainError(n, "Norm is negative."); within = norm, context = (:Output,))
    return n
end

number_eltype(::Type{ValidationMPoint{V}}) where {V} = number_eltype(V)
number_eltype(::Type{ValidationFibreVector{TType, V, P}}) where {TType, V, P} = number_eltype(V)

function project!(M::ValidationManifold, Y, p, X; kwargs...)
    is_point(M, p; within = project, context = (:Input,), kwargs...)
    project!(M.manifold, internal_value(Y), internal_value(p), internal_value(X))
    _update_basepoint!(M, Y, p)
    is_vector(M, p, Y; within = project, context = (:Output,), kwargs...)
    return Y
end

function rand(M::ValidationManifold; vector_at = nothing, kwargs...)
    if vector_at !== nothing
        is_point(M, vector_at; within = rand, context = (:Input,), kwargs...)
    end
    pX = rand(M.manifold; vector_at = vector_at, kwargs...)
    if vector_at !== nothing
        is_vector(M, vector_at, pX; within = rand, context = (:Output,), kwargs...)
    else
        is_point(M, pX; within = rand, context = (:Output,), kwargs...)
    end
    return pX
end

representation_size(M::ValidationManifold) = representation_size(M.manifold)

function riemann_tensor(M::ValidationManifold, p, X, Y, Z; kwargs...)
    is_point(M, p; within = riemann_tensor, context = (:Input,), kwargs...)
    for W in (X, Y, Z)
        is_vector(M, p, W; within = riemann_tensor, context = (:Input,), kwargs...)
    end
    W = riemann_tensor(
        M.manifold,
        internal_value(p),
        internal_value(X),
        internal_value(Y),
        internal_value(Z),
    )
    is_vector(M, p, W; within = riemann_tensor, context = (:Output,), kwargs...)
    return ValidationTangentVector(W, M.store_base_point ? copy(M, p) : nothing)
end

function riemann_tensor!(M::ValidationManifold, W, p, X, Y, Z; kwargs...)
    is_point(M, p; within = riemann_tensor, context = (:Input,), kwargs...)
    for W in (X, Y, Z)
        is_vector(M, p, W; within = riemann_tensor, context = (:Input,), kwargs...)
    end
    riemann_tensor!(
        M.manifold,
        internal_value(W),
        internal_value(p),
        internal_value(X),
        internal_value(Y),
        internal_value(Z),
    )
    _update_basepoint!(M, W, p)
    is_vector(M, p, W; within = riemann_tensor, context = (:Output,), kwargs...)
    return W
end

function show(io::IO, M::ValidationManifold)
    s = """
    ValidationManifold of $(M.manifold)
        * mode = :$(M.mode)
        * store_base_point = $(M.store_base_point)
    """
    if length(M.ignore_contexts) > 0
        s *= "    * ignore_context = $(M.ignore_contexts)\n"
    end
    if length(M.ignore_functions) > 0
        s *= "    * ignore_functions = $(M.ignore_functions)"
    end
    return print(io, s)
end

function vector_transport_to(
        M::ValidationManifold,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod;
        kwargs...,
    )
    is_point(M, q; within = vector_transport_to, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = vector_transport_to, context = (:Input,), kwargs...)
    Y = vector_transport_to(
        M.manifold,
        internal_value(p),
        internal_value(X),
        internal_value(q),
        m,
    )
    is_vector(M, q, Y; within = vector_transport_to, context = (:Output,), kwargs...)
    return Y
end
function vector_transport_to!(
        M::ValidationManifold,
        Y,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod;
        kwargs...,
    )
    is_point(M, q; within = vector_transport_to, context = (:Input,), kwargs...)
    is_vector(M, p, X; within = vector_transport_to, context = (:Input,), kwargs...)
    vector_transport_to!(
        M.manifold,
        internal_value(Y),
        internal_value(p),
        internal_value(X),
        internal_value(q),
        m,
    )
    _update_basepoint!(M, Y, q)
    is_vector(M, q, Y; within = vector_transport_to, context = (:Output,), kwargs...)
    return Y
end

function zero_vector(M::ValidationManifold, p; kwargs...)
    is_point(M, p; within = zero_vector, context = (:Input,), kwargs...)
    w = zero_vector(M.manifold, internal_value(p))
    is_vector(M, p, w; within = zero_vector, context = (:Output,), kwargs...)
    return w
end

function zero_vector!(M::ValidationManifold, X, p; kwargs...)
    is_point(M, p; within = zero_vector, context = (:Input,), kwargs...)
    zero_vector!(M.manifold, internal_value(X), internal_value(p); kwargs...)
    _update_basepoint!(M, X, p)
    is_vector(M, p, X; within = zero_vector, context = (:Output,), kwargs...)
    return X
end

module ManifoldsBase

import Base:
    isapprox,
    exp,
    log,
    convert,
    copy,
    copyto!,
    angle,
    eltype,
    fill,
    fill!,
    isempty,
    length,
    similar,
    show,
    +,
    -,
    *,
    ==
import LinearAlgebra: ×, dot, norm, det, cross, I, UniformScaling, Diagonal
import Random: rand, rand!

using LinearAlgebra
using Markdown: @doc_str
using Printf: @sprintf
using Random

include("maintypes.jl")
include("numbers.jl")
include("Fiber.jl")
include("bases.jl")
include("approximation_methods.jl")
include("retractions.jl")
include("exp_log_geo.jl")
include("projections.jl")

if isdefined(Base, Symbol("@constprop"))
    macro aggressive_constprop(ex)
        return esc(:(Base.@constprop :aggressive $ex))
    end
else
    macro aggressive_constprop(ex)
        return esc(ex)
    end
end

"""
    allocate(a)
    allocate(a, dims::Integer...)
    allocate(a, dims::Tuple)
    allocate(a, ::Nothing)
    allocate(a, T::Type)
    allocate(a, T::Type, dims::Integer...)
    allocate(a, T::Type, dims::Tuple)
    allocate(a, T::Type, ::Nothing)
    allocate(::Number)
    allocate(::Number, T::Type)
    allocate(M::AbstractManifold, a)
    allocate(M::AbstractManifold, a, dims::Integer...)
    allocate(M::AbstractManifold, a, dims::Tuple)
    allocate(M::AbstractManifold, a, ::Nothing)
    allocate(M::AbstractManifold, a, T::Type)
    allocate(M::AbstractManifold, a, T::Type, dims::Integer...)
    allocate(M::AbstractManifold, a, T::Type, dims::Tuple)
    allocate(M::AbstractManifold, a, T::Type, ::Nothing)

Allocate an object similar to `a`. It is similar to function `similar`, although
instead of working only on the outermost layer of a nested structure, it maps recursively
through outer layers and calls `similar` on the innermost array-like object only.
Type `T` is the new number element type [`number_eltype`](@ref), if it is not given
the element type of `a` is retained. The `dims` argument can be given for non-nested
allocation and is forwarded to the function `similar`.

It's behavior can be overridden by a specific manifold, for example power manifold with
nested replacing representation can decide that `allocate` for `Array{<:SArray}` returns
another `Array{<:SArray}` instead of `Array{<:MArray}`, as would be done by default.

If the last argument is `nothing`, it is ignored to support cases where
`representation_size` is not defined and returns `nothing` but allocation can still go
off of `a`.

If the first argument is a `Number`, it returns a zero-index array with element of type `T`
(if given) or the element type of the number.
"""
allocate(a, args...)
allocate(a) = similar(a)
allocate(a, ::Nothing) = similar(a)
allocate(a, dim1::Integer, dims::Integer...) = similar(a, dim1, dims...)
allocate(a, dims::Tuple) = similar(a, dims)
allocate(a, T::Type) = similar(a, T)
allocate(a, T::Type, ::Nothing) = similar(a, T)
allocate(::T) where {T <: Number} = fill(zero(T))
allocate(::Number, T::Type) = fill(zero(T))
allocate(a, T::Type, dim1::Integer, dims::Integer...) = similar(a, T, dim1, dims...)
allocate(a, T::Type, dims::Tuple) = similar(a, T, dims)
allocate(a::AbstractArray{<:AbstractArray}) = map(allocate, a)
allocate(a::AbstractArray{<:AbstractArray}, T::Type) = map(t -> allocate(t, T), a)
allocate(a::NTuple{N, AbstractArray} where {N}) = map(allocate, a)
allocate(a::NTuple{N, AbstractArray} where {N}, T::Type) = map(t -> allocate(t, T), a)

allocate(::AbstractManifold, a) = allocate(a)
allocate(::AbstractManifold, a, ::Nothing) = allocate(a)
function allocate(::AbstractManifold, a, dim1::Integer, dims::Integer...)
    return allocate(a, dim1, dims...)
end
allocate(::AbstractManifold, a, dims::Tuple) = allocate(a, dims)
allocate(::AbstractManifold, a, T::Type) = allocate(a, T)
allocate(::AbstractManifold, a, T::Type, ::Nothing) = allocate(a, T)
function allocate(::AbstractManifold, a, T::Type, dim1::Integer, dims::Integer...)
    return allocate(a, T, dim1, dims...)
end
allocate(::AbstractManifold, a, T::Type, dims::Tuple) = allocate(a, T, dims)

"""
    allocate_on(M::AbstractManifold, [T:::Type])
    allocate_on(M::AbstractManifold, F::FiberType, [T:::Type])

Allocate a new point on manifold `M` with optional type given by `T`. Note that `T` is not
number element type as in [`allocate`](@ref) but rather the type of the entire point to be
returned.

If `F` is provided, then an element of the corresponding fiber is allocated, assuming it is
independent of the base point.

To allocate a tangent vector, use ``

# Example

```julia-repl
julia> using ManifoldsBase

julia> M = ManifoldsBase.DefaultManifold(4)
DefaultManifold(4; field = ℝ)

julia> allocate_on(M)
4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0

julia> allocate_on(M, Array{Float64})
4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0

julia> allocate_on(M, TangentSpaceType())
4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0

julia> allocate_on(M, TangentSpaceType(), Array{Float64})
4-element Vector{Float64}:
 0.0
 0.0
 0.0
 0.0

```
"""
allocate_on(M::AbstractManifold) = similar(Array{Float64}, representation_size(M))
function allocate_on(M::AbstractManifold, T::Type{<:AbstractArray})
    return similar(T, representation_size(M))
end

"""
    _pick_basic_allocation_argument(::AbstractManifold, f, x...)

Pick which one of elements of `x` should be used as a basis for allocation in the
`allocate_result(M::AbstractManifold, f, x...)` method. This can be specialized to, for
example, skip `Identity` arguments in Manifolds.jl group-related functions.
"""
function _pick_basic_allocation_argument(::AbstractManifold, f, x...)
    return x[1]
end

"""
    allocate_result(M::AbstractManifold, f, x...)

Allocate an array for the result of function `f` on [`AbstractManifold`](@ref) `M` and arguments
`x...` for implementing the non-modifying operation using the modifying operation.

Usefulness of passing a function is demonstrated by methods that allocate results of musical
isomorphisms.
"""
@inline function allocate_result(M::AbstractManifold, f, x...)
    T = allocate_result_type(M, f, x)
    picked = _pick_basic_allocation_argument(M, f, x...)
    return allocate(M, picked, T)
end
@inline function allocate_result(M::AbstractManifold, f)
    T = allocate_result_type(M, f, ())
    rs = representation_size(M)
    return allocate_result_array(M, f, T, rs)
end

function allocate_result_array(M::AbstractManifold, f, ::Type, ::Nothing)
    msg = "Could not allocate result of function $f on manifold $M."
    if base_manifold(M) isa ProductManifold
        msg *= " This error could be resolved by importing RecursiveArrayTools.jl. If this is not the case, please open report an issue."
    end
    return error(msg)
end
function allocate_result_array(::AbstractManifold, f, T::Type, rs::Tuple)
    return Array{T}(undef, rs...)
end

"""
    allocate_result_type(M::AbstractManifold, f, args::NTuple{N,Any}) where N

Return type of element of the array that will represent the result of function `f` and the
[`AbstractManifold`](@ref) `M` on given arguments `args` (passed as a tuple).
"""
@inline function allocate_result_type(
        ::AbstractManifold, f::TF, args::NTuple{N, Any},
    ) where {N, TF}
    @inline eti_to_one(eti) = one(number_eltype(eti))
    return typeof(sum(map(eti_to_one, args)))
end
@inline function allocate_result_type(M::AbstractManifold, f::TF, args::Tuple{}) where {TF}
    return allocation_promotion_function(M, f, ())(Float64)
end

"""
    angle(M::AbstractManifold, p, X, Y)

Compute the angle between tangent vectors `X` and `Y` at point `p` from the
[`AbstractManifold`](@ref) `M` with respect to the inner product from [`inner`](@ref).
"""
function angle(M::AbstractManifold, p, X, Y)
    return acos(real(inner(M, p, X, Y)) / norm(M, p, X) / norm(M, p, Y))
end

"""
    are_linearly_independent(M::AbstractManifold, p, X, Y)

Check is vectors `X`, `Y` tangent at `p` to `M` are linearly independent.
"""
function are_linearly_independent(
        M::AbstractManifold, p, X, Y; atol::Real = sqrt(eps(number_eltype(X))),
    )
    norm_X = norm(M, p, X)
    norm_Y = norm(M, p, Y)
    innerXY = inner(M, p, X, Y)
    return norm_X > atol && norm_Y > atol && !isapprox(abs(innerXY), norm_X * norm_Y)
end

"""
    base_manifold(M::AbstractManifold, depth = Val(-1))

Return the internally stored [`AbstractManifold`](@ref) for decorated manifold `M` and the base
manifold for vector bundles or power manifolds. The optional parameter `depth` can be used
to remove only the first `depth` many decorators and return the [`AbstractManifold`](@ref) from that
level, whether its decorated or not. Any negative value deactivates this depth limit.
"""
base_manifold(M::AbstractManifold, ::Val = Val(-1)) = M


"""
    check_approx(M::AbstractManifold, p, q; kwargs...)
    check_approx(M::AbstractManifold, p, X, Y; kwargs...)

Check whether two elements are approximately equal, either `p`, `q` on the [`AbstractManifold`](@ref)
or the two tangent vectors `X`, `Y` in the tangent space at `p` are approximately the same.
The keyword arguments `kwargs` can be used to set tolerances, similar to Julia's `isapprox`.

This function might use `isapprox` from Julia internally and is similar to [`isapprox`](@ref),
with the difference that is returns an [`ApproximatelyError`](@ref) if the two elements are
not approximately equal, containting a more detailed description/reason.
If the two elements are approximalely equal, this method returns `nothing`.

This method is an internal function and is called by `isapprox` whenever the user specifies
an `error=` keyword therein. [`_isapprox`](@ref) is another related internal function. It is
supposed to provide a fast true/false decision whether points or vectors are equal or not,
while `check_approx` also provides a textual explanation. If no additional explanation
is needed, a manifold may just implement a method of [`_isapprox`](@ref), while it should also
implement `check_approx` if a more detailed explanation could be helpful.
"""
function check_approx(M::AbstractManifold, p, q; kwargs...)
    # fall back to classical approx mode - just that we do not have a reason then
    res = _isapprox(M, p, q; kwargs...)
    # since we can not assume distance to be implemented, we can not provide a default value
    res && return nothing
    s = "The two points $p and $q on $M are not (approximately) equal."
    return ApproximatelyError(s)
end
function check_approx(M::AbstractManifold, p, X, Y; kwargs...)
    # fall back to classical mode - just that we do not have a reason then
    res = _isapprox(M, p, X, Y; kwargs...)
    res && return nothing
    s = "The two tangent vectors $X and $Y in the tangent space at $p on $M are not (approximately) equal."
    v = try
        norm(M, p, X - Y)
    catch e
        NaN
    end
    return ApproximatelyError(v, s)
end

"""
    check_point(M::AbstractManifold, p; kwargs...) -> Union{Nothing,String}

Return `nothing` when `p` is a point on the [`AbstractManifold`](@ref) `M`. Otherwise, return an
error with description why the point does not belong to manifold `M`.

By default, `check_point` returns `nothing`, i.e. if no checks are implemented, the
assumption is to be optimistic for a point not deriving from the [`AbstractManifoldPoint`](@ref) type.
"""
check_point(M::AbstractManifold, p; kwargs...) = nothing

"""
    check_vector(M::AbstractManifold, p, X; kwargs...) -> Union{Nothing,String}

Check whether `X` is a valid tangent vector in the tangent space of `p` on the
[`AbstractManifold`](@ref) `M`. An implementation does not have to validate the point `p`.
If it is not a tangent vector, an error string should be returned.

By default, `check_vector` returns `nothing`, i.e. if no checks are implemented, the
assumption is to be optimistic for tangent vectors not deriving from the [`AbstractTangentVector`](@ref)
type.
"""
check_vector(M::AbstractManifold, p, X; kwargs...) = nothing

"""
    check_size(M::AbstractManifold, p)
    check_size(M::AbstractManifold, p, X)

Check whether `p` has the right [`representation_size`](@ref) for a [`AbstractManifold`](@ref) `M`.
Additionally if a tangent vector is given, both `p` and `X` are checked to be of
corresponding correct representation sizes for points and tangent vectors on `M`.

By default, `check_size` returns `nothing`, i.e. if no checks are implemented, the
assumption is to be optimistic.
"""
function check_size(M::AbstractManifold, p)
    m = representation_size(M)
    m === nothing && return nothing # nothing reasonable in size to check
    n = size(p)
    if length(n) != length(m)
        return DomainError(
            length(n),
            "The point $(p) can not belong to the manifold $(M), since its size $(n) is not equal to the manifolds representation size ($(m)).",
        )
    end
    if n != m
        return DomainError(
            n,
            "The point $(p) can not belong to the manifold $(M), since its size $(n) is not equal to the manifolds representation size ($(m)).",
        )
    end
end
function check_size(M::AbstractManifold, p, X)
    mse = check_size(M, p)
    mse === nothing || return mse
    m = representation_size(M)
    m === nothing && return nothing # without a representation size - nothing to check.
    n = size(X)
    if length(n) != length(m)
        return DomainError(
            length(n),
            "The tangent vector $(X) can not belong to the manifold $(M), since its size $(n) is not equal to the manifolds representation size ($(m)).",
        )
    end
    if n != m
        return DomainError(
            n,
            "The tangent vector $(X) can not belong to the manifold $(M), since its size $(n) is not equal to the manifodls representation size ($(m)).",
        )
    end
end

"""
    convert(T::Type, M::AbstractManifold, p)

Convert point `p` from manifold `M` to type `T`.
"""
convert(T::Type, ::AbstractManifold, p) = convert(T, p)
"""
    convert(T::Type, M::AbstractManifold, p, X)

Convert vector `X` tangent at point `p` from manifold `M` to type `T`.
"""
convert(T::Type, ::AbstractManifold, p, X) = convert(T, p, X)

@doc raw"""
    copy(M::AbstractManifold, p)

Copy the value(s) from the point `p` on the [`AbstractManifold`](@ref) `M` into a new point.
See [`allocate_result`](@ref) for the allocation of new point memory and [`copyto!`](@ref) for the copying.
"""
function copy(M::AbstractManifold, p)
    q = allocate_result(M, copy, p)
    copyto!(M, q, p)
    return q
end
function copy(::AbstractManifold, p::Number)
    return copy(p)
end

@doc raw"""
    copy(M::AbstractManifold, p, X)

Copy the value(s) from the tangent vector `X` at a point `p` on the
[`AbstractManifold`](@ref) `M` into a new tangent vector.
See [`allocate_result`](@ref) for the allocation of new point memory and [`copyto!`](@ref) for the copying.
"""
function copy(M::AbstractManifold, p, X)
    # the order of args switched, since the allocation by default takes the type of the first.
    Y = allocate_result(M, copy, X, p)
    copyto!(M, Y, p, X)
    return Y
end
function copy(::AbstractManifold, p, X::Number)
    return copy(X)
end


@doc raw"""
    copyto!(M::AbstractManifold, q, p)

Copy the value(s) from `p` to `q`, where both are points on the [`AbstractManifold`](@ref) `M`.
This function defaults to calling `copyto!(q, p)`, but it might be useful to overwrite the
function at the level, where also information from `M` can be accessed.
"""
copyto!(::AbstractManifold, q, p) = copyto!(q, p)

@doc raw"""
    copyto!(M::AbstractManifold, Y, p, X)

Copy the value(s) from `X` to `Y`, where both are tangent vectors from the tangent space at
`p` on the [`AbstractManifold`](@ref) `M`.
This function defaults to calling `copyto!(Y, X)`, but it might be useful to overwrite the
function at the level, where also information from `p` and `M` can be accessed.
"""
copyto!(::AbstractManifold, Y, p, X) = copyto!(Y, X)

"""
    default_type(M::AbstractManifold)

Get the default type of points on manifold `M`.
"""
default_type(M::AbstractManifold) = typeof(allocate_on(M))
"""
    default_type(M::AbstractManifold, ft::FiberType)

Get the default type of points from the fiber `ft` of the fiber bundle based on manifold `M`.
For example, call `default_type(MyManifold(), TangentSpaceType())` to get the default type
of a tangent vector.
"""
default_type(M::AbstractManifold, ft::FiberType) = typeof(allocate_on(M, ft))

@doc raw"""
    distance(M::AbstractManifold, p, q)

Shortest distance between the points `p` and `q` on the [`AbstractManifold`](@ref) `M`,
i.e.

```math
d(p,q) = \inf_{γ} L(γ),
```
where the infimum is over all piecewise smooth curves ``γ: [a,b] \to \mathcal M``
connecting ``γ(a)=p`` and ``γ(b)=q`` and

```math
L(γ) = \displaystyle\int_{a}^{b} \lVert \dotγ(t)\rVert_{γ(t)} \mathrm{d}t
```
is the length of the curve $γ$.

If ``\mathcal M`` is not connected, i.e. consists of several disjoint components,
the distance between two points from different components should be ``∞``.
"""
distance(M::AbstractManifold, p, q) = norm(M, p, log(M, p, q))
"""
    distance(M::AbstractManifold, p, q, m::AbstractInverseRetractionMethod)

Approximate distance between points `p` and `q` on manifold `M` using
[`AbstractInverseRetractionMethod`](@ref) `m`.
"""
function distance(M::AbstractManifold, p, q, m::AbstractInverseRetractionMethod)
    return norm(M, p, inverse_retract(M, p, q, m))
end
distance(M::AbstractManifold, p, q, ::LogarithmicInverseRetraction) = distance(M, p, q)

"""
    embed(M::AbstractManifold, p)

Embed point `p` from the [`AbstractManifold`](@ref) `M` into the ambient space.
This method is only available for manifolds where implicitly an embedding or ambient space
is given.
Additionally, `embed` includes changing data representation, if applicable, i.e.
if the points on `M` are not represented in the same way as points on the embedding,
the representation is changed accordingly.

The default is set in such a way that memory is allocated and `embed!(M, q, p)` is called.

See also: [`EmbeddedManifold`](@ref), [`project`](@ref project(M::AbstractManifold,p))
"""
function embed(M::AbstractManifold, p)
    local q
    try
        q = allocate_result_embedding(M, embed, p)
    catch e
        # because we want `embed` to default to identity
        q = allocate_result(M, embed, p)
    end
    embed!(M, q, p)
    return q
end

"""
    embed!(M::AbstractManifold, q, p)

Embed point `p` from the [`AbstractManifold`](@ref) `M` into an ambient space.
This method is only available for manifolds where implicitly an embedding or ambient space
is given. Not implementing this function means, there is no proper embedding for your manifold.
Additionally, `embed` might include changing data representation, if applicable, i.e.
if points on `M` are not represented in the same way as their counterparts in the embedding,
the representation is changed accordingly.

The default is set in such a way that it assumes that the points on `M` are represented in
their embedding (for example like the unit vectors in a space to represent the sphere) and
hence embedding in the identity by default.

If you have more than one embedding, see [`EmbeddedManifold`](@ref) for defining a second
embedding. If your point `p` is already represented in some embedding,
see [`AbstractDecoratorManifold`](@ref) how you can avoid reimplementing code from the embedded manifold

See also: [`EmbeddedManifold`](@ref), [`project!`](@ref project!(M::AbstractManifold, q, p))
"""
embed!(M::AbstractManifold, q, p) = copyto!(M, q, p)

"""
    embed(M::AbstractManifold, p, X)

Embed a tangent vector `X` at a point `p` on the [`AbstractManifold`](@ref) `M` into an ambient space.
This method is only available for manifolds where implicitly an embedding or ambient space
is given. Not implementing this function means, there is no proper embedding for your tangent space(s).

Additionally, `embed` might include changing data representation, if applicable, i.e.
if tangent vectors on `M` are not represented in the same way as their counterparts in the
embedding, the representation is changed accordingly.

The default is set in such a way that memory is allocated and `embed!(M, Y, p. X)` is called.

If you have more than one embedding, see [`EmbeddedManifold`](@ref) for defining a second
embedding. If your tangent vector `X` is already represented in some embedding,
see [`AbstractDecoratorManifold`](@ref) how you can avoid reimplementing code from the embedded manifold

See also: [`EmbeddedManifold`](@ref), [`project`](@ref project(M::AbstractManifold, p, X))
"""
function embed(M::AbstractManifold, p, X)
    # the order of args switched, since the allocation by default takes the type of the first.
    local Y
    try
        Y = allocate_result_embedding(M, embed, X, p)
    catch e
        # because we want `embed` to default to identity
        Y = allocate_result(M, embed, X, p)
    end
    embed!(M, Y, p, X)
    return Y
end

"""
    embed!(M::AbstractManifold, Y, p, X)

Embed a tangent vector `X` at a point `p` on the [`AbstractManifold`](@ref) `M` into the ambient
space and return the result in `Y`.
This method is only available for manifolds where implicitly an embedding or ambient space
is given.
Additionally, `embed!` includes changing data representation, if applicable, i.e.
if the tangents on `M` are not represented in the same way as tangents on the embedding,
the representation is changed accordingly. This is the case for example for Lie groups,
when tangent vectors are represented in the Lie algebra. The embedded tangents are then in
the tangent spaces of the embedded base points.

The default is set in such a way that it assumes that the points on `M` are represented in
their embedding (for example like the unit vectors in a space to represent the sphere) and
hence embedding also for tangent vectors is the identity by default.

See also: [`EmbeddedManifold`](@ref), [`project!`](@ref project!(M::AbstractManifold, Y, p, X))
"""
embed!(M::AbstractManifold, Y, p, X) = copyto!(M, Y, p, X)

"""
    embed_project(M::AbstractManifold, p)

Embed `p` from manifold `M` an project it back to `M`. For points from `M` this is identity
but in case embedding is defined for points outside of `M`, this can serve as a way
to for example remove numerical inaccuracies caused by some algorithms.
"""
function embed_project(M::AbstractManifold, p)
    return project(M, embed(M, p))
end
"""
    embed_project(M::AbstractManifold, p, X)

Embed vector `X` tangent at `p` from manifold `M` an project it back to tangent space
at `p`. For points from that tangent space this is identity but in case embedding is
defined for tangent vectors from outside of it, this can serve as a way to for example remove
numerical inaccuracies caused by some algorithms.
"""
function embed_project(M::AbstractManifold, p, X)
    return project(M, p, embed(M, p, X))
end

"""
    embed_project!(M::AbstractManifold, q, p)

Embed `p` from manifold `M` an project it back to `M`, saving the result in `q`. For points
from `M` this is identity but in case embedding is defined for points outside of `M`, this
can serve as a way to for example remove numerical inaccuracies caused by some algorithms.
"""
function embed_project!(M::AbstractManifold, q, p)
    return project!(M, q, embed(M, p))
end

"""
    embed_project!(M::AbstractManifold, Y, p, X)

Embed vector `X` tangent at `p` from manifold `M` an project it back to tangent space
at `p`, saving the result in `Y`. For points from that tangent space this is identity but
in case embedding is defined for tangent vectors from outside of it, this can serve as a way
to for example remove numerical inaccuracies caused by some algorithms.
"""
function embed_project!(M::AbstractManifold, Y, p, X)
    return project!(M, Y, p, embed(M, p, X))
end

_doc_embedding = """
    get_embedding(M::AbstractManifold)
    get_embedding(M::AbstractManifold, ::Type)

Return the embedding [`AbstractManifold`](@ref) of `M`, if it exists.
The embedding might depend on the type  ``P`` points are represented with.
The default is, that the signature with the type defaults to the one without.
"""
@doc "$(_doc_embedding)"
get_embedding(M::AbstractManifold, ::Type) = get_embedding(M)
@doc "$(_doc_embedding)"
get_embedding(M::AbstractManifold)

"""
    has_components(M::AbstractManifold)

Return whether the [`AbstractManifold`](@ref)`(M)` consists of components,
like the [`PowerManifold`](@ref) or the [`ProductManifold`](@ref), that one can iterate over.
By default, this function returns `false`.
"""
has_components(M::AbstractManifold) = false

@doc raw"""
    injectivity_radius(M::AbstractManifold)

Infimum of the injectivity radii `injectivity_radius(M,p)` of all points `p` on the [`AbstractManifold`](@ref).

    injectivity_radius(M::AbstractManifold, p)

Return the distance $d$ such that [`exp(M, p, X)`](@ref exp(::AbstractManifold, ::Any, ::Any)) is
injective for all tangent vectors shorter than $d$ (i.e. has an inverse).

    injectivity_radius(M::AbstractManifold[, x], method::AbstractRetractionMethod)
    injectivity_radius(M::AbstractManifold, x, method::AbstractRetractionMethod)

Distance ``d`` such that
[`retract(M, p, X, method)`](@ref retract(::AbstractManifold, ::Any, ::Any, ::AbstractRetractionMethod))
is injective for all tangent vectors shorter than ``d`` (i.e. has an inverse) for point `p`
if provided or all manifold points otherwise.

In order to dispatch on different retraction methods, please either implement
`_injectivity_radius(M[, p], m::T)` for your retraction `R` or specifically `injectivity_radius_exp(M[, p])` for the exponential map.
By default the variant with a point `p` assumes that the default (without `p`) can ve called as a lower bound.
"""
injectivity_radius(M::AbstractManifold)
injectivity_radius(M::AbstractManifold, p) = injectivity_radius(M)
function injectivity_radius(M::AbstractManifold, p, m::AbstractRetractionMethod)
    return _injectivity_radius(M, p, m)
end
function injectivity_radius(M::AbstractManifold, m::AbstractRetractionMethod)
    return _injectivity_radius(M, m)
end
function _injectivity_radius(M::AbstractManifold, p, m::AbstractRetractionMethod)
    return _injectivity_radius(M, m)
end
function _injectivity_radius(M::AbstractManifold, ::AbstractRetractionMethod)
    return _injectivity_radius(M, ExponentialRetraction())
end
function _injectivity_radius(M::AbstractManifold, p, ::ExponentialRetraction)
    return injectivity_radius_exp(M, p)
end
function _injectivity_radius(M::AbstractManifold, ::ExponentialRetraction)
    return injectivity_radius_exp(M)
end
injectivity_radius_exp(M::AbstractManifold, p) = injectivity_radius_exp(M)
injectivity_radius_exp(M::AbstractManifold) = injectivity_radius(M)

"""
    inner(M::AbstractManifold, p, X, Y)

Compute the inner product of tangent vectors `X` and `Y` at point `p` from the
[`AbstractManifold`](@ref) `M`. The result type varies by the exact type of `M`:

1. On a [Riemannian manifold](https://en.wikipedia.org/wiki/Riemannian_manifold)
   the result is a real number.
2. On an [almost complex manifold](https://en.wikipedia.org/wiki/Almost_complex_manifold)
   the result is a complex number.
3. On an [almost quaternionic manifold](https://en.wikipedia.org/wiki/Quaternionic_manifold#Almost_quaternionic_structure)
   the result is a quaternion.
4. On a [CR manifold](https://en.wikipedia.org/wiki/CR_manifold) the result may be either
   real or complex, depending on the particular manifold.

In cases 2, 3 and 4 the Riemannian inner product can be obtained by taking the real part.
"""
inner(M::AbstractManifold, p, X, Y)

"""
    is_flat(M::AbstractManifold)

Return true if the [`AbstractManifold`](@ref) `M` is flat, i.e. if its Riemann curvature
tensor is everywhere zero.
"""
is_flat(M::AbstractManifold)

"""
    isapprox(M::AbstractManifold, p, q; error::Symbol=:none, kwargs...)

Check if points `p` and `q` from [`AbstractManifold`](@ref) `M` are approximately equal.

The keyword argument can be used to get more information for the case that
the result is false, if the concrete manifold provides such information.
Currently the following are supported

* `:error` - throws an error if `isapprox` evaluates to false, providing possibly a more detailed error.
  Note that this turns `isapprox` basically to an `@assert`.
* `:info` – prints the information in an `@info`
* `:warn` – prints the information in an `@warn`
* `:none` (default) – the function just returns `true`/`false`

Keyword arguments can be used to specify tolerances.
"""
function isapprox(M::AbstractManifold, p, q; error::Symbol = :none, kwargs...)
    if error === :none  # Shortcut to avoid error message allocation
        return _isapprox(M, p, q; kwargs...)
    else
        ma = check_approx(M, p, q; kwargs...)
        if ma !== nothing
            (error === :error) && throw(ma)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, ma)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
            return false
        end
        return true
    end
end

"""
    isapprox(M::AbstractManifold, p, X, Y; error:Symbol=:none; kwargs...)

Check if vectors `X` and `Y` tangent at `p` from [`AbstractManifold`](@ref) `M` are approximately
equal.

The optional positional argument can be used to get more information for the case that
the result is false, if the concrete manifold provides such information.
Currently the following are supported

* `:error` - throws an error if `isapprox` evaluates to false, providing possibly a more detailed error.
  Note that this turns `isapprox` basically to an `@assert`.
* `:info` – prints the information in an `@info`
* `:warn` – prints the information in an `@warn`
* `:none` (default) – the function just returns `true`/`false`

By default these pieces of information are collected by calling [`check_approx`](@ref).

Keyword arguments can be used to specify tolerances.
"""
function isapprox(M::AbstractManifold, p, X, Y; error::Symbol = :none, kwargs...)
    if error === :none # Shortcut to avoid error message allocation
        return _isapprox(M, p, X, Y; kwargs...)::Bool
    else
        mat = check_approx(M, p, X, Y; kwargs...)
        if mat !== nothing
            (error === :error) && throw(mat)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, mat)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
            return false
        end
        return true
    end
end

"""
    _isapprox(M::AbstractManifold, p, q; kwargs...)

An internal function for testing whether points `p` and `q` from manifold `M` are
approximately equal. Returns either `true` or `false` and does not support errors like
[`isapprox`](@ref).

For more details see documentation of [`check_approx`](@ref).
"""
function _isapprox(M::AbstractManifold, p, q; kwargs...)
    return isapprox(p, q; kwargs...)
end
"""
    _isapprox(M::AbstractManifold, p, X, Y; kwargs...)

An internal function for testing whether tangent vectors `X` and `Y` from tangent space
at point `p` from manifold `M` are approximately equal. Returns either `true` or `false`
and does not support errors like [`isapprox`](@ref).

For more details see documentation of [`check_approx`](@ref).
"""
function _isapprox(M::AbstractManifold, p, X, Y; kwargs...)
    return isapprox(X, Y; kwargs...)
end

"""
    is_point(M::AbstractManifold, p; error::Symbol = :none, kwargs...)
    is_point(M::AbstractManifold, p, throw_error::Bool; kwargs...)

Return whether `p` is a valid point on the [`AbstractManifold`](@ref) `M`.
By default the function calls [`check_point`](@ref), which returns an `ErrorException` or `nothing`.

How to report a potential error can be set using the `error=` keyword

* `:error`          - throws an error if `p` is not a point
* `:info`           - displays the error message as an `@info`
* `:warn`           - displays the error message as a `@warning`
* `:none` (default) – the function just returns `true`/`false`

all other symbols are equivalent to `error=:none`.

The second signature is a shorthand, where the boolean is used for `error=:error` (`true`)
and `error=:none` (default, `false`). This case ignores the `error=` keyword
"""
function is_point(
        M::AbstractManifold,
        p,
        throw_error::Bool;
        error::Symbol = :none,
        kwargs...,
    )
    return is_point(M, p; error = throw_error ? :error : :none, kwargs...)
end
function is_point(M::AbstractManifold, p; error::Symbol = :none, kwargs...)
    mps = check_size(M, p)
    if mps !== nothing
        (error === :error) && throw(mps)
        if (error === :info) || (error === :warn)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, mps)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
        end
        return false
    end
    mpe = check_point(M, p; kwargs...)
    if mpe !== nothing
        (error === :error) && throw(mpe)
        if (error === :info) || (error === :warn)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, mpe)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
        end
        return false
    end
    return true
end


"""
    is_vector(M::AbstractManifold, p, X, check_base_point::Bool=true; error::Symbol=:none, kwargs...)
    is_vector(M::AbstractManifold, p, X, check_base_point::Bool=true, throw_error::Boolean; kwargs...)

Return whether `X` is a valid tangent vector at point `p` on the [`AbstractManifold`](@ref) `M`.
Returns either `true` or `false`.

If `check_base_point` is set to true, this function also (first) calls [`is_point`](@ref)
on `p`.
Then, the function calls [`check_vector`](@ref) and checks whether the returned
value is `nothing` or an error.

How to report a potential error can be set using the `error=` keyword

* `:error`          - throws an error if `X` is not a tangent vector and/or `p` is not point
^ `:info`           - displays the error message as an `@info`
* `:warn`           - displays the error message as a `@warn`ing.
* `:none`           - (default) the function just returns `true`/`false`

all other symbols are equivalent to `error=:none`

The second signature is a shorthand, where `throw_error` is used for `error=:error` (`true`)
and `error=:none` (default, `false`). This case ignores the `error=` keyword.
"""
function is_vector(
        M::AbstractManifold, p, X, check_base_point::Bool, throw_error::Bool;
        error::Symbol = :none, kwargs...,
    )
    return is_vector(
        M, p, X, check_base_point;
        error = throw_error ? :error : :none, kwargs...,
    )
end
function is_vector(
        M::AbstractManifold, p, X, check_base_point::Bool = true;
        error::Symbol = :none, kwargs...,
    )
    if check_base_point
        # if error, is_point throws, otherwise if not a point return false
        !is_point(M, p; error = error, kwargs...) && return false
    end
    mXs = check_size(M, p, X)
    if mXs !== nothing
        (error === :error) && throw(mXs)
        if (error === :info) || (error === :warn)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, mXs)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
        end
        return false
    end
    mXe = check_vector(M, p, X; kwargs...)
    if mXe !== nothing
        (error === :error) && throw(mXe)
        if (error === :info) || (error === :warn)
            # else: collect and info showerror
            io = IOBuffer()
            showerror(io, mXe)
            s = String(take!(io))
            (error === :info) && @info s
            (error === :warn) && @warn s
        end
        return false
    end
    return true
end

@doc raw"""
    manifold_dimension(M::AbstractManifold)

The dimension $n=\dim_{\mathcal M}$ of real space $\mathbb R^n$ to which the neighborhood of
each point of the [`AbstractManifold`](@ref) `M` is homeomorphic.
"""
manifold_dimension(M::AbstractManifold)

"""
    mid_point(M::AbstractManifold, p1, p2)

Calculate the middle between the two point `p1` and `p2` from manifold `M`.
By default uses [`log`](@ref), divides the vector by 2 and uses [`exp`](@ref).
"""
function mid_point(M::AbstractManifold, p1, p2)
    q = allocate(p1)
    return mid_point!(M, q, p1, p2)
end

"""
    mid_point!(M::AbstractManifold, q, p1, p2)

Calculate the middle between the two point `p1` and `p2` from manifold `M`.
By default uses [`log`](@ref), divides the vector by 2 and uses [`exp!`](@ref).
Saves the result in `q`.
"""
function mid_point!(M::AbstractManifold, q, p1, p2)
    X = log(M, p1, p2)
    return exp!(M, q, p1, X / 2)
end

"""
    norm(M::AbstractManifold, p, X)

Compute the norm of tangent vector `X` at point `p` from a [`AbstractManifold`](@ref) `M`.
By default this is computed using [`inner`](@ref).
"""
norm(M::AbstractManifold, p, X) = sqrt(max(real(inner(M, p, X, X)), 0))

"""
    number_eltype(x)

Numeric element type of the a nested representation of a point or a vector.
To be used in conjunction with [`allocate`](@ref) or [`allocate_result`](@ref).
"""
number_eltype(x) = eltype(x)
@inline function number_eltype(x::AbstractArray)
    return typeof(mapreduce(eti -> one(number_eltype(eti)), +, x))
end
@inline number_eltype(::AbstractArray{T}) where {T <: Number} = T
@inline function number_eltype(::Type{<:AbstractArray{T}}) where {T}
    return number_eltype(T)
end
@inline function number_eltype(::Type{<:AbstractArray{T}}) where {T <: Number}
    return T
end
@inline function number_eltype(x::Tuple)
    @inline eti_to_one(eti) = one(number_eltype(eti))
    return typeof(sum(map(eti_to_one, x)))
end

"""
    Random.rand(M::AbstractManifold, [d::Integer]; vector_at=nothing)
    Random.rand(rng::AbstractRNG, M::AbstractManifold, [d::Integer]; vector_at=nothing)


Generate a random point on manifold `M` (when `vector_at` is `nothing`) or a tangent
vector at point `vector_at` (when it is not `nothing`).

Optionally a random number generator `rng` to be used can be specified. An optional integer
`d` indicates that a vector of `d` points or tangent vectors is to be generated.

!!! note

    Usually a uniform distribution should be expected for compact manifolds and a
    Gaussian-like distribution for non-compact manifolds and tangent vectors, although it is
    not guaranteed. The distribution may change between releases.

    `rand` methods for specific manifolds may take additional keyword arguments.

"""
Random.rand(M::AbstractManifold)

function Random.rand(M::AbstractManifold, d::Integer; kwargs...)
    return [rand(M; kwargs...) for _ in 1:d]
end
function Random.rand(rng::AbstractRNG, M::AbstractManifold, d::Integer; kwargs...)
    return [rand(rng, M; kwargs...) for _ in 1:d]
end
function Random.rand(M::AbstractManifold; vector_at = nothing, kwargs...)
    if vector_at === nothing
        pX = allocate_result(M, rand)
    else
        pX = allocate_result(M, rand, vector_at)
    end
    rand!(M, pX; vector_at = vector_at, kwargs...)
    return pX
end
function Random.rand(rng::AbstractRNG, M::AbstractManifold; vector_at = nothing, kwargs...)
    if vector_at === nothing
        pX = allocate_result(M, rand)
    else
        pX = allocate_result(M, rand, vector_at)
    end
    rand!(rng, M, pX; vector_at = vector_at, kwargs...)
    return pX
end

function Random.rand!(M::AbstractManifold, pX; kwargs...)
    return rand!(Random.default_rng(), M, pX; kwargs...)
end


@doc raw"""
    representation_size(M::AbstractManifold)

Return the size of an array representing a point or a tangent vector on a
certain [`AbstractManifold`](@ref) `M`.
This is either the size of the `AbstractArray` representing points or tangent vectors on `M`
or what a `size(p)` would return for the case of points and tangent vectors that are
subtypes of [`AbstractManifoldPoint`](@ref) or [`AbstractTangentVector`](@ref), respectively.

By default this function returns `nothing` indicating that the representation on
`M` can not be done in (plain, wrapped) arrays, for example because it is a number of a collection of arrays.
"""
function representation_size(::AbstractManifold)
    return nothing
end

@doc raw"""
    riemann_tensor(M::AbstractManifold, p, X, Y, Z)

Compute the value of the Riemann tensor ``R(X_f,Y_f)Z_f`` at point `p`, where
``X_f``, ``Y_f`` and ``Z_f`` are vector fields defined by parallel transport of,
respectively, `X`, `Y` and `Z` to the desired point. All computations are performed
using the connection associated to manifold `M`.

The formula reads ``R(X_f,Y_f)Z_f = \nabla_X\nabla_Y Z - \nabla_Y\nabla_X Z - \nabla_{[X, Y]}Z``,
where ``[X, Y]`` is the Lie bracket of vector fields.

Note that some authors define this quantity with inverse sign.
"""
function riemann_tensor(M::AbstractManifold, p, X, Y, Z)
    Xresult = allocate_result(M, riemann_tensor, X)
    return riemann_tensor!(M, Xresult, p, X, Y, Z)
end

@doc raw"""
    sectional_curvature(M::AbstractManifold, p, X, Y)

Compute the sectional curvature of a manifold ``\mathcal M`` at a point ``p \in \mathcal M``
on two linearly independent tangent vectors at ``p``.
The formula reads
```math

    \kappa_p(X, Y) = \frac{⟨R(X, Y, Y), X⟩_p}{\lVert X \rVert^2_p \lVert Y \rVert^2_p - ⟨X, Y⟩^2_p}

```
where ``R(X, Y, Y)`` is the [`riemann_tensor`](@ref) on ``\mathcal M``.

# Input

* `M`:   a manifold ``\mathcal M``
* `p`:   a point ``p \in \mathcal M``
* `X`:   a tangent vector ``X \in T_p \mathcal M``
* `Y`:   a tangent vector ``Y \in T_p \mathcal M``

"""
function sectional_curvature(M::AbstractManifold, p, X, Y)
    R = riemann_tensor(M, p, X, Y, Y)
    return inner(M, p, R, X) / ((norm(M, p, X)^2 * norm(M, p, Y)^2) - (inner(M, p, X, Y)^2))
end

@doc raw"""
    sectional_curvature_max(M::AbstractManifold)

Upper bound on sectional curvature of manifold `M`. The formula reads
```math
\omega = \operatorname{sup}_{p\in\mathcal M, X\in T_p\mathcal M, Y\in T_p\mathcal M, ⟨X, Y⟩ ≠ 0} \kappa_p(X, Y)
```
"""
sectional_curvature_max(M::AbstractManifold)

@doc raw"""
    sectional_curvature_min(M::AbstractManifold)

Lower bound on sectional curvature of manifold `M`. The formula reads
```math
\omega = \operatorname{inf}_{p\in\mathcal M, X\in T_p\mathcal M, Y\in T_p\mathcal M, ⟨X, Y⟩ ≠ 0} \kappa_p(X, Y)
```
"""
sectional_curvature_min(M::AbstractManifold)

"""
    size_to_tuple(::Type{S}) where S<:Tuple

Converts a size given by `Tuple{N, M, ...}` into a tuple `(N, M, ...)`.
"""
Base.@pure size_to_tuple(::Type{S}) where {S <: Tuple} = tuple(S.parameters...) # COV_EXCL_LINE
# the line above is excluded from coverage, since codecov has sometimes troubles with macros.

"""
    tangent_vector_type(::AbstractManifold, point_type::Type)

Change `point_type` that is a type of points on manifold `M` to matching type for
representing tangent vectors.
"""
tangent_vector_type(::AbstractManifold, point_type::Type) = point_type

@doc raw"""
    Weingarten!(M, Y, p, X, V)

Compute the Weingarten map ``\mathcal W_p\colon T_p\mathcal M × N_p\mathcal M \to T_p\mathcal M``
in place of `Y`, see [`Weingarten`](@ref).
"""
Weingarten!(M::AbstractManifold, Y, p, X, V)

@doc raw"""
    Weingarten(M, p, X, V)

Compute the Weingarten map ``\mathcal W_p\colon T_p\mathcal M × N_p\mathcal M \to T_p\mathcal M``,
where ``N_p\mathcal M`` is the orthogonal complement of the tangent space ``T_p\mathcal M``
of the embedded submanifold ``\mathcal M``, where we denote the embedding by ``\mathcal E``.

The Weingarten map can be defined by restricting the differential of the orthogonal [`project`](@ref)ion
``\operatorname{proj}_{T_p\mathcal M}\colon T_p \mathcal E \to T_p\mathcal M`` with respect to the base point ``p``,
i.e. defining
```math
\mathcal P_X := D_p\operatorname{proj}_{T_p\mathcal M}(Y)[X],
\qquad Y \in T_p \mathcal E, X \in T_p\mathcal M,
```
the Weingarten map can be written as ``\mathcal W_p(X,V) = \mathcal P_X(V)``.

The Weingarten map is named after [Julius Weingarten](https://en.wikipedia.org/wiki/Julius_Weingarten) (1836–1910).
"""
function Weingarten(M::AbstractManifold, p, X, V)
    Y = copy(M, p, X)
    Weingarten!(M, Y, p, X, V)
    return Y
end


@doc raw"""
    zero_vector!(M::AbstractManifold, X, p)

Save to `X` the tangent vector from the tangent space ``T_p\mathcal M`` at `p` that
represents the zero vector, i.e. such that retracting `X` to the [`AbstractManifold`](@ref) `M` at
`p` produces `p`.
"""
zero_vector!(M::AbstractManifold, X, p) = log!(M, X, p, p)

@doc raw"""
    zero_vector(M::AbstractManifold, p)

Return the tangent vector from the tangent space ``T_p\mathcal M`` at `p` on the
[`AbstractManifold`](@ref) `M`, that represents the zero vector, i.e. such that a retraction at
`p` produces `p`.
"""
function zero_vector(M::AbstractManifold, p)
    X = allocate_result(M, zero_vector, p)
    zero_vector!(M, X, p)
    return X
end
include("errors.jl")
include("parallel_transport.jl")
include("vector_transport.jl")
include("shooting.jl")
include("vector_spaces.jl")
include("point_vector_fallbacks.jl")
include("nested_trait.jl")

include("connection.jl")
include("metric.jl")

include("decorator_trait.jl")
include("numerical_checks.jl")

include("VectorFiber.jl")
include("TangentSpace.jl")
include("ValidationManifold.jl")
include("EmbeddedManifold.jl")
include("DefaultManifold.jl")
include("ProductManifold.jl")
include("PowerManifold.jl")
include("quotientmanifold.jl")

include("deprecated.jl")
#
#
# Init
# -----
function __init__()
    #
    # Error Hints
    #
    return @static if isdefined(Base.Experimental, :register_error_hint) # COV_EXCL_LINE
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            if exc.f === plot_slope
                print(
                    io,
                    """

                    `plot_slope` has to be implemented using your favourite plotting package.
                    A default is available when Plots.jl is added to the current environment.
                    To then get the plotting functionality activated, do
                    """,
                )
                printstyled(io, "`using Plots`"; color = :cyan)
            end
            if exc.f === find_best_slope_window
                print(
                    io,
                    """

                    `find_best_slope_window` has to be implemented using some statistics package
                    A default is available when Statistics.jl is added to the current environment.
                    To then get the functionality activated, do
                    """,
                )
                printstyled(io, "`using Statistics`"; color = :cyan)
            end
        end
    end
end
#
#
# Export
# ------
#
# (a) Manifolds and general types
export AbstractManifold,
    AbstractManifoldPoint,
    AbstractTangentVector,
    AbstractCotangentVector,
    TFVector,
    CoTFVector
export AbstractAffineConnection, ConnectionManifold, LeviCivitaConnection
export AbstractMetric, MetricManifold
export VectorSpaceFiber
export TangentSpace, TangentSpaceType
export CotangentSpace, CotangentSpaceType
export AbstractDecoratorManifold
export AbstractForwardingType, StopForwardingType, SimpleForwardingType
export AbstractEmbeddedForwardingType, EmbeddedForwardingType
export ValidationManifold,
    ValidationMPoint, ValidationTangentVector, ValidationCotangentVector
export EmbeddedManifold
export AbstractPowerManifold, PowerManifold
export AbstractPowerRepresentation,
    NestedPowerRepresentation, NestedReplacingPowerRepresentation
export ProductManifold

# (b) Generic Estimation Types

export GeodesicInterpolationWithinRadius,
    CyclicProximalPointEstimation,
    ExtrinsicEstimation,
    GradientDescentEstimation,
    WeiszfeldEstimation,
    AbstractApproximationMethod,
    GeodesicInterpolation


# (b) Retraction Types
export AbstractRetractionMethod,
    ApproximateRetraction,
    ApproximateExponentialRetraction,
    CayleyRetraction,
    EmbeddedRetraction,
    ExponentialRetraction,
    NLSolveInverseRetraction,
    QRRetraction,
    PadeRetraction,
    PolarRetraction,
    ProductRetraction,
    ProjectionRetraction,
    RetractionWithKeywords,
    SasakiRetraction,
    ShootingInverseRetraction,
    SoftmaxRetraction,
    StabilizedRetraction

# (c) Inverse Retraction Types
export AbstractInverseRetractionMethod,
    ApproximateInverseRetraction,
    ApproximateLogarithmicInverseRetraction,
    CayleyInverseRetraction,
    EmbeddedInverseRetraction,
    InverseProductRetraction,
    LogarithmicInverseRetraction,
    NLSolveInverseRetraction,
    QRInverseRetraction,
    PadeInverseRetraction,
    PolarInverseRetraction,
    ProjectionInverseRetraction,
    InverseRetractionWithKeywords,
    SoftmaxInverseRetraction,
    StabilizedInverseRetraction

# (d) Vector Transport Types
export AbstractVectorTransportMethod,
    DifferentiatedRetractionVectorTransport,
    EmbeddedVectorTransport,
    ParallelTransport,
    PoleLadderTransport,
    ProductVectorTransport,
    ProjectionTransport,
    ScaledVectorTransport,
    SchildsLadderTransport,
    VectorTransportDirection,
    VectorTransportTo,
    VectorTransportWithKeywords

# (e) Basis Types
export CachedBasis,
    DefaultBasis,
    DefaultOrthogonalBasis,
    DefaultOrthonormalBasis,
    DiagonalizingOrthonormalBasis,
    DefaultOrthonormalBasis,
    GramSchmidtOrthonormalBasis,
    ProjectedOrthonormalBasis,
    VeeOrthogonalBasis

# (f) Error Messages
export OutOfInjectivityRadiusError, ManifoldDomainError
export ApproximatelyError
export CompositeManifoldError, ComponentManifoldError, ManifoldDomainError

# (g) Functions on Manifolds
export ×,
    ℝ,
    ℂ,
    allocate,
    allocate_on,
    angle,
    base_manifold,
    base_point,
    canonical_project,
    canonical_project!,
    change_basis,
    change_basis!,
    change_metric,
    change_metric!,
    change_representer,
    change_representer!,
    check_geodesic,
    check_inverse_retraction,
    check_retraction,
    check_vector_transport,
    copy,
    copyto!,
    default_approximation_method,
    default_basis,
    default_inverse_retraction_method,
    default_retraction_method,
    default_type,
    default_vector_transport_method,
    diff_canonical_project,
    diff_canonical_project!,
    distance,
    exp,
    exp!,
    embed,
    embed!,
    embed_project,
    embed_project!,
    fill,
    fill!,
    geodesic,
    geodesic!,
    get_basis,
    get_component,
    get_coordinates,
    get_coordinates!,
    get_embedding,
    get_embedding_type,
    get_total_space,
    get_vector,
    get_vector!,
    get_vectors,
    has_components,
    hat,
    hat!,
    horizontal_component,
    horizontal_component!,
    horizontal_lift,
    horizontal_lift!,
    injectivity_radius,
    inner,
    internal_value,
    inverse_retract,
    inverse_retract!,
    isapprox,
    is_flat,
    is_point,
    is_vector,
    isempty,
    length,
    log,
    log!,
    manifold_dimension,
    mid_point,
    mid_point!,
    norm,
    number_eltype,
    number_of_coordinates,
    number_system,
    power_dimensions,
    parallel_transport_direction,
    parallel_transport_direction!,
    parallel_transport_to,
    parallel_transport_to!,
    project,
    project!,
    real_dimension,
    representation_size,
    set_component!,
    shortest_geodesic,
    shortest_geodesic!,
    show,
    rand,
    rand!,
    retract,
    retract!,
    riemann_tensor,
    riemann_tensor!,
    sectional_curvature,
    sectional_curvature_max,
    sectional_curvature_min,
    vector_space_dimension,
    vector_transport_direction,
    vector_transport_direction!,
    vector_transport_to,
    vector_transport_to!,
    vee,
    vee!,
    vertical_component,
    vertical_component!,
    Weingarten,
    Weingarten!,
    zero_vector,
    zero_vector!
end # module

using ManifoldsBase
using ManifoldsBase: ℝ
using Test

struct ErrorTestManifold <: AbstractManifold{ℝ} end

function ManifoldsBase.check_size(::ErrorTestManifold, p)
    size(p) != (2,) && return DomainError(size(p), "size $p not (2,)")
    return nothing
end
function ManifoldsBase.check_size(::ErrorTestManifold, p, X)
    size(X) != (2,) && return DomainError(size(X), "size $X not (2,)")
    return nothing
end
function ManifoldsBase.check_point(::ErrorTestManifold, x)
    if any(u -> u < 0, x)
        return DomainError(x, "<0")
    end
    return nothing
end
function ManifoldsBase.check_vector(M::ErrorTestManifold, x, v)
    mpe = ManifoldsBase.check_point(M, x)
    mpe === nothing || return mpe
    if any(u -> u < 0, v)
        return DomainError(v, "<0")
    end
    return nothing
end

@testset "Domain errors" begin
    M = ErrorTestManifold()
    @test isa(ManifoldsBase.check_point(M, [-1, 1]), DomainError)
    @test isa(ManifoldsBase.check_size(M, [-1, 1, 1]), DomainError)
    @test isa(ManifoldsBase.check_size(M, [-1, 1], [1, 1, 1]), DomainError)
    @test ManifoldsBase.check_point(M, [1, 1]) === nothing
    @test !is_point(M, [-1, 1])
    @test !is_point(M, [1, 1, 1]) # checksize fails
    @test_throws DomainError is_point(M, [-1, 1, 1], true) # checksize errors
    @test_throws DomainError is_point(M, [-1, 1, 1]; error = :error) # checksize errors
    cs = "DomainError with (3,):\nsize [-1, 1, 1] not (2,)"
    @test_logs (:info, cs) is_point(M, [-1, 1, 1]; error = :info)
    @test_logs (:warn, cs) is_point(M, [-1, 1, 1]; error = :warn)
    @test is_point(M, [1, 1])
    @test is_point(M, [1, 1]; error = :error)
    @test_throws DomainError is_point(M, [-1, 1], true)
    @test_throws DomainError is_point(M, [-1, 1]; error = :error)
    ps = "DomainError with [-1, 1]:\n<0"
    @test_logs (:info, ps) is_point(M, [-1, 1]; error = :info)
    @test_logs (:warn, ps) is_point(M, [-1, 1]; error = :warn)

    @test isa(ManifoldsBase.check_vector(M, [1, 1], [-1, 1]), DomainError)
    @test ManifoldsBase.check_vector(M, [1, 1], [1, 1]) === nothing
    @test !is_vector(M, [1, 1], [-1, 1])
    @test !is_vector(M, [1, 1], [1, 1, 1])
    @test_throws DomainError is_vector(M, [1, 1], [-1, 1, 1], false, true)
    @test_throws DomainError is_vector(M, [1, 1], [-1, 1, 1]; error = :error)
    vs = "DomainError with (3,):\nsize [-1, 1, 1] not (2,)"
    @test_logs (:info, vs) is_vector(M, [1, 1], [-1, 1, 1]; error = :info)
    @test_logs (:warn, vs) is_vector(M, [1, 1], [-1, 1, 1]; error = :warn)
    @test !is_vector(M, [1, 1, 1], [1, 1, 1], false)
    @test_throws DomainError is_vector(M, [1, 1, 1], [1, 1], true, true)
    @test_throws DomainError is_vector(M, [1, 1, 1], [1, 1], true; error = :error)
    ps2 = "DomainError with (3,):\nsize [1, 1, 1] not (2,)"
    @test_logs (:info, ps2) is_vector(M, [1, 1, 1], [1, 1], true; error = :info)
    @test_logs (:warn, ps2) is_vector(M, [1, 1, 1], [1, 1], true; error = :warn)
    @test is_vector(M, [1, 1], [1, 1])
    @test is_vector(M, [1, 1], [1, 1]; error = :none)
    @test_throws DomainError is_vector(M, [1, 1], [-1, 1]; error = :error)
    @test_throws DomainError is_vector(M, [1, 1], [-1, 1], true; error = :error)
    ps3 = "DomainError with [-1, 1]:\n<0"
    @test_logs (:info, ps3) is_vector(M, [1, 1], [-1, 1], true; error = :info)
    @test_logs (:warn, ps3) is_vector(M, [1, 1], [-1, 1], true; error = :warn)
end

"""
    ManifoldsBaseTestSuite.jl

A small module to provide common dummy types and defaults for testing.

! Note
    Whenever you rewrite tests maybe think about moving common definitions here.
"""
module ManifoldsBaseTestSuite
using ManifoldsBase, Test


# Validation Specials


struct CustomValidationManifoldRetraction <: ManifoldsBase.AbstractRetractionMethod end

function ManifoldsBase.injectivity_radius(
        ::ManifoldsBase.DefaultManifold,
        ::CustomValidationManifoldRetraction,
    )
    return 10.0
end
function ManifoldsBase.injectivity_radius(
        ::ManifoldsBase.DefaultManifold,
        p,
        ::CustomValidationManifoldRetraction,
    )
    return 11.0
end

struct ValidationDummyManifold <: ManifoldsBase.AbstractManifold{ℝ} end
ManifoldsBase.check_point(::ValidationDummyManifold, p) = nothing
ManifoldsBase.check_vector(::ValidationDummyManifold, p, X) = nothing
function ManifoldsBase.project(M::ValidationDummyManifold, p, X)
    Y = similar(X)
    project!(M, Y, p, X)
    return Y
end
ManifoldsBase.project!(::ValidationDummyManifold, Y, p, X) = (Y .= 2 .* X)
function ManifoldsBase.project(M::ValidationDummyManifold, p)
    q = similar(p)
    project!(M, q, p)
    return q
end
ManifoldsBase.project!(::ValidationDummyManifold, q, p) = (q .= 2 .* p)
ManifoldsBase.distance(::ValidationDummyManifold, p, q) = -1.0
ManifoldsBase.norm(::ValidationDummyManifold, p, v) = -1.0
ManifoldsBase.get_embedding(::ValidationDummyManifold) = ManifoldsBase.DefaultManifold(3)
end

module ManifoldsBasePlotsExt

using ManifoldsBase
using Plots
using Printf: @sprintf

function ManifoldsBase.plot_slope(
        ::Val{:Plots}, x, y;
        slope = 2, line_base = 0, a = 0, b = 2.0, i = 1, j = length(x),
    )
    fig = plot(
        x, y; xaxis = :log, yaxis = :log, label = "\$E(t)\$",
        linewidth = 3, legend = :topleft, color = :lightblue,
    )
    s_line = [exp10(line_base + t * slope) for t in log10.(x)]
    plot!(
        fig, x, s_line; label = "slope s=$slope",
        linestyle = :dash, color = :black, linewidth = 2,
    )
    if (i != 0) && (j != 0)
        best_line = [exp10(a + t * b) for t in log10.(x[i:j])]
        plot!(
            fig, x[i:j], best_line;
            label = "best slope $(@sprintf("%.4f", b))",
            color = :blue, linestyle = :dot, linewidth = 2,
        )
    end
    return fig
end
function ManifoldsBase.plot_check_geodesic(::Val{:Plots}, T, N, e_norm, e_pt, e_alpha)
    fig = plot(
        T[1:(N - 1)], e_norm;
        # Deviation from constant speed: |‖Xᵢ‖ − mean‖X‖|
        label = "Speed deviation: |‖Xᵢ‖ − mean‖X‖|",
        linewidth = 3, legend = :topright, color = :lightblue,
        xlabel = "t", ylabel = "error magnitude", title = "Geodesic checks"
    )
    plot!(
        fig, T[1:(N - 2)], e_pt;
        # Parallel transport mismatch: ‖Xᵢ − PT_{i+1→i}(X_{i+1})‖
        label = "PT difference (norm)",
        linewidth = 3, color = :blue,
    )
    plot!(
        fig, T[1:(N - 2)], e_alpha;
        # Angle-preservation error: |1 − cos∠(Xᵢ, PT_{i+1→i}X_{i+1})|
        label = "PT difference (angle)",
        linewidth = 3, color = :green,
    )
    return fig
end
end

using ManifoldsBase

@testset "deprecated functions still working" begin
    x = [1.0, 2.0, 3.0]
    y = ValidationMPoint(x)
    #@test_logs (:warn,) ManifoldsBase.array_value(y) == internal_value(y)
end

"""
    manifold_element_forwards(T, field::Symbol)
    manifold_element_forwards(T, Twhere, field::Symbol)

Introduce basic fallbacks for type `T` (which can be a subtype of `Twhere`) that represents
points or vectors for a manifold.
Fallbacks will work by forwarding to the field passed in `field``

List of forwarded functions:
* [`allocate`](@ref),
* [`copy`](@ref),
* [`copyto!`](@ref),
* [`number_eltype`](@ref) (only for values, not the type itself),
* `similar`,
* `size`,
* `==`.
"""
macro manifold_element_forwards(T, field::Symbol)
    return esc(
        quote
            ManifoldsBase.@manifold_element_forwards ($T) _unused ($field)
        end
    )
end
macro manifold_element_forwards(T, Twhere, field::Symbol)
    TWT = if Twhere === :_unused
        T
    else
        :($T where {$Twhere})
    end
    code = quote
        function ManifoldsBase.number_eltype(p::$TWT)
            return typeof(one(eltype(p.$field)))
        end

        Base.size(p::$TWT) = size(p.$field)
    end
    if Twhere === :_unused
        push!(
            code.args,
            quote
                ManifoldsBase.allocate(p::$T) = $T(allocate(p.$field))
                function ManifoldsBase.allocate(p::$T, ::Type{P}) where {P}
                    return $T(allocate(p.$field, P))
                end
                function ManifoldsBase.allocate(p::$T, ::Type{P}, dims::Tuple) where {P}
                    return $T(allocate(p.$field, P, dims))
                end
                @inline Base.copy(p::$T) = $T(copy(p.$field))
                function Base.copyto!(q::$T, p::$T)
                    copyto!(q.$field, p.$field)
                    return q
                end
                Base.similar(p::$T) = $T(similar(p.$field))
                Base.similar(p::$T, ::Type{P}) where {P} = $T(similar(p.$field, P))
                Base.:(==)(p::$T, q::$T) = (p.$field == q.$field)
            end,
        )
    else
        push!(
            code.args,
            quote
                ManifoldsBase.allocate(p::$T) where {$Twhere} = $T(allocate(p.$field))
                function ManifoldsBase.allocate(p::$T, ::Type{P}) where {P, $Twhere}
                    return $T(allocate(p.$field, P))
                end
                function ManifoldsBase.allocate(
                        p::$T,
                        ::Type{P},
                        dims::Tuple,
                    ) where {P, $Twhere}
                    return $T(allocate(p.$field, P, dims))
                end
                @inline Base.copy(p::$T) where {$Twhere} = $T(copy(p.$field))
                function Base.copyto!(q::$T, p::$T) where {$Twhere}
                    copyto!(q.$field, p.$field)
                    return q
                end
                Base.similar(p::$T) where {$Twhere} = $T(similar(p.$field))
                Base.similar(p::$T, ::Type{P}) where {P, $Twhere} = $T(similar(p.$field, P))
                Base.:(==)(p::$T, q::$T) where {$Twhere} = (p.$field == q.$field)
            end,
        )
    end

    return esc(code)
end


"""
    default_manifold_fallbacks(TM, TP, TV, pfield::Symbol, vfield::Symbol)

Introduce default fallbacks for all basic functions on manifolds, for manifold of type `TM`,
points of type `TP`, tangent vectors of type `TV`, with forwarding to fields `pfield` and
`vfield` for point and tangent vector functions, respectively.
"""
macro default_manifold_fallbacks(TM, TP, TV, pfield::Symbol, vfield::Symbol)
    block = quote
        function ManifoldsBase.allocate_result(::$TM, ::typeof(log), p::$TP, ::$TP)
            a = allocate(p.$vfield)
            return $TV(a)
        end
        function ManifoldsBase.allocate_result(
                ::$TM, ::typeof(inverse_retract), p::$TP, ::$TP,
            )
            a = allocate(p.$vfield)
            return $TV(a)
        end
        function ManifoldsBase.allocate_coordinates(M::$TM, p::$TP, T, n::Int)
            return ManifoldsBase.allocate_coordinates(M, p.$pfield, T, n)
        end

        function ManifoldsBase.angle(M::$TM, p::$TP, X::$TV, Y::$TV)
            return ManifoldsBase.angle(M, p.$pfield, X.$vfield, Y.$vfield)
        end

        function ManifoldsBase.check_point(M::$TM, p::$TP; kwargs...)
            return ManifoldsBase.check_point(M, p.$pfield; kwargs...)
        end

        function ManifoldsBase.check_vector(M::$TM, p::$TP, X::$TV; kwargs...)
            return ManifoldsBase.check_vector(M, p.$pfield, X.$vfield; kwargs...)
        end

        function ManifoldsBase.check_approx(M::$TM, p::$TP, q::$TP; kwargs...)
            return ManifoldsBase.check_approx(M, p.$pfield, q.$pfield; kwargs...)
        end
        function ManifoldsBase.check_approx(M::$TM, p::$TP, X::$TV, Y::$TV; kwargs...)
            return ManifoldsBase.check_approx(M, p.$pfield, X.$vfield, Y.$vfield; kwargs...)
        end

        function ManifoldsBase.distance(M::$TM, p::$TP, q::$TP)
            return ManifoldsBase.distance(M, p.$pfield, q.$pfield)
        end

        function ManifoldsBase.embed!(M::$TM, q::$TP, p::$TP)
            ManifoldsBase.embed!(M, q.$pfield, p.$pfield)
            return q
        end

        function ManifoldsBase.embed!(M::$TM, Y::$TV, p::$TP, X::$TV)
            ManifoldsBase.embed!(M, Y.$vfield, p.$pfield, X.$vfield)
            return Y
        end

        function ManifoldsBase.exp!(M::$TM, q::$TP, p::$TP, X::$TV)
            ManifoldsBase.exp!(M, q.$pfield, p.$pfield, X.$vfield)
            return q
        end

        function ManifoldsBase.exp_fused!(M::$TM, q::$TP, p::$TP, X::$TV, t::Number)
            ManifoldsBase.exp_fused!(M, q.$pfield, p.$pfield, X.$vfield, t)
            return q
        end

        function ManifoldsBase.inner(M::$TM, p::$TP, X::$TV, Y::$TV)
            return ManifoldsBase.inner(M, p.$pfield, X.$vfield, Y.$vfield)
        end

        function ManifoldsBase.inverse_retract!(
                M::$TM, X::$TV, p::$TP, q::$TP, m::ManifoldsBase.LogarithmicInverseRetraction,
            )
            ManifoldsBase.inverse_retract!(M, X.$vfield, p.$pfield, q.$pfield, m)
            return X
        end

        function ManifoldsBase.isapprox(M::$TM, p::$TP, q::$TP; kwargs...)
            return ManifoldsBase.isapprox(M, p.$pfield, q.$pfield; kwargs...)
        end

        function ManifoldsBase.isapprox(M::$TM, p::$TP, X::$TV, Y::$TV; kwargs...)
            return ManifoldsBase.isapprox(M, p.$pfield, X.$vfield, Y.$vfield; kwargs...)
        end

        function ManifoldsBase.log!(M::$TM, X::$TV, p::$TP, q::$TP)
            ManifoldsBase.log!(M, X.$vfield, p.$pfield, q.$pfield)
            return X
        end

        function ManifoldsBase.norm(M::$TM, p::$TP, X::$TV)
            return ManifoldsBase.norm(M, p.$pfield, X.$vfield)
        end

        function ManifoldsBase.retract!(
                M::$TM, q::$TP, p::$TP, X::$TV, m::ManifoldsBase.ExponentialRetraction,
            )
            ManifoldsBase.retract!(M, q.$pfield, p.$pfield, X.$vfield, m)
            return q
        end

        function ManifoldsBase.retract_fused!(
                M::$TM, q::$TP, p::$TP, X::$TV, t::Number, m::ManifoldsBase.ExponentialRetraction,
            )
            ManifoldsBase.retract_fused!(M, q.$pfield, p.$pfield, X.$vfield, t, m)
            return q
        end

        function ManifoldsBase.zero_vector(M::$TM, p::$TP)
            return $TV(zero_vector(M, p.$pfield))
        end

        function ManifoldsBase.zero_vector!(M::$TM, X::$TV, p::$TP)
            ManifoldsBase.zero_vector!(M, X.$vfield, p.$pfield)
            return X
        end
    end
    for f_postfix in [:default, :orthogonal, :orthonormal, :vee, :cached, :diagonalizing]
        ca = Symbol("get_coordinates_$(f_postfix)")
        cm = Symbol("get_coordinates_$(f_postfix)!")
        va = Symbol("get_vector_$(f_postfix)")
        vm = Symbol("get_vector_$(f_postfix)!")
        B_types = if f_postfix in [:default, :orthogonal, :orthonormal, :vee]
            [:AbstractNumbers, :RealNumbers, :ComplexNumbers]
        elseif f_postfix === :cached
            [:CachedBasis]
        elseif f_postfix === :diagonalizing
            [:DiagonalizingOrthonormalBasis]
        else
            [:Any]
        end
        for B_type in B_types
            push!(
                block.args,
                quote
                    function ManifoldsBase.$ca(M::$TM, p::$TP, X::$TV, B::$B_type)
                        return ManifoldsBase.$ca(M, p.$pfield, X.$vfield, B)
                    end
                    function ManifoldsBase.$cm(M::$TM, Y, p::$TP, X::$TV, B::$B_type)
                        ManifoldsBase.$cm(M, Y, p.$pfield, X.$vfield, B)
                        return Y
                    end
                    function ManifoldsBase.$va(M::$TM, p::$TP, X, B::$B_type)
                        return $TV(ManifoldsBase.$va(M, p.$pfield, X, B))
                    end
                    function ManifoldsBase.$vm(M::$TM, Y::$TV, p::$TP, X, B::$B_type)
                        ManifoldsBase.$vm(M, Y.$vfield, p.$pfield, X, B)
                        return Y
                    end
                end,
            )
        end
    end
    for f_postfix in [:polar, :project, :qr, :softmax, :sasaki]
        rm = Symbol("retract_$(f_postfix)!")
        push!(
            block.args, quote
                function ManifoldsBase.$rm(M::$TM, q, p::$TP, X::$TV)
                    ManifoldsBase.$rm(M, q.$pfield, p.$pfield, X.$vfield)
                    return q
                end
            end
        )
        rmf = Symbol("retract_$(f_postfix)_fused!")
        push!(
            block.args,
            quote
                function ManifoldsBase.$rmf(M::$TM, q, p::$TP, X::$TV, t::Number)
                    ManifoldsBase.$rmf(M, q.$pfield, p.$pfield, X.$vfield, t)
                    return q
                end
            end,
        )
    end
    push!(
        block.args,
        quote
            function ManifoldsBase.retract_approx!(
                    M::$TM, q::$TP, p::$TP, X::$TV, m::ManifoldsBase.ApproximateExponentialRetraction,
                )
                ManifoldsBase.retract_approx!(M, q.$pfield, p.$pfield, X.$vfield, m)
                return q
            end
            function ManifoldsBase.retract_approx_fused!(
                    M::$TM, q::$TP, p::$TP, X::$TV, t::Number, m::ManifoldsBase.ApproximateExponentialRetraction,
                )
                ManifoldsBase.retract_approx_fused!(M, q.$pfield, p.$pfield, X.$vfield, t, m)
                return q
            end
            function ManifoldsBase.retract_pade!(
                    M::$TM, q::$TP, p::$TP, X::$TV, m::ManifoldsBase.PadeRetraction,
                )
                ManifoldsBase.retract_pade!(M, q.$pfield, p.$pfield, X.$vfield, m)
                return q
            end
            function ManifoldsBase.retract_pade_fused!(
                    M::$TM, q::$TP, p::$TP, X::$TV, t::Number, m::ManifoldsBase.PadeRetraction,
                )
                ManifoldsBase.retract_pade_fused!(M, q.$pfield, p.$pfield, X.$vfield, t, m)
                return q
            end
            function ManifoldsBase.retract_embedded!(
                    M::$TM, q::$TP, p::$TP, X::$TV, m::ManifoldsBase.AbstractRetractionMethod,
                )
                ManifoldsBase.retract_embedded!(M, q.$pfield, p.$pfield, X.$vfield, m)
                return q
            end
            function ManifoldsBase.retract_embedded_fused!(
                    M::$TM, q::$TP, p::$TP, X::$TV, t::Number, m::ManifoldsBase.AbstractRetractionMethod,
                )
                ManifoldsBase.retract_embedded_fused!(
                    M, q.$pfield, p.$pfield, X.$vfield, t, m,
                )
                return q
            end
            function ManifoldsBase.retract_sasaki!(
                    M::$TM, q::$TP, p::$TP, X::$TV, m::ManifoldsBase.SasakiRetraction,
                )
                ManifoldsBase.retract_sasaki!(M, q.$pfield, p.$pfield, X.$vfield, m)
                return q
            end
            function ManifoldsBase.retract_sasaki_fused!(
                    M::$TM, q::$TP, p::$TP, X::$TV, t::Number, m::ManifoldsBase.SasakiRetraction,
                )
                ManifoldsBase.retract_sasaki_fused!(
                    M, q.$pfield, p.$pfield, X.$vfield, t, m,
                )
                return q
            end
        end,
    )
    for f_postfix in [:polar, :project, :qr, :softmax]
        rm = Symbol("inverse_retract_$(f_postfix)!")
        push!(
            block.args, quote
                function ManifoldsBase.$rm(M::$TM, Y::$TV, p::$TP, q::$TP)
                    ManifoldsBase.$rm(M, Y.$vfield, p.$pfield, q.$pfield)
                    return Y
                end
            end
        )
    end
    push!(
        block.args,
        quote
            function ManifoldsBase.inverse_retract_approx!(
                    M::$TM, X::$TV, p::$TP, q::$TP, m::ManifoldsBase.ApproximateLogarithmicInverseRetraction,
                )
                ManifoldsBase.inverse_retract_approx!(M, X.$vfield, p.$pfield, q.$pfield, m)
                return X
            end
            function ManifoldsBase.inverse_retract_embedded!(
                    M::$TM, X::$TV, p::$TP, q::$TP, m::ManifoldsBase.AbstractInverseRetractionMethod,
                )
                ManifoldsBase.inverse_retract_embedded!(
                    M, X.$vfield, p.$pfield, q.$pfield, m,
                )
                return X
            end
            function ManifoldsBase.inverse_retract_nlsolve!(
                    M::$TM, X::$TV, p::$TP, q::$TP, m::ManifoldsBase.NLSolveInverseRetraction,
                )
                ManifoldsBase.inverse_retract_nlsolve!(
                    M, X.$vfield, p.$pfield, q.$pfield, m,
                )
                return X
            end
        end,
    )
    # forward vector transports

    for sub in [:project, :diff, :embedded]
        # project & diff
        vttm = Symbol("vector_transport_to_$(sub)!")
        push!(
            block.args,
            quote
                function ManifoldsBase.$vttm(M::$TM, Y::$TV, p::$TP, X::$TV, q::$TP)
                    ManifoldsBase.$vttm(M, Y.$vfield, p.$pfield, X.$vfield, q.$pfield)
                    return Y
                end
            end,
        )
    end
    # parallel transports
    push!(
        block.args,
        quote
            function ManifoldsBase.parallel_transport_direction(
                    M::$TM, p::$TP, X::$TV, d::$TV,
                )
                return $TV(
                    ManifoldsBase.parallel_transport_direction(
                        M, p.$pfield, X.$vfield, d.$vfield,
                    ),
                )
            end
            function ManifoldsBase.parallel_transport_direction!(
                    M::$TM, Y::$TV, p::$TP, X::$TV, d::$TV,
                )
                ManifoldsBase.parallel_transport_direction!(
                    M, Y.$vfield, p.$pfield, X.$vfield, d.$vfield,
                )
                return Y
            end
            function ManifoldsBase.parallel_transport_to(M::$TM, p::$TP, X::$TV, q::$TP)
                return $TV(
                    ManifoldsBase.parallel_transport_to(M, p.$pfield, X.$vfield, q.$pfield),
                )
            end
            function ManifoldsBase.parallel_transport_to!(
                    M::$TM, Y::$TV, p::$TP, X::$TV, q::$TP,
                )
                ManifoldsBase.parallel_transport_to!(
                    M, Y.$vfield, p.$pfield, X.$vfield, q.$pfield,
                )
                return Y
            end
        end,
    )
    return esc(block)
end


@doc raw"""
    manifold_vector_forwards(T, field::Symbol)
    manifold_vector_forwards(T, Twhere, field::Symbol)

Introduce basic fallbacks for type `T` that represents vectors from a vector bundle for a
manifold. `Twhere` is put into `where` clause of each method. Fallbacks work by forwarding
to field passed as `field`.

List of forwarded functions:
* basic arithmetic (`*`, `/`, `\`, `+`, `-`),
* all things from [`@manifold_element_forwards`](@ref),
* broadcasting support.

# example

    @eval @manifold_vector_forwards ValidationFibreVector{TType} TType value
"""
macro manifold_vector_forwards(T, field::Symbol)
    return esc(
        quote
            ManifoldsBase.@manifold_vector_forwards ($T) _unused ($field)
        end
    )
end
macro manifold_vector_forwards(T, Twhere, field::Symbol)
    TWT = if Twhere === :_unused
        T
    else
        :($T where {$Twhere})
    end
    code = quote
        @eval ManifoldsBase.@manifold_element_forwards $T $Twhere $field

        Base.axes(p::$TWT) = axes(p.$field)

        Broadcast.broadcastable(X::$TWT) = X

        Base.@propagate_inbounds function Broadcast._broadcast_getindex(X::$TWT, I)
            return X.$field
        end
    end

    broadcast_copyto_code = quote
        axes(dest) == axes(bc) || Broadcast.throwdm(axes(dest), axes(bc))
        # Performance optimization: broadcast!(identity, dest, A) is equivalent to copyto!(dest, A) if indices match
        if bc.f === identity && bc.args isa Tuple{$T} # only a single input argument to broadcast!
            A = bc.args[1]
            if axes(dest) == axes(A)
                return copyto!(dest, A)
            end
        end
        bc′ = Broadcast.preprocess(dest, bc)
        # Performance may vary depending on whether `@inbounds` is placed outside the
        # for loop or not. (cf. https://github.com/JuliaLang/julia/issues/38086)
        copyto!(dest.$field, bc′[1])
        return dest
    end

    if Twhere === :_unused
        push!(
            code.args,
            quote
                Base.:*(X::$T, s::Number) = $T(X.$field * s)
                Base.:*(s::Number, X::$T) = $T(s * X.$field)
                Base.:/(X::$T, s::Number) = $T(X.$field / s)
                Base.:\(s::Number, X::$T) = $T(s \ X.$field)
                Base.:-(X::$T) = $T(-X.$field)
                Base.:+(X::$T) = $T(X.$field)
                Base.zero(X::$T) = $T(zero(X.$field))
                Base.:+(X::$T, Y::$T) = $T(X.$field + Y.$field)
                Base.:-(X::$T, Y::$T) = $T(X.$field - Y.$field)

                function Broadcast.BroadcastStyle(::Type{<:$T})
                    return Broadcast.Style{$T}()
                end

                function Broadcast.BroadcastStyle(
                        ::Broadcast.AbstractArrayStyle{0},
                        b::Broadcast.Style{$T},
                    )
                    return b
                end

                function Broadcast.instantiate(
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}, Nothing},
                    )
                    return bc
                end
                function Broadcast.instantiate(
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}},
                    )
                    Broadcast.check_broadcast_axes(bc.axes, bc.args...)
                    return bc
                end

                @inline function Base.copy(bc::Broadcast.Broadcasted{Broadcast.Style{$T}})
                    return $T(Broadcast._broadcast_getindex(bc, 1))
                end

                @inline function Base.copyto!(
                        dest::$T,
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}},
                    )
                    return $broadcast_copyto_code
                end
            end,
        )
    else
        push!(
            code.args,
            quote
                Base.:*(X::$T, s::Number) where {$Twhere} = $T(X.$field * s)
                Base.:*(s::Number, X::$T) where {$Twhere} = $T(s * X.$field)
                Base.:/(X::$T, s::Number) where {$Twhere} = $T(X.$field / s)
                Base.:\(s::Number, X::$T) where {$Twhere} = $T(s \ X.$field)
                Base.:-(X::$T) where {$Twhere} = $T(-X.$field)
                Base.:+(X::$T) where {$Twhere} = $T(X.$field)
                Base.zero(X::$T) where {$Twhere} = $T(zero(X.$field))
                Base.:+(X::$T, Y::$T) where {$Twhere} = $T(X.$field + Y.$field)
                Base.:-(X::$T, Y::$T) where {$Twhere} = $T(X.$field - Y.$field)

                function Broadcast.BroadcastStyle(::Type{<:$T}) where {$Twhere}
                    return Broadcast.Style{$T}()
                end

                function Broadcast.BroadcastStyle(
                        ::Broadcast.AbstractArrayStyle{0},
                        b::Broadcast.Style{$T},
                    ) where {$Twhere}
                    return b
                end

                function Broadcast.instantiate(
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}, Nothing},
                    ) where {$Twhere}
                    return bc
                end
                function Broadcast.instantiate(
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}},
                    ) where {$Twhere}
                    Broadcast.check_broadcast_axes(bc.axes, bc.args...)
                    return bc
                end

                @inline function Base.copy(
                        bc::Broadcast.Broadcasted{Broadcast.Style{$T}},
                    ) where {$Twhere}
                    return $T(Broadcast._broadcast_getindex(bc, 1))
                end

                @inline function Base.copyto!(
                        dest::$T, bc::Broadcast.Broadcasted{Broadcast.Style{$T}},
                    ) where {$Twhere}
                    return $broadcast_copyto_code
                end
            end,
        )
    end
    return esc(code)
end

using ManifoldsBase, Test

struct DummyQuotientManifold <: AbstractManifold{ℝ} end
struct DummyTotalSpace <: AbstractManifold{ℝ} end

ManifoldsBase.canonical_project!(M::DummyQuotientManifold, q, p) = copyto!(q, p)
ManifoldsBase.diff_canonical_project!(M::DummyQuotientManifold, Y, p, X) = copyto!(Y, X)
ManifoldsBase.get_total_space(::DummyQuotientManifold) = DummyTotalSpace()
ManifoldsBase.horizontal_component!(N::DummyQuotientManifold, Y, p, X) = copyto!(Y, X)
ManifoldsBase.horizontal_lift!(N::DummyQuotientManifold, Y, q, X) = copyto!(Y, X)
ManifoldsBase.zero_vector(::DummyQuotientManifold, p) = zeros(2)
@testset "Allocations on a dummy quotient manifold" begin
    M = DummyQuotientManifold()
    p = [1.0, 2.0]
    X = [3.0, 4.0]
    q = canonical_project(M, p)
    @test q == p
    Y = diff_canonical_project(M, p, X)
    @test Y == X
    @test get_total_space(M) == DummyTotalSpace()
    Yh = horizontal_component(M, p, X)
    @test Yh == X
    Yl = horizontal_lift(M, p, X)
    @test Yl == X
    # Since all of the above are the identity, in this dummy v_space is 0
    Yv = vertical_component(M, p, X)
    @test Yv == zeros(2)
    vertical_component!(M, Yv, p, X)
    @test Yv == zeros(2)
end

@doc raw"""
    AbstractDecoratorManifold{𝔽} <: AbstractManifold{𝔽}

Declare a manifold to be an abstract decorator.
A manifold which is a subtype of is a __decorated manifold__, i.e. has

* certain additional properties or
* delegates certain properties to other manifolds.

Most prominently, a manifold might be an embedded manifold, i.e. points on a manifold ``\mathcal M``
are represented by (some, maybe not all) points on another manifold ``\mathcal N``.
Depending on the type of embedding, several functions are dedicated to the embedding.
For example if the embedding is isometric, then the [`inner`](@ref) does not have to be
implemented for ``\mathcal M`` but can be automatically implemented by deligation to ``\mathcal N``.

This is modelled by the `AbstractDecoratorManifold` and traits. These are mapped to functions,
which determine the types of transparencies.
"""
abstract type AbstractDecoratorManifold{𝔽} <: AbstractManifold{𝔽} end

# turn formatting for for the following functions
# due to the if with returns inside (formatter puts a return upfront the if)
function _split_signature(sig::Expr)
    if sig.head == :where
        where_exprs = sig.args[2:end]
        call_expr = sig.args[1]
    elseif sig.head == :call
        where_exprs = []
        call_expr = sig
    else
        error("Incorrect syntax in $sig. Expected a :where or :call expression.")
    end
    fname = call_expr.args[1]
    if isa(call_expr.args[2], Expr) && call_expr.args[2].head == :parameters
        # we have keyword arguments
        callargs = call_expr.args[3:end]
        kwargs_list = call_expr.args[2].args
    else
        callargs = call_expr.args[2:end]
        kwargs_list = []
    end
    argnames = map(callargs) do arg
        if isa(arg, Expr) && arg.head === :kw # default val present
            arg = arg.args[1]
        end
        if isa(arg, Expr) && arg.head === :(::) # typed
            return arg.args[1]
        end
        return arg
    end
    argtypes = map(callargs) do arg
        if isa(arg, Expr) && arg.head === :kw # default val present
            arg = arg.args[1]
        end
        if isa(arg, Expr)
            return arg.args[2]
        else
            return Any
        end
    end

    kwargs_call = map(kwargs_list) do kwarg
        if kwarg.head === :...
            return kwarg
        else
            if isa(kwarg.args[1], Symbol)
                kwargname = kwarg.args[1]
            else
                kwargname = kwarg.args[1].args[1]
            end
            return :($kwargname = $kwargname)
        end
    end

    return (;
        fname = fname,
        where_exprs = where_exprs,
        callargs = callargs,
        kwargs_list = kwargs_list,
        argnames = argnames,
        argtypes = argtypes,
        kwargs_call = kwargs_call,
    )
end

macro invoke_maker(argnum, type, sig)
    parts = ManifoldsBase._split_signature(sig)
    kwargs_list = parts[:kwargs_list]
    callargs = parts[:callargs]
    fname = parts[:fname]
    where_exprs = parts[:where_exprs]
    argnames = parts[:argnames]
    argtypes = parts[:argtypes]
    kwargs_call = parts[:kwargs_call]

    return esc(
        quote
            function ($fname)($(callargs...); $(kwargs_list...)) where {$(where_exprs...)}
                return invoke(
                    $fname,
                    Tuple{$(argtypes[1:(argnum - 1)]...), $type, $(argtypes[(argnum + 1):end]...)},
                    $(argnames...);
                    $(kwargs_call...),
                )
            end
        end,
    )
end

#TODO: Document thoroughly
macro trait_function(
        sig,
        include_forwards = :(
            (
                EmbeddedForwardingType{DirectEmbedding},
                SimpleForwardingType,
                StopForwardingType,
            )
        ),
        manifold_arg_no = 1,
    )
    parts = ManifoldsBase._split_signature(sig)
    kwargs_list = parts[:kwargs_list]
    callargs = parts[:callargs]
    fname = parts[:fname]
    fname_fwd = Symbol(:_, fname, :_forwarding)
    where_exprs = parts[:where_exprs]
    argnames = parts[:argnames]
    kwargs_call = parts[:kwargs_call]

    argnametype_exprs = [:(typeof($(argname))) for argname in argnames]
    gft = if :p in callargs
        :(ManifoldsBase.get_forwarding_type(M, $fname, typeof(p)))
    elseif :(vector_at = vector_at) in kwargs_call
        # For rand(M; vector_at=p)
        :(ManifoldsBase.get_forwarding_type(M, $fname, typeof(vector_at)))
    else
        :(ManifoldsBase.get_forwarding_type(M, $fname))
    end

    ge = if :p in callargs
        :(get_embedding(M, typeof(p)))
    else
        :(get_embedding(M))
    end


    block = quote
        @inline function ($fname)($(callargs...); $(kwargs_list...)) where {$(where_exprs...)}
            M = $(argnames[manifold_arg_no])
            return ($fname_fwd)(($gft), $(argnames...); $(kwargs_call...))
        end
    end
    if :(EmbeddedForwardingType{DirectEmbedding}) in include_forwards.args
        block = quote
            $block
            @inline function ($fname_fwd)(
                    ::ManifoldsBase.EmbeddedForwardingType{ManifoldsBase.DirectEmbedding},
                    $(callargs...);
                    $(kwargs_list...),
                ) where {$(where_exprs...)}
                M = $(argnames[manifold_arg_no])
                return ($fname)(
                    $(argnames[1:(manifold_arg_no - 1)]...),
                    ($ge),
                    $(argnames[(manifold_arg_no + 1):end]...);
                    $(kwargs_call...),
                )
            end
        end
    end
    if :SimpleForwardingType in include_forwards.args
        block = quote
            $block
            @inline function ($fname_fwd)(
                    ::ManifoldsBase.SimpleForwardingType,
                    $(callargs...);
                    $(kwargs_list...),
                ) where {$(where_exprs...)}
                M = $(argnames[manifold_arg_no])
                return ($fname)(
                    $(argnames[1:(manifold_arg_no - 1)]...),
                    decorated_manifold(M),
                    $(argnames[(manifold_arg_no + 1):end]...);
                    $(kwargs_call...),
                )
            end
        end
    end
    if :StopForwardingType in include_forwards.args
        block = quote
            $block
            @inline function ($fname_fwd)(
                    ::ManifoldsBase.StopForwardingType,
                    $(callargs...);
                    $(kwargs_list...),
                ) where {$(where_exprs...)}
                M = $(argnames[manifold_arg_no])
                return invoke(
                    $fname,
                    Tuple{
                        $(argnametype_exprs[1:(manifold_arg_no - 1)]...),
                        ManifoldsBase.AbstractManifold,
                        $(argnametype_exprs[(manifold_arg_no + 1):end]...),
                    },
                    $(argnames[1:(manifold_arg_no - 1)]...),
                    M,
                    $(argnames[(manifold_arg_no + 1):end]...);
                    $(kwargs_call...),
                )
            end
        end
    end

    return esc(block)
end

_doc_canonical_project = raw"""
    canonical_project(M::AbstractManifold, p)
    canonical_project!(M::AbstractManifold, q, p)

Compute the canonical projection ``π`` on a quotient manifold ``\mathcal M``.
The canonical (or natural) projection ``π`` from the total space ``\mathcal N``
onto ``\mathcal M`` given by

```math
    π = π_{\mathcal N, \mathcal M} : \mathcal N → \mathcal M, p ↦ π_{\mathcal N, \mathcal M}(p) = [p].
```

in other words, this function implicitly assumes, that the total space ``\mathcal N`` is given.
"""
@doc "$(_doc_canonical_project)"
function canonical_project(M::AbstractManifold, p)
    q = allocate_result(M, canonical_project, p)
    return canonical_project!(M, q, p)
end

function canonical_project! end

@doc "$(_doc_canonical_project)"
canonical_project!(M::AbstractManifold, q, p)

_doc_diff_canonical_project = raw"""
    diff_canonical_project(M::AbstractManifold, p, X)
    diff_canonical_project!(M::AbstractManifold, Y, p, X)

Compute the differential of the canonical projection ``π`` on a quotient manifold
``\mathcal M``.
The canonical (or natural) projection ``π`` from the total space ``\mathcal N``
onto ``\mathcal M``, such that its differential

```math
 Dπ(p) : T_p\mathcal N → T_{π(p)}\mathcal M
```

where again the total space might be implicitly assumed.
"""

@doc "$(_doc_diff_canonical_project)"
function diff_canonical_project(M::AbstractManifold, p, X)
    q = allocate_result(M, diff_canonical_project, p, X)
    return diff_canonical_project!(M, q, p, X)
end

function diff_canonical_project! end
@doc "$(_doc_diff_canonical_project)"
diff_canonical_project!(M::AbstractManifold, q, p)

_doc_horizontal_lift = raw"""
    horizontal_lift(N::AbstractManifold, q, X)
    horizontal_lift!(N::AbstractManifold, Y, q, X)

Given a point `q` in total space of the quotient manifold `N` such that ``p=π(q)`` is a point on
a quotient manifold `M` (implicitly given for the first case) and a tangent vector `X` this
method computes a tangent vector `Y` on the horizontal space of ``T_q\mathcal N``,
i.e. the subspace that is orthogonal to the kernel of ``Dπ(q)``.
"""

@doc "$(_doc_horizontal_lift)"
function horizontal_lift(N::AbstractManifold, q, X)
    Y = zero_vector(N, q)
    return horizontal_lift!(N, Y, q, X)
end

function horizontal_lift! end
@doc "$(_doc_horizontal_lift)"
horizontal_lift!(N::AbstractManifold, Y, q, X)

_doc_horizontal_lift = raw"""
    horizontal_component(M::AbstractManifold, p, X)
    horizontal_component!(M::AbstractManifold, Y, p, X)

Compute the horizontal component of tangent vector `X` at point `p`
in the total space of quotient manifold `N`.

This is often written as the space ``\mathrm{Hor}_p^π\mathcal N``.
"""

@doc "$(_doc_horizontal_lift)"
function horizontal_component(N::AbstractManifold, p, X)
    Y = allocate_result(N, horizontal_component, X, p)
    return horizontal_component!(N, Y, p, X)
end

function horizontal_component! end
@doc "$(_doc_horizontal_lift)"
horizontal_component!(N::AbstractManifold, Y, p, X)

function get_total_space end
@doc raw"""
    get_total_space(M::AbstractManifold)

Return the total space of a quotient manifold.
"""
get_total_space(::AbstractManifold)

_doc_vertical_component = raw"""
    vertical_component(N::AbstractManifold, p, X)
    vertical_component!(N::AbstractManifold, Y, p, X)

Compute the vertical component of tangent vector `X` at point `p`
in the total space of quotient manifold `N`.

This is often written as the space ``\mathrm{ver}_p^π\mathcal N``.
"""

@doc "$(_doc_vertical_component)"
function vertical_component(N::AbstractManifold, p, X)
    return X - horizontal_component(N, p, X)
end

@doc "$(_doc_vertical_component)"
function vertical_component!(N::AbstractManifold, Y, p, X)
    horizontal_component!(N, Y, p, X)
    Y .*= -1
    Y .+= X
    return Y
end

using ManifoldsBase, LinearAlgebra, Random, Test

s = joinpath(@__DIR__, "ManifoldsBaseTestSuite.jl")
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestSuite

@testset "Validation manifold" begin
    M = ManifoldsBase.DefaultManifold(3)
    A = ValidationManifold(M)
    @test A == ValidationManifold(M, A) # A equals the VM with same defaults
    x = [1.0, 0.0, 0.0]
    y = 1 / sqrt(2) * [1.0, 1.0, 0.0]
    z = [0.0, 1.0, 0.0]
    v = log(M, x, y)
    x2 = ValidationMPoint(x)
    y2 = ValidationMPoint(y)
    v2 = log(A, x, y) # auto convert
    y2 = exp(A, x, v2)
    w = log(M, x, z)
    w2 = log(A, x, z; atol = 10^(-15))
    @testset "Checks forward" begin
        @test ManifoldsBase.check_size(A, x2, v2) === ManifoldsBase.check_size(M, x, v)
        @test ManifoldsBase.check_size(A, x2) === ManifoldsBase.check_size(M, x)
    end
    @testset "is_point / is_vector error." begin
        @test is_point(A, x; error = :error)
        @test_throws DomainError is_point(A, [1, 2, 3, 4]; error = :error)
        @test is_vector(A, x, v; error = :error)
        @test_throws DomainError is_vector(A, x, [1, 2, 3, 4]; error = :error)
        # Test that we can ignore point contexts
        A2a = ValidationManifold(M; ignore_contexts = [:Point])
        @test is_point(A2a, [1, 2, 3, 4])
        @test_throws DomainError !is_vector(A2a, x, [1, 2, 3, 4])
        A2b = ValidationManifold(M; ignore_contexts = [:Vector])
        @test_throws DomainError !is_point(A2b, [1, 2, 3, 4])
        @test is_vector(A2b, x, [1, 2, 3, 4])
        A3a = ValidationManifold(M; ignore_functions = Dict(exp => :All))
        @test is_point(A3a, [1, 2, 3, 4]; within = exp)
        @test_throws DomainError is_point(A3a, [1, 2, 3, 4]; within = log)
        A3b = ValidationManifold(M; ignore_functions = Dict(exp => [:Point, :Vector]))
        @test is_point(A3b, [1, 2, 3, 4]; within = exp)
        @test_throws DomainError is_point(A3b, [1, 2, 3, 4]; within = log)
        @test is_vector(A3b, x, [1, 2, 3, 4]; within = exp)
        @test_throws DomainError is_vector(A3b, x, [1, 2, 3, 4]; within = log)
    end
    @testset "Types and Conversion" begin
        @test convert(typeof(M), A) == M
        # equality does not work, since we have mutable fields, but the type agrees
        @test typeof(convert(typeof(A), M)) == typeof(A)
        @test base_manifold(A) == M
        @test base_manifold(base_manifold(A)) == base_manifold(A)
        @test ManifoldsBase.representation_size(A) == ManifoldsBase.representation_size(M)
        @test ManifoldsBase.representation_size(A) == (3,)
        @test manifold_dimension(A) == manifold_dimension(M)
        @test manifold_dimension(A) == 3
        for T in [ValidationMPoint, ValidationTangentVector, ValidationCotangentVector]
            p = T(x)
            @test convert(typeof(x), p) == x
            @test convert(typeof(p), y) == T(y)
            @test number_eltype(typeof(p)) == eltype(x)
            @test number_eltype(p) == eltype(x)
            @test typeof(allocate(p)) == typeof(p)
            @test typeof(allocate(p, eltype(x))) == typeof(p)
            if T === ValidationMPoint
                @test typeof(allocate(p, eltype(x), (3, 1))) == T{Matrix{Float64}}
            else
                @test typeof(allocate(p, eltype(x), (3, 1))) == T{Matrix{Float64}, Nothing}
            end
            @test allocate(p) isa T
            @test allocate(p, Float32) isa T
            @test number_eltype(allocate(p, Float32)) == Float32
            @test similar(p) isa T
            @test similar(p, Float32) isa T
            @test number_eltype(similar(p, Float32)) == Float32
            q = allocate(p)
            if T == ValidationMPoint
                copyto!(A, q, p)
            else
                copyto!(A, q, ValidationMPoint(x), p) # generate base point “on the fly”
            end
            @test isapprox(A, q, p)
            @test ManifoldsBase.internal_value(p) == x
            @test ManifoldsBase.internal_value(x) == x
            @test copy(p) == p
            q = allocate(p)
            copyto!(q, p)
            @test q == p
            @test isapprox(A, q, p)
        end
    end
    @testset "Vector functions" begin
        for T in [ValidationTangentVector, ValidationCotangentVector]
            a = T(v)
            b = T(w)
            @test isapprox(A, a + b, T(v + w))
            @test isapprox(A, (a - b), T(v - w))
            @test isapprox(A, -b, T(-w))
            @test isapprox(A, +b, T(+w))
            @test isapprox(A, 2 * a, T(2 .* v))
            @test isapprox(A, a * 2, T(v .* 2))
            @test isapprox(A, 2 \ a, T(2 .\ v))
            @test isapprox(A, a / 2, T(v ./ 2))
            @test zero(a) == T(zero(v))
            @test isapprox(A, 2 .* a .+ b, T(2 .* v .+ w))
            c = similar(a)
            c .= a .+ b
            @test isapprox(A, c, a .+ b)
        end
    end
    @testset "AbstractManifold functions" begin
        @test manifold_dimension(A) == manifold_dimension(M)
        @test isapprox(y2.value, y)
        @test distance(A, x, y) == distance(M, x, y)
        @test norm(A, x, v) == norm(M, x, v)
        @test inner(A, x, v2, w2; atol = 10^(-15)) == inner(M, x, v, w)
        @test isapprox(A, x2, y2) == isapprox(M, x, y)
        @test isapprox(A, x, y) == isapprox(A, x2, y2)
        @test isapprox(A, x, v2, v2) == isapprox(M, x, v, v)
        v2s = similar(v2)
        project!(A, v2s, x2, v2)
        @test isapprox(A, v2, v2s)
        y2s = similar(y2)
        exp!(A, y2s, x2, v2)
        @test isapprox(A, y2s, y2)
        log!(A, v2s, x, y)
        @test mid_point(A, x, y) == 0.5 * (x .+ y)
        mp = similar(x)
        mid_point!(A, mp, x, y)
        @test mp == 0.5 * (x .+ y)
        @test isapprox(A, x, v2s, v2)
        @test isapprox(A, exp(A, x, v), y2)
        @test isapprox(A, zero_vector(A, x), zero_vector(M, x))
        vector_transport_to!(A, v2s, x2, v2, y2)
        @test isapprox(A, x2, v2, v2s)
        @test isapprox(A, x2, v2, vector_transport_to(A, x2, v2, y2))
        slt = ManifoldsBase.SchildsLadderTransport()
        vector_transport_to!(A, v2s, x2, v2, y2, slt)
        @test isapprox(A, x2, v2, v2s)
        @test isapprox(A, x2, v2, vector_transport_to(A, x2, v2, y2, slt))
        plt = ManifoldsBase.PoleLadderTransport()
        vector_transport_to!(A, v2s, x2, v2, y, plt)
        @test isapprox(A, x2, v2, vector_transport_to(A, x2, v2, y2, plt))
        @test isapprox(A, x2, v2, v2s)
        pt = ManifoldsBase.ProjectionTransport()
        vector_transport_to!(A, v2s, x2, v2, y2, pt)
        @test isapprox(A, x2, v2, v2s)
        @test isapprox(A, x2, v2, vector_transport_to(A, x2, v2, y2, pt))
        zero_vector!(A, v2s, x)
        @test isapprox(A, x, v2s, zero_vector(M, x))
        c2 = [x2]
        v3 = similar(v2)
        @test injectivity_radius(A) == Inf
        @test injectivity_radius(A, x) == Inf
        @test injectivity_radius(A, ManifoldsBase.ExponentialRetraction()) == Inf
        @test injectivity_radius(A, x, ManifoldsBase.ExponentialRetraction()) == Inf
        @test injectivity_radius(
            A,
            ManifoldsBaseTestSuite.CustomValidationManifoldRetraction(),
        ) == 10
        @test injectivity_radius(
            A,
            x,
            ManifoldsBaseTestSuite.CustomValidationManifoldRetraction(),
        ) == 11
    end
    @testset "ValidationManifold basis" begin
        b = [Matrix(I, 3, 3)[:, i] for i in 1:3]
        for BT in (DefaultBasis, DefaultOrthonormalBasis, DefaultOrthogonalBasis)
            @testset "Basis $(BT)" begin
                cb = BT()
                @test b == get_vectors(M, x, get_basis(A, x, cb))
                v = similar(x)
                v2 = similar(x)
                @test_throws ArgumentError get_vector(A, x, [1.0], cb)
                @test_throws DomainError get_vector(A, [1.0], [1.0, 0.0, 0.0], cb)
                @test_throws ArgumentError get_vector!(A, v, x, [], cb)
                @test_throws DomainError get_vector!(A, v, [1.0], [1.0, 0.0, 0.0], cb)
                @test_throws DomainError get_coordinates(A, x, [1.0], cb)
                @test_throws DomainError get_coordinates!(A, v, x, [], cb)
                @test_throws DomainError get_coordinates!(A, v, [1.0], [1.0, 0.0, 0.0], cb)
                @test get_vector(A, x, [1, 2, 3], cb) ≈ get_vector(M, x, [1, 2, 3], cb)
                @test get_vector!(A, v2, x, [1, 2, 3], cb) ≈
                    get_vector!(M, v, x, [1, 2, 3], cb)
                @test get_coordinates(A, x, [1, 2, 3], cb) ≈
                    get_coordinates(M, x, [1, 2, 3], cb)
                @test get_coordinates!(A, v2, x, [1, 2, 3], cb) ≈
                    get_coordinates!(M, v, x, [1, 2, 3], cb)

                @test_throws ErrorException get_basis(A, x, CachedBasis(cb, [x]))
                @test_throws ErrorException get_basis(A, x, CachedBasis(cb, [x, x, x]))
                @test_throws ErrorException get_basis(A, x, CachedBasis(cb, [2 * x, x, x]))
                if BT <: ManifoldsBase.AbstractOrthonormalBasis
                    @test_throws ArgumentError get_basis(
                        A,
                        x,
                        CachedBasis(
                            cb,
                            [[2.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]],
                        ),
                    )
                elseif BT <: ManifoldsBase.AbstractOrthogonalBasis
                    @test_throws ArgumentError get_basis(
                        A,
                        x,
                        CachedBasis(
                            cb,
                            [[1.0, 0.0, 0.0], [1.0, 1.0, 0.0], [0.0, 0.0, 1.0]],
                        ),
                    )
                end
            end
        end
    end
    @testset "Output distance an norm – on different message types" begin
        Dm = ManifoldsBaseTestSuite.ValidationDummyManifold()
        Ad = ValidationManifold(Dm)
        @test_throws DomainError distance(Ad, [], [])
        @test_throws DomainError norm(Ad, [], [])
        AdI = ValidationManifold(Dm; error = :info)
        @test_logs (:info,) distance(AdI, [], [])
        @test_logs (:info,) norm(AdI, [], [])
        AdW = ValidationManifold(Dm; error = :warn)
        @test_logs (:warn,) distance(AdW, [], [])
        @test_logs (:warn,) norm(AdW, [], [])
        AdO = ValidationManifold(Dm; ignore_contexts = [:Output])
        @test distance(AdO, [], []) == -1.0
        @test norm(AdO, [], []) == -1.0
        AdN = ValidationManifold(Dm; error = :None)
        @test distance(AdN, [], []) == -1.0
        @test norm(AdN, [], []) == -1.0
    end
    @testset "rand" begin
        Random.seed!(42)
        p = rand(A)
        @test is_point(A, p)
        X = rand(A; vector_at = p)
        @test is_vector(A, p, X)
    end
    @testset "embed and project" begin
        Dm = ManifoldsBaseTestSuite.ValidationDummyManifold()
        Ad = ValidationManifold(Dm)
        p = [0.0, 0.0, 1.0]
        X = [1.0, 0.0, 0.0]
        q = embed(Ad, p)
        @test q isa ValidationMPoint
        q2 = copy(Ad, q)
        embed!(Ad, q2, p)
        @test q2 == q
        Y = embed(Ad, p, X)
        @test Y isa ValidationTangentVector
        Y2 = copy(Ad, q, Y)
        embed!(Ad, Y2, p, X)
        @test Y2 == Y
        #
        q3 = embed_project(Ad, p)
        @test q3 isa ValidationMPoint
        q4 = copy(Ad, q3)
        embed_project!(Ad, q4, p)
        @test q3 == q4
        Y3 = embed_project(Ad, p, X)
        @test Y3 isa ValidationTangentVector
        Y4 = copy(Ad, p, Y3)
        embed_project!(Ad, Y4, p, X)
        @test Y3 == Y4
    end
    @testset "riemannian_tensor" begin
        r = riemann_tensor(M, x, x, y, z)
        r2 = riemann_tensor(A, x, x, y, z)
        @test r2 isa ValidationTangentVector
        r3 = copy(A, r2)
        r3 = riemann_tensor!(A, r3, x, x, y, z)
        @test r2 == r3
    end
    @testset "_msg defaults w/strings" begin
        @test_logs (:warn, "msg") ManifoldsBase._msg(A, "msg"; error = :warn)
        @test_logs (:info, "msg") ManifoldsBase._msg(A, "msg"; error = :info)
    end
    @testset "_update_basepoint" begin
        v = ValidationTangentVector([1.0, 0.0, 0.0], [1.0, 0.0, 0.0])
        ManifoldsBase._update_basepoint!(A, v, [0.0, 0.0, 1.0])
        @test v.point == [0.0, 0.0, 1.0]
    end
    @testset "show" begin
        As = ValidationManifold(
            M;
            ignore_contexts = [:Point],
            ignore_functions = Dict(exp => :All),
        )
        sAs = repr(As)
        @test contains(sAs, "ValidationManifold")
        @test contains(sAs, repr(Dict(exp => :All)))
        @test contains(sAs, ":Point")
    end
end

using Test
using ManifoldsBase
using ManifoldsBase: DefaultManifold, connection, decorated_manifold, is_default_connection, is_default_metric, metric

using Random

using LinearAlgebra: I, dot, Diagonal, normalize
import ManifoldsBase: default_retraction_method, connection

struct TestDefaultManifold{N} <: AbstractManifold{ℝ} end
struct TestDefaultManifoldMetric <: AbstractMetric end
struct TestScaledDefaultManifoldMetric <: AbstractMetric end
struct TestRetraction <: AbstractRetractionMethod end
struct TestConnection <: AbstractAffineConnection end

ManifoldsBase.connection(::TestDefaultManifold) = TestConnection()
ManifoldsBase.default_retraction_method(::TestDefaultManifold) = TestRetraction()
function ManifoldsBase.default_retraction_method(
        ::MetricManifold{ℝ, <:TestDefaultManifold, <:TestDefaultManifoldMetric},
    )
    return TestRetraction()
end

ManifoldsBase.manifold_dimension(::TestDefaultManifold{N}) where {N} = N
function ManifoldsBase.get_coordinates_orthogonal(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestDefaultManifoldMetric},
        ::Any,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return 1 ./ [1.0:manifold_dimension(M)...] .* X
end
function ManifoldsBase.get_coordinates_orthogonal!(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestDefaultManifoldMetric},
        c,
        ::Any,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    c .= 1 ./ [1.0:manifold_dimension(M)...] .* X
    return c
end
function ManifoldsBase.get_vector_orthonormal!(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestDefaultManifoldMetric},
        X,
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    X .= [1.0:manifold_dimension(M)...] .* c
    return X
end
function ManifoldsBase.get_coordinates_orthogonal!(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestScaledDefaultManifoldMetric},
        c,
        ::Any,
        X,
    )
    c .= 1 ./ (2 .* [1.0:manifold_dimension(M)...]) .* X
    return c
end
function ManifoldsBase.get_vector_orthogonal!(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestScaledDefaultManifoldMetric},
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    return 2 .* [1.0:manifold_dimension(M)...] .* c
end
function ManifoldsBase.get_vector_orthogonal!(
        M::MetricManifold{ℝ, <:TestDefaultManifold, <:TestScaledDefaultManifoldMetric},
        X,
        ::Any,
        c,
        ::ManifoldsBase.AbstractNumbers,
    )
    X .= 2 .* [1.0:manifold_dimension(M)...] .* c
    return X
end

struct BaseManifold{N} <: AbstractManifold{ℝ} end
struct BaseManifoldMetric{M} <: AbstractMetric end
struct DefaultBaseManifoldMetric <: AbstractMetric end
struct NotImplementedMetric <: AbstractMetric end

ManifoldsBase.manifold_dimension(::BaseManifold{N}) where {N} = N
ManifoldsBase.inner(::BaseManifold, p, X, Y) = 2 * dot(X, Y)
ManifoldsBase.representation_size(::BaseManifold{N}) where {N} = (N,)
function ManifoldsBase.rand!(rng::AbstractRNG, ::BaseManifold, p; kwargs...)
    return randn!(rng, p)
end
ManifoldsBase.get_embedding(::BaseManifold{N}) where {N} = ManifoldsBase.DefaultManifold(N)
ManifoldsBase.exp!(::BaseManifold, q, p, X) = q .= p + 2 * X
ManifoldsBase.exp_fused!(::BaseManifold, q, p, X, t::Number) = q .= p + 2 * t * X
ManifoldsBase.log!(::BaseManifold, Y, p, q) = Y .= (q - p) / 2
ManifoldsBase.project!(::BaseManifold, Y, p, X) = Y .= 2 .* X
ManifoldsBase.project!(::BaseManifold, q, p) = (q .= p)
ManifoldsBase.injectivity_radius(::BaseManifold) = Inf
ManifoldsBase.injectivity_radius(::BaseManifold, ::Any) = Inf
ManifoldsBase.injectivity_radius(::BaseManifold, ::AbstractRetractionMethod) = Inf
ManifoldsBase._injectivity_radius(::BaseManifold, ::ExponentialRetraction) = Inf
ManifoldsBase.injectivity_radius(::BaseManifold, ::Any, ::AbstractRetractionMethod) = Inf
ManifoldsBase._injectivity_radius(::BaseManifold, ::Any, ::ExponentialRetraction) = Inf
function ManifoldsBase.exp!(
        M::MetricManifold{ℝ, <:BaseManifold{N}, BaseManifoldMetric{N}},
        q,
        p,
        X,
    ) where {N}
    return exp!(base_manifold(M), q, p, X)
end
function ManifoldsBase.exp_fused!(
        M::MetricManifold{ℝ, <:BaseManifold{N}, BaseManifoldMetric{N}},
        q,
        p,
        X,
        t::Number,
    ) where {N}
    return ManifoldsBase.exp_fused!(base_manifold(M), q, p, X, t)
end
function ManifoldsBase.parallel_transport_to!(::BaseManifold, Y, p, X, q)
    return (Y .= X)
end
function ManifoldsBase.get_basis(
        ::BaseManifold{N},
        p,
        B::DefaultOrthonormalBasis{<:Any, ManifoldsBase.TangentSpaceType},
    ) where {N}
    return CachedBasis(B, [(Matrix{eltype(p)}(I, N, N)[:, i]) for i in 1:N])
end
function ManifoldsBase.get_coordinates_orthonormal!(
        ::BaseManifold,
        Y,
        p,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return Y .= X
end
function ManifoldsBase.get_vector_orthonormal!(
        ::BaseManifold,
        Y,
        p,
        X,
        ::ManifoldsBase.AbstractNumbers,
    )
    return Y .= X
end

ManifoldsBase.metric(::BaseManifold) = DefaultBaseManifoldMetric()

@testset "Metrics" begin
    # some tests failed due to insufficient accuracy for a particularly bad RNG state
    Random.seed!(42)
    @testset "Metric Basics" begin
        @test ManifoldsBase.EuclideanMetric() isa ManifoldsBase.AbstractMetric
        @test repr(MetricManifold(DefaultManifold(3), ManifoldsBase.EuclideanMetric())) ===
            "MetricManifold(DefaultManifold(3; field = ℝ), ManifoldsBase.EuclideanMetric())"
    end
    @testset "Connection Trait" begin
        E = DefaultManifold(3)
        M = ConnectionManifold(E, LeviCivitaConnection())
        @test is_default_connection(M)
        @test decorated_manifold(M) == E
        @test connection(M) == LeviCivitaConnection()
        @test is_default_connection(E, LeviCivitaConnection())
        @test !is_default_connection(TestDefaultManifold{3}(), LeviCivitaConnection())
        @test connection(TestDefaultManifold{3}()) == TestConnection()

        @test manifold_dimension(M) == manifold_dimension(E)
        @test representation_size(M) == representation_size(E)
    end

    @testset "solve_exp_ode error message" begin
        E = TestDefaultManifold{3}()
        g = TestDefaultManifoldMetric()
        M = MetricManifold(E, g)
        default_retraction_method(::TestDefaultManifold) = TestRetraction()
        @test TestDefaultManifoldMetric(E) === M
        @test g(E) === M
        p = [1.0, 2.0, 3.0]
        X = [2.0, 3.0, 4.0]
        q = similar(X)
        @test_throws MethodError exp(M, p, X)
        @test_throws MethodError ManifoldsBase.exp_fused(M, p, X, 1.0)
        @test_throws MethodError exp!(M, q, p, X)
        @test_throws MethodError ManifoldsBase.exp_fused!(M, q, p, X, 1.0)

        N = ConnectionManifold(E, LeviCivitaConnection())
        @test_throws MethodError exp(N, p, X)
        @test_throws MethodError ManifoldsBase.exp_fused(N, p, X, 1.0)
        @test_throws MethodError exp!(N, q, p, X)
        @test_throws MethodError ManifoldsBase.exp_fused!(N, q, p, X, 1.0)
    end

    @testset "Local Metric Error message" begin
        M = MetricManifold(BaseManifold{2}(), NotImplementedMetric())
        p = [3, 4]
        X = [3, 4]
        Y = [3, 4]
        Z = [3, 4]
        @test_throws MethodError inner(M, p, X, Y)
        @test_throws MethodError Weingarten(M, p, X, Y)
        @test_throws MethodError Weingarten!(M, Z, p, X, Y)
    end
    @testset "scaled DefaultManifold metric" begin
        n = 3
        E = TestDefaultManifold{n}()
        g = TestDefaultManifoldMetric()
        M = MetricManifold(E, g)
        @test repr(M) == "MetricManifold(TestDefaultManifold{3}(), TestDefaultManifoldMetric())"

        @test TestDefaultManifoldMetric()(E) === M
        @test TestDefaultManifoldMetric(E) === M
        @test connection(M) === ManifoldsBase.LeviCivitaConnection()

        @test manifold_dimension(M) == n
        @test representation_size(M) === nothing
        @test base_manifold(M) === E
        @test metric(M) === g

        p, X = randn(n), randn(n)

        @test ManifoldsBase.check_point(M, p) == ManifoldsBase.check_point(E, p)
        @test ManifoldsBase.check_vector(M, p, X) == ManifoldsBase.check_vector(E, p, X)
    end

    @testset "default_* functions" begin
        E = DefaultManifold(3)
        EM = MetricManifold(E, ManifoldsBase.EuclideanMetric())
        T = Vector{Float64}
        @test default_retraction_method(EM) === default_retraction_method(E)
        @test default_inverse_retraction_method(EM) === default_inverse_retraction_method(E)
        @test default_vector_transport_method(EM) === default_vector_transport_method(E)
        @test default_retraction_method(EM, T) == default_retraction_method(E, T)
        @test default_inverse_retraction_method(EM, T) == default_inverse_retraction_method(E, T)
        @test default_vector_transport_method(EM, T) == default_vector_transport_method(E, T)

        EC = ConnectionManifold(E, TestConnection())
        @test default_retraction_method(EC) === default_retraction_method(E)
        @test default_inverse_retraction_method(EC) === default_inverse_retraction_method(E)
        @test default_vector_transport_method(EC) === default_vector_transport_method(E)
        @test default_retraction_method(EC, T) == default_retraction_method(E, T)
        @test default_inverse_retraction_method(EC, T) == default_inverse_retraction_method(E, T)
        @test default_vector_transport_method(EC, T) == default_vector_transport_method(E, T)
    end

    @testset "is_metric_function" begin
        for f in [exp, inner, log]
            @test ManifoldsBase.is_metric_function(f)
        end
        for f in [manifold_dimension, representation_size]
            @test !ManifoldsBase.is_metric_function(f)
        end
    end

    @testset "Metric decorator" begin
        M = BaseManifold{3}()
        g = BaseManifoldMetric{3}()
        MM = MetricManifold(M, g)
        TP = Vector{Float64}

        @test DefaultBaseManifoldMetric(BaseManifold{3}()) ===
            MetricManifold(BaseManifold{3}(), DefaultBaseManifoldMetric())
        MT = DefaultBaseManifoldMetric()
        @test MT(BaseManifold{3}()) ===
            MetricManifold(BaseManifold{3}(), DefaultBaseManifoldMetric())

        g2 = DefaultBaseManifoldMetric()
        MM2 = MetricManifold(M, g2)

        @test is_default_metric(MM) == is_default_metric(base_manifold(MM), metric(MM))
        @test is_default_metric(MM2) == is_default_metric(base_manifold(MM2), metric(MM2))
        @test is_default_metric(MM2)

        @test g2(MM) === g2(M)
        @test DefaultBaseManifoldMetric(MM) === g2(M)

        @test get_embedding(MM) === get_embedding(M)
        @test get_embedding(MM, TP) === get_embedding(M, TP)

        @test convert(typeof(MM2), M) == MM2
        @test_throws ErrorException convert(typeof(MM), M)
        p = [0.1, 0.2, 0.4]
        X = [0.5, 0.7, 0.11]
        Y = [0.13, 0.17, 0.19]
        q = allocate(p)

        @test is_point(MM, rand(MM))
        @test is_point(MM, rand(Xoshiro(), MM))
        @test is_vector(MM, p, rand(MM; vector_at = p))
        rand!(MM, q)
        @test is_point(MM, q)
        @test embed(MM, p) == p
        @test embed!(MM, q, p) == q

        p2 = allocate(p)
        copyto!(MM, p2, p)
        p3 = allocate(p)
        copyto!(M, p3, p)
        @test p2 == p3
        X = zero_vector(MM, p)
        Y = allocate(X)
        copyto!(MM, Y, p, X)
        Y2 = allocate(X)
        copyto!(M, Y2, p, X)
        @test Y == Y2

        X = [0.5, 0.7, 0.11]

        @test inner(M, p, X, Y) == 2 * dot(X, Y)
        @test exp(M, p, X) == p + 2 * X
        @test ManifoldsBase.exp_fused(M, p, X, 0.5) == p + X
        @test exp(MM2, p, X) == exp(M, p, X)
        @test ManifoldsBase.exp_fused(MM2, p, X, 0.5) == ManifoldsBase.exp_fused(M, p, X, 0.5)
        @test exp!(MM, q, p, X) === exp!(M, q, p, X)
        @test ManifoldsBase.exp_fused!(MM, q, p, X, 0.5) ===
            ManifoldsBase.exp_fused!(M, q, p, X, 0.5)
        @test retract(MM, p, X) == retract(M, p, X)
        @test retract!(MM, q, p, X) === retract!(M, q, p, X)
        @test ManifoldsBase.retract_fused!(MM, q, p, X, 1) ===
            ManifoldsBase.retract_fused!(M, q, p, X, 1)
        @test ManifoldsBase.retract_fused(MM, p, X, 1) ==
            ManifoldsBase.retract_fused(M, p, X, 1)
        @test project(MM, p) == project(M, p)
        @test project(MM, p, X) == project(M, p, X)
        @test project!(MM, Y, p, X) === project!(M, Y, p, X)
        @test project!(MM, q, p) === project!(M, q, p)
        # without a definition for the metric from the embedding, no projection possible
        @test_throws MethodError log!(MM, Y, p, q) === project!(M, Y, p, q)
        @test_throws MethodError vector_transport_to!(MM, Y, p, X, q) ===
            vector_transport_to!(M, Y, p, X, q)
        # without DiffEq, these error
        @test_throws MethodError exp(MM, p, X, 1:3)
        # these always fall back anyways.
        @test zero_vector!(MM, X, p) === zero_vector!(M, X, p)

        @test default_approximation_method(MM, retract) === default_approximation_method(M, retract)

        @test injectivity_radius(MM, p) === injectivity_radius(M, p)
        @test injectivity_radius(MM) === injectivity_radius(M)
        @test injectivity_radius(MM, ProjectionRetraction()) ===
            injectivity_radius(M, ProjectionRetraction())
        @test injectivity_radius(MM, ExponentialRetraction()) ===
            injectivity_radius(M, ExponentialRetraction())
        @test injectivity_radius(MM) === injectivity_radius(M)

        @test is_point(MM, p) === is_point(M, p)
        @test is_vector(MM, p, X) === is_vector(M, p, X)

        @test inner(MM2, p, X, Y) === inner(M, p, X, Y)
        @test norm(MM2, p, X) === norm(M, p, X)
        @test distance(MM2, p, q) === distance(M, p, q)
        @test exp!(MM2, q, p, X) === exp!(M, q, p, X)
        @test exp(MM2, p, X) == exp(M, p, X)
        @test log!(MM2, X, p, q) === log!(M, X, p, q)
        @test log(MM2, p, q) == log(M, p, q)
        @test retract!(MM2, q, p, X) === retract!(M, q, p, X)
        for rm in [ExponentialRetraction(), EmbeddedRetraction(ExponentialRetraction())]
            @test retract(MM2, p, X, rm) == retract(M, p, X, rm)
            @test retract!(MM2, q, p, X, rm) === retract!(M, q, p, X, rm)
        end
        @test inverse_retract!(MM2, Y2, p, q) === inverse_retract!(M, Y2, q, p)
        shooting_ir = ShootingInverseRetraction(
            ExponentialRetraction(),
            EmbeddedInverseRetraction(LogarithmicInverseRetraction()),
            ParallelTransport(),
            4,
            1.0e-9,
            10_000,
        )
        for irm in [
                LogarithmicInverseRetraction(),
                EmbeddedInverseRetraction(LogarithmicInverseRetraction()),
                shooting_ir,
            ]
            @test inverse_retract(MM2, p, q, irm) == inverse_retract(M, q, p, irm)
            @test inverse_retract!(MM2, Y2, p, q, irm) === inverse_retract!(M, Y2, q, p, irm)
        end
        @test_throws MethodError inverse_retract(MM, p, q, shooting_ir)
        @test_throws MethodError inverse_retract(MM, p, q, LogarithmicInverseRetraction())
        @test_throws MethodError inverse_retract!(MM, Y2, p, q, LogarithmicInverseRetraction())
        @test ManifoldsBase.retract_fused!(MM2, q, p, X, 1) ===
            ManifoldsBase.retract_fused!(M, q, p, X, 1)
        @test_throws MethodError is_flat(MM)

        @test project!(MM2, q, p) === project!(M, q, p)
        @test project!(MM2, Y, p, X) === project!(M, Y, p, X)
        @test parallel_transport_to(MM2, p, X, q) == parallel_transport_to(M, q, X, p)
        @test_throws MethodError parallel_transport_to(MM, p, X, q)
        @test parallel_transport_to!(MM2, Y, p, X, q) ==
            parallel_transport_to!(M, Y, q, X, p)
        @test project!(MM2, Y, p, X) === project!(M, Y, p, X)
        @test_throws MethodError vector_transport_to(MM, p, X, q)
        @test vector_transport_to(MM2, p, X, q) == vector_transport_to(M, q, X, p)
        @test vector_transport_to!(MM2, Y, p, X, q) == vector_transport_to!(M, Y, p, X, q)

        @test_throws MethodError vector_transport_direction(MM, p, X, Y)
        @test_throws MethodError vector_transport_direction!(MM, Y2, p, X, Y)
        @test vector_transport_direction(MM2, p, X, Y) == vector_transport_to(M, p, X, Y)
        @test vector_transport_direction!(MM2, Y2, p, X, Y) == vector_transport_to!(M, Y2, p, X, Y)

        c = 2 * ones(3)
        m = ParallelTransport()
        @test zero_vector!(MM2, X, p) === zero_vector!(M, X, p)
        @test injectivity_radius(MM2, p) === injectivity_radius(M, p)
        @test injectivity_radius(MM2) === injectivity_radius(M)
        @test injectivity_radius(MM2, p, ExponentialRetraction()) ===
            injectivity_radius(M, p, ExponentialRetraction())
        @test injectivity_radius(MM2, ExponentialRetraction()) ===
            injectivity_radius(M, ExponentialRetraction())
        @test injectivity_radius(MM2, p, ProjectionRetraction()) ===
            injectivity_radius(M, p, ProjectionRetraction())
        @test injectivity_radius(MM2, ProjectionRetraction()) ===
            injectivity_radius(M, ProjectionRetraction())
        @test is_point(MM2, p) === is_point(M, p)
        @test is_vector(MM2, p, X) === is_vector(M, p, X)

        @test_throws MethodError log(MM, p, q)

        @test get_basis(M, p, DefaultOrthonormalBasis()).data ==
            get_basis(MM2, p, DefaultOrthonormalBasis()).data
        @test_throws MethodError get_basis(MM, p, DefaultOrthonormalBasis())

        @test_throws MethodError get_coordinates(MM, p, X, DefaultOrthonormalBasis())
        c2 = similar(c)
        @test_throws MethodError get_coordinates!(MM, c2, p, X, DefaultOrthonormalBasis())
        @test_throws MethodError get_vector(MM, p, c, DefaultOrthonormalBasis())
        @test_throws MethodError get_vector!(MM, Y2, p, c, DefaultOrthonormalBasis())
    end
end

"""
    AbstractManifold{𝔽}

A type to represent a (Riemannian) manifold.
The [`AbstractManifold`](@ref) is a central type of this interface.
It allows to distinguish different implementations of functions like the [`exp`](@ref)onential and
[`log`](@ref)arithmic map for different manifolds.
Usually, the manifold is the first parameter in any of these functions within `ManifoldsBase.jl`.
Based on these, say “elementary” functions, as the two mentioned above, more general functions are built,
for example the [`shortest_geodesic`](@ref) and the [`geodesic`](@ref).
These should only be overwritten (reimplemented) if for a certain manifold specific, more efficient implementations are possible, that do not just call the elementary functions.

The [`AbstractManifold`] is parametrized by [`AbstractNumbers`](@ref) to distinguish for example
real (ℝ) and complex (ℂ) manifolds.

For subtypes the preferred order of parameters is: size and simple value parameters,
followed by the [`AbstractNumbers`](@ref) `field`, followed by data type parameters,
which might depend on the abstract number field type.
"""
abstract type AbstractManifold{𝔽} end

"""
    AbstractManifoldPoint

Type for a point on a manifold.
While an [`AbstractManifold`](@ref) does not necessarily require this
type, for example when it is implemented for `Vector`s or `Matrix` type elements, this type
can be used either

* for more complicated representations,
* semantic verification, or
* when dispatching on different representations of points on a manifold.

Since semantic verification and different representations usually might still only store a
matrix internally, it is possible to use [`@manifold_element_forwards`](@ref) and
[`@default_manifold_fallbacks`](@ref) to reduce implementation overhead.
"""
abstract type AbstractManifoldPoint end

"""
    TypeParameter{T}

Represents numeric parameters of a manifold type as type parameters, allowing for static
specialization of methods.
"""
struct TypeParameter{T} end
TypeParameter(t::NTuple) = TypeParameter{Tuple{t...}}()

get_parameter(::TypeParameter{T}) where {T} = tuple(T.parameters...)
get_parameter(P) = P

"""
    wrap_type_parameter(parameter::Symbol, data)

Wrap `data` in `TypeParameter` if `parameter` is `:type` or return `data` unchanged
if `parameter` is `:field`. Intended for use in manifold constructors, see
[`DefaultManifold`](@ref) for an example.
"""
@inline function wrap_type_parameter(parameter::Symbol, data)
    if parameter === :field
        return data
    elseif parameter === :type
        TypeParameter(data)
    else
        throw(ArgumentError("Parameter can be either :field or :type. Given: $parameter"))
    end
end

"""
    VectorSpaceFiber{𝔽,M,TSpaceType} = Fiber{𝔽,TSpaceType,M}
        where {𝔽,M<:AbstractManifold,TSpaceType<:VectorSpaceType}

Alias for a [`Fiber`](@ref) when the fiber is a vector space.
"""
const VectorSpaceFiber{𝔽, M, TSpaceType} =
    Fiber{𝔽, TSpaceType, M} where {𝔽, M <: AbstractManifold, TSpaceType <: VectorSpaceType}

LinearAlgebra.norm(M::VectorSpaceFiber, X) = norm(M.manifold, M.point, X)
# disambiguation
LinearAlgebra.norm(M::VectorSpaceFiber, X::Real) = norm(M.manifold, M.point, X)

#
# Test specific error methods
#
using ManifoldsBase
using Test

@testset "Test specific Errors and their format." begin
    e = DomainError(1.0, "Norm not zero.") # a dummy
    e2 = ComponentManifoldError(1, e)

    s1 = sprint(showerror, e)
    s2 = sprint(showerror, e2)
    @test s2 == "At #1: $(s1)"

    e3 = CompositeManifoldError()
    s3 = sprint(showerror, e3)
    @test s3 == "CompositeManifoldError()\n"
    @test length(e3) == 0
    @test isempty(e3)
    @test repr(e3) == "CompositeManifoldError()"

    e4 = CompositeManifoldError([e2])
    @test repr(e4) == "CompositeManifoldError([$(repr(e2)), ])"
    s4 = sprint(showerror, e4)
    @test s4 == "CompositeManifoldError: $(s2)"

    eV = [e2, e2]
    e5 = CompositeManifoldError(eV)
    @test repr(e5) == "CompositeManifoldError([$(repr(e2)), $(repr(e2)), ])"
    s5 = sprint(showerror, e5)
    @test s5 == "CompositeManifoldError: $(s2)\n\n...and $(length(eV) - 1) more error(s).\n"

    e6 = ManifoldDomainError("A.", e)
    s6 = sprint(showerror, e6)
    @test s6 == "ManifoldDomainError: A.\n$(s1)"

    e7 = ApproximatelyError(1.0, "M.")
    s7 = sprint(showerror, e7)
    @test s7 == "ApproximatelyError with 1.0\nM.\n"
    p7 = sprint(show, e7)
    @test p7 == "ApproximatelyError(1.0, \"M.\")"
end

using ManifoldsBase
import ManifoldsBase: representation_size, manifold_dimension, inner
using LinearAlgebra
using Test

struct ComplexEuclidean{N} <: AbstractManifold{ℂ} where {N} end
ComplexEuclidean(n::Int) = ComplexEuclidean{n}()
representation_size(::ComplexEuclidean{N}) where {N} = (N,)
manifold_dimension(::ComplexEuclidean{N}) where {N} = 2N
@inline inner(::ComplexEuclidean, x, v, w) = dot(v, w)

@testset "Complex Euclidean" begin
    M = ComplexEuclidean(3)

    x = complex.([1.0, 2.0, 3.0], [4.0, 5.0, 6.0])
    v1 = complex.([0.1, 0.2, 0.3], [0.4, 0.5, 0.6])
    v2 = complex.([0.3, 0.2, 0.1], [0.6, 0.5, 0.4])

    @test norm(M, x, v1) isa Real
    @test norm(M, x, v1) ≈ norm(v1)
    @test angle(M, x, v1, v2) isa Real
    @test angle(M, x, v1, v2) ≈ acos(real(dot(v1, v2)) / norm(v1) / norm(v2))

    vv1 = vcat(reim(v1)...)
    vv2 = vcat(reim(v2)...)
    @test angle(M, x, v1, v2) ≈ acos(dot(normalize(vv1), normalize(vv2)))
end

@doc raw"""
    AbstractAffineConnection

Abstract type for affine connections on a manifold.
"""
abstract type AbstractAffineConnection end

"""
    LeviCivitaConnection

The [Levi-Civita connection](https://en.wikipedia.org/wiki/Levi-Civita_connection) of a Riemannian manifold.
"""
struct LeviCivitaConnection <: AbstractAffineConnection end

"""
    ConnectionManifold{𝔽,,M<:AbstractManifold{𝔽},G<:AbstractAffineConnection} <: AbstractDecoratorManifold{𝔽}

# Constructor

    ConnectionManifold(M, C)

Decorate the [`AbstractManifold`](@ref) `M` with [`AbstractAffineConnection`](@ref) `C`.
"""
struct ConnectionManifold{𝔽, M <: AbstractManifold{𝔽}, C <: AbstractAffineConnection} <:
    AbstractDecoratorManifold{𝔽}
    manifold::M
    connection::C
end

"""
    connection(M::AbstractManifold)

Get the connection (an object of a subtype of [`AbstractAffineConnection`](@ref))
of [`AbstractManifold`](@ref) `M`.

The global default connection is the [`LeviCivitaConnection`](@ref).
"""
connection(::AbstractManifold) = LeviCivitaConnection()

"""
    connection(M::ConnectionManifold)

Return the connection associated with [`ConnectionManifold`](@ref) `M`.
"""
connection(M::ConnectionManifold) = M.connection

decorated_manifold(M::ConnectionManifold) = M.manifold

default_retraction_method(M::ConnectionManifold) = default_retraction_method(M.manifold)
function default_retraction_method(M::ConnectionManifold, t::Type)
    return default_retraction_method(M.manifold, t)
end
function default_inverse_retraction_method(M::ConnectionManifold)
    return default_inverse_retraction_method(M.manifold)
end
function default_inverse_retraction_method(M::ConnectionManifold, t::Type)
    return default_inverse_retraction_method(M.manifold, t)
end
function default_vector_transport_method(M::ConnectionManifold)
    return default_vector_transport_method(M.manifold)
end
function default_vector_transport_method(M::ConnectionManifold, t::Type)
    return default_vector_transport_method(M.manifold, t)
end

"""
    is_default_connection(M::AbstractManifold, c::AbstractAffineConnection)

returns whether an [`AbstractAffineConnection`](@ref) is the default metric on the manifold `M` or not.

This function falls back to check whether [`connection`](@ref)`(M) == c`.
"""
is_default_connection(M::AbstractManifold, c::AbstractAffineConnection)
function is_default_connection(M::AbstractManifold, c::AbstractAffineConnection)
    return connection(M) == c
end
is_default_connection(M::ConnectionManifold) = true

manifold_dimension(M::ConnectionManifold) = manifold_dimension(M.manifold)

representation_size(M::ConnectionManifold) = representation_size(M.manifold)

using ManifoldsBase, Test

@testset "AbstractManifold with empty implementation" begin
    M = ManifoldsBase.Test.NonManifold()
    p = ManifoldsBase.Test.NonMPoint()
    v = ManifoldsBase.Test.NonTangentVector()
    @test base_manifold(M) === M
    @test number_system(M) === ℝ
    @test representation_size(M) === nothing
    @test !has_components(M)

    @test_throws MethodError manifold_dimension(M)

    # by default isapprox compares given points or vectors
    @test isapprox(M, [0], [0])
    @test isapprox(M, [0], [0]; atol = 1.0e-6)
    @test !isapprox(M, [0], [1])
    @test !isapprox(M, [0], [1]; atol = 1.0e-6)
    @test isapprox(M, [0], [0], [0])
    @test isapprox(M, [0], [0], [0]; atol = 1.0e-6)
    @test !isapprox(M, [0], [0], [1])
    @test !isapprox(M, [0], [0], [1]; atol = 1.0e-6)

    exp_retr = ManifoldsBase.ExponentialRetraction()

    @test_throws MethodError retract!(M, p, p, v)
    @test_throws MethodError retract!(M, p, p, v, exp_retr)
    @test_throws MethodError ManifoldsBase.retract_fused!(M, p, p, [0.0], 0.0)
    @test_throws MethodError ManifoldsBase.retract_fused!(M, p, p, [0.0], 0.0, exp_retr)
    @test_throws MethodError retract!(M, [0], [0], [0])
    @test_throws MethodError retract!(M, [0], [0], [0], exp_retr)
    @test_throws MethodError ManifoldsBase.retract_fused!(M, [0], [0], [0], 0.0)
    @test_throws MethodError ManifoldsBase.retract_fused!(M, [0], [0], [0], 0.0, exp_retr)
    @test_throws MethodError retract(M, [0], [0])
    @test_throws MethodError retract(M, [0], [0], exp_retr)
    @test_throws MethodError ManifoldsBase.retract_fused(M, [0], [0], 0.0)
    @test_throws MethodError ManifoldsBase.retract_fused(M, [0], [0], 0.0, exp_retr)
    @test_throws MethodError retract(M, [0.0], [0.0])
    @test_throws MethodError retract(M, [0.0], [0.0], exp_retr)
    @test_throws MethodError ManifoldsBase.retract_fused(M, [0.0], [0.0], 0.0)
    @test_throws MethodError ManifoldsBase.retract_fused(M, [0.0], [0.0], 0.0, exp_retr)
    @test_throws MethodError retract(M, [0.0], [0.0], ManifoldsBase.Test.NotImplementedRetraction())
    sr = SasakiRetraction(2)
    @test_throws MethodError ManifoldsBase.retract_fused(M, [0.0], [0.0], 0.0, sr)
    @test_throws MethodError retract(M, [0.0], [0.0], sr)

    log_invretr = ManifoldsBase.LogarithmicInverseRetraction()

    @test_throws MethodError inverse_retract!(M, p, p, p)
    @test_throws MethodError inverse_retract!(M, p, p, p, log_invretr)
    @test_throws MethodError inverse_retract!(M, [0], [0], [0])
    @test_throws MethodError inverse_retract!(M, [0], [0], [0], log_invretr)
    @test_throws MethodError inverse_retract(M, [0], [0])
    @test_throws MethodError inverse_retract(M, [0], [0], log_invretr)
    @test_throws MethodError inverse_retract(M, [0.0], [0.0])
    @test_throws MethodError inverse_retract(M, [0.0], [0.0], log_invretr)
    @test_throws MethodError inverse_retract(
        M, [0.0], [0.0], ManifoldsBase.Test.NotImplementedInverseRetraction(),
    )

    @test_throws MethodError project!(M, p, [0])
    @test_throws MethodError project!(M, [0], [0])
    @test_throws MethodError project(M, [0])

    @test_throws MethodError project!(M, v, p, [0.0])
    @test_throws MethodError project!(M, [0], [0], [0])
    @test_throws MethodError project(M, [0], [0])
    @test_throws MethodError project(M, [0.0], [0.0])

    @test_throws MethodError inner(M, p, v, v)
    @test_throws MethodError inner(M, [0], [0], [0])
    @test_throws MethodError norm(M, p, v)
    @test_throws MethodError norm(M, [0], [0])
    @test_throws MethodError angle(M, p, v, v)
    @test_throws MethodError angle(M, [0], [0], [0])

    @test_throws MethodError distance(M, [0.0], [0.0])

    @test_throws MethodError exp!(M, p, p, v)
    @test_throws MethodError ManifoldsBase.exp_fused!(M, p, p, v, 0.0)
    @test_throws MethodError exp!(M, [0], [0], [0])
    @test_throws MethodError ManifoldsBase.exp_fused!(M, [0], [0], [0], 0.0)
    @test_throws MethodError exp(M, [0], [0])
    @test_throws MethodError ManifoldsBase.exp_fused(M, [0], [0], 0.0)
    @test_throws MethodError exp(M, [0.0], [0.0])
    @test_throws MethodError ManifoldsBase.exp_fused(M, [0.0], [0.0], 0.0)

    @test_throws MethodError embed!(M, p, [0]) # no copy for NoPoint p
    @test embed!(M, [0], [0]) == [0]
    @test embed(M, [0]) == [0]

    # Identity
    @test_throws MethodError embed!(M, v, p, [0.0]) # no copyto
    @test embed!(M, [0], [0], [0]) == [0]
    @test_throws MethodError embed(M, [0], v) # no copyto
    @test embed(M, [0.0], [0.0]) == [0.0]


    @test_throws MethodError log!(M, v, p, p)
    @test_throws MethodError log!(M, [0], [0], [0])
    @test_throws MethodError log(M, [0.0], [0.0])

    @test_throws MethodError vector_transport_to!(M, [0], [0], [0], [0])
    @test_throws MethodError vector_transport_to(M, [0], [0], [0])
    @test_throws MethodError vector_transport_to!(M, [0], [0], [0], ProjectionTransport())

    @test_throws MethodError vector_transport_direction!(M, [0], [0], [0], [0])
    @test_throws MethodError vector_transport_direction(M, [0], [0], [0])

    @test_throws MethodError injectivity_radius(M)
    @test_throws MethodError injectivity_radius(M, [0])
    @test_throws MethodError injectivity_radius(M, [0], exp_retr)
    @test_throws MethodError injectivity_radius(M, exp_retr)

    @test_throws MethodError zero_vector!(M, [0], [0])
    @test_throws MethodError zero_vector(M, [0])

    @test ManifoldsBase.check_point(M, [0]) === nothing
    @test ManifoldsBase.check_point(M, p) === nothing
    @test is_point(M, [0])
    @test ManifoldsBase.check_point(M, [0]) === nothing

    @test ManifoldsBase.check_vector(M, [0], [0]) === nothing
    @test ManifoldsBase.check_vector(M, p, v) === nothing
    @test is_vector(M, [0], [0])
    @test ManifoldsBase.check_vector(M, [0], [0]) === nothing

    @test_throws MethodError hat!(M, [0], [0], [0])
    @test_throws MethodError vee!(M, [0], [0], [0])
end

"""
    AbstractNumbers

An abstract type to represent the number system on which a manifold is built.

This provides concrete number types for dispatch. The two most common number types are
the fields [`RealNumbers`](@ref) (`ℝ` for short) and [`ComplexNumbers`](@ref) (`ℂ`).
"""
abstract type AbstractNumbers end

"""
    RealNumbers <: AbstractNumbers
    ℝ = RealNumbers()

The field of real numbers.
"""
struct RealNumbers <: AbstractNumbers end

"""
    ComplexNumbers <: AbstractNumbers
    ℂ = ComplexNumbers()

The field of complex numbers.
"""
struct ComplexNumbers <: AbstractNumbers end

"""
    QuaternionNumbers <: AbstractNumbers
    ℍ = QuaternionNumbers()

The division algebra of quaternions.
"""
struct QuaternionNumbers <: AbstractNumbers end

const ℝ = RealNumbers()
const ℂ = ComplexNumbers()
const ℍ = QuaternionNumbers()

@inline function allocate_result_type(
        ::AbstractManifold{ℂ}, f::TF, args::Tuple{},
    ) where {TF}
    return ComplexF64
end

"""
    _unify_number_systems(𝔽s::AbstractNumbers...)

Compute a number system that includes all given number systems (as sub-systems) and is
closed under addition and multiplication.
"""
function _unify_number_systems(a::AbstractNumbers, rest::AbstractNumbers...)
    return _unify_number_systems(a, _unify_number_systems(rest...))
end
_unify_number_systems(𝔽::AbstractNumbers) = 𝔽
_unify_number_systems(r::RealNumbers, ::RealNumbers) = r
_unify_number_systems(::RealNumbers, c::ComplexNumbers) = c
_unify_number_systems(::RealNumbers, q::QuaternionNumbers) = q
_unify_number_systems(c::ComplexNumbers, ::RealNumbers) = c
_unify_number_systems(c::ComplexNumbers, ::ComplexNumbers) = c
_unify_number_systems(::ComplexNumbers, q::QuaternionNumbers) = q
_unify_number_systems(q::QuaternionNumbers, ::RealNumbers) = q
_unify_number_systems(q::QuaternionNumbers, ::ComplexNumbers) = q
_unify_number_systems(q::QuaternionNumbers, ::QuaternionNumbers) = q

Base.show(io::IO, ::RealNumbers) = print(io, "ℝ")
Base.show(io::IO, ::ComplexNumbers) = print(io, "ℂ")
Base.show(io::IO, ::QuaternionNumbers) = print(io, "ℍ")

@doc raw"""
    real_dimension(𝔽::AbstractNumbers)

Return the real dimension $\dim_ℝ 𝔽$ of the [`AbstractNumbers`](@ref) system `𝔽`.
The real dimension is the dimension of a real vector space with which a number in `𝔽` can be
identified.
For example, [`ComplexNumbers`](@ref) have a real dimension of 2, and
[`QuaternionNumbers`](@ref) have a real dimension of 4.
"""
function real_dimension(𝔽::AbstractNumbers)
    return error("real_dimension not defined for number system $(𝔽)")
end
real_dimension(::RealNumbers) = 1
real_dimension(::ComplexNumbers) = 2
real_dimension(::QuaternionNumbers) = 4

@doc raw"""
    number_system(M::AbstractManifold{𝔽})

Return the number system the manifold `M` is based on, i.e. the parameter `𝔽`.
"""
number_system(M::AbstractManifold{𝔽}) where {𝔽} = 𝔽

"""
    DefaultManifold <: AbstractManifold

This default manifold illustrates the main features of the interface and provides a skeleton
to build one's own manifold. It is a simplified/shortened variant of `Euclidean` from
`Manifolds.jl`.

This manifold further illustrates how to type your manifold points and tangent vectors. Note
that the interface does not require this, but it might be handy in debugging and educative
situations to verify correctness of involved variables.

# Constructor

    DefaultManifold(n::Int...; field = ℝ, parameter::Symbol = :field)


Arguments:

- `n`: shape of array representing points on the manifold.
- `field`: field over which the manifold is defined. Either `ℝ`, `ℂ` or `ℍ`.
- `parameter`: whether a type parameter should be used to store `n`. By default size
  is stored in a field. Value can either be `:field` or `:type`.
"""
struct DefaultManifold{𝔽, T} <: AbstractManifold{𝔽}
    size::T
end
function DefaultManifold(n::Vararg{Int}; field = ℝ, parameter::Symbol = :field)
    size = wrap_type_parameter(parameter, n)
    return DefaultManifold{field, typeof(size)}(size)
end

function allocation_promotion_function(
        ::DefaultManifold{ℂ},
        ::Union{typeof(get_vector), typeof(get_coordinates)},
        ::Tuple,
    )
    return complex
end

change_representer!(M::DefaultManifold, Y, ::EuclideanMetric, p, X) = copyto!(M, Y, p, X)

change_metric!(M::DefaultManifold, Y, ::EuclideanMetric, p, X) = copyto!(M, Y, p, X)

function check_approx(M::DefaultManifold, p, q; kwargs...)
    res = isapprox(p, q; kwargs...)
    res && return nothing
    v = distance(M, p, q)
    s = "The two points $p and $q on $M are not (approximately) equal."
    return ApproximatelyError(v, s)
end

function check_approx(M::DefaultManifold, p, X, Y; kwargs...)
    res = isapprox(X, Y; kwargs...)
    res && return nothing
    v = norm(M, p, X - Y)
    s = "The two tangent vectors $X and $Y in the tangent space at $p on $M are not (approximately) equal."
    return ApproximatelyError(v, s)
end


function check_point(M::DefaultManifold{𝔽}, p) where {𝔽}
    if (𝔽 === ℝ) && !(eltype(p) <: Real)
        return DomainError(
            eltype(p),
            "The matrix $(p) is not a real-valued matrix, so it does not lie on $(M).",
        )
    end
    if (𝔽 === ℂ) && !(eltype(p) <: Real) && !(eltype(p) <: Complex)
        return DomainError(
            eltype(p),
            "The matrix $(p) is neither a real- nor complex-valued matrix, so it does not lie on $(M).",
        )
    end
    return nothing
end

function check_vector(M::DefaultManifold{𝔽}, p, X; kwargs...) where {𝔽}
    if (𝔽 === ℝ) && !(eltype(X) <: Real)
        return DomainError(
            eltype(X),
            "The matrix $(X) is not a real-valued matrix, so it can not be a tangent vector to $(p) on $(M).",
        )
    end
    if (𝔽 === ℂ) && !(eltype(X) <: Real) && !(eltype(X) <: Complex)
        return DomainError(
            eltype(X),
            "The matrix $(X) is neither a real- nor complex-valued matrix, so it can not be a tangent vector to $(p) on $(M).",
        )
    end
    return nothing
end

distance(::DefaultManifold, p, q, r::Real = 2) = norm(p - q, r)

embed(::DefaultManifold, p) = p

embed(::DefaultManifold, p, X) = X

embed!(::DefaultManifold, q, p) = copyto!(q, p)

embed!(::DefaultManifold, Y, p, X) = copyto!(Y, X)

exp!(::DefaultManifold, q, p, X) = (q .= p .+ X)

for fname in [:get_basis_orthonormal, :get_basis_orthogonal, :get_basis_default]
    BD = Dict(
        :get_basis_orthonormal => :DefaultOrthonormalBasis,
        :get_basis_orthogonal => :DefaultOrthogonalBasis,
        :get_basis_default => :DefaultBasis,
    )
    BT = BD[fname]
    @eval function $fname(::DefaultManifold{ℝ}, p, N::RealNumbers)
        return CachedBasis($BT(N), [_euclidean_basis_vector(p, i) for i in eachindex(p)])
    end
    @eval function $fname(::DefaultManifold{ℂ}, p, N::ComplexNumbers)
        return CachedBasis(
            $BT(N),
            [_euclidean_basis_vector(p, i, real) for i in eachindex(p)],
        )
    end
end
function get_basis_diagonalizing(M::DefaultManifold, p, B::DiagonalizingOrthonormalBasis)
    vecs = get_vectors(M, p, get_basis(M, p, DefaultOrthonormalBasis()))
    eigenvalues = zeros(real(eltype(p)), manifold_dimension(M))
    return CachedBasis(B, DiagonalizingBasisData(B.frame_direction, eigenvalues, vecs))
end

# Complex manifold, real basis -> coefficients c are complex -> reshape
# Real manifold, real basis -> reshape
function get_coordinates_orthonormal!(M::DefaultManifold, c, p, X, N::AbstractNumbers)
    return copyto!(c, reshape(X, number_of_coordinates(M, N)))
end
function get_coordinates_diagonalizing!(
        M::DefaultManifold,
        c,
        p,
        X,
        ::DiagonalizingOrthonormalBasis{ℝ},
    )
    return copyto!(c, reshape(X, number_of_coordinates(M, ℝ)))
end
function get_coordinates_orthonormal!(::DefaultManifold{ℂ}, c, p, X, ::RealNumbers)
    m = length(X)
    return copyto!(c, [reshape(real(X), m); reshape(imag(X), m)])
end

get_embedding(M::DefaultManifold) = M

get_forwarding_type(::DefaultManifold, ::Any) = StopForwardingType()

function get_vector_orthonormal!(M::DefaultManifold, Y, p, c, ::AbstractNumbers)
    return copyto!(Y, reshape(c, representation_size(M)))
end
function get_vector_diagonalizing!(
        M::DefaultManifold,
        Y,
        p,
        c,
        ::DiagonalizingOrthonormalBasis{ℝ},
    )
    return copyto!(Y, reshape(c, representation_size(M)))
end
function get_vector_orthonormal!(M::DefaultManifold{ℂ}, Y, p, c, ::RealNumbers)
    n = div(length(c), 2)
    return copyto!(Y, reshape(c[1:n] + c[(n + 1):(2n)] * 1im, representation_size(M)))
end

has_components(::DefaultManifold) = true

injectivity_radius(::DefaultManifold) = Inf

@inline inner(::DefaultManifold, p, X, Y) = dot(X, Y)

is_flat(::DefaultManifold) = true

log!(::DefaultManifold, Y, p, q) = (Y .= q .- p)

function manifold_dimension(M::DefaultManifold{𝔽}) where {𝔽}
    size = get_parameter(M.size)
    return prod(size) * real_dimension(𝔽)
end

number_system(::DefaultManifold{𝔽}) where {𝔽} = 𝔽

norm(::DefaultManifold, p, X, r::Real = 2) = norm(X, r)

function parallel_transport_to!(::DefaultManifold, Y, p, X, q)
    return copyto!(Y, X)
end

project(::DefaultManifold, p) = p
project(::DefaultManifold, p, X) = X

project!(::DefaultManifold, q, p) = copyto!(q, p)
project!(::DefaultManifold, Y, p, X) = copyto!(Y, X)

representation_size(M::DefaultManifold) = get_parameter(M.size)

function Base.show(io::IO, M::DefaultManifold{𝔽, <:TypeParameter}) where {𝔽}
    return print(
        io,
        "DefaultManifold($(join(get_parameter(M.size), ", ")); field = $(𝔽), parameter = :type)",
    )
end
function Base.show(io::IO, M::DefaultManifold{𝔽}) where {𝔽}
    return print(io, "DefaultManifold($(join(get_parameter(M.size), ", ")); field = $(𝔽))")
end

function Random.rand!(::DefaultManifold, pX; σ = one(eltype(pX)), vector_at = nothing)
    pX .= randn(size(pX)) .* σ
    return pX
end
function Random.rand!(
        rng::AbstractRNG,
        ::DefaultManifold,
        pX;
        σ = one(eltype(pX)),
        vector_at = nothing,
    )
    pX .= randn(rng, size(pX)) .* σ
    return pX
end

function riemann_tensor!(::DefaultManifold, Xresult, p, X, Y, Z)
    return fill!(Xresult, 0)
end

sectional_curvature_max(::DefaultManifold) = 0.0
sectional_curvature_min(::DefaultManifold) = 0.0

Weingarten!(::DefaultManifold, Y, p, X, V) = fill!(Y, 0)

zero_vector(::DefaultManifold, p) = zero(p)

zero_vector!(::DefaultManifold, Y, p) = fill!(Y, 0)

using LinearAlgebra
using ManifoldsBase
using ManifoldsBase: ℝ, ℂ, DefaultManifold, RealNumbers
using Test

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))

using ManifoldsBaseTestUtils

@testset "TestSphere" begin
    @testset "ShootingInverseRetraction" begin
        vector_transports =
            [ScaledVectorTransport(ProjectionTransport()), PoleLadderTransport()]
        num_transport_points = [2, 4]
        @testset for M in [TestSphere(2), TestSphere(3, ℂ)]
            T = number_system(M) === ℝ ? Float64 : ComplexF64
            p = project(M, randn(T, representation_size(M)))
            X = project(M, p, randn(T, representation_size(M)))
            X ./= norm(M, p, X)
            q = exp(M, p, X)
            @testset for vector_transport in vector_transports, ntp in num_transport_points
                inverse_retraction = ShootingInverseRetraction(
                    ExponentialRetraction(),
                    ProjectionInverseRetraction(),
                    vector_transport,
                    ntp,
                    1.0e-9,
                    10_000,
                )
                Y = inverse_retract(M, p, q, inverse_retraction)
                @test isapprox(M, p, Y, X; atol = 1.0e-3)
                Y2 = similar(Y)
                inverse_retract!(M, Y2, p, q, inverse_retraction)
                @test isapprox(M, p, Y2, Y)
            end

            @testset "isapprox" begin
                @test_logs (:info,) !isapprox(M, p, q; error = :info)
                @test_logs (:info,) !isapprox(M, p, X, zero_vector(M, p); error = :info)
            end
        end
    end
    @testset "Weingarten" begin
        M = TestSphere(2)
        p = [1.0, 0.0, 0.0]
        X = [0.0, 0.2, 0.0]
        V = [0.1, 0.0, 0.0] #orthogonal to TpM -> parallel to p
        @test isapprox(M, p, Weingarten(M, p, X, V), -0.1 * X)
    end
    @testset "Tangent Space" begin
        M = TestSphere(2)
        p = [1.0, 0.0, 0.0]
        X = [0.0, 0.2, 0.0]
        TpM = TangentSpace(M, p)
        @test is_point(TpM, X)
        @test !is_point(TpM, p)
        @test is_vector(TpM, X, X)
        @test !is_vector(TpM, X, p)
        @test zero_vector(TpM) == zero_vector(M, p)
    end
end

#
# Test the specific vector trnasport along implementations that do iterative transport,
# also the Schild and pole special cases
#
using ManifoldsBase, Test
import ManifoldsBase: parallel_transport_to!

struct NonDefaultEuclidean <: AbstractManifold{ManifoldsBase.ℝ} end
ManifoldsBase.log!(::NonDefaultEuclidean, v, x, y) = (v .= y .- x)
ManifoldsBase.exp!(::NonDefaultEuclidean, y, x, v) = (y .= x .+ v)
function ManifoldsBase.parallel_transport_to!(::NonDefaultEuclidean, Y, p, X, q; a = 0)
    return copyto!(Y, X .+ a)
end

@testset "vector-transport fallback types" begin
    VT = VectorTransportDirection()
    M = NonDefaultEuclidean()
    p = [1.0, 0.0, 0.0]
    q = [0.0, 1.0, 0.0]
    X = [0.0, 0.0, 1.0]
    Y = similar(X)
    @test vector_transport_direction(M, p, X, p - q, VT) == X
    @test vector_transport_direction!(M, Y, p, X, p - q, VT) == X
    VT2 = VectorTransportTo()
    @test vector_transport_to(M, p, X, q, VT2) == X
    @test vector_transport_to!(M, Y, p, X, q, VT2) == X
    VT3 = VectorTransportWithKeywords(VT; a = 1)
    @test vector_transport_direction(M, p, X, q, VT3) == (X .+ 1)
    @test vector_transport_direction!(M, Y, p, X, q, VT3) == (X .+ 1)
    VT4 = VectorTransportWithKeywords(VT2; a = 2)
    @test vector_transport_to(M, p, X, q, VT4) == (X .+ 2)
    @test vector_transport_to!(M, Y, p, X, q, VT4) == (X .+ 2)
end

@doc raw"""
    AbstractApproximationMethod

Abstract type for defining estimation methods on manifolds.
"""
abstract type AbstractApproximationMethod end

@doc raw"""
    GradientDescentEstimation <: AbstractApproximationMethod

Method for estimation using [gradient descent](https://en.wikipedia.org/wiki/Gradient_descent).
"""
struct GradientDescentEstimation <: AbstractApproximationMethod end

@doc raw"""
    CyclicProximalPointEstimation <: AbstractApproximationMethod

Method for estimation using the cyclic proximal point technique, which is based on [proximal maps](https://en.wikipedia.org/wiki/Proximal_operator).
"""
struct CyclicProximalPointEstimation <: AbstractApproximationMethod end

@doc raw"""
    EfficientEstimator <: AbstractApproximationMethod

Method for estimation in the best possible sense, see [Efficiency (Statistics)](https://en.wikipedia.org/wiki/Efficiency_(statistics)) for more details.
This can for example be used when computing the usual mean on an Euclidean space, which is the best estimator.
"""
struct EfficientEstimator <: AbstractApproximationMethod end


@doc raw"""
    ExtrinsicEstimation{T} <: AbstractApproximationMethod

Method for estimation in the ambient space with a method of type `T` and projecting the result back
to the manifold.
"""
struct ExtrinsicEstimation{T <: AbstractApproximationMethod} <: AbstractApproximationMethod
    extrinsic_estimation::T
end

@doc raw"""
    WeiszfeldEstimation <: AbstractApproximationMethod

Method for estimation using the Weiszfeld algorithm, compare for example the computation of the
[Geometric median](https://en.wikipedia.org/wiki/Geometric_median).
"""
struct WeiszfeldEstimation <: AbstractApproximationMethod end

@doc raw"""
    GeodesicInterpolation <: AbstractApproximationMethod

Method for estimation based on geodesic interpolation.
"""
struct GeodesicInterpolation <: AbstractApproximationMethod end

@doc raw"""
    GeodesicInterpolationWithinRadius{T} <: AbstractApproximationMethod

Method for estimation based on geodesic interpolation that is restricted to some `radius`

# Constructor

    GeodesicInterpolationWithinRadius(radius::Real)
"""
struct GeodesicInterpolationWithinRadius{T <: Real} <: AbstractApproximationMethod
    radius::T
    function GeodesicInterpolationWithinRadius(radius::T) where {T <: Real}
        radius > 0 && return new{T}(radius)
        return throw(
            DomainError("The radius must be strictly positive, received $(radius)."),
        )
    end
end

@doc raw"""
    default_approximation_method(M::AbstractManifold, f)
    default_approximation_method(M::AbstractManifold, f, T)

Specify a default estimation method for an [`AbstractManifold`](@ref) and a specific function `f`
and optionally as well a type `T` to distinguish different (point or vector) representations on `M`.

By default, all functions `f` call the signature for just a manifold.
The exceptional functions are:

* `retract` and `retract!` which fall back to [`default_retraction_method`](@ref)
* `inverse_retract` and `inverse_retract!` which fall back to [`default_inverse_retraction_method`](@ref)
* any of the vector transport methods fall back to [`default_vector_transport_method`](@ref)
"""
default_approximation_method(M::AbstractManifold, f)
default_approximation_method(M::AbstractManifold, f, T) = default_approximation_method(M, f)

using Aqua, ManifoldsBase, Test

@testset "Aqua.jl" begin
    Aqua.test_all(
        ManifoldsBase;
        ambiguities = (
            exclude = [
                allocate, # has many possible call patterns that are not supported and ambiguous
                getindex, # ambiguous call patterns are not supported
                setindex!, # ambiguous call patterns are not supported
            ], broken = false,
        ),
    )
end

using Test
using ManifoldsBase
using ManifoldsBase: DefaultManifold, submanifold_component, submanifold_components
using ManifoldsBase:
    AbstractNumbers, ℝ, ℂ, NestedReplacingPowerRepresentation, ProductBasisData
using LinearAlgebra
using Random

@testset "Product manifold without RecursiveArrayTools.jl" begin
    M1 = ManifoldsBase.Test.TestSphere(2)
    M2 = ManifoldsBase.DefaultManifold(2, 2)

    M = ProductManifold(M1, M2)
    @test_throws ErrorException rand(M)
end

using RecursiveArrayTools

@testset "Product manifold" begin
    M1 = ManifoldsBase.Test.TestSphere(2)
    M2 = ManifoldsBase.DefaultManifold(2, 2)
    @test (@inferred ProductManifold(M1, M2)) isa ProductManifold

    M = ProductManifold(M1, M2)

    @test_throws MethodError ProductManifold()

    p1 = ArrayPartition([1, 0.0, 0.0], [4.0 5.0; 6.0 7.0])
    p2 = ArrayPartition([0.0, 1.0, 0.0], [4.0 8.0; 3.0 7.5])
    X1 = ArrayPartition([0.0, 1.0, 0.2], [4.0 0.0; 2.0 7.0])

    @test !is_flat(M)
    @test has_components(M)
    @test M[1] == M1
    @test M[2] == M2
    @test injectivity_radius(M) ≈ π
    @test injectivity_radius(
        M,
        ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
    ) ≈ π
    @test injectivity_radius(M, ExponentialRetraction()) ≈ π
    @test injectivity_radius(
        M,
        p1,
        ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
    ) ≈ π
    @test injectivity_radius(M, p1) ≈ π
    @test injectivity_radius(M, p1, ExponentialRetraction()) ≈ π

    @test ManifoldsBase.number_of_components(M) == 2
    @test ManifoldsBase.submanifold(M, 1) === M1
    @test ManifoldsBase.submanifold(M, [2, 1]) === ProductManifold(M2, M1)
    @test ManifoldsBase.check_point(M, p1) === nothing
    @test ManifoldsBase.check_vector(M, p1, X1) === nothing
    # test that arrays are not points
    @test_throws DomainError is_point(M, [1, 2], true)
    @test ManifoldsBase.check_point(M, [1, 2]) isa DomainError
    @test_throws DomainError is_vector(
        M,
        1,
        [1, 2];
        error = :error,
        check_base_point = false,
    )
    @test ManifoldsBase.check_vector(M, 1, [1, 2]; check_base_point = false) isa DomainError
    #default fallbacks for check_size, Product not working with Arrays
    @test ManifoldsBase.check_size(M, zeros(2)) isa DomainError
    @test ManifoldsBase.check_size(M, zeros(2), zeros(3)) isa DomainError

    retraction_methods = [
        ManifoldsBase.ProductRetraction(
            ManifoldsBase.ExponentialRetraction(),
            ManifoldsBase.ExponentialRetraction(),
        ),
    ]
    inverse_retraction_methods = [
        ManifoldsBase.InverseProductRetraction(
            ManifoldsBase.LogarithmicInverseRetraction(),
            ManifoldsBase.LogarithmicInverseRetraction(),
        ),
    ]

    @test ManifoldsBase.default_retraction_method(M) === retraction_methods[1]
    @test ManifoldsBase.default_retraction_method(M, typeof(p1)) === retraction_methods[1]
    @test ManifoldsBase.default_inverse_retraction_method(M) ===
        inverse_retraction_methods[1]
    @test ManifoldsBase.default_inverse_retraction_method(M, typeof(X1)) ===
        inverse_retraction_methods[1]
    @test ManifoldsBase.default_inverse_retraction_method(M, typeof(p1)) ===
        inverse_retraction_methods[1]

    @testset "get_component, set_component!, getindex and setindex!" begin
        @test get_component(M, p1, 1) == p1.x[1]
        @test get_component(M, p1, Val(1)) == p1.x[1]
        @test p1[M, 1] == p1.x[1]
        @test p1[M, Val(1)] == p1.x[1]
        @test p1[M, 1] isa Vector
        @test p1[M, Val(1)] isa Vector
        p2c = [5 6; 4 0]
        set_component!(M, p1, p2c, 2)
        @test get_component(M, p1, 2) == p2c
        p1[M, 2] = 2 * p2c
        @test p1[M, 2] == 2 * p2c
        p3 = [11.0 15.0; 3 3]
        set_component!(M, p1, p3, Val(2))
        @test get_component(M, p1, Val(2)) == p3
        p1[M, Val(2)] = 2 * p3
        @test p1[M, Val(2)] == 2 * p3

        p1c = copy(p1)
        p1c.x[1][1] = -123.0
        @test p1c.x[1][1] == -123.0
        @test p1.x[1][1] == 1.0
        copyto!(p1c, p1)
        @test p1c.x[1][1] == 1.0

        p1c.x[1][1] = -123.0
        copyto!(p1, p1c)
        @test p1.x[1][1] == -123.0
    end

    @testset "some ArrayPartition functions" begin
        q = allocate(p1)
        @test q.x[1] isa Vector
        p = ArrayPartition([[0.0, 1.0, 0.0]], [0.0, 0.0])
        q = allocate(p, Int)
        @test q.x[1] isa Vector{Vector{Int}}

        q = allocate(p1)
        copyto!(M, q, p1)
        @test isapprox(q, p1)
        @test ManifoldsBase.allocate_result(M, zero_vector) isa ArrayPartition
    end

    @testset "allocate on PowerManifold of ProductManifold" begin
        q = allocate([p1])
        @test q[1] isa ArrayPartition
        @test q[1].x[1] isa Vector
    end

    @testset "allocate_on" begin
        p1 = allocate_on(M)
        @test p1 isa ArrayPartition{Float64, Tuple{Vector{Float64}, Matrix{Float64}}}

        p1 = allocate_on(M, ArrayPartition{Float32, Tuple{Vector{Float32}, Matrix{Float32}}})
        @test p1 isa ArrayPartition{Float32, Tuple{Vector{Float32}, Matrix{Float32}}}

        p1 = allocate_on(M, ArrayPartition)
        @test p1 isa ArrayPartition{Float64, Tuple{Vector{Float64}, Matrix{Float64}}}

        X1 = allocate_on(M, TangentSpaceType())
        @test X1 isa ArrayPartition{Float64, Tuple{Vector{Float64}, Matrix{Float64}}}

        X1 = allocate_on(
            M,
            TangentSpaceType(),
            ArrayPartition{Float32, Tuple{Vector{Float32}, Matrix{Float32}}},
        )
        @test X1 isa ArrayPartition{Float32, Tuple{Vector{Float32}, Matrix{Float32}}}

        X1 = allocate_on(M, TangentSpaceType(), ArrayPartition)
        @test X1 isa ArrayPartition{Float64, Tuple{Vector{Float64}, Matrix{Float64}}}
    end

    p1 = ArrayPartition([1.0, 0.0, 0.0], [4.0 5.0; 6.0 7.0])
    p2 = ArrayPartition(1 / sqrt(2) .* [1.0, 1.0, 0.0], [4.0 8.0; 3.0 7.5])
    X1 = ArrayPartition([0.0, 1.0, 0.2], [4.0 0.0; 2.0 7.0])
    X2 = ArrayPartition([0.0, -1.0, 0.4], [3.0 1.0; -2.0 2.0])
    d1 = distance(M1, p1.x[1], p2.x[1])
    d1r = distance(M1, p1.x[1], p2.x[1], ProjectionInverseRetraction())
    d2 = distance(M2, p1.x[2], p2.x[2])
    @testset "Basic operations" begin
        @test manifold_dimension(M) == 6
        @test representation_size(M) === nothing
        @test distance(M, p1, p2) ≈ norm([d1, d2])
        @test distance(M, p1, p2, 1) ≈ norm([d1, d2], 1)
        @test distance(M, p1, p2, Inf) ≈ norm([d1, d2], Inf)
        # Fallback log
        m1 = LogarithmicInverseRetraction()
        @test distance(M, p1, p2, m1) ≈ norm([d1, d2])
        @test distance(M, p1, p2, m1, 1) ≈ norm([d1, d2], 1)
        @test distance(M, p1, p2, m1, Inf) ≈ norm([d1, d2], Inf)
        m2 = InverseProductRetraction(
            ProjectionInverseRetraction(),
            LogarithmicInverseRetraction(),
        )
        @test distance(M, p1, p2, m2) ≈ norm([d1r, d2])
        @test distance(M, p1, p2, m2, 1) ≈ norm([d1r, d2], 1)
        @test distance(M, p1, p2, m2, Inf) ≈ norm([d1r, d2], Inf)
        qr = similar(p1)
        exp!(M, qr, p1, X1)
        @test exp(M, p1, X1) ≈
            ArrayPartition(exp(M1, p1[M, 1], X1[M, 1]), exp(M2, p1[M, 2], X1[M, 2]))
        @test exp(M, p1, X1) ≈ qr
        @test ManifoldsBase.exp_fused(M, p1, X1, 2.0) ≈ exp(M, p1, 2 * X1)
        ManifoldsBase.exp_fused!(M, qr, p1, X1, 2.0)
        @test qr ≈ exp(M, p1, 2 * X1)
        @test qr ≈ retract(
            M,
            p1,
            2 * X1,
            ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
        )
        # single retraction gets “broadcasted”
        @test qr ≈ retract(M, p1, 2 * X1, ExponentialRetraction())
        qr2 = similar(p1)
        retract!(
            M,
            qr2,
            p1,
            2 * X1,
            ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
        )
        @test qr2 ≈ qr
        qr3a = similar(p1)
        ManifoldsBase.retract_fused!(
            M,
            qr3a,
            p1,
            2 * X1,
            1.0,
            ProductRetraction(ExponentialRetraction(), ExponentialRetraction()),
        )
        @test qr3a ≈ qr
        qr3b = similar(p1)
        ManifoldsBase.retract_fused!(M, qr3b, p1, 2 * X1, 1.0, ExponentialRetraction())
        @test qr3b ≈ qr
        qr4 = similar(p1)
        retract!(M, qr4, p1, 2 * X1, ExponentialRetraction())
        @test qr4 ≈ qr
        Xr = similar(X1)
        log!(M, Xr, p1, p2)
        @test log(M, p1, p2) ≈ ArrayPartition([0.0, π / 4, 0.0], [0.0 3.0; -3.0 0.5])
        @test log(M, p1, p2) ≈ Xr
        @test inverse_retract(
            M,
            p1,
            p2,
            InverseProductRetraction(
                LogarithmicInverseRetraction(),
                LogarithmicInverseRetraction(),
            ),
        ) ≈ Xr
        # single inverse retraction gets “broadcasted”
        @test inverse_retract(M, p1, p2, LogarithmicInverseRetraction()) ≈ Xr

        Zr = similar(X1)
        inverse_retract!(
            M,
            Zr,
            p1,
            p2,
            InverseProductRetraction(
                LogarithmicInverseRetraction(),
                LogarithmicInverseRetraction(),
            ),
        )
        @test Zr ≈ Xr
        Zr2 = similar(X1)
        inverse_retract!(M, Zr2, p1, p2, LogarithmicInverseRetraction())
        @test Zr2 ≈ Xr
        @test inner(M, p1, X1, X2) ≈ 21.08
        @test norm(M, p1, X1) ≈ sqrt(70.04)
        @test project(M, p1) ≈ p1
        q1 = similar(p1)
        project!(M, q1, p1)
        @test q1 ≈ p1
        @test project(M, p1, X1) ≈ X1
        Y1 = similar(X1)
        project!(M, Y1, p1, X1)
        @test X1 ≈ Y1
        @test zero_vector(M, p1) == zero(X1)

        @test rand(M) isa ArrayPartition
        @test rand(M; vector_at = p1) isa ArrayPartition
        @test rand(Random.default_rng(), M) isa ArrayPartition
        @test rand(Random.default_rng(), M; vector_at = p1) isa ArrayPartition
        @test is_point(M, rand!(M, q1))
        @test is_vector(M, p1, rand!(M, Y1; vector_at = p1))

        #explicit mid point test
        q = ArrayPartition(
            mid_point(
                M1,
                ManifoldsBase.submanifold_components(M, p1)[1],
                ManifoldsBase.submanifold_components(M, p2)[1],
            ),
            mid_point(
                M2,
                ManifoldsBase.submanifold_components(M, p1)[2],
                ManifoldsBase.submanifold_components(M, p2)[2],
            ),
        )
        q2 = copy(M, p1)
        mid_point!(M, q2, p1, p2)
        @test isapprox(M, q, q2)
    end

    @testset "Broadcasting" begin
        br_result = p1 .+ 2.0 .* p2
        @test br_result isa ArrayPartition
        @test br_result.x[1] ≈ [1 + sqrt(2), sqrt(2), 0.0]
        @test br_result.x[2] ≈ [12.0 21.0; 12.0 22.0]

        br_result .= 2.0 .* p1 .+ p2
        @test br_result.x[1] ≈ [2.0 + 1 / sqrt(2), 1 / sqrt(2), 0.0]
        @test br_result.x[2] ≈ [12.0 18.0; 15.0 21.5]

        br_result .= p1
        @test br_result.x[1] ≈ p1.x[1]
        @test br_result.x[2] ≈ p1.x[2]

        @test axes(p1) == (Base.OneTo(7),)

        @test ManifoldsBase._get_vector_cache_broadcast(p1) === Val(false)

        # errors
        p3 = ArrayPartition([3.0, 4.0, 5.0], [2.0, 5.0], [3.0, 2.0])
        @test_throws DimensionMismatch p1 .+ p3
        @test_throws DimensionMismatch p1 .= p3
    end

    @testset "CompositeManifoldError" begin
        Mpr = ProductManifold(M1, M1)
        let p1 = [1.0, 0.0, 0.0],
                p2 = [0.0, 1.0, 0.0],
                X1 = [0.0, 1.0, 0.2],
                X2 = [1.0, 0.0, 0.2]

            p = ArrayPartition(p1, p2)
            X = ArrayPartition(X1, X2)
            pf = ArrayPartition(p1, X1)
            Xf = ArrayPartition(X1, p2)
            @test is_point(Mpr, p, true)
            @test_throws CompositeManifoldError is_point(Mpr, X, true)
            @test_throws ComponentManifoldError is_vector(Mpr, pf, X; error = :error)
            @test_throws ComponentManifoldError is_vector(Mpr, p, Xf; error = :error)
        end
    end

    @testset "Weingarten" begin
        Mpr = ProductManifold(M1, M1)
        p = [1.0, 0.0, 0.0]
        X = [0.0, 0.2, 0.0]
        V = [0.1, 0.0, 0.0] #orthogonal to TpM -> parallel to p
        @test isapprox(
            M,
            Weingarten(
                Mpr,
                ArrayPartition(p, p),
                ArrayPartition(X, X),
                ArrayPartition(V, V),
            ),
            ArrayPartition(-0.1 * X, -0.1 * X),
        )
    end

    @testset "arithmetic" begin
        a = 1 / sqrt(2)
        @test isapprox(M, p1 + p2, ArrayPartition([1.0 + a, a, 0.0], [8.0 13.0; 9.0 14.5]))
        @test isapprox(M, p1 - p2, ArrayPartition([1.0 - a, -a, 0.0], [0.0 -3.0; 3.0 -0.5]))
        @test isapprox(M, -p1, ArrayPartition([-1.0, -0.0, -0.0], [-4.0 -5.0; -6.0 -7.0]))
        @test isapprox(M, p1 * 2, ArrayPartition([2.0, 0.0, 0.0], [8.0 10.0; 12.0 14.0]))
        @test isapprox(M, 2 * p1, ArrayPartition([2.0, 0.0, 0.0], [8.0 10.0; 12.0 14.0]))
        @test isapprox(M, p1 / 2, ArrayPartition([0.5, 0.0, 0.0], [2.0 2.5; 3.0 3.5]))
    end

    @testset "Show methods" begin
        M2p = ProductManifold(M1, M1, M2, M2)
        @test sprint(show, M2p) == "ProductManifold($(M1), $(M1), $(M2), $(M2))"
        withenv("LINES" => 10, "COLUMNS" => 100) do
            @test sprint(show, "text/plain", ProductManifold(M1)) ==
                "ProductManifold with 1 submanifold:\n $(M1)"
            @test sprint(show, "text/plain", M2p) ==
                "ProductManifold with 4 submanifolds:\n $(M1)\n $(M1)\n $(M2)\n $(M2)"
            return nothing
        end
        withenv("LINES" => 7, "COLUMNS" => 100) do
            @test sprint(show, "text/plain", M2p) ==
                "ProductManifold with 4 submanifolds:\n $(M1)\n ⋮\n $(M2)"
            return nothing
        end

        @test sprint(show, "text/plain", ProductManifold(M, M)) == """
            ProductManifold with 2 submanifolds:
             ProductManifold($(M1), $(M2))
             ProductManifold($(M1), $(M2))"""
    end

    @testset "Change Representer and Metric" begin
        G = ManifoldsBase.EuclideanMetric()
        @test change_representer(M, G, p1, X1) == X1
        Y1 = similar(X1)
        change_representer!(M, Y1, G, p1, X1)
        @test isapprox(M, p1, Y1, X1)
        @test change_metric(M, G, p1, X1) == X1
        Z1 = similar(X1)
        change_metric!(M, Z1, G, p1, X1)
        @test isapprox(M, p1, Z1, X1)
    end

    @testset "product vector transport" begin
        X = log(M, p1, p2)
        m = ProductVectorTransport(ParallelTransport(), ParallelTransport())
        @test default_vector_transport_method(M) === m
        @test default_vector_transport_method(M, typeof(X)) === m
        Y = vector_transport_to(M, p1, X, p2, m)
        Y2 = similar(Y)
        vector_transport_to!(M, Y2, p1, X, p2, m)
        Z = -log(M, p2, p1)
        @test isapprox(M, p2, Y, Z)
        @test isapprox(M, p2, Y2, Z)

        Y3 = vector_transport_direction(M, p1, X, X, m)
        Y4 = similar(Y)
        vector_transport_direction!(M, Y4, p1, X, X, m)
        Y5 = similar(Y)
        vector_transport_direction!(M, Y5, p1, X, X, ParallelTransport())
        @test isapprox(M, p2, Y3, Z)
        @test isapprox(M, p2, Y4, Z)
        @test isapprox(M, p2, Y5, Z)
    end

    @testset "Implicit product vector transport" begin
        p = ArrayPartition([1, 0.0, 0.0], [4 5.0; 6 7])
        q = ArrayPartition([0.0, 1.0, 0.0], [4 8.0; 3 7.5])

        X = log(M, p, q)
        for m in [ParallelTransport(), SchildsLadderTransport(), PoleLadderTransport()]
            Y = vector_transport_to(M, p, X, q, m)
            Z1 = vector_transport_to(
                M.manifolds[1],
                submanifold_component.([p, X, q], Ref(1))...,
                m,
            )
            Z2 = vector_transport_to(
                M.manifolds[2],
                submanifold_component.([p, X, q], Ref(2))...,
                m,
            )
            Z = ArrayPartition(Z1, Z2)
            @test isapprox(M, q, Y, Z)
            Y2 = allocate(M, Y)
            vector_transport_to!(M, Y2, p, X, q, m)
            @test isapprox(M, q, Y2, Z)
        end
        for m in [ParallelTransport(), SchildsLadderTransport(), PoleLadderTransport()]
            Y = vector_transport_direction(M, p, X, X, m)
            Z1 = vector_transport_direction(
                M.manifolds[1],
                submanifold_component.([p, X, X], Ref(1))...,
                m,
            )
            Z2 = vector_transport_direction(
                M.manifolds[2],
                submanifold_component.([p, X, X], Ref(2))...,
                m,
            )
            Z = ArrayPartition(Z1, Z2)
            @test isapprox(M, q, Y, Z)
        end
    end

    @testset "Parallel transport" begin
        p = ArrayPartition([1, 0.0, 0.0], [4 5.0; 6 7])
        q = ArrayPartition([0.0, 1.0, 0.0], [4 8.0; 3 7.5])

        X = log(M, p, q)
        # to
        Y = parallel_transport_to(M, p, X, q)
        Z1 = parallel_transport_to(
            M.manifolds[1],
            submanifold_component.([p, X, q], Ref(1))...,
        )
        Z2 = parallel_transport_to(
            M.manifolds[2],
            submanifold_component.([p, X, q], Ref(2))...,
        )
        Z = ArrayPartition(Z1, Z2)
        @test isapprox(M, q, Y, Z)
        Ym = allocate(Y)
        parallel_transport_to!(M, Ym, p, X, q)
        @test isapprox(M, q, Y, Z)

        # direction
        Y = parallel_transport_direction(M, p, X, X)
        Z1 = parallel_transport_direction(
            M.manifolds[1],
            submanifold_component.([p, X, X], Ref(1))...,
        )
        Z2 = parallel_transport_direction(
            M.manifolds[2],
            submanifold_component.([p, X, X], Ref(2))...,
        )
        Z = ArrayPartition(Z1, Z2)
        @test isapprox(M, q, Y, Z)
        Ym = allocate(Y)
        parallel_transport_direction!(M, Ym, p, X, X)
        @test isapprox(M, q, Ym, Z)
    end

    @testset "ArrayPartition" begin
        @test submanifold_component(M, p1, 1) === p1.x[1]
        # @invoke to test that the generic fallback is used, which should behave the same as the specialized version
        @test (@invoke submanifold_component(M, p1::Any, 1)) === p1.x[1]
        @test submanifold_component(M, p1, Val(1)) === p1.x[1]
        @test submanifold_component(p1, 1) === p1.x[1]
        @test (@invoke submanifold_component(p1::Any, 1)) === p1.x[1]
        @test submanifold_component(p1, Val(1)) === p1.x[1]
        @test submanifold_components(M, p1) === p1.x
        @test submanifold_components(p1) === p1.x
    end

    @testset "vee/hat" begin
        X = [0.1, 0.2, 0.3, -1.0, 2.0, -3.0]

        Xc = hat(M, p1, X)
        X2 = vee(M, p1, Xc)
        @test isapprox(X, X2)
    end

    @testset "get_coordinates" begin
        # make sure `get_coordinates` does not return an `ArrayPartition`
        p1 = ArrayPartition([0.0, 1.0, 0.0], [0.0 0.0; 1.0 2.0])
        X1 = ArrayPartition([1.0, 0.0, -1.0], [1.0 0.0; 2.0 1.0])
        Tp1M = TangentSpace(M, p1)
        c = get_coordinates(Tp1M, p1, X1, DefaultOrthonormalBasis())
        @test c isa Vector

        p1 = ArrayPartition([0.0, 1.0, 0.0], [0.0 0.0; 3.0 20])
        X1ap = ArrayPartition([1.0, 0.0, -1.0], [1.0 0.0; 0.0 3.0])
        Tp1M = TangentSpace(M, p1)
        cap = get_coordinates(Tp1M, p1, X1ap, DefaultOrthonormalBasis())
        @test cap isa Vector
    end

    @testset "Basis printing" begin
        p = ArrayPartition([1.0, 0.0, 0.0], [1.0 0.0; 1.0 2.0])
        B = DefaultOrthonormalBasis()
        Bc = get_basis(M, p, B)
        Bc_components_s = sprint.(show, "text/plain", Bc.data.parts)
        @test sprint(show, "text/plain", Bc) == """
            $(typeof(B)) for a product manifold
            Basis for component 1:
            $(Bc_components_s[1])
            Basis for component 2:
            $(Bc_components_s[2])
            """
    end

    @testset "Basis-related errors" begin
        a = ArrayPartition([1.0, 0.0, 0.0], [0.0 0.0; 0.0 0.0])
        B = CachedBasis(DefaultOrthonormalBasis(), ProductBasisData(([],)))
        @test_throws AssertionError get_vector!(
            M,
            a,
            ArrayPartition([1.0, 0.0, 0.0], [0.0, 0.0]),
            [1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0], # this is one element too long, hence assertion error
            B,
        )
        @test_throws MethodError get_vector!(
            M,
            a,
            ArrayPartition([1.0, 0.0, 0.0], [0.0 0.0; 0.0 0.0]),
            [1.0, 2.0, 3.0, 4.0, 5.0, 6.0],
            B, # empty elements yield a submanifold MethodError
        )
    end

    @testset "Basis -- other" begin
        p1 = ArrayPartition([1.0, 0.0, 0.0], [1.0 0.0; 1.0 2.0])
        X1 = ArrayPartition([0.0, 2.0, -1.0], [1.0 0.0; 2.0 1.0])
        B = DefaultOrthonormalBasis()
        Bc = get_basis(M, p1, B)

        BcO = get_basis(M, p1, DiagonalizingOrthonormalBasis(X1))
        @test BcO.data isa ProductBasisData

        for basis in
            [DefaultOrthonormalBasis(), get_basis(M, p1, DefaultOrthonormalBasis())]
            @test length(get_vectors(M, p1, get_basis(M, p1, basis))) == 6
            X1c = get_coordinates(M, p1, X1, basis)
            @test isapprox(X1c, [2.0, -1.0, 1.0, 2.0, 0.0, 1.0])
            Y1c = allocate(M, X1c)
            get_coordinates!(M, Y1c, p1, X1, basis)
            @test isapprox(X1c, Y1c)
            @test isapprox(get_vector(M, p1, X1c, basis), X1)
            Z1 = allocate(M, X1)
            get_vector!(M, Z1, p1, X1c, basis)
            @test isapprox(X1, X1)
        end
    end

    @testset "allocation promotion" begin
        M2c = DefaultManifold(2; field = ℂ)
        Mc = ProductManifold(M1, M2c)
        @test ManifoldsBase.allocation_promotion_function(Mc, get_vector, ()) === complex
        @test ManifoldsBase.allocation_promotion_function(M, get_vector, ()) === identity
    end

    @testset "Riemann tensor" begin
        p = ArrayPartition([0.0, 1.0, 0.0], [2.0 3.0; 0.0 0.0])
        X = ArrayPartition([1.0, 0.0, 0.0], [2.0 3.0; 0.0 0.0])
        Y = ArrayPartition([0.0, 0.0, 3.0], [-2.0 3.0; 0.0 0.0])
        Z = ArrayPartition([-1.0, 0.0, 2.0], [2.0 -3.0; 0.0 0.0])
        Xresult = ArrayPartition([6.0, 0.0, 3.0], [0.0 0.0; 0.0 0.0])
        @test isapprox(riemann_tensor(M, p, X, Y, Z), Xresult)
        Xresult2 = allocate(Xresult)
        riemann_tensor!(M, Xresult2, p, X, Y, Z)
        @test isapprox(Xresult2, Xresult)
    end

    @testset "sectional curvature" begin
        p = ArrayPartition([0.0, 1.0, 0.0], [0.0, 1.0, 0.0])
        X1 = ArrayPartition([1.0, 0.0, 0.0], [0.0, 0.0, 0.0])
        X2 = ArrayPartition([0.0, 0.0, 1.0], [0.0, 0.0, 0.0])
        X3 = ArrayPartition([0.0, 0.0, 0.0], [0.0, 0.0, 1.0])

        @test sectional_curvature_max(M) == 1.0
        @test sectional_curvature_min(M) == 0.0

        Mss = ProductManifold(M1, M1)
        @test sectional_curvature_max(Mss) == 1.0
        @test sectional_curvature_min(Mss) == 0.0
        @test sectional_curvature(Mss, p, X1, X2) == 1.0
        @test sectional_curvature(Mss, p, X1, X3) == 0.0

        @test sectional_curvature_max(ProductManifold(M1)) == 1.0
        @test sectional_curvature_min(ProductManifold(M1)) == 1.0
    end

    @testset "× constructors" begin
        @test M1 × M2 == M
        @test M × M2 == ProductManifold(M1, M2, M2)
        @test M2 × M == ProductManifold(M2, M1, M2)
        @test M × M == ProductManifold(M1, M2, M1, M2)

        r1 = ExponentialRetraction()
        r2 = ProjectionRetraction()
        s1 = r1 × r2
        @test s1 == ProductRetraction(r1, r2)
        @test "$(s1)" == "ProductRetraction($(r1), $(r2))"
        @test s1 × r2 == ProductRetraction(r1, r2, r2)
        @test r2 × s1 == ProductRetraction(r2, r1, r2)
        @test r1 × r1 × r1 == ProductRetraction(r1, r1, r1)
        @test s1 × s1 == ProductRetraction(r1, r2, r1, r2)

        ir1 = LogarithmicInverseRetraction()
        ir2 = ProjectionInverseRetraction()
        is1 = ir1 × ir2
        @test is1 == InverseProductRetraction(ir1, ir2)
        @test "$(is1)" == "InverseProductRetraction($(ir1), $(ir2))"
        @test is1 × ir2 == InverseProductRetraction(ir1, ir2, ir2)
        @test ir2 × is1 == InverseProductRetraction(ir2, ir1, ir2)
        @test ir1 × ir1 × ir1 == InverseProductRetraction(ir1, ir1, ir1)
        @test is1 × is1 == InverseProductRetraction(ir1, ir2, ir1, ir2)

        tr1 = ParallelTransport()
        tr2 = ProjectionTransport()
        ts1 = tr1 × tr2
        @test ts1 == ProductVectorTransport(tr1, tr2)
        @test "$(ts1)" == "ProductVectorTransport($(tr1), $(tr2))"
        @test ts1 × tr2 == ProductVectorTransport(tr1, tr2, tr2)
        @test tr2 × ts1 == ProductVectorTransport(tr2, tr1, tr2)
        @test tr1 × tr1 × tr1 == ProductVectorTransport(tr1, tr1, tr1)
        @test ts1 × ts1 == ProductVectorTransport(tr1, tr2, tr1, tr2)
    end

    @testset "TangentSpace" begin
        TpM = TangentSpace(M, p1)
        Tp1M1 = TpM[1]
        @test base_point(Tp1M1) === p1[M, 1]
        @test base_manifold(Tp1M1) === M[1]
    end

    @testset "Special Case for r-distance" begin
        M1 = ManifoldsBase.Test.TestSphere(2)
        M = ProductManifold(M1, M1)
        p1 = ArrayPartition([1.0, 0.0, 0.0], 1 / sqrt(2) .* [1.0, 1.0, 0.0])
        p2 = ArrayPartition(1 / sqrt(2) .* [1.0, 1.0, 0.0], [0.0, 1.0, 0.0])
        m = ProjectionInverseRetraction()
        ds = [distance(M1, p1[M, i], p2[M, i], m) for i in [1, 2]]
        @test distance(M, p1, p2, m) == norm(ds)
        @test distance(M, p1, p2, m, 1) == norm(ds, 1)
        @test distance(M, p1, p2, m, 2) == norm(ds, 2)
        @test distance(M, p1, p2, m, Inf) == norm(ds, Inf)
        @test distance(M, p1, p2, m, -Inf) == norm(ds, -Inf)
    end

    @testset "Product with a custom point type" begin
        M = ProductManifold(ManifoldsBase.DefaultManifold(3), ManifoldsBase.DefaultManifold(2))
        p = ArrayPartition(ManifoldsBase.Test.DefaultPoint([1.0, 0.0]), ManifoldsBase.Test.DefaultPoint([0.0, 0.0, 0.0]))
        X = zero_vector(M, p)
        @test X isa ArrayPartition{Float64, Tuple{ManifoldsBase.Test.DefaultTangentVector{Vector{Float64}}, ManifoldsBase.Test.DefaultTangentVector{Vector{Float64}}}}
    end
end

"""
    ShootingInverseRetraction <: ApproximateInverseRetraction

Approximating the inverse of a retraction using the shooting method.

This implementation of the shooting method works by using another inverse retraction to form
the first guess of the vector. This guess is updated by shooting the vector, guessing the
vector pointing from the shooting result to the target point, and transporting this vector
update back to the initial point on a discretized grid. This process is repeated until the
norm of the vector update falls below a specified tolerance or the maximum number of
iterations is reached.

# Fields
- `retraction::AbstractRetractionMethod`: The retraction whose inverse is approximated.
- `initial_inverse_retraction::AbstractInverseRetractionMethod`: The inverse retraction used
    to form the initial guess of the vector.
- `vector_transport::AbstractVectorTransportMethod`: The vector transport used to transport
    the initial guess of the vector.
- `num_transport_points::Int`: The number of discretization points used for vector
    transport in the shooting method. 2 is the minimum number of points, including just the
    endpoints.
- `tolerance::Real`: The tolerance for the shooting method.
- `max_iterations::Int`: The maximum number of iterations for the shooting method.
"""
struct ShootingInverseRetraction{
        R <: AbstractRetractionMethod,
        IR <: AbstractInverseRetractionMethod,
        VT <: AbstractVectorTransportMethod,
        T <: Real,
    } <: ApproximateInverseRetraction
    retraction::R
    initial_inverse_retraction::IR
    vector_transport::VT
    num_transport_points::Int
    tolerance::T
    max_iterations::Int
end

function _inverse_retract!(M::AbstractManifold, X, p, q, m::ShootingInverseRetraction)
    return inverse_retract_shooting!(M, X, p, q, m)
end

"""
    inverse_retract_shooting!(M::AbstractManifold, X, p, q, m::ShootingInverseRetraction)

Approximate the inverse of a retraction using the shooting method.
"""
function inverse_retract_shooting!(
        M::AbstractManifold,
        X,
        p,
        q,
        m::ShootingInverseRetraction,
    )
    inverse_retract!(M, X, p, q, m.initial_inverse_retraction)
    gap = norm(M, p, X)
    gap < m.tolerance && return X
    T = real(Base.promote_type(number_eltype(X), number_eltype(p), number_eltype(q)))
    transport_grid = range(one(T), zero(T); length = m.num_transport_points)[2:(end - 1)]
    ΔX = allocate(X)
    ΔXnew = tX = allocate(ΔX)
    retr_tX = allocate_result(M, retract, p, X)
    if m.num_transport_points > 2
        retr_tX_new = allocate_result(M, retract, p, X)
    end
    iteration = 1
    while (gap > m.tolerance) && (iteration < m.max_iterations)
        retract!(M, retr_tX, p, X, m.retraction)
        inverse_retract!(M, ΔX, retr_tX, q, m.initial_inverse_retraction)
        gap = norm(M, retr_tX, ΔX)
        for t in transport_grid
            tX .= t .* X
            retract!(M, retr_tX_new, p, tX, m.retraction)
            vector_transport_to!(M, ΔXnew, retr_tX, ΔX, retr_tX_new, m.vector_transport)
            # realias storage
            retr_tX, retr_tX_new, ΔX, ΔXnew, tX = retr_tX_new, retr_tX, ΔXnew, ΔX, ΔX
        end
        vector_transport_to!(M, ΔXnew, retr_tX, ΔX, p, m.vector_transport)
        X .+= ΔXnew
        iteration += 1
    end
    return X
end

"""
    AbstractVectorTransportMethod <: AbstractApproximationMethod

Abstract type for methods for transporting vectors. Such vector transports are not
necessarily linear.

# See also

[`AbstractLinearVectorTransportMethod`](@ref)
"""
abstract type AbstractVectorTransportMethod <: AbstractApproximationMethod end

"""
    AbstractLinearVectorTransportMethod <: AbstractVectorTransportMethod

Abstract type for linear methods for transporting vectors, that is transport of a linear
combination of vectors is a linear combination of transported vectors.
"""
abstract type AbstractLinearVectorTransportMethod <: AbstractVectorTransportMethod end

@doc raw"""
    DifferentiatedRetractionVectorTransport{R<:AbstractRetractionMethod} <:
        AbstractVectorTransportMethod

A type to specify a vector transport that is given by differentiating a retraction.
This can be introduced in two ways. Let ``\mathcal M`` be a Riemannian manifold,
``p∈\mathcal M`` a point, and ``X,Y∈ T_p\mathcal M`` denote two tangent vectors at ``p``.

Given a retraction (cf. [`AbstractRetractionMethod`](@ref)) ``\operatorname{retr}``,
the vector transport of `X` in direction `Y` (cf. [`vector_transport_direction`](@ref))
by differentiation this retraction, is given by

```math
\mathcal T^{\operatorname{retr}}_{p,Y}X
= D_Y\operatorname{retr}_p(Y)[X]
= \frac{\mathrm{d}}{\mathrm{d}t}\operatorname{retr}_p(Y+tX)\Bigr|_{t=0}.
```
see [AbsilMahonySepulchre:2008](@cite), Section 8.1.2 for more details.

This can be phrased similarly as a [`vector_transport_to`](@ref) by introducing
``q=\operatorname{retr}_pX`` and defining

```math
\mathcal T^{\operatorname{retr}}_{q \gets p}X = \mathcal T^{\operatorname{retr}}_{p,Y}X
```

which in practice usually requires the [`inverse_retract`](@ref) to exists in order to
compute ``Y = \operatorname{retr}_p^{-1}q``.

# Constructor

    DifferentiatedRetractionVectorTransport(m::AbstractRetractionMethod)
"""
struct DifferentiatedRetractionVectorTransport{R <: AbstractRetractionMethod} <:
    AbstractLinearVectorTransportMethod
    retraction::R
end

@doc raw"""
    EmbeddedVectorTransport{T<:AbstractVectorTransportMethod} <: AbstractVectorTransportMethod

Compute a vector transport by using the vector transport of type `T` in the embedding and projecting the result.

# Constructor

    EmbeddedVectorTransport(vt::AbstractVectorTransportMethod)

Generate the vector transport with vector transport `vt` to use in the embedding.
"""
struct EmbeddedVectorTransport{T <: AbstractVectorTransportMethod} <:
    AbstractVectorTransportMethod
    vector_transport::T
end

@doc raw"""
    ParallelTransport <: AbstractVectorTransportMethod

Compute the vector transport by parallel transport, see
[`parallel_transport_to`](@ref)
"""
struct ParallelTransport <: AbstractLinearVectorTransportMethod end

"""
    ProjectionTransport <: AbstractVectorTransportMethod

Specify to use projection onto tangent space as vector transport method within
[`vector_transport_to`](@ref) or [`vector_transport_direction`](@ref).
See [`project`](@ref) for details.
"""
struct ProjectionTransport <: AbstractLinearVectorTransportMethod end


@doc raw"""
    PoleLadderTransport <: AbstractVectorTransportMethod

Specify to use [`pole_ladder`](@ref) as vector transport method within
[`vector_transport_to`](@ref) or [`vector_transport_direction`](@ref), i.e.

Let $X∈ T_p\mathcal M$ be a tangent vector at $p∈\mathcal M$ and $q∈\mathcal M$ the
point to transport to. Then $x = \exp_pX$ is used to call
`y = `[`pole_ladder`](@ref)`(M, p, x, q)` and the resulting vector is obtained by computing
$Y = -\log_qy$.

The [`PoleLadderTransport`](@ref) posesses two advantages compared to
[`SchildsLadderTransport`](@ref):
* it is cheaper to evaluate, if you want to transport several vectors, since the
  mid point $c$ then stays unchanged.
* while both methods are exact if the curvature is zero, pole ladder is even exact in
  symmetric Riemannian manifolds [Pennec:2018](@cite)

The pole ladder was was proposed in [LorenziPennec:2013](@cite). Its name stems from the fact that
it resembles a pole ladder when applied to a sequence of points usccessively.

# Constructor
````julia
PoleLadderTransport(
    retraction = ExponentialRetraction(),
    inverse_retraction = LogarithmicInverseRetraction(),
)
````
Construct the classical pole ladder that employs exp and log, i.e. as proposed
in[LorenziPennec:2013](@cite). For an even cheaper transport the inner operations can be
changed to an [`AbstractRetractionMethod`](@ref) `retraction` and an
[`AbstractInverseRetractionMethod`](@ref) `inverse_retraction`, respectively.
"""
struct PoleLadderTransport{
        RT <: AbstractRetractionMethod, IRT <: AbstractInverseRetractionMethod,
    } <: AbstractLinearVectorTransportMethod
    retraction::RT
    inverse_retraction::IRT
    function PoleLadderTransport(
            retraction = ExponentialRetraction(),
            inverse_retraction = LogarithmicInverseRetraction(),
        )
        return new{typeof(retraction), typeof(inverse_retraction)}(
            retraction,
            inverse_retraction,
        )
    end
end

@doc raw"""
    ScaledVectorTransport{T} <: AbstractVectorTransportMethod

Introduce a scaled variant of any [`AbstractVectorTransportMethod`](@ref) `T`,
as introduced in [SatoIwai:2013](@cite) for some ``X∈ T_p\mathcal M`` as

```math
    \mathcal T^{\mathrm{S}}(X) = \frac{\lVert X\rVert_p}{\lVert \mathcal T(X)\rVert_q}\mathcal T(X).
```

Note that the resulting point `q` has to be known, i.e. for [`vector_transport_direction`](@ref)
the curve or more precisely its end point has to be known (via an exponential map or a
retraction). Therefore a default implementation is only provided for the [`vector_transport_to`](@ref)

# Constructor

    ScaledVectorTransport(m::AbstractVectorTransportMethod)
"""
struct ScaledVectorTransport{T <: AbstractVectorTransportMethod} <:
    AbstractVectorTransportMethod
    method::T
end

@doc raw"""
    SchildsLadderTransport <: AbstractVectorTransportMethod

Specify to use [`schilds_ladder`](@ref) as vector transport method within
[`vector_transport_to`](@ref) or [`vector_transport_direction`](@ref), i.e.

Let $X∈ T_p\mathcal M$ be a tangent vector at $p∈\mathcal M$ and $q∈\mathcal M$ the
point to transport to. Then

````math
P^{\mathrm{S}}_{q\gets p}(X) =
    \log_q\bigl( \operatorname{retr}_p ( 2\operatorname{retr}_p^{-1}c ) \bigr),
````

where $c$ is the mid point between $q$ and $d=\exp_pX$.

This method employs the internal function [`schilds_ladder`](@ref)`(M, p, d, q)` that avoids
leaving the manifold.

The name stems from the image of this paralleltogram in a repeated application yielding the
image of a ladder. The approximation was proposed in [EhlersPiraniSchild:1972](@cite).

# Constructor
````julia
SchildsLadderTransport(
    retraction = ExponentialRetraction(),
    inverse_retraction = LogarithmicInverseRetraction(),
)
````
Construct the classical Schilds ladder that employs exp and log, i.e. as proposed
in [EhlersPiraniSchild:1972](@cite). For an even cheaper transport these inner operations can be
changed to an [`AbstractRetractionMethod`](@ref) `retraction` and an
[`AbstractInverseRetractionMethod`](@ref) `inverse_retraction`, respectively.
"""
struct SchildsLadderTransport{
        RT <: AbstractRetractionMethod, IRT <: AbstractInverseRetractionMethod,
    } <: AbstractLinearVectorTransportMethod
    retraction::RT
    inverse_retraction::IRT
    function SchildsLadderTransport(
            retraction = ExponentialRetraction(),
            inverse_retraction = LogarithmicInverseRetraction(),
        )
        return new{typeof(retraction), typeof(inverse_retraction)}(
            retraction,
            inverse_retraction,
        )
    end
end

@doc raw"""
    VectorTransportDirection{VM<:AbstractVectorTransportMethod,RM<:AbstractRetractionMethod}
        <: AbstractVectorTransportMethod

Specify a [`vector_transport_direction`](@ref) using a [`AbstractVectorTransportMethod`](@ref)
with explicitly using the [`AbstractRetractionMethod`](@ref) to determine the point in
the specified direction where to transsport to.
Note that you only need this for the non-default (non-implicit) second retraction method
associated to a vector transport, i.e. when a first implementation assumed
an implicit associated retraction.
"""
struct VectorTransportDirection{
        VM <: AbstractVectorTransportMethod, RM <: AbstractRetractionMethod,
    } <: AbstractVectorTransportMethod
    retraction::RM
    vector_transport::VM
    function VectorTransportDirection(
            vector_transport = ParallelTransport(),
            retraction = ExponentialRetraction(),
        )
        return new{typeof(vector_transport), typeof(retraction)}(
            retraction,
            vector_transport,
        )
    end
end

@doc raw"""
    VectorTransportTo{VM<:AbstractVectorTransportMethod,RM<:AbstractRetractionMethod}
        <: AbstractVectorTransportMethod

Specify a [`vector_transport_to`](@ref) using a [`AbstractVectorTransportMethod`](@ref)
with explicitly using the [`AbstractInverseRetractionMethod`](@ref) to determine the direction
that transports from  in `p`to `q`.
Note that you only need this for the non-default (non-implicit) second retraction method
associated to a vector transport, i.e. when a first implementation assumed
an implicit associated retraction.
"""
struct VectorTransportTo{
        VM <: AbstractVectorTransportMethod, IM <: AbstractInverseRetractionMethod,
    } <: AbstractVectorTransportMethod
    inverse_retraction::IM
    vector_transport::VM
    function VectorTransportTo(
            vector_transport = ParallelTransport(),
            inverse_retraction = LogarithmicInverseRetraction(),
        )
        return new{typeof(vector_transport), typeof(inverse_retraction)}(
            inverse_retraction,
            vector_transport,
        )
    end
end

"""
    VectorTransportWithKeywords{V<:AbstractVectorTransportMethod, K} <: AbstractVectorTransportMethod

Since vector transports might have keywords, this type is a way to set them as an own type to be
used as a specific vector transport.
Another reason for this type is that we dispatch on the vector transport first and only the
last layer would be implemented with keywords, so this way they can be passed down.

## Fields

* `vector_transport` the vector transport that is decorated with keywords
* `kwargs` the keyword arguments

Note that you can nest this type. Then the most outer specification of a keyword is used.

## Constructor

    VectorTransportWithKeywords(m::T; kwargs...) where {T <: AbstractVectorTransportMethod}

Specify the subtype `T <: `[`AbstractVectorTransportMethod`](@ref) to have keywords `kwargs...`.
"""
struct VectorTransportWithKeywords{T <: AbstractVectorTransportMethod, K} <:
    AbstractVectorTransportMethod
    vector_transport::T
    kwargs::K
end
function VectorTransportWithKeywords(
        m::T;
        kwargs...,
    ) where {T <: AbstractVectorTransportMethod}
    return VectorTransportWithKeywords{T, typeof(kwargs)}(m, kwargs)
end

"""
    default_vector_transport_method(M::AbstractManifold)
    default_vector_transport_method(M::AbstractManifold, ::Type{T}) where {T}

The [`AbstractVectorTransportMethod`](@ref) that is used when calling [`vector_transport_to`](@ref)
or [`vector_transport_direction`](@ref) without specifying the vector transport method.
By default, this is [`ParallelTransport`](@ref).

This method can also be specified more precisely with a point type `T`, for the case
that on a `M` there are two different representations of points, which provide
different vector transport methods.
"""
function default_vector_transport_method(::AbstractManifold)
    return ParallelTransport()
end
function default_vector_transport_method(M::AbstractManifold, ::Type{T}) where {T}
    return default_vector_transport_method(M)
end


@doc raw"""
    pole_ladder(
        M, p, d, q, c = mid_point(M, p, q);
        retraction=default_retraction_method(M, typeof(p)),
        inverse_retraction=default_inverse_retraction_method(M, typeof(p))
    )

Compute an inner step of the pole ladder, that can be used as a [`vector_transport_to`](@ref).
Let $c = \gamma_{p,q}(\frac{1}{2})$ mid point between `p` and `q`, then the pole ladder is
given by

````math
    \operatorname{Pl}(p,d,q) = \operatorname{retr}_d (2\operatorname{retr}_d^{-1}c)
````

Where the classical pole ladder employs $\operatorname{retr}_d=\exp_d$
and $\operatorname{retr}_d^{-1}=\log_d$ but for an even cheaper transport these can be set
to different [`AbstractRetractionMethod`](@ref) and [`AbstractInverseRetractionMethod`](@ref).

When you have $X=log_pd$ and $Y = -\log_q \operatorname{Pl}(p,d,q)$,
you will obtain the [`PoleLadderTransport`](@ref). When performing multiple steps, this
method avoids the switching to the tangent space. Keep in mind that after $n$ successive
steps the tangent vector reads $Y_n = (-1)^n\log_q \operatorname{Pl}(p_{n-1},d_{n-1},p_n)$.

It is cheaper to evaluate than [`schilds_ladder`](@ref), sinc if you want to form multiple
ladder steps between `p` and `q`, but with different `d`, there is just one evaluation of a geodesic
each., since the center `c` can be reused.
"""
function pole_ladder(
        M, p, d, q, c = mid_point(M, p, q);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )
    return retract(M, d, 2 * inverse_retract(M, d, c, inverse_retraction), retraction)
end
@doc raw"""
    pole_ladder(
        M, pl, p, d, q, c = mid_point(M, p, q), X = allocate_result_type(M, log, d, c);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )

Compute the [`pole_ladder`](@ref), i.e. the result is saved in `pl`.
`X` is used for storing intermediate inverse retraction.
"""
function pole_ladder!(
        M, pl, p, d, q, c = mid_point(M, p, q), X = allocate_result(M, log, d, c);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )
    inverse_retract!(M, X, d, c, inverse_retraction)
    X *= 2
    return retract!(M, pl, d, X, retraction)
end

@doc raw"""
    schilds_ladder(
        M, p, d, q, c = mid_point(M, q, d);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )

Perform an inner step of schilds ladder, which can be used as a
[`vector_transport_to`](@ref), see [`SchildsLadderTransport`](@ref).
Let $c = \gamma_{q,d}(\frac{1}{2})$ denote the mid point
on the shortest geodesic connecting $q$ and the point $d$. Then Schild's ladder reads as

````math
\operatorname{Sl}(p,d,q) = \operatorname{retr}_p( 2\operatorname{retr}_p^{-1} c)
````

Where the classical Schilds ladder employs $\operatorname{retr}_d=\exp_d$
and $\operatorname{retr}_d^{-1}=\log_d$ but for an even cheaper transport these can be set
to different [`AbstractRetractionMethod`](@ref) and [`AbstractInverseRetractionMethod`](@ref).

In consistency with [`pole_ladder`](@ref) you can change the way the mid point is computed
using the optional parameter `c`, but note that here it's the mid point between `q` and `d`.

When you have $X=log_pd$ and $Y = \log_q \operatorname{Sl}(p,d,q)$,
you will obtain the [`PoleLadderTransport`](@ref).
Then the approximation to the transported vector is given by $\log_q\operatorname{Sl}(p,d,q)$.

When performing multiple steps, this method avoidsd the switching to the tangent space.
Hence after $n$ successive steps the tangent vector reads
$Y_n = \log_q \operatorname{Pl}(p_{n-1},d_{n-1},p_n)$.
"""
function schilds_ladder(
        M, p, d, q, c = mid_point(M, q, d);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )
    return retract(M, p, 2 * inverse_retract(M, p, c, inverse_retraction), retraction)
end
@doc raw"""
    schilds_ladder!(M, sl, p, d, q, c = mid_point(M, q, d),
        X = allocate_result_type(M, log, d, c);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )

Compute [`schilds_ladder`](@ref) and return the value in the parameter `sl`.
If the required mid point `c` was computed before, it can be passed using `c`,
and the allocation of new memory can be avoided providing a tangent vector `X`
for the interims result.
"""
function schilds_ladder!(
        M, sl, p, d, q, c = mid_point(M, q, d), X = allocate_result(M, log, d, c);
        retraction = default_retraction_method(M, typeof(p)),
        inverse_retraction = default_inverse_retraction_method(M, typeof(p)),
    )
    inverse_retract!(M, X, p, c, inverse_retraction)
    X *= 2
    return retract!(M, sl, p, X, retraction)
end

function show(io::IO, ::ParallelTransport)
    return print(io, "ParallelTransport()")
end
function show(io::IO, m::ScaledVectorTransport)
    return print(io, "ScaledVectorTransport($(m.method))")
end

@doc raw"""
    vector_transport_direction(M::AbstractManifold, p, X, d)
    vector_transport_direction(M::AbstractManifold, p, X, d, m::AbstractVectorTransportMethod)

Given an [`AbstractManifold`](@ref) ``\mathcal M`` the vector transport is a generalization of the
[`parallel_transport_direction`](@ref) that identifies vectors from different tangent spaces.

More precisely using [AbsilMahonySepulchre:2008](@cite), Def. 8.1.1, a vector transport
``T_{p,d}: T_p\mathcal M \to T_q\mathcal M``, ``p∈ \mathcal M``, ``Y∈ T_p\mathcal M`` is a smooth mapping
associated to a retraction ``\operatorname{retr}_p(Y) = q`` such that

1. (associated retraction) ``\mathcal T_{p,d}X ∈ T_q\mathcal M`` if and only if ``q = \operatorname{retr}_p(d)``.
2. (consistency) ``\mathcal T_{p,0_p}X = X`` for all ``X∈T_p\mathcal M``
3. (linearity) ``\mathcal T_{p,d}(αX+βY) = α\mathcal T_{p,d}X + β\mathcal T_{p,d}Y``

For the [`AbstractVectorTransportMethod`](@ref) we might even omit the third point.
The [`AbstractLinearVectorTransportMethod`](@ref)s are linear.

# Input Parameters
* `M` a manifold
* `p` indicating the tangent space of
* `X` the tangent vector to be transported
* `d` indicating a transport direction (and distance through its length)
* `m` an [`AbstractVectorTransportMethod`](@ref), by default [`default_vector_transport_method`](@ref), so usually [`ParallelTransport`](@ref)

Usually this method requires a [`AbstractRetractionMethod`](@ref) as well.
By default this is assumed to be the [`default_retraction_method`](@ref) or
implicitly given (and documented) for a vector transport.
To explicitly distinguish different retractions for a vector transport,
see [`VectorTransportDirection`](@ref).

Instead of spcifying a start direction `d` one can equivalently also specify a target tanget space
``T_q\mathcal M``, see [`vector_transport_to`](@ref).
By default [`vector_transport_direction`](@ref) falls back to using [`vector_transport_to`](@ref),
using the [`default_retraction_method`](@ref) on `M`.
"""
function vector_transport_direction(
        M::AbstractManifold, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    return _vector_transport_direction(M, p, X, d, m)
end
function _vector_transport_direction(
        M::AbstractManifold, p, X, d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p));
        kwargs...,
    )
    # allocate first
    Y = allocate_result(M, vector_transport_direction, X, p, d)
    return vector_transport_direction!(M, Y, p, X, d, m; kwargs...)
end
function _vector_transport_direction(
        M::AbstractManifold,
        p,
        X,
        d,
        m::VectorTransportDirection;
        kwargs...,
    )
    mv =
        length(kwargs) > 0 ? VectorTransportWithKeywords(m.vector_transport; kwargs...) :
        m.vector_transport
    mr = m.retraction
    return vector_transport_to(M, p, X, retract(M, p, d, mr), mv)
end
function _vector_transport_direction(
        M::AbstractManifold,
        p,
        X,
        d,
        m::VectorTransportWithKeywords;
        kwargs...,
    )
    return _vector_transport_direction(
        M,
        p,
        X,
        d,
        m.vector_transport;
        kwargs...,
        m.kwargs...,
    )
end

"""
    vector_transport_direction!(M::AbstractManifold, Y, p, X, d)
    vector_transport_direction!(M::AbstractManifold, Y, p, X, d, m::AbstractVectorTransportMethod)

Transport a vector `X` from the tangent space at a point `p` on the [`AbstractManifold`](@ref) `M`
in the direction indicated by the tangent vector `d` at `p`. By default, [`retract`](@ref) and
[`vector_transport_to!`](@ref) are used with the `m` and `r`, which default
to [`default_vector_transport_method`](@ref)`(M)` and [`default_retraction_method`](@ref)`(M)`, respectively.
The result is saved to `Y`.

See [`vector_transport_direction`](@ref) for more details.
"""
function vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p));
        kwargs...,
    )
    return _vector_transport_direction!(M, Y, p, X, d, m; kwargs...)
end
function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p));
        kwargs...,
    )
    r = default_retraction_method(M, typeof(p))
    v = length(kwargs) > 0 ? VectorTransportWithKeywords(m; kwargs...) : m
    return vector_transport_to!(M, Y, p, X, retract(M, p, d, r), v)
end
function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::VectorTransportDirection;
        kwargs...,
    )
    v =
        length(kwargs) > 0 ? VectorTransportWithKeywords(m.vector_transport; kwargs...) :
        m.vector_transport
    return vector_transport_to!(M, Y, p, X, retract(M, p, d, m.retraction), v)
end
function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::DifferentiatedRetractionVectorTransport;
        kwargs...,
    )
    return vector_transport_direction_diff!(M, Y, p, X, d, m.retraction; kwargs...)
end
function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::EmbeddedVectorTransport;
        kwargs...,
    )
    return vector_transport_direction_embedded!(
        M,
        Y,
        p,
        X,
        d,
        m.vector_transport;
        kwargs...,
    )
end
@doc raw"""
    vector_transport_direction_diff!(M::AbstractManifold, Y, p, X, d, m::AbstractRetractionMethod)

Compute the vector transport of `X` from ``T_p\mathcal M`` into the direction `d`
using the differential of the [`AbstractRetractionMethod`](@ref) `m` in place of `Y`.
"""
vector_transport_direction_diff!(M, Y, p, X, d, m)

function vector_transport_direction_diff! end

function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        ::ParallelTransport;
        kwargs...,
    )
    return parallel_transport_direction!(M, Y, p, X, d; kwargs...)
end

function _vector_transport_direction!(
        M::AbstractManifold,
        Y,
        p,
        X,
        d,
        m::VectorTransportWithKeywords;
        kwargs...,
    )
    return _vector_transport_direction!(
        M,
        Y,
        p,
        X,
        d,
        m.vector_transport;
        kwargs...,
        m.kwargs...,
    )
end

@doc raw"""
    vector_transport_direction_embedded!(M::AbstractManifold, Y, p, X, d, m::AbstractVectorTransportMethod)

Compute the vector transport of `X` from ``T_p\mathcal M`` into the direction `d`
using the [`AbstractRetractionMethod`](@ref) `m` in the embedding.

The default implementataion requires one allocation for the points and tangent vectors in the
embedding and the resulting point, but the final projection is performed in place of `Y`
"""
function vector_transport_direction_embedded!(
        M::AbstractManifold,
        Y,
        p::P,
        X,
        d,
        m::AbstractVectorTransportMethod,
    ) where {P}
    p_e = embed(M, p)
    d_e = embed(M, d)
    X_e = embed(M, p, X)
    Y_e = vector_transport_direction(get_embedding(M, P), p_e, X_e, d_e, m)
    q = exp(M, p, d)
    return project!(M, Y, q, Y_e)
end

@doc raw"""
    vector_transport_to(M::AbstractManifold, p, X, q)
    vector_transport_to(M::AbstractManifold, p, X, q, m::AbstractVectorTransportMethod)
    vector_transport_to(M::AbstractManifold, p, X, q, m::AbstractVectorTransportMethod)

Transport a vector `X` from the tangent space at a point `p` on the [`AbstractManifold`](@ref) `M`
along a curve implicitly given by an [`AbstractRetractionMethod`](@ref) associated to `m`.
By default `m` is the [`default_vector_transport_method`](@ref)`(M)`.
To explicitly specify a (different) retraction to the implicitly assumeed retraction, see [`VectorTransportTo`](@ref).
Note that some vector transport methods might also carry their own retraction they are associated to,
like the  [`DifferentiatedRetractionVectorTransport`](@ref) and some are even independent of the retraction, for example the [`ProjectionTransport`](@ref).

This method is equivalent to using ``d = \operatorname{retr}^{-1}_p(q)`` in [`vector_transport_direction`](@ref)`(M, p, X, q, m, r)`,
where you can find the formal definition. This is the fallback for [`VectorTransportTo`](@ref).
"""
function vector_transport_to(
        M::AbstractManifold,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    return _vector_transport_to(M, p, X, q, m)
end
function _vector_transport_to(M::AbstractManifold, p, X, q, m::VectorTransportTo; kwargs...)
    d = inverse_retract(M, p, q, m.inverse_retraction)
    v =
        length(kwargs) > 0 ? VectorTransportWithKeywords(m.vector_transport; kwargs...) :
        m.vector_transport
    return vector_transport_direction(M, p, X, d, v)
end
function _vector_transport_to(M::AbstractManifold, p, X, q, ::ParallelTransport; kwargs...)
    return parallel_transport_to(M, p, X, q; kwargs...)
end
function _vector_transport_to(
        M::AbstractManifold,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod;
        kwargs...,
    )
    Y = allocate_result(M, vector_transport_to, X, p)
    return vector_transport_to!(M, Y, p, X, q, m; kwargs...)
end
function _vector_transport_to(
        M::AbstractManifold,
        p,
        X,
        q,
        m::VectorTransportWithKeywords;
        kwargs...,
    )
    return _vector_transport_to(M, p, X, q, m.vector_transport; kwargs..., m.kwargs...)
end

"""
    vector_transport_to!(M::AbstractManifold, Y, p, X, q)
    vector_transport_to!(M::AbstractManifold, Y, p, X, q, m::AbstractVectorTransportMethod)

Transport a vector `X` from the tangent space at a point `p` on the [`AbstractManifold`](@ref) `M`
to `q` using the [`AbstractVectorTransportMethod`](@ref) `m` and the [`AbstractRetractionMethod`](@ref) `r`.

The result is computed in `Y`.
See [`vector_transport_to`](@ref) for more details.
"""
function vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::AbstractVectorTransportMethod = default_vector_transport_method(M, typeof(p)),
    )
    return _vector_transport_to!(M, Y, p, X, q, m)
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::VectorTransportTo;
        kwargs...,
    )
    d = inverse_retract(M, p, q, m.inverse_retraction)
    return _vector_transport_direction!(M, Y, p, X, d, m.vector_transport; kwargs...)
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        ::ParallelTransport;
        kwargs...,
    )
    return parallel_transport_to!(M, Y, p, X, q; kwargs...)
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::DifferentiatedRetractionVectorTransport;
        kwargs...,
    )
    return vector_transport_to_diff!(M, Y, p, X, q, m.retraction; kwargs...)
end

function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::EmbeddedVectorTransport;
        kwargs...,
    )
    return vector_transport_to_embedded!(M, Y, p, X, q, m.vector_transport; kwargs...)
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        ::ProjectionTransport;
        kwargs...,
    )
    return vector_transport_to_project!(M, Y, p, X, q; kwargs...)
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::PoleLadderTransport;
        kwargs...,
    )
    inverse_retract!(
        M,
        Y,
        q,
        pole_ladder(
            M,
            p,
            retract(M, p, X, m.retraction),
            q;
            retraction = m.retraction,
            inverse_retraction = m.inverse_retraction,
            kwargs...,
        ),
        m.inverse_retraction,
    )
    copyto!(Y, -Y)
    return Y
end
function _vector_transport_to!(
        M::AbstractManifold,
        Y,
        p,
        X,
        q,
        m::ScaledVectorTransport;
        kwargs...,
    )
    v = length(kwargs) > 0 ? VectorTransportWithKeywords(m.method; kwargs...) : m.method
    vector_transport_to!(M, Y, p, X, q, v)
    Y .*= norm(M, p, X) / norm(M, q, Y)
    return Y
end
function _vector_transport_to!(
        M::AbstractManifold, Y, p, X, q, m::VectorTransportWithKeywords; kwargs...,
    )
    return _vector_transport_to!(M, Y, p, X, q, m.vector_transport; kwargs..., m.kwargs...)
end
function _vector_transport_to!(
        M::AbstractManifold, Y, p, X, q, m::SchildsLadderTransport;
        kwargs...,
    )
    return inverse_retract!(
        M, Y, q,
        schilds_ladder(
            M, p, retract(M, p, X, m.retraction), q;
            retraction = m.retraction,
            inverse_retraction = m.inverse_retraction,
            kwargs...,
        ),
        m.inverse_retraction,
    )
end

@doc raw"""
    vector_transport_to_diff(M::AbstractManifold, p, X, q, r)

Compute a vector transport by using a [`DifferentiatedRetractionVectorTransport`](@ref) `r` in place of `Y`.
"""
vector_transport_to_diff!(M::AbstractManifold, Y, p, X, q, r)

function vector_transport_to_diff! end

@doc raw"""
    vector_transport_to_embedded!(M::AbstractManifold, Y, p, X, q, m::AbstractRetractionMethod)

Compute the vector transport of `X` from ``T_p\mathcal M`` to the point `q`
using the  of the [`AbstractRetractionMethod`](@ref) `m` in th embedding.

The default implementataion requires one allocation for the points and tangent vectors in the
embedding and the resulting point, but the final projection is performed in place of `Y`
"""
function vector_transport_to_embedded!(M::AbstractManifold, Y, p::P, X, q, m) where {P}
    p_e = embed(M, p)
    X_e = embed(M, p, X)
    q_e = embed(M, q)
    Y_e = vector_transport_to(get_embedding(M, P), p_e, X_e, q_e, m)
    return project!(M, Y, q, Y_e)
end

@doc raw"""
    vector_transport_to_project!(M::AbstractManifold, Y, p, X, q)

Compute a vector transport by projecting ``X\in T_p\mathcal M`` onto the tangent
space ``T_q\mathcal M`` at ``q`` in place of `Y`.
"""
function vector_transport_to_project!(M::AbstractManifold, Y, p, X, q; kwargs...)
    # Note that we have to use embed (not embed!) since we do not have memory to store this embedded value in
    return project!(M, Y, q, embed(M, p, X); kwargs...)
end

# default estimation fallbacks with and without the T
function default_approximation_method(
        M::AbstractManifold,
        ::typeof(vector_transport_direction),
    )
    return default_vector_transport_method(M)
end
function default_approximation_method(M::AbstractManifold, ::typeof(vector_transport_to))
    return default_vector_transport_method(M)
end
function default_approximation_method(
        M::AbstractManifold,
        ::typeof(vector_transport_direction),
        T,
    )
    return default_vector_transport_method(M, T)
end
function default_approximation_method(M::AbstractManifold, ::typeof(vector_transport_to), T)
    return default_vector_transport_method(M, T)
end

using Test
using ManifoldsBase

#
# A Manifold decorator test - check that StopForwarding cases call Abstract and those fail with
# MethodError due to ambiguities (between Abstract and Decorator)
struct NonDecoratorManifold <: AbstractDecoratorManifold{ManifoldsBase.ℝ} end
ManifoldsBase.representation_size(::NonDecoratorManifold) = (2,)

@testset "Testing a NonDecoratorManifold - StopForwarding fallbacks" begin
    M = NonDecoratorManifold()
    p = [2.0, 1.0]
    q = similar(p)
    X = [1.0, 0.0]
    Xc = [1.0, 0.0]
    Y = similar(X)
    Yc = similar(Xc)
    @test ManifoldsBase.check_size(M, p) === nothing
    @test ManifoldsBase.check_size(M, p, X) === nothing
    # default to identity
    @test embed(M, p) == p
    @test embed!(M, q, p) == p
    @test embed(M, p, X) == X
    @test embed!(M, Y, p, X) == X
    # the following is implemented but passes to the second and hence fails
    @test_throws MethodError exp(M, p, X)
    @test_throws MethodError ManifoldsBase.exp_fused(M, p, X, 2.0)
    @test_throws MethodError exp!(M, q, p, X)
    @test_throws MethodError ManifoldsBase.exp_fused!(M, q, p, X, 2.0)
    @test_throws MethodError retract(M, p, X)
    @test_throws MethodError ManifoldsBase.retract_fused(M, p, X, 2.0)
    @test_throws MethodError ManifoldsBase.retract_fused(
        M,
        p,
        X,
        2.0,
        ExponentialRetraction(),
    )
    @test_throws MethodError retract!(M, q, p, X)
    @test_throws MethodError ManifoldsBase.retract_fused!(M, q, p, X, 2.0)
    @test_throws MethodError ManifoldsBase.retract_fused!(
        M,
        q,
        p,
        X,
        2.0,
        ExponentialRetraction(),
    )
    @test_throws MethodError log(M, p, q)
    @test_throws MethodError log!(M, Y, p, q)
    @test_throws MethodError inverse_retract(M, p, q)
    @test_throws MethodError inverse_retract!(M, Y, p, q)
    @test_throws MethodError parallel_transport_direction(M, p, X, X)
    @test_throws MethodError parallel_transport_direction!(M, Y, p, X, X)
    @test_throws MethodError parallel_transport_to(M, p, X, q)
    @test_throws MethodError parallel_transport_to!(M, Y, p, X, q)
    @test_throws MethodError get_vector(M, p, Xc)
    @test_throws MethodError get_vector(M, p, Xc, DefaultOrthogonalBasis())
    @test_throws MethodError get_coordinates!(M, Yc, p, X)
    @test_throws MethodError get_vector!(M, Y, p, Xc)
    @test_throws MethodError get_coordinates!(M, Yc, p, X, DefaultOrthogonalBasis())
    @test_throws MethodError get_vector!(M, Y, p, Xc, DefaultOrthogonalBasis())

    @test_throws MethodError project(M, p)
    @test_throws MethodError project(M, p, X)
    @test_throws MethodError project!(M, q, p)
    @test_throws MethodError project!(M, Y, p, X)
end

# With even less, check that representation size stack overflows
struct NonDecoratorNonManifold <: AbstractDecoratorManifold{ManifoldsBase.ℝ} end
@testset "Testing a NonDecoratorNonManifold - StopForwarding fallback returns nothing" begin
    N = NonDecoratorNonManifold()
    @test representation_size(N) === nothing
end

@testset "Non-decorator manifold trait defaults" begin
    M = ManifoldsBase.Test.ProjManifold()
    p = [sqrt(2) / 2 0.0 0.0; 0.0 sqrt(2) / 2 0.0]

    @test ManifoldsBase.get_forwarding_type(M, exp) === StopForwardingType()
    @test ManifoldsBase.get_forwarding_type(M, exp, typeof(p)) === StopForwardingType()
end

abstract type AbstractA end
abstract type DecoA <: AbstractA end # A few concrete types
struct A <: AbstractA end
struct A1 <: DecoA end

h(::AbstractA, x::Float64, y; a = 1) = x + y - a
h(::DecoA, x, y) = x + y
ManifoldsBase.@invoke_maker 1 AbstractA h(A::DecoA, x::Float64, y)

@testset "@invoke_maker" begin
    @test h(A1(), 1.0, 2) == 2
    sig = ManifoldsBase._split_signature(:(fname(x::T; k::Float64 = 1) where {T}))
    @test sig.fname == :fname
    @test sig.where_exprs == Any[:T]
    @test sig.callargs == Any[:(x::T)]
    @test sig.kwargs_list == Any[:($(Expr(:kw, :(k::Float64), 1)))]
    @test sig.argnames == [:x]
    @test sig.argtypes == [:T]
    @test sig.kwargs_call == Expr[:(k = k)]
    @test_throws ErrorException ManifoldsBase._split_signature(:(a = b))

    sig2 = ManifoldsBase._split_signature(:(fname(x; kwargs...)))
    @test sig2.kwargs_call == Expr[:(kwargs...)]

    sig3 = ManifoldsBase._split_signature(:(fname(x::T, y::Int = 10; k1 = 1) where {T}))
    @test sig3.kwargs_call == Expr[:(k1 = k1)]
    @test sig3.callargs[2] == :($(Expr(:kw, :(y::Int), 10)))
    @test sig3.argnames == [:x, :y]
end

"""
    VectorSpaceType

Abstract type for tangent spaces, cotangent spaces, their tensor products,
exterior products, etc.

Every vector space `fiber` is supposed to provide:
* a method of constructing vectors,
* basic operations: addition, subtraction, multiplication by a scalar
  and negation (unary minus),
* `zero_vector(fiber, p)` to construct zero vectors at point `p`,
* `allocate(X)` and `allocate(X, T)` for vector `X` and type `T`,
* `copyto!(X, Y)` for vectors `X` and `Y`,
* `number_eltype(X)` for vector `X`,
* [`vector_space_dimension`](@ref).

Optionally:
* inner product via `inner` (used to provide Riemannian metric on vector
  bundles),
* [`flat`](https://juliamanifolds.github.io/Manifolds.jl/stable/features/atlases.html#Manifolds.flat-Tuple{AbstractManifold,%20Any,%20Any}) and [`sharp`](https://juliamanifolds.github.io/Manifolds.jl/stable/features/atlases.html#Manifolds.sharp-Tuple{AbstractManifold,%20Any,%20Any}),
* `norm` (by default uses `inner`),
* [`project`](@ref) (for embedded vector spaces),
* [`representation_size`](@ref),
* broadcasting for basic operations.
"""
abstract type VectorSpaceType <: FiberType end

"""
    struct TangentSpaceType <: VectorSpaceType end

A type that indicates that a [`Fiber`](@ref) is a [`TangentSpace`](@ref).
"""
struct TangentSpaceType <: VectorSpaceType end

"""
    struct CotangentSpaceType <: VectorSpaceType end

A type that indicates that a [`Fiber`](@ref) is a [`CotangentSpace`](@ref).
"""
struct CotangentSpaceType <: VectorSpaceType end

TCoTSpaceType = Union{TangentSpaceType, CotangentSpaceType}

"""
    AbstractBasis{𝔽,VST<:VectorSpaceType}

Abstract type that represents a basis of vector space of type `VST` on a manifold or
a subset of it.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
abstract type AbstractBasis{𝔽, VST <: VectorSpaceType} end

"""
    DefaultBasis{𝔽,VST<:VectorSpaceType}

An arbitrary basis of vector space of type `VST` on a manifold. This will usually
be the fastest basis available for a manifold.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
struct DefaultBasis{𝔽, VST <: VectorSpaceType} <: AbstractBasis{𝔽, VST}
    vector_space::VST
end
function DefaultBasis(𝔽::AbstractNumbers = ℝ, vs::VectorSpaceType = TangentSpaceType())
    return DefaultBasis{𝔽, typeof(vs)}(vs)
end
function DefaultBasis{𝔽}(vs::VectorSpaceType = TangentSpaceType()) where {𝔽}
    return DefaultBasis{𝔽, typeof(vs)}(vs)
end
function DefaultBasis{𝔽, TangentSpaceType}() where {𝔽}
    return DefaultBasis{𝔽, TangentSpaceType}(TangentSpaceType())
end

"""
    AbstractOrthogonalBasis{𝔽,VST<:VectorSpaceType}

Abstract type that represents an orthonormal basis of vector space of type `VST` on a
manifold or a subset of it.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
abstract type AbstractOrthogonalBasis{𝔽, VST <: VectorSpaceType} <: AbstractBasis{𝔽, VST} end

"""
    DefaultOrthogonalBasis{𝔽,VST<:VectorSpaceType}

An arbitrary orthogonal basis of vector space of type `VST` on a manifold. This will usually
be the fastest orthogonal basis available for a manifold.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
struct DefaultOrthogonalBasis{𝔽, VST <: VectorSpaceType} <: AbstractOrthogonalBasis{𝔽, VST}
    vector_space::VST
end
function DefaultOrthogonalBasis(
        𝔽::AbstractNumbers = ℝ,
        vs::VectorSpaceType = TangentSpaceType(),
    )
    return DefaultOrthogonalBasis{𝔽, typeof(vs)}(vs)
end
function DefaultOrthogonalBasis{𝔽}(vs::VectorSpaceType = TangentSpaceType()) where {𝔽}
    return DefaultOrthogonalBasis{𝔽, typeof(vs)}(vs)
end
function DefaultOrthogonalBasis{𝔽, TangentSpaceType}() where {𝔽}
    return DefaultOrthogonalBasis{𝔽, TangentSpaceType}(TangentSpaceType())
end


struct VeeOrthogonalBasis{𝔽} <: AbstractOrthogonalBasis{𝔽, TangentSpaceType} end
VeeOrthogonalBasis(𝔽::AbstractNumbers = ℝ) = VeeOrthogonalBasis{𝔽}()

"""
    AbstractOrthonormalBasis{𝔽,VST<:VectorSpaceType}

Abstract type that represents an orthonormal basis of vector space of type `VST` on a
manifold or a subset of it.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
abstract type AbstractOrthonormalBasis{𝔽, VST <: VectorSpaceType} <:
AbstractOrthogonalBasis{𝔽, VST} end

"""
    DefaultOrthonormalBasis(𝔽::AbstractNumbers = ℝ, vs::VectorSpaceType = TangentSpaceType())

An arbitrary orthonormal basis of vector space of type `VST` on a manifold. This will usually
be the fastest orthonormal basis available for a manifold.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# See also

[`VectorSpaceType`](@ref)
"""
struct DefaultOrthonormalBasis{𝔽, VST <: VectorSpaceType} <: AbstractOrthonormalBasis{𝔽, VST}
    vector_space::VST
end

function DefaultOrthonormalBasis(
        𝔽::AbstractNumbers = ℝ, vs::VectorSpaceType = TangentSpaceType(),
    )
    return DefaultOrthonormalBasis{𝔽, typeof(vs)}(vs)
end
function DefaultOrthonormalBasis{𝔽}(vs::VectorSpaceType = TangentSpaceType()) where {𝔽}
    return DefaultOrthonormalBasis{𝔽, typeof(vs)}(vs)
end
function DefaultOrthonormalBasis{𝔽, TangentSpaceType}() where {𝔽}
    return DefaultOrthonormalBasis{𝔽, TangentSpaceType}(TangentSpaceType())
end

"""
    ProjectedOrthonormalBasis(method::Symbol, 𝔽::AbstractNumbers = ℝ)

An orthonormal basis that comes from orthonormalization of basis vectors
of the ambient space projected onto the subspace representing the tangent space
at a given point.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

Available methods:
  - `:gram_schmidt` uses a modified Gram-Schmidt orthonormalization.
  - `:svd` uses SVD decomposition to orthogonalize projected vectors.
    The SVD-based method should be more numerically stable at the cost of
    an additional assumption (local metric tensor at a point where the
    basis is calculated has to be diagonal).
"""
struct ProjectedOrthonormalBasis{Method, 𝔽} <: AbstractOrthonormalBasis{𝔽, TangentSpaceType} end

function ProjectedOrthonormalBasis(method::Symbol, 𝔽::AbstractNumbers = ℝ)
    return ProjectedOrthonormalBasis{method, 𝔽}()
end

@doc raw"""
    GramSchmidtOrthonormalBasis{𝔽} <: AbstractOrthonormalBasis{𝔽}

An orthonormal basis obtained from a basis.

# Constructor

    GramSchmidtOrthonormalBasis(𝔽::AbstractNumbers = ℝ)
"""
struct GramSchmidtOrthonormalBasis{𝔽} <: AbstractOrthonormalBasis{𝔽, TangentSpaceType} end
GramSchmidtOrthonormalBasis(𝔽::AbstractNumbers = ℝ) = GramSchmidtOrthonormalBasis{𝔽}()

@doc raw"""
    DiagonalizingOrthonormalBasis{𝔽,TV} <: AbstractOrthonormalBasis{𝔽,TangentSpaceType}

An orthonormal basis `Ξ` as a vector of tangent vectors (of length determined by
[`manifold_dimension`](@ref)) in the tangent space that diagonalizes the curvature
tensor ``R(u,v)w`` and where the direction `frame_direction` ``v`` has curvature `0`.

The type parameter `𝔽` denotes the [`AbstractNumbers`](@ref) that will be used
as coefficients in linear combinations of the basis vectors.

# Constructor

    DiagonalizingOrthonormalBasis(frame_direction, 𝔽::AbstractNumbers = ℝ)
"""
struct DiagonalizingOrthonormalBasis{𝔽, TV} <: AbstractOrthonormalBasis{𝔽, TangentSpaceType}
    frame_direction::TV
end
function DiagonalizingOrthonormalBasis(X, 𝔽::AbstractNumbers = ℝ)
    return DiagonalizingOrthonormalBasis{𝔽, typeof(X)}(X)
end
struct DiagonalizingBasisData{D, V, ET}
    frame_direction::D
    eigenvalues::ET
    vectors::V
end

const DefaultOrDiagonalizingBasis{𝔽} =
    Union{DefaultOrthonormalBasis{𝔽, TangentSpaceType}, DiagonalizingOrthonormalBasis{𝔽}}

"""
    CachedBasis{𝔽,V,<:AbstractBasis{𝔽}} <: AbstractBasis{𝔽}

A cached version of the given `basis` with precomputed basis vectors. The basis vectors
are stored in `data`, either explicitly (like in cached variants of
[`ProjectedOrthonormalBasis`](@ref)) or implicitly.

# Constructor

    CachedBasis(basis::AbstractBasis, data)
"""
struct CachedBasis{𝔽, B, V} <:
    AbstractBasis{𝔽, TangentSpaceType} where {B <: AbstractBasis{𝔽, TangentSpaceType}, V}
    data::V
end
function CachedBasis(::B, data::V) where {V, 𝔽, B <: AbstractBasis{𝔽, <:TangentSpaceType}}
    return CachedBasis{𝔽, B, V}(data)
end
function CachedBasis(basis::CachedBasis) # avoid double encapsulation
    return basis
end
function CachedBasis(
        basis::DiagonalizingOrthonormalBasis,
        eigenvalues::ET,
        vectors::T,
    ) where {ET <: AbstractVector, T <: AbstractVector}
    data = DiagonalizingBasisData(basis.frame_direction, eigenvalues, vectors)
    return CachedBasis(basis, data)
end

# forward declarations
function get_coordinates end
function get_vector end

const all_uncached_bases{T} = Union{
    AbstractBasis{<:Any, T},
    DefaultBasis{<:Any, T},
    DefaultOrthogonalBasis{<:Any, T},
    DefaultOrthonormalBasis{<:Any, T},
}

function allocate_on(M::AbstractManifold, ::TangentSpaceType)
    return similar(Array{Float64}, representation_size(M))
end
function allocate_on(M::AbstractManifold, ::TangentSpaceType, T::Type{<:AbstractArray})
    return similar(T, representation_size(M))
end

"""
    allocate_coordinates(M::AbstractManifold, p, T, n::Int)

Allocate vector of coordinates of length `n` of type `T` of a vector at point `p`
on manifold `M`.
"""
allocate_coordinates(::AbstractManifold, p, T, n::Int) = allocate(p, T, n)
function allocate_coordinates(M::AbstractManifold, p::Int, T, n::Int)
    return (representation_size(M) == () && n == 0) ? zero(T) : zeros(T, n)
end
function allocate_result(
        M::AbstractManifold, f::typeof(get_coordinates), p, X, basis::AbstractBasis{𝔽},
    ) where {𝔽}
    T = coordinate_eltype(M, p, 𝔽)
    return allocate_coordinates(M, p, T, number_of_coordinates(M, basis))
end

@inline function allocate_result_type(
        M::AbstractManifold, f::typeof(get_vector), args::Tuple{Any, Vararg{Any}},
    )
    apf = allocation_promotion_function(M, f, args)
    return apf(
        invoke(allocate_result_type, Tuple{AbstractManifold, Any, typeof(args)}, M, f, args),
    )
end

"""
    allocation_promotion_function(M::AbstractManifold, f, args::Tuple)

Determine the function that must be used to ensure that the allocated representation is of
the right type. This is needed for [`get_vector`](@ref) when a point on a complex manifold
is represented by a real-valued vectors with a real-coefficient basis, so that
a complex-valued vector representation is allocated.
"""
allocation_promotion_function(::AbstractManifold, f, ::Tuple) = identity


_doc_default_basis = """
    default_basis(M::AbstractManifold, ::typeof(p); kwargs...)
    default_basis(M::AbstractManifold; kwargs...)

Provide a default basis for a manifold's tangent space. This can be specific for different
points `p` on `M`
The global default for both is the [`DefaultOrthonormalBasis`](@ref) with
the same number type as `M`.

This method can also be specified more precisely with a point type `T`, for the case
that on a `M` there are two different representations of points, which provide
different inverse retraction methods.

## Keyword arguments

* `field::`[`AbstractNumbers`](@ref) field for the coefficients of the basis
"""

@doc "$(_doc_default_basis)"
function default_basis(M::AbstractManifold, ::Type{T}; field::AbstractNumbers = ℝ) where {T}
    return default_basis(M; field = field)
end

@doc "$(_doc_default_basis)"
function default_basis(::AbstractManifold; field::AbstractNumbers = ℝ)
    return DefaultOrthonormalBasis(field)
end

"""
    change_basis(M::AbstractManifold, p, c, B_in::AbstractBasis, B_out::AbstractBasis)

Given a vector with coordinates `c` at point `p` from manifold `M` in basis `B_in`,
compute coordinates of the same vector in basis `B_out`.
"""
function change_basis(M::AbstractManifold, p, c, B_in::AbstractBasis, B_out::AbstractBasis)
    return get_coordinates(M, p, get_vector(M, p, c, B_in), B_out)
end

function change_basis!(
        M::AbstractManifold, c_out, p, c, B_in::AbstractBasis, B_out::AbstractBasis,
    )
    return get_coordinates!(M, c_out, p, get_vector(M, p, c, B_in), B_out)
end

function combine_allocation_promotion_functions(f::T, ::T) where {T}
    return f
end
function combine_allocation_promotion_functions(::typeof(complex), ::typeof(identity))
    return complex
end
function combine_allocation_promotion_functions(::typeof(identity), ::typeof(complex))
    return complex
end

"""
    coordinate_eltype(M::AbstractManifold, p, 𝔽::AbstractNumbers)

Get the element type for 𝔽-field coordinates of the tangent space at a point `p` from
manifold `M`. This default assumes that usually complex bases of complex manifolds have
real coordinates but it can be overridden by a more specific method.
"""
@inline function coordinate_eltype(::AbstractManifold, p, 𝔽::ComplexNumbers)
    return complex(float(number_eltype(p)))
end
@inline function coordinate_eltype(::AbstractManifold, p, ::RealNumbers)
    return real(float(number_eltype(p)))
end

@doc raw"""
    dual_basis(M::AbstractManifold, p, B::AbstractBasis)

Get the dual basis to `B`, a basis of a vector space at point `p` from manifold `M`.

The dual to the ``i``th vector ``v_i`` from basis `B` is a vector ``v^i`` from the dual space
such that ``v^i(v_j) = δ^i_j``, where ``δ^i_j`` is the Kronecker delta symbol:
````math
δ^i_j = \begin{cases}
1 & \text{ if } i=j, \\
0 & \text{ otherwise.}
\end{cases}
````
"""
dual_basis(M::AbstractManifold, p, B::AbstractBasis) = _dual_basis(M, p, B)

function _dual_basis(
        ::AbstractManifold,
        p,
        ::DefaultOrthonormalBasis{𝔽, TangentSpaceType},
    ) where {𝔽}
    return DefaultOrthonormalBasis{𝔽}(CotangentSpaceType())
end
function _dual_basis(
        ::AbstractManifold,
        p,
        ::DefaultOrthonormalBasis{𝔽, CotangentSpaceType},
    ) where {𝔽}
    return DefaultOrthonormalBasis{𝔽}(TangentSpaceType())
end

# if `p` has complex eltype but you'd like to have real basis vectors,
# you can pass `real` as a third argument to get that
function _euclidean_basis_vector(p::StridedArray, i, eltype_transform = identity)
    X = zeros(eltype_transform(eltype(p)), size(p)...)
    X[i] = 1
    return X
end
function _euclidean_basis_vector(p, i, eltype_transform = identity)
    # when p is for example a SArray
    X = similar(p, eltype_transform(eltype(p)))
    fill!(X, zero(eltype(X)))
    X[i] = 1
    return X
end

"""
    get_basis(M::AbstractManifold, p, B::AbstractBasis; kwargs...) -> CachedBasis

Compute the basis vectors of the tangent space at a point on manifold `M`
represented by `p`.

Returned object derives from [`AbstractBasis`](@ref) and may have a field `.vectors`
that stores tangent vectors or it may store them implicitly, in which case
the function [`get_vectors`](@ref) needs to be used to retrieve the basis vectors.

See also: [`get_coordinates`](@ref), [`get_vector`](@ref)
"""
function get_basis(M::AbstractManifold, p, B::AbstractBasis; kwargs...)
    return _get_basis(M, p, B; kwargs...)
end

function _get_basis(::AbstractManifold, ::Any, B::CachedBasis)
    return B
end
function _get_basis(M::AbstractManifold, p, B::ProjectedOrthonormalBasis{:svd, ℝ})
    S = representation_size(M)
    PS = prod(S)
    dim = manifold_dimension(M)
    # projection
    # TODO: find a better way to obtain a basis of the ambient space
    Xs = [
        convert(Vector, reshape(project(M, p, _euclidean_basis_vector(p, i)), PS)) for
            i in eachindex(p)
    ]
    O = reduce(hcat, Xs)
    # orthogonalization
    # TODO: try using rank-revealing QR here
    decomp = svd(O)
    rotated = Diagonal(decomp.S) * decomp.Vt
    vecs = [collect(reshape(rotated[i, :], S)) for i in 1:dim]
    # normalization
    for i in 1:dim
        i_norm = norm(M, p, vecs[i])
        vecs[i] /= i_norm
    end
    return CachedBasis(B, vecs)
end
function _get_basis(
        M::AbstractManifold,
        p,
        B::ProjectedOrthonormalBasis{:gram_schmidt, ℝ};
        kwargs...,
    )
    E = [project(M, p, _euclidean_basis_vector(p, i)) for i in eachindex(p)]
    V = gram_schmidt(M, p, E; kwargs...)
    return CachedBasis(B, V)
end
function _get_basis(M::AbstractManifold, p, B::VeeOrthogonalBasis)
    return get_basis_vee(M, p, number_system(B))
end
function get_basis_vee(M::AbstractManifold, p, N)
    return get_basis(M, p, DefaultOrthogonalBasis(N))
end

function _get_basis(M::AbstractManifold, p, B::DefaultBasis)
    return get_basis_default(M, p, number_system(B))
end
function get_basis_default(M::AbstractManifold, p, N)
    return get_basis(M, p, DefaultOrthogonalBasis(N))
end

function _get_basis(M::AbstractManifold, p, B::DefaultOrthogonalBasis)
    return get_basis_orthogonal(M, p, number_system(B))
end
function get_basis_orthogonal(M::AbstractManifold, p, N)
    return get_basis(M, p, DefaultOrthonormalBasis(N))
end

function _get_basis(M::AbstractManifold, p, B::DiagonalizingOrthonormalBasis)
    return get_basis_diagonalizing(M, p, B)
end
function get_basis_diagonalizing end

function _get_basis(M::AbstractManifold, p, B::DefaultOrthonormalBasis)
    return get_basis_orthonormal(M, p, number_system(B))
end

function get_basis_orthonormal(M::AbstractManifold, p, N::AbstractNumbers; kwargs...)
    B = DefaultOrthonormalBasis(N)
    dim = number_of_coordinates(M, B)
    Eltp = coordinate_eltype(M, p, N)
    p0 = zero(Eltp)
    p1 = one(Eltp)
    return CachedBasis(
        B,
        [get_vector(M, p, [ifelse(i == j, p1, p0) for j in 1:dim], B) for i in 1:dim],
    )
end

@doc raw"""
    get_coordinates(M::AbstractManifold, p, X, B::AbstractBasis=default_basis(M, typeof(p)))
    get_coordinates(M::AbstractManifold, p, X, B::CachedBasis)

Compute a one-dimensional vector of coefficients of the tangent vector `X`
at point denoted by `p` on manifold `M` in basis `B`.

Depending on the basis, `p` may not directly represent a point on the manifold.
For example if a basis transported along a curve is used, `p` may be the coordinate
along the curve. If a [`CachedBasis`](@ref) is provided, their stored vectors are used,
otherwise the user has to provide a method to compute the coordinates.

For the [`CachedBasis`](@ref) keep in mind that the reconstruction with [`get_vector`](@ref)
requires either a dual basis or the cached basis to be selfdual, for example orthonormal

See also: [`get_vector`](@ref), [`get_basis`](@ref)
"""
function get_coordinates(
        M::AbstractManifold, p, X, B::AbstractBasis = default_basis(M, typeof(p)),
    )
    return _get_coordinates(M, p, X, B)
end

function _get_coordinates(M::AbstractManifold, p, X, B::VeeOrthogonalBasis)
    return get_coordinates_vee(M, p, X, number_system(B))
end
function get_coordinates_vee(M::AbstractManifold, p, X, N)
    return get_coordinates(M, p, X, DefaultOrthogonalBasis(N))
end

function _get_coordinates(M::AbstractManifold, p, X, B::DefaultBasis)
    return get_coordinates_default(M, p, X, number_system(B))
end
function get_coordinates_default(M::AbstractManifold, p, X, N::AbstractNumbers)
    return get_coordinates(M, p, X, DefaultOrthogonalBasis(N))
end

function _get_coordinates(M::AbstractManifold, p, X, B::DefaultOrthogonalBasis)
    return get_coordinates_orthogonal(M, p, X, number_system(B))
end
function get_coordinates_orthogonal(M::AbstractManifold, p, X, N)
    return get_coordinates_orthonormal(M, p, X, N)
end

function _get_coordinates(M::AbstractManifold, p, X, B::DefaultOrthonormalBasis)
    return get_coordinates_orthonormal(M, p, X, number_system(B))
end
function get_coordinates_orthonormal(M::AbstractManifold, p, X, N)
    # arguments X and p for allocate_result are intentionally reversed
    # to make ManifoldDiff.jl tests pass
    c = allocate_result(M, get_coordinates, X, p, DefaultOrthonormalBasis(N))
    return get_coordinates_orthonormal!(M, c, p, X, N)
end

function _get_coordinates(M::AbstractManifold, p, X, B::DiagonalizingOrthonormalBasis)
    return get_coordinates_diagonalizing(M, p, X, B)
end
function get_coordinates_diagonalizing(
        M::AbstractManifold,
        p,
        X,
        B::DiagonalizingOrthonormalBasis,
    )
    c = allocate_result(M, get_coordinates, p, X, B)
    return get_coordinates_diagonalizing!(M, c, p, X, B)
end

function _get_coordinates(M::AbstractManifold, p, X, B::CachedBasis)
    return get_coordinates_cached(M, number_system(M), p, X, B, number_system(B))
end
function get_coordinates_cached(
        M::AbstractManifold,
        ::ComplexNumbers,
        p,
        X,
        B::CachedBasis,
        ::ComplexNumbers,
    )
    return map(vb -> conj(inner(M, p, X, vb)), get_vectors(M, p, B))
end
function get_coordinates_cached(
        M::AbstractManifold,
        ::𝔽,
        p,
        X,
        C::CachedBasis,
        ::RealNumbers,
    ) where {𝔽}
    return map(vb -> real(inner(M, p, X, vb)), get_vectors(M, p, C))
end

function get_coordinates!(
        M::AbstractManifold,
        Y,
        p,
        X,
        B::AbstractBasis = DefaultOrthonormalBasis(),
    )
    return _get_coordinates!(M, Y, p, X, B)
end
function _get_coordinates!(M::AbstractManifold, Y, p, X, B::VeeOrthogonalBasis)
    return get_coordinates_vee!(M, Y, p, X, number_system(B))
end
function get_coordinates_vee!(M::AbstractManifold, Y, p, X, N)
    return get_coordinates!(M, Y, p, X, DefaultOrthogonalBasis(N))
end

function _get_coordinates!(M::AbstractManifold, Y, p, X, B::DefaultBasis)
    return get_coordinates_default!(M, Y, p, X, number_system(B))
end
function get_coordinates_default!(M::AbstractManifold, Y, p, X, N)
    return get_coordinates!(M, Y, p, X, DefaultOrthogonalBasis(N))
end

function _get_coordinates!(M::AbstractManifold, Y, p, X, B::DefaultOrthogonalBasis)
    return get_coordinates_orthogonal!(M, Y, p, X, number_system(B))
end
function get_coordinates_orthogonal!(M::AbstractManifold, Y, p, X, N)
    return get_coordinates!(M, Y, p, X, DefaultOrthonormalBasis(N))
end

function _get_coordinates!(M::AbstractManifold, Y, p, X, B::DefaultOrthonormalBasis)
    return get_coordinates_orthonormal!(M, Y, p, X, number_system(B))
end
function get_coordinates_orthonormal! end

function _get_coordinates!(M::AbstractManifold, Y, p, X, B::DiagonalizingOrthonormalBasis)
    return get_coordinates_diagonalizing!(M, Y, p, X, B)
end
function get_coordinates_diagonalizing! end

function _get_coordinates!(M::AbstractManifold, Y, p, X, B::CachedBasis)
    return get_coordinates_cached!(M, number_system(M), Y, p, X, B, number_system(B))
end
function get_coordinates_cached!(
        M::AbstractManifold, ::ComplexNumbers, Y, p, X, B::CachedBasis, ::ComplexNumbers,
    )
    map!(vb -> conj(inner(M, p, X, vb)), Y, get_vectors(M, p, B))
    return Y
end
function get_coordinates_cached!(
        M::AbstractManifold, ::𝔽, Y, p, X, C::CachedBasis, ::RealNumbers,
    ) where {𝔽}
    map!(vb -> real(inner(M, p, X, vb)), Y, get_vectors(M, p, C))
    return Y
end

"""
    X = get_vector(M::AbstractManifold, p, c, B::AbstractBasis=default_basis(M, typeof(p)))

Convert a one-dimensional vector of coefficients in a basis `B` of
the tangent space at `p` on manifold `M` to a tangent vector `X` at `p`.

Depending on the basis, `p` may not directly represent a point on the manifold.
For example if a basis transported along a curve is used, `p` may be the coordinate
along the curve.

For the [`CachedBasis`](@ref) keep in mind that the reconstruction from [`get_coordinates`](@ref)
requires either a dual basis or the cached basis to be selfdual, for example orthonormal

See also: [`get_coordinates`](@ref), [`get_basis`](@ref), [`default_basis`](@ref)
"""
@inline function get_vector(
        M::AbstractManifold, p, c, B::AbstractBasis = default_basis(M, typeof(p)),
    )
    return _get_vector(M, p, c, B)
end

@inline function _get_vector(M::AbstractManifold, p, c, B::VeeOrthogonalBasis)
    return get_vector_vee(M, p, c, number_system(B))
end
@inline function get_vector_vee(M::AbstractManifold, p, c, N)
    return get_vector(M, p, c, DefaultOrthogonalBasis(N))
end

@inline function _get_vector(M::AbstractManifold, p, c, B::DefaultBasis)
    return get_vector_default(M, p, c, number_system(B))
end
@inline function get_vector_default(M::AbstractManifold, p, c, N)
    return get_vector(M, p, c, DefaultOrthogonalBasis(N))
end

@inline function _get_vector(M::AbstractManifold, p, c, B::DefaultOrthogonalBasis)
    return get_vector_orthogonal(M, p, c, number_system(B))
end
@inline function get_vector_orthogonal(M::AbstractManifold, p, c, N)
    return get_vector_orthonormal(M, p, c, N)
end

function _get_vector(M::AbstractManifold, p, c, B::DefaultOrthonormalBasis)
    return get_vector_orthonormal(M, p, c, number_system(B))
end
function get_vector_orthonormal(M::AbstractManifold, p, c, N)
    B = DefaultOrthonormalBasis(N)
    Y = allocate_result(M, get_vector, p, c)
    return get_vector!(M, Y, p, c, B)
end

@inline function _get_vector(M::AbstractManifold, p, c, B::DiagonalizingOrthonormalBasis)
    return get_vector_diagonalizing(M, p, c, B)
end
function get_vector_diagonalizing(
        M::AbstractManifold,
        p,
        c,
        B::DiagonalizingOrthonormalBasis,
    )
    Y = allocate_result(M, get_vector, p, c)
    return get_vector!(M, Y, p, c, B)
end

@inline function _get_vector(M::AbstractManifold, p, c, B::CachedBasis)
    return get_vector_cached(M, p, c, B)
end
_get_vector_cache_broadcast(::Any) = Val(true)
function get_vector_cached(M::AbstractManifold, p, X, B::CachedBasis)
    # quite convoluted but:
    #  1) preserves the correct `eltype`
    #  2) guarantees a reasonable array type `Y`
    #     (for example scalar * `SizedValidation` is an `SArray`)
    bvectors = get_vectors(M, p, B)
    if _get_vector_cache_broadcast(bvectors[1]) === Val(false)
        Xt = X[1] * bvectors[1]
        for i in 2:length(X)
            copyto!(Xt, Xt + X[i] * bvectors[i])
        end
    else
        Xt = X[1] .* bvectors[1]
        for i in 2:length(X)
            Xt .+= X[i] .* bvectors[i]
        end
    end
    return Xt
end
@inline function get_vector!(
        M::AbstractManifold,
        Y,
        p,
        c,
        B::AbstractBasis = DefaultOrthonormalBasis(),
    )
    return _get_vector!(M, Y, p, c, B)
end

@inline function _get_vector!(M::AbstractManifold, Y, p, c, B::VeeOrthogonalBasis)
    return get_vector_vee!(M, Y, p, c, number_system(B))
end
@inline get_vector_vee!(M, Y, p, c, N) = get_vector!(M, Y, p, c, DefaultOrthogonalBasis(N))

@inline function _get_vector!(M::AbstractManifold, Y, p, c, B::DefaultBasis)
    return get_vector_default!(M, Y, p, c, number_system(B))
end
@inline function get_vector_default!(M::AbstractManifold, Y, p, c, N)
    return get_vector!(M, Y, p, c, DefaultOrthogonalBasis(N))
end

@inline function _get_vector!(M::AbstractManifold, Y, p, c, B::DefaultOrthogonalBasis)
    return get_vector_orthogonal!(M, Y, p, c, number_system(B))
end
@inline function get_vector_orthogonal!(M::AbstractManifold, Y, p, c, N)
    return get_vector!(M, Y, p, c, DefaultOrthonormalBasis(N))
end

@inline function _get_vector!(M::AbstractManifold, Y, p, c, B::DefaultOrthonormalBasis)
    return get_vector_orthonormal!(M, Y, p, c, number_system(B))
end
function get_vector_orthonormal! end

@inline function _get_vector!(
        M::AbstractManifold, Y, p, c, B::DiagonalizingOrthonormalBasis,
    )
    return get_vector_diagonalizing!(M, Y, p, c, B)
end
function get_vector_diagonalizing! end

@inline function _get_vector!(M::AbstractManifold, Y, p, c, B::CachedBasis)
    return get_vector_cached!(M, Y, p, c, B)
end
function get_vector_cached!(M::AbstractManifold, Y, p, X, B::CachedBasis)
    # quite convoluted but:
    #  1) preserves the correct `eltype`
    #  2) guarantees a reasonable array type `Y`
    #     (for example scalar * `SizedValidation` is an `SArray`)
    bvectors = get_vectors(M, p, B)
    return if _get_vector_cache_broadcast(bvectors[1]) === Val(false)
        Xt = X[1] * bvectors[1]
        copyto!(Y, Xt)
        for i in 2:length(X)
            copyto!(Y, Y + X[i] * bvectors[i])
        end
        return Y
    else
        Xt = X[1] .* bvectors[1]
        copyto!(Y, Xt)
        for i in 2:length(X)
            Y .+= X[i] .* bvectors[i]
        end
        return Y
    end
end

"""
    get_vectors(M::AbstractManifold, p, B::AbstractBasis=get_basis(M, p, DefaultOrthonormalBasis()))

Get the basis vectors of basis `B` of the tangent space at point `p`.
The function may or may not work if passed a basis other than a [`CachedBasis`](@ref).
A `CachedBasis` can be obtained by calling [`get_basis`](@ref).
"""
function get_vectors(M::AbstractManifold, p, B::AbstractBasis)
    return _get_vectors(M, p, B)
end
function get_vectors(M::AbstractManifold, p)
    return get_vectors(M, p, get_basis(M, p, DefaultOrthonormalBasis()))
end
function _get_vectors(::AbstractManifold, ::Any, B::CachedBasis)
    return _get_vectors(B)
end
_get_vectors(B::CachedBasis{𝔽, <:AbstractBasis, <:AbstractArray}) where {𝔽} = B.data
function _get_vectors(B::CachedBasis{𝔽, <:AbstractBasis, <:DiagonalizingBasisData}) where {𝔽}
    return B.data.vectors
end

@doc raw"""
    gram_schmidt(M::AbstractManifold{𝔽}, p, B::AbstractBasis{𝔽}) where {𝔽}
    gram_schmidt(M::AbstractManifold, p, V::AbstractVector)

Compute an ONB in the tangent space at `p` on the [`AbstractManifold`](@ref} `M` from either an
[`AbstractBasis`](@ref) basis ´B´ or a set of (at most) [`manifold_dimension`](@ref)`(M)`
many vectors.
Note that this method requires the manifold and basis to work on the same
[`AbstractNumbers`](@ref) `𝔽`, i.e. with real coefficients.

The method always returns a basis, i.e. linearly dependent vectors are removed.

# Keyword arguments

* `warn_linearly_dependent` (`false`) – warn if the basis vectors are not linearly
  independent
* `skip_linearly_dependent` (`false`) – whether to just skip (`true`) a vector that
  is linearly dependent to the previous ones or to stop (`false`, default) at that point
* `return_incomplete_set` (`false`) – throw an error if the resulting set of vectors is not
  a basis but contains less vectors

further keyword arguments can be passed to set the accuracy of the independence test.
Especially `atol` is raised slightly by default to `atol = 5*1e-16`.

# Return value

When a set of vectors is orthonormalized a set of vectors is returned.
When an [`AbstractBasis`](@ref) is orthonormalized, a [`CachedBasis`](@ref) is returned.
"""
function gram_schmidt(
        M::AbstractManifold{𝔽}, p, B::AbstractBasis{𝔽};
        warn_linearly_dependent = false, return_incomplete_set = false, skip_linearly_dependent = false,
        kwargs...,
    ) where {𝔽}
    V = gram_schmidt(
        M, p, get_vectors(M, p, B);
        warn_linearly_dependent = warn_linearly_dependent, skip_linearly_dependent = skip_linearly_dependent,
        return_incomplete_set = return_incomplete_set, kwargs...,
    )
    return CachedBasis(GramSchmidtOrthonormalBasis(𝔽), V)
end
function gram_schmidt(
        M::AbstractManifold, p, V::AbstractVector;
        atol = eps(number_eltype(first(V))), warn_linearly_dependent = false,
        return_incomplete_set = false, skip_linearly_dependent = false,
        kwargs...,
    )
    N = length(V)
    Ξ = empty(V)
    dim = manifold_dimension(M)
    N < dim && @warn "Input only has $(N) vectors, but manifold dimension is $(dim)."
    @inbounds for n in 1:N
        Ξₙ = copy(M, p, V[n])
        for k in 1:length(Ξ)
            Ξₙ .-= real(inner(M, p, Ξ[k], Ξₙ)) .* Ξ[k]
        end
        nrmΞₙ = norm(M, p, Ξₙ)
        if isapprox(nrmΞₙ / dim, 0; atol = atol, kwargs...)
            warn_linearly_dependent &&
                @warn "Input vector $(n) lies in the span of the previous ones."
            !skip_linearly_dependent && throw(
                ErrorException("Input vector $(n) lies in the span of the previous ones."),
            )
        else
            push!(Ξ, Ξₙ ./ nrmΞₙ)
        end
        if length(Ξ) == dim
            (n < N) &&
                @warn "More vectors ($(N)) entered than the dimension of the manifold ($dim). All vectors after the $n th ignored."
            return Ξ
        end
    end
    if return_incomplete_set # if we reach this point - length(Ξ) < dim
        return Ξ
    else
        throw(
            ErrorException(
                "gram_schmidt found only $(length(Ξ)) orthonormal basis vectors, but manifold dimension is $(dim).",
            ),
        )
    end
end


@doc raw"""
    hat(M::AbstractManifold, p, Xⁱ)

Given a basis ``e_i`` on the tangent space at a point `p` and tangent
component vector ``X^i ∈ ℝ``, compute the equivalent vector representation
``X=X^i e_i``, where Einstein summation notation is used:

````math
∧ : X^i ↦ X^i e_i
````

For array manifolds, this converts a vector representation of the tangent
vector to an array representation. The [`vee`](@ref) map is the `hat` map's
inverse.
"""
@inline hat(M::AbstractManifold, p, X) = get_vector(M, p, X, VeeOrthogonalBasis(ℝ))
@inline hat!(M::AbstractManifold, Y, p, X) = get_vector!(M, Y, p, X, VeeOrthogonalBasis(ℝ))

"""
    number_of_coordinates(M::AbstractManifold, B::AbstractBasis)
    number_of_coordinates(M::AbstractManifold, ::𝔾)

Compute the number of coordinates in basis of field type `𝔾` on a manifold `M`.
This also corresponds to the number of vectors represented by `B`,
or stored within `B` in case of a [`CachedBasis`](@ref).
"""
function number_of_coordinates(M::AbstractManifold, ::AbstractBasis{𝔾}) where {𝔾}
    return number_of_coordinates(M, 𝔾)
end
function number_of_coordinates(M::AbstractManifold, f::𝔾) where {𝔾}
    return div(manifold_dimension(M), real_dimension(f))
end

"""
    number_system(::AbstractBasis)

The number system for the vectors of the given basis.
"""
number_system(::AbstractBasis{𝔽}) where {𝔽} = 𝔽

"""
    requires_caching(B::AbstractBasis)

Return whether basis `B` can be used in [`get_vector`](@ref) and [`get_coordinates`](@ref)
without calling [`get_basis`](@ref) first.
"""
requires_caching(::AbstractBasis) = true
requires_caching(::CachedBasis) = false
requires_caching(::DefaultBasis) = false
requires_caching(::DefaultOrthogonalBasis) = false
requires_caching(::DefaultOrthonormalBasis) = false

function _show_basis_vector(io::IO, X; pre = "", head = "")
    sX = sprint(show, "text/plain", X, context = io, sizehint = 0)
    sX = replace(sX, '\n' => "\n$(pre)")
    return print(io, head, pre, sX)
end
function _show_basis_vector_range(io::IO, Ξ, range; pre = "", sym = "E")
    for i in range
        _show_basis_vector(io, Ξ[i]; pre = pre, head = "\n$(sym)$(i) =\n")
    end
    return nothing
end
function _show_basis_vector_range_noheader(io::IO, Ξ; max_vectors = 4, pre = "", sym = "E")
    nv = length(Ξ)
    return if nv ≤ max_vectors
        _show_basis_vector_range(io, Ξ, 1:nv; pre = "  ", sym = " E")
    else
        halfn = div(max_vectors, 2)
        _show_basis_vector_range(io, Ξ, 1:halfn; pre = "  ", sym = " E")
        print(io, "\n ⋮")
        _show_basis_vector_range(io, Ξ, (nv - halfn + 1):nv; pre = "  ", sym = " E")
    end
end

function show(io::IO, ::DefaultBasis{𝔽}) where {𝔽}
    return print(io, "DefaultBasis($(𝔽))")
end
function show(io::IO, ::DefaultOrthogonalBasis{𝔽}) where {𝔽}
    return print(io, "DefaultOrthogonalBasis($(𝔽))")
end
function show(io::IO, ::DefaultOrthonormalBasis{𝔽}) where {𝔽}
    return print(io, "DefaultOrthonormalBasis($(𝔽))")
end
function show(io::IO, ::GramSchmidtOrthonormalBasis{𝔽}) where {𝔽}
    return print(io, "GramSchmidtOrthonormalBasis($(𝔽))")
end
function show(io::IO, ::ProjectedOrthonormalBasis{method, 𝔽}) where {method, 𝔽}
    return print(io, "ProjectedOrthonormalBasis($(repr(method)), $(𝔽))")
end
function show(io::IO, ::MIME"text/plain", onb::DiagonalizingOrthonormalBasis)
    println(
        io,
        "DiagonalizingOrthonormalBasis($(number_system(onb))) with eigenvalue 0 in direction:",
    )
    sk = sprint(show, "text/plain", onb.frame_direction, context = io, sizehint = 0)
    sk = replace(sk, '\n' => "\n ")
    return print(io, sk)
end
function show(
        io::IO,
        ::MIME"text/plain",
        B::CachedBasis{𝔽, T, D},
    ) where {𝔽, T <: AbstractBasis, D}
    try
        vectors = _get_vectors(B)
        print(
            io,
            "Cached basis of type $T with $(length(vectors)) basis vector$(length(vectors) == 1 ? "" : "s"):",
        )
        return _show_basis_vector_range_noheader(
            io,
            vectors;
            max_vectors = 4,
            pre = "  ",
            sym = " E",
        )
    catch e
        # in case _get_vectors(B) is not defined
        print(io, "Cached basis of type $T")
    end
end
function show(
        io::IO,
        ::MIME"text/plain",
        B::CachedBasis{𝔽, T, D},
    ) where {𝔽, T <: DiagonalizingOrthonormalBasis, D <: DiagonalizingBasisData}
    vectors = _get_vectors(B)
    nv = length(vectors)
    sk = sprint(show, "text/plain", T(B.data.frame_direction), context = io, sizehint = 0)
    sk = replace(sk, '\n' => "\n ")
    print(io, sk)
    println(io, "\nand $(nv) basis vector$(nv == 1 ? "" : "s").")
    print(io, "Basis vectors:")
    _show_basis_vector_range_noheader(io, vectors; max_vectors = 4, pre = "  ", sym = " E")
    println(io, "\nEigenvalues:")
    sk = sprint(show, "text/plain", B.data.eigenvalues, context = io, sizehint = 0)
    sk = replace(sk, '\n' => "\n ")
    return print(io, ' ', sk)
end

@doc raw"""
    vee(M::AbstractManifold, p, X)

Given a basis ``e_i`` on the tangent space at a point `p` and tangent
vector `X`, compute the vector components ``X^i ∈ ℝ``, such that ``X = X^i e_i``, where
Einstein summation notation is used:

````math
\vee : X^i e_i ↦ X^i
````

For array manifolds, this converts an array representation of the tangent
vector to a vector representation. The [`hat`](@ref) map is the `vee` map's
inverse.
"""
vee(M::AbstractManifold, p, X) = get_coordinates(M, p, X, VeeOrthogonalBasis(ℝ))
function vee!(M::AbstractManifold, Y, p, X)
    return get_coordinates!(M, Y, p, X, VeeOrthogonalBasis(ℝ))
end

@doc raw"""
    check_inverse_retraction(
        M::AbstractManifold,
        inverse_rectraction_method::AbstractInverseRetractionMethod,
        p=rand(M),
        X=rand(M; vector_at=p);
        #
        exactness_tol::Real = 1e-12,
        io::Union{IO,Nothing} = nothing,
        limits::Tuple = (-8.0, 0.0),
        log_range::AbstractVector = range(limits[1], limits[2]; length=N),
        N::Int = 101,
        name::String = "inverse retraction",
        plot::Bool = false,
        second_order::Bool = true
        slope_tol::Real = 0.1,
        error::Symbol = :none,
        window = nothing,
    )

Check numerically whether the inverse retraction `inverse_retraction_method` is correct.
This requires the [`exp`](@ref) and [`norm`](@ref) functions to be implemented for the [`AbstractManifold`](@ref) `M`.

This implements a method similar to [Boumal:2023; Section 4.8 or Section 6.8](@cite).

Note that if the errors are below the given tolerance and the method is exact,
no plot is generated,

# Keyword arguments

* `exactness_tol`:     if all errors are below this tolerance, the inverse retraction is considered to be exact
* `io`:                provide an `IO` to print the result to
* `limits`:            specify the limits in the `log_range`, that is the exponent for the range
* `log_range`:         specify the range of points (in log scale) to sample the length of the tangent vector `X`
* `N`:                 number of points to verify within the `log_range` default range ``[10^{-8},10^{0}]``
* `name`:              name to display in the plot
* `plot`:              whether to plot the result (see [`plot_slope`](@ref))
  The plot is in log-log-scale. This is returned and can then also be saved.
* `second_order`:      check whether the retraction is of second order. if set to `false`, first order is checked.
* `slope_tol`:         tolerance for the slope (global) of the approximation
* `error`:             specify how to report errors: `:none`, `:info`, `:warn`, or `:error` are available
* `window`:            specify window sizes within the `log_range` that are used for the slope estimation.
  the default is, to use all window sizes `2:N`.

Note that since the plot yields more information than throwing an error, when both are specified,
the plot is generated first and returned (to be shown/displayed), such that no error is thrown.
You can switch to e.g. `:warn` to get a warning together with the plot.
"""
function check_inverse_retraction(
        M::AbstractManifold,
        inverse_retraction_method::AbstractInverseRetractionMethod,
        p = rand(M),
        X = rand(M; vector_at = p);
        exactness_tol::Real = 1.0e-12,
        io::Union{IO, Nothing} = nothing,
        limits = (-8.0, 0.0),
        N::Int = 101,
        second_order::Bool = true,
        name::String = second_order ? "second order inverse retraction" : "inverse retraction",
        log_range::AbstractVector = range(limits[1], limits[2]; length = N),
        plot::Bool = false,
        slope_tol::Real = 0.1,
        error::Symbol = :none,
        window = nothing,
    )
    Xn = X ./ norm(M, p, X) # normalize tangent direction
    # function for the directional derivative
    #
    T = exp10.(log_range)
    # points `p_i` to evaluate the error function at
    points = [exp_fused(M, p, Xn, t) for t in T]
    Xs = [t * Xn for t in T]
    approx_Xs = [inverse_retract(M, p, q, inverse_retraction_method) for q in points]
    errors = [norm(M, p, X - Y) for (X, Y) in zip(Xs, approx_Xs)]
    return prepare_check_result(
        log_range, errors, second_order ? 3.0 : 2.0;
        error = error, exactness_tol = exactness_tol, io = io,
        name = name, plot = plot, slope_tol = slope_tol, window = window,
    )
end

"""
    plot_check_geodesic(T, N, e_norm, e_pt, e_alpha)

Plot the three errors `e_norm`, `e_pt, `e_alpha` as described in [`check_geodesic`](@ref),
where `T` are all time points used, `N` is their length, where
* `e_norm` is of length N-1, since it is obtained from forward differences,
* `e_pt` and `e_alpha` are of length `N-2` since they are second order forward differences
"""
function plot_check_geodesic end

function plot_check_geodesic(T, N, e_norm, e_pt, e_alpha)
    return plot_check_geodesic(Val(Symbol(get_plotting_backend())), T, N, e_norm, e_pt, e_alpha)
end

@doc raw"""
    check_geodesic(
        M::AbstractManifold,
        p=rand(M),
        X=rand(M; vector_at=p);
        #
        tol::Real = 1e-12,
        io::Union{IO,Nothing} = nothing,
        N::Int = 101,
        name::String = "geodesic",
        plot::Bool = false,
        error::Symbol = :none,
        inverse_retraction_method::AbstractInverseRetractionMethod = LogarithmicInverseRetraction(),
        vector_transport_method::AbstractVectorTransportMethod = ParallelTransport(),
    )

Numerically check whether the [`geodesic`](@ref) implementation is correct.
This check requires both the [`log`](@ref) and [`parallel_transport_to`](@ref) functions to be implemented
in order to an exact numerical verification.
We further require the [`norm`](@ref) function to be implemented for the [`AbstractManifold`](@ref) `M`.

You can provide an `inverse_retraction_method` and `vector_transport_method` to be used,
but the verification will then be less accurate.

The tests performed are the following based on sampling the geodesic ``\gamma(t) = ``[`geodesic`](@ref)`(M, p, X)` at
`N` equidistant points ``t_i = i/(N-1)``, `i=0,...,N-1` we denote by ``p_i = \gamma(t_i)``

1. Compute the norms of the tangent vectors ``\dot\gamma(t_i) ≈ X_i = \log_{p_i}(p_{i+1})``, ``i=0,...,N-2``
   and check how far these norms deviate from their mean value.
2. Check how far this mean deviates from being ``\frac{||X||}{N-1}``
3. Check that the parallel transport of each ``X_i`` from ``p_i`` to ``p_{i+1}`` is close to ``X_{i+1}``.

# Arguments
* `M`:    the manifold to check
* `p`:    point on the manifold to start the geodesic, a random point is used by default
* `X`:    tangent vector at `p` to start the geodesic, a random tangent vector is used by default

# Keyword arguments
* `tol`:     if all errors are below this tolerance, the geodesic is considered to be exact
* `io`:      provide an `IO` to print the result to
* `N`:       number of points to sample the geodesic on ``[0,1]`` (default: 101)
* `plot`:    whether to plot the result (if `Plots.jl` is loaded).
* `error`:   specify how to report errors: `:none`, `:info`, `:warn`, or `:error` are available
* `inverse_retraction_method`:  method to use for the inverse retraction, it is recommended to use [`LogarithmicInverseRetraction`](@ref)
* `vector_transport_method`:    method to use for the vector transport, it is recommended to use [`ParallelTransport`](@ref)

Note that since the plot yields more information than throwing an error, when both are specified,
the plot is generated first and returned (to be shown/displayed), such that no error is thrown.
You can switch to e.g. `:warn` to get a warning together with the plot.
"""
function check_geodesic(
        M::AbstractManifold, p = rand(M), X = rand(M; vector_at = p);
        error::Symbol = :none, io::Union{IO, Nothing} = nothing,
        N::Int = 101, tol::Real = 1.0e-12, plot::Bool = false,
        inverse_retraction_method::AbstractInverseRetractionMethod = LogarithmicInverseRetraction(),
        vector_transport_method::AbstractVectorTransportMethod = ParallelTransport(),
    )
    T = range(0.0, 1.0; length = N)
    γ = geodesic(M, p, X)
    # points `p_i` to evaluate the error function at
    ps = [ γ(t) for t in T ]
    Xs = [ inverse_retract(M, ps[i], ps[i + 1], inverse_retraction_method) for i in 1:(N - 1) ]
    norms = [ norm(M, p, X) for (p, X) in zip(ps[1:(end - 1)], Xs) ]
    mean_norm = sum(norms) / length(norms)
    # errors_1 how far awary are we from constant speed
    errors_norm = [ abs(n - mean_norm) for n in norms ]
    err_n_max = maximum(errors_norm)
    # PT Xs to their neighbors, now Xi and Yi are in the same tangent space
    Ys = [ vector_transport_to(M, ps[i + 1], Xs[i + 1], ps[i], vector_transport_method) for i in 1:(N - 2)]
    # transporting (an approximation of) γ'(t_{i+1}) to T_{p_i}M should approximately equal γ'(t_i)
    # (a) we measure this in norm
    errors_pt = [ norm(M, p, X - Y) for (p, X, Y) in zip(ps[1:(N - 2)], Xs[1:(N - 2)], Ys) ]
    err_pt_max = maximum(errors_pt)
    # (b) we measure the angle preservation
    errors_α = [ abs(1 - inner(M, p, X, Y) / (norm(M, p, X) * norm(M, p, Y))) for (p, X, Y) in zip(ps[1:(N - 2)], Xs[1:(N - 2)], Ys) ]
    err_α_max = maximum(errors_α)
    msg = """
    Geodesic check results:
    - max deviation from constant speed: $(err_n_max)
    - max deviation from parallel transport: $(err_pt_max)
    - max deviation from angle preservation: $(err_α_max)
    """
    (io !== nothing) && print(io, msg)
    dre = (err_n_max > tol) || (err_pt_max > tol) || (err_α_max > tol)
    dre && (error === :info) && @info msg
    dre && (error === :warn) && @warn msg
    plot && return ManifoldsBase.plot_check_geodesic(T, N, errors_norm, errors_pt, errors_α)
    dre && (error === :error) && throw(ErrorException(msg))
    return !dre
end
@doc raw"""
    check_retraction(
        M::AbstractManifold, rectraction_method::AbstractRetractionMethod,
        p=rand(M), X=rand(M; vector_at=p);
        #
        exactness_tol::Real = 1e-12,
        io::Union{IO,Nothing} = nothing,
        limits::Tuple = (-8.0, 0.0),
        log_range::AbstractVector = range(limits[1], limits[2]; length=N),
        N::Int = 101,
        name::String = "retraction",
        plot::Bool = false,
        second_order::Bool = true
        slope_tol::Real = 0.1,
        error::Symbol = :none,
        window = nothing,
    )

Check numerically whether the retraction `vector_transport_to` is correct, by selecting
a set of points ``q_i = \exp_p (t_i X)`` where ``t`` takes all values from `log_range`,
to then compare [`parallel_transport_to`](@ref) to the `vector_transport_method`
applied to the vector `Y`.

This requires the [`exp`](@ref), [`parallel_transport_to`](@ref) and [`norm`](@ref) function
to be implemented for the [`AbstractManifold`](@ref) `M`.

This implements a method similar to [Boumal:2023; Section 4.8 or Section 6.8](@cite).

Note that if the errors are below the given tolerance and the method is exact,
no plot is generated,

# Keyword arguments

* `exactness_tol`:     if all errors are below this tolerance, the retraction is considered to be exact
* `io`:                provide an `IO` to print the result to
* `limits`:            specify the limits in the `log_range`, that is the exponent for the range
* `log_range`:         specify the range of points (in log scale) to sample the length of the tangent vector `X`
* `N`:                 number of points to verify within the `log_range` default range ``[10^{-8},10^{0}]``
* `name`:              name to display in the plot
* `plot`:              whether to plot the result (if `Plots.jl` is loaded).
  The plot is in log-log-scale. This is returned and can then also be saved.
* `second_order`:      check whether the retraction is of second order. if set to `false`, first order is checked.
* `slope_tol`:         tolerance for the slope (global) of the approximation
* `error`:             specify how to report errors: `:none`, `:info`, `:warn`, or `:error` are available
* `window`:            specify window sizes within the `log_range` that are used for the slope estimation.
  the default is, to use all window sizes `2:N`.

Note that since the plot yields more information than throwing an error, when both are specified,
the plot is generated first and returned (to be shown/displayed), such that no error is thrown.
You can switch to e.g. `:warn` to get a warning together with the plot.
"""
function check_retraction(
        M::AbstractManifold, retraction_method::AbstractRetractionMethod,
        p = rand(M), X = rand(M; vector_at = p);
        error::Symbol = :none, exactness_tol::Real = 1.0e-12,
        io::Union{IO, Nothing} = nothing, limits::Tuple = (-8.0, 0.0), N::Int = 101,
        second_order::Bool = true,
        name::String = second_order ? "second order retraction" : "retraction",
        log_range = range(limits[1], limits[2]; length = N),
        plot::Bool = false, slope_tol::Real = 0.1, window = nothing,
    )
    Xn = X ./ norm(M, p, X) # normalize tangent direction
    # function for the directional derivative
    #
    T = exp10.(log_range)
    # points `p_i` to evaluate the error function at
    points = [exp_fused(M, p, Xn, t) for t in T]
    approx_points = [retract_fused(M, p, Xn, t, retraction_method) for t in T]
    errors = [distance(M, p, q) for (p, q) in zip(points, approx_points)]
    return prepare_check_result(
        log_range, errors, second_order ? 3.0 : 2.0;
        error = error, exactness_tol = exactness_tol, io = io,
        name = name, plot = plot, slope_tol = slope_tol, window = window,
    )
end

@doc raw"""
    check_vector_transport(
        M::AbstractManifold, vector_transport_method::AbstractVectorTransportMethod,
        p=rand(M), X=rand(M; vector_at=p), Y=rand(M; vector_at=p);
        #
        error::Symbol = :none,
        exactness_tol::Real = 1e-12,
        io::Union{IO,Nothing} = nothing,
        limits::Tuple = (-8.0, 0.0),
        log_range::AbstractVector = range(limits[1], limits[2]; length=N),
        N::Int = 101,
        name::String = "inverse retraction",
        plot::Bool = false,
        second_order::Bool = true
        slope_tol::Real = 0.1,
        window = nothing,
    )

Check numerically whether the retraction `vector_transport_to` is correct, by selecting
a set of points ``q_i = \exp_p (t_i X)`` where ``t`` takes all values from `log_range`,
to then compare [`parallel_transport_to`](@ref) to the `vector_transport_method`
applied to the vector `Y`.

This requires the [`exp`](@ref), [`parallel_transport_to`](@ref) and [`norm`](@ref) function
to be implemented for the [`AbstractManifold`](@ref) `M`.

This implements a method similar to [Boumal:2023; Section 4.8 or Section 6.8](@cite).

Note that if the errors are below the given tolerance and the method is exact,
no plot is generated,

# Keyword arguments

* `exactness_tol`:     if all errors are below this tolerance, the differential is considered to be exact
* `io`:                provide an `IO` to print the result to
* `limits`:            specify the limits in the `log_range`, that is the exponent for the range
* `log_range`:         specify the range of points (in log scale) to sample the differential line
* `N`:                 number of points to verify within the `log_range` default range ``[10^{-8},10^{0}]``
* `name`:              name to display in the plot
* `plot`:              whether to plot the result (if `Plots.jl` is loaded).
  The plot is in log-log-scale. This is returned and can then also be saved.
* `second_order`:      check whether the retraction is of second order. if set to `false`, first order is checked.
* `slope_tol`:         tolerance for the slope (global) of the approximation
* `error`:             specify how to report errors: `:none`, `:info`, `:warn`, or `:error` are available
* `window`:            specify window sizes within the `log_range` that are used for the slope estimation.
  the default is, to use all window sizes `2:N`.

Note that since the plot yields more information than throwing an error, when both are specified,
the plot is generated first and returned (to be shown/displayed), such that no error is thrown.
You can switch to e.g. `:warn` to get a warning together with the plot.
"""
function check_vector_transport(
        M::AbstractManifold, vector_transport_method::AbstractVectorTransportMethod,
        p = rand(M), X = rand(M; vector_at = p), Y = rand(M; vector_at = p);
        error::Symbol = :none, exactness_tol::Real = 1.0e-12,
        io::Union{IO, Nothing} = nothing,
        limits::Tuple = (-8.0, 0.0),
        N::Int = 101,
        log_range::AbstractVector = range(limits[1], limits[2]; length = N),
        second_order::Bool = true,
        name::String = second_order ? "second order vector transport" : "vector transport",
        plot::Bool = false, slope_tol::Real = 0.1, window = nothing,
    )
    Xn = X ./ norm(M, p, X) # normalize tangent direction
    # function for the directional derivative
    #
    T = exp10.(log_range)
    # points `p_i` to evaluate the error function at
    points = [exp_fused(M, p, Xn, t) for t in T]
    Yv = [vector_transport_to(M, p, Y, q, vector_transport_method) for q in points]
    Yp = [parallel_transport_to(M, p, Y, q) for q in points]
    errors = [norm(M, q, X - Y) for (q, X, Y) in zip(points, Yv, Yp)]
    return prepare_check_result(
        log_range, errors, second_order ? 3.0 : 2.0;
        error = error, exactness_tol = exactness_tol,
        io = io, name = name, plot = plot, slope_tol = slope_tol, window = window,
    )
end

function plot_slope end

"""
    plot_slope(
        x, y; slope=2, line_base=0, a=0, b=2.0, i=1, j=length(x)
    )

Plot the result from the verification functions on data `x,y` with two comparison lines

1) `line_base` + t`slope`  as the global slope(s) the plot could have
2) `a` + `b*t` on the interval [`x[i]`, `x[j]`] for some (best fitting) comparison slope

!!! note
    This function has to be implemented for a certain plotting package.
    loading [Plots.jl](https://docs.juliaplots.org/stable/) provides a default implementation.
"""
plot_slope(x, y; kwargs...)

function plot_slope(x, y; kwargs...)
    return plot_slope(Val(Symbol(get_plotting_backend())), x, y; kwargs...)
end

"""
    prepare_check_result(
        log_range::AbstractVector, errors::AbstractVector, slope::Real;
        error::Symbol = :none, exactness_to::Real = 1e3*eps(eltype(errors)),
        io::Union{IO,Nothing} = nothing name::String = "estimated slope",
        plot::Bool = false, slope_tol::Real = 0.1,
    )

Given a range of values `log_range`, with computed `errors`,
verify whether this yields a slope of `slope` in log-scale

Note that if the errors are below the given tolerance and the method is exact,
no plot is be generated,

# Keyword arguments

* `exactness_tol`: if all errors are below this tolerance, the verification is considered exact.
  Errors below it are excluded from the slope estimation, since an error that small is round-off
  from evaluating the function rather than approximation error.
* `io`:            provide an `IO` to print the result to
* `name`:          name to display in the plot title
* `plot`:          whether to plot the result, see [`plot_slope`](@ref)
  The plot is in log-log-scale. This is returned and can then also be saved.
* `slope_tol`:     tolerance for the slope (global) of the approximation
* `error`:         specify how to handle errors, `:none`, `:info`, `:warn`, `:error`

Note that since the plot yields more information than throwing an error, when both are specified,
the plot is generated first and returned (to be shown/displayed), such that no error is thrown.
You you can switch to e.g. `:warn` to get a warning together with the plot.
"""
function prepare_check_result(
        log_range::AbstractVector, errors::AbstractVector, slope::Real;
        error::Symbol = :none, exactness_tol::Real = 1.0e3 * eps(eltype(errors)),
        io::Union{IO, Nothing} = nothing, name::String = "estimated slope",
        plot::Bool = false, slope_tol::Real = 1.0e-1, window = nothing,
    )
    if max(errors...) < exactness_tol
        (io !== nothing) && print(
            io,
            "All errors are below the exactness tolerance $(exactness_tol). Your check can be considered exact, hence there is no use to check for a slope.\n",
        )
        return true
    end
    # all samples that can be displayed in a log-log plot
    x_all = log_range[errors .> 0]
    T = exp10.(x_all)
    e_all = errors[errors .> 0]
    y_all = log10.(e_all)
    # samples that still say something: once the error is down to the round-off of evaluating
    # the function it no longer decreases with `t`, and fitting those in flattens the slope –
    # the more so the higher the order, whose error reaches round-off for larger `t` already
    k = findall(>(exactness_tol), e_all)
    (length(k) < 3) && (k = eachindex(e_all)) # too little left to fit a line through
    x = x_all[k]
    y = y_all[k]
    # anchor the reference line at the first sample that is used for the fit
    line_base = y[1] - slope * x[1]
    (a, b) = find_best_slope_window(x, y, length(x))[1:2]
    if isapprox(b, slope; atol = slope_tol)
        plot && return plot_slope(
            T, e_all;
            slope = slope, line_base = line_base, a = a, b = b, i = first(k), j = last(k),
        )
        (io !== nothing) && print(
            io,
            "Your $name's slope is globally $(@sprintf("%.4f", b)), so within $slope ± $(slope_tol).\n",
        )
        return true
    end
    # otherwise
    # find best contiguous window of length w
    (ab, bb, ib, jb) = find_best_slope_window(
        x, y, window; slope = slope, slope_tol = slope_tol
    )
    msg = "The $(name) fits best on [$(exp10(x[ib])),$(exp10(x[jb]))] with slope  $(@sprintf("%.4f", bb)), but globally your slope $(@sprintf("%.4f", b)) is outside of the tolerance $slope ± $(slope_tol).\n"
    (io !== nothing) && print(io, msg)
    (error === :info) && @info msg
    (error === :warn) && @warn msg
    plot && return plot_slope(
        T, e_all;
        slope = slope, line_base = line_base, a = ab, b = bb, i = k[ib], j = k[jb],
    )
    (error === :error) && throw(ErrorException(msg))
    return false
end

function find_best_slope_window end

"""
    (a, b, i, j) = find_best_slope_window(X, Y, window=nothing; slope::Real=2.0, slope_tol::Real=0.1)

Check data X,Y for the largest contiguous interval (window) with a regression line fitting “best”.
Among all intervals with a slope within `slope_tol` to `slope` the longest one is taken.
If no such interval exists, the one with the slope closest to `slope` is taken.

If the window is set to `nothing` (default), all window sizes `2,...,length(X)` are checked.
You can also specify a window size or an array of window sizes.

For each window size, all its translates in the data is checked.
For all these (shifted) windows the regression line is computed (with `a,b` in `a + t*b`)
and the best line is computed.

From the best line the following data is returned

* `a`, `b` specifying the regression line `a + t*b`
* `i`, `j` determining the window, i.e the regression line stems from data `X[i], ..., X[j]`

!!! note
    This function has to be implemented using some statistics package.
    loading [Statistics.jl](https://github.com/JuliaStats/Statistics.jl) provides a default implementation.
"""
find_best_slope_window(X, Y, window = nothing)

using ManifoldsBase, Plots, Statistics, Test
# don't show plots actually
default(; show = false, reuse = true)

s = @__DIR__
!(s in LOAD_PATH) && (push!(LOAD_PATH, s))
using ManifoldsBaseTestUtils

@testset "Numerical Check functions" begin
    @testset "Test retract checks" begin
        M = TestSphere(10)
        q = zeros(11)
        q[1] = 1.0
        p = zeros(11)
        p[1:4] .= 1 / sqrt(4)
        X = log(M, p, q)

        @test check_retraction(M, ProjectionRetraction(), p, X; limits = (-2.5, 0.0))
        # One call with generating a plot
        check_retraction(M, ProjectionRetraction(), p, X; limits = (-2.5, 0.0), plot = true)

        # ProjectionRetraction only works <= 1 well in stepsize
        @test_throws ErrorException check_retraction(
            M, ProjectionRetraction(), p, X; limits = (-2.5, 2.0), error = :error,
        )
        @test !check_retraction(M, ProjectionRetraction(), p, X; limits = (-2.5, 2.0))

        #test window size error
        @test_throws ErrorException ManifoldsBase.find_best_slope_window(
            zeros(2), zeros(2), 20,
        )
        @test_throws ErrorException ManifoldsBase.find_best_slope_window(
            zeros(2), zeros(2), [2, 20],
        )
        @test check_retraction(M, ExponentialRetraction(), p, X; exactness_tol = 1.0e-7)
        check_retraction(
            M, ExponentialRetraction(), p, X; plot = true, exactness_tol = 1.0e-7,
        )
    end
    @testset "Test inverse_retract checks" begin
        M = TestSphere(10)
        q = zeros(11)
        q[1] = 1.0
        p = zeros(11)
        p[1:4] .= 1 / sqrt(4)
        X = log(M, p, q)

        @test check_inverse_retraction(
            M,
            ProjectionInverseRetraction(),
            p,
            X;
            limits = (-2.5, 0.0),
        )
        # One call with generating a plot
        check_inverse_retraction(
            M,
            ProjectionInverseRetraction(),
            p,
            X;
            limits = (-2.5, 0.0),
            plot = true,
        )

        # ProjectionRetraction only works <= 1 well in stepsize
        @test_throws ErrorException check_inverse_retraction(
            M,
            ProjectionInverseRetraction(),
            p,
            X;
            limits = (-2.5, 2.0), # yields a bit too long tangents
            error = :error,
        )
        @test !check_inverse_retraction(
            M,
            ProjectionInverseRetraction(),
            p,
            X;
            limits = (-2.5, 2.0),
        )
        # Check exatness case
        @test check_inverse_retraction(
            M,
            LogarithmicInverseRetraction(),
            p,
            X;
            exactness_tol = 1.0e-7,
        )
        check_inverse_retraction(
            M,
            LogarithmicInverseRetraction(),
            p,
            X;
            plot = true,
            exactness_tol = 1.0e-7,
        )
    end
    @testset "Test vector_transport_to checks" begin
        M = TestSphere(10)
        q = zeros(11)
        q[1] = 1.0
        p = zeros(11)
        p[1:4] .= 1 / sqrt(4)
        X = log(M, p, q)
        r = zeros(11)
        r[3] = 1.0
        Y = log(M, p, r)

        @test check_vector_transport(
            M,
            ProjectionTransport(),
            p,
            X,
            Y;
            second_order = false,
        )
        # One call with generating a plot
        check_vector_transport(
            M,
            ProjectionTransport(),
            p,
            X,
            Y;
            second_order = false,
            plot = true,
        )

        # ProjectionRetraction only works <= 1 well in stepsize
        @test_throws ErrorException check_vector_transport(
            M,
            ProjectionTransport(),
            p,
            X,
            Y;
            limits = (-2.5, 2.0), # yields a bit too long tangents
            error = :error,
        )
        @test !check_vector_transport(
            M,
            ProjectionTransport(),
            p,
            X,
            Y;
            limits = (-2.5, 2.0),
        )
        # Check exactness case
        @test check_vector_transport(M, ParallelTransport(), p, X, Y; exactness_tol = 1.0e-7)
        check_vector_transport(
            M,
            ParallelTransport(),
            p,
            X,
            Y;
            plot = true,
            exactness_tol = 1.0e-7,
        )
    end
    @testset "StabilizedRetraction and its inverse" begin
        M = TestSphere(10)
        p1 = [
            -0.3676232664793671,
            0.6626844596366377,
            -0.061901832129538106,
            -0.025815090234793503,
            -0.07866889208988073,
            0.3529796828577404,
            -0.12233959915005299,
            0.004087934754632594,
            -0.37359690909547544,
            -0.2105625166208829,
            0.30253234782275296,
        ]
        p2 = copy(p1)
        p3 = copy(p1)
        p4 = copy(p1)
        p5 = copy(p1)
        X1 = [
            -1.3114742420546033,
            0.2735101165024386,
            -0.30976071299605357,
            -0.11884353912873682,
            0.5654677284268061,
            0.3525791677021648,
            0.4338068524082538,
            1.2746832300177995,
            0.7740842662015813,
            -0.06325213712780621,
            -1.460513999668164,
        ]
        X2 = copy(X1)
        X3 = copy(X1)
        X4 = copy(X1)
        X5 = copy(X1)
        # inverse
        p6 = copy(p1) # keep for checks
        p7 = exp(M, p1, X1)
        p8 = exp(M, p1, X1)
        p9 = exp(M, p1, X1)
        Y1 = copy(X1)
        Y2 = copy(X1)
        Y3 = copy(X1)
        q = similar(p1)
        SR = StabilizedRetraction()
        @test repr(SR) == "StabilizedRetraction()"
        SIR = StabilizedInverseRetraction()
        @test repr(SIR) == "StabilizedInverseRetraction()"
        err_eps = 1.0e-5
        for _ in 1:1000
            X1 .+= err_eps
            exp!(M, q, p1, X1)
            parallel_transport_to!(M, X1, p1, X1, q)
            p1 .= q
            # mutating non-fused
            X2 .+= err_eps
            retract!(M, q, p2, X2, SR)
            parallel_transport_to!(M, X2, p2, X2, q)
            p2 .= q
            # mutating fused
            X3 .+= err_eps
            ManifoldsBase.retract_fused!(M, q, p3, X3, 1.0, SR)
            parallel_transport_to!(M, X3, p3, X3, q)
            p3 .= q
            # non-mutating non-fused
            X4 .+= err_eps
            q4 = retract(M, p4, X4, SR)
            parallel_transport_to!(M, X4, p4, X4, q4)
            p4 .= q4
            # non-mutating fused
            X5 .+= err_eps
            q5 = ManifoldsBase.retract_fused(M, p5, X5, 1.0, SR)
            parallel_transport_to!(M, X5, p5, X5, q5)
            p5 .= q5

            p7 .+= err_eps
            Y1 .= log(M, p6, p7)
            p8 .+= err_eps
            Y2 .= inverse_retract(M, p6, p8, SIR)
            p9 .+= err_eps
            inverse_retract!(M, Y3, p6, p9, SIR)
        end
        @test !is_point(M, p1)
        @test is_point(M, p2; error = :error)
        @test is_point(M, p3; error = :error)
        @test is_point(M, p4; error = :error)
        @test is_point(M, p5; error = :error)
        # test the inverse as well
        @test !is_vector(M, p6, Y1)
        @test is_vector(M, p6, Y2; error = :error, atol = 1.0e-16)
        @test is_vector(M, p6, Y3; error = :error, atol = 1.0e-16)
    end
    @testset "Test check_geodesic" begin
        M = TestSphere(10)
        q = zeros(11)
        q[1] = 1.0
        p = zeros(11)
        p[1:4] .= 1 / sqrt(4)
        X = log(M, p, q)
        @test check_geodesic(M, p, X)
        # One call with generating a plot
        check_geodesic(M, p, X; plot = true)

        # Check with too large steps
        X2 = zeros(11) # but make it non-tangent to q
        X2[1] = 1.0
        X2[2:4] .= 2.0
        @test_throws ErrorException check_geodesic(M, q, X2; error = :error)
    end
end

# Numerical Verification

```@autodocs
Modules = [ManifoldsBase]
Pages = ["src/numerical_checks.jl"]
Order = [:macro, :type, :function]
Private = false
Public = true
```

## Internal functions

The following functions split the check into several parts, for
example looking for the best fitting window and finding out the best slope,
or plotting the slope.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["src/numerical_checks.jl"]
Order = [:macro, :type, :function]
Private = true
Public = false
```

---
title: "How to Implement a Manifold"
---

````{=commonmark}
```@meta
CurrentModule = ManifoldsBase
```
````

This tutorial illustrates, how to implement your very first manifold.
We start from the very beginning and cover the basic ideas of the interface provided by
`ManifoldsBase.jl` interface.

```{julia}
#| echo: false
#| code-fold: true
#| output: false
using Pkg;
cd(@__DIR__)
Pkg.activate("."); # for reproducibility use the local tutorial environment.
# But for this version use here the most recent dev version from the parent folder
Pkg.develop(PackageSpec(; path=(@__DIR__) * "/../"))
```

## Preliminaries

We will use a simple example in this tutorial, since the main focus here is to illustrate how to define a manifold.
We will use the sphere of radius $r$ embedded in $\mathbb R^{d+1}$, i.e. all vectors of length $r$. Formally we define

```math
\mathbb S_r^d :=
\bigl\{
    p \in \mathbb R^{d+1}
    \big|
    \lVert p \rVert = r
\bigr\}
```

When defining a Riemannian manifold mathematically, there is several things to keep in mind, for example the metric imposed on the tangent spaces. For this interface we assume these things to be given implicitly for a first implementation, but they can be made more precise when necessary.

The only thing we have to be aware of for now is the [`number_system`](@ref), i.e. whether our manifold is a real-valued or a complex-valued manifold.
The abstract type all manifolds inherit from, the [`AbstractManifold`](@ref)`{𝔽}` has this number system as a parameter.
The usual parameter we will use are the [`RealNumbers`](@ref)`()`,
which have a short hand in `ManifoldsBase.jl`, namely `ℝ`.
The second one are the [`ComplexNumbers`](@ref)`()`, or `ℂ` for short.

```{julia}
using LinearAlgebra, ManifoldsBase
using ManifoldsBase: ℝ
```

## Defining a manifold

A manifold itself is a `struct` that is a subtype of `AbstractManifold` and should contain. We usually recommend to also document your new manifold.

Since the [`Sphere`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/sphere.html) is already a name used within [`Manifolds.jl`](https://github.com/JuliaManifolds/Manifolds.jl/), let's use a slightly more specific name. We define

```{julia}
#| output: false
"""
    ScaledSphere <: AbstractManifold{ℝ}

Define a sphere of fixed radius

# Fields

* `dimension` dimension of the sphere
* `radius` the radius of the sphere

# Constructor

    ScaledSphere(dimension,radius=1.0)

Initialize the manifold to a certain `dimension` and `radius`,
which by default is set to `1.0`
"""
struct ScaledSphere <: AbstractManifold{ℝ}
    dimension::Int
    radius::Float64
end
```

And we can directly use this manifold and set

```{julia}
M = ScaledSphere(2,1.5)
```

## Functions I: Manifold properties

While the interface provides a lot of possible functions to define for your manifold, you only need to define those that are necessary for your implementation.
If you are using other packages depending on `ManifoldsBase.jl` you will often just get a “Method not defined” and sometimes an ambiguity error indicating that a function is missing that is required for a certain task.

We can first start with a technical function which internally is often used. Any of our points or tangent vectors are represented as a $(d+1)$-dimensional vector. This is internally often used when allocating memory, see [`representation_size`](@ref).
It returns a tuple representing the size of arrays for valid points.
We define

```{julia}
#| output: false
import ManifoldsBase: representation_size
representation_size(M::ScaledSphere) = (M.dimension+1,)
```

Similarly, we can implement the function returning the dimension of the manifold, cf. [`manifold_dimension`](@ref) as

```{julia}
#| output: false
import ManifoldsBase: manifold_dimension
manifold_dimension(M::ScaledSphere) = M.dimension
```

and we can now easily use them to access the dimension of the manifold

```{julia}
manifold_dimension(M)
```

## Functions II: Verifying Points and tangent vectors


The first two functions we want to define are those to check points and tangent vectors for our manifold.
Let's first clarify what the tangent space looks like. The directions “we can walk into” from a point $p\in \mathbb S_r^d$ are all $X$ that are orthogonal to $p$, which is the plane/vector space tangent to the sphere. Formally

```math
T_p\mathbb S_r^d :=
\bigl\{
    X \in \mathbb R^{d+1}
    \big|
    \langle p, X \rangle = 0
\bigr\}, \qquad p \in \mathbb S_r^d
```

to verify either `p` or `X` one uses [`is_point`](@ref)`(M,p)`
and [`is_vector`](@ref)`(M, p, X)` respectively. Since both involve some automatic options and possibilities, for example whether to throw an error or just return false, both mention that the actual functions to implement are [`check_point`](@ref) and [`check_vector`](@ref), which both do not throw but _return_ an error if something is wrong.

In principle we would have to check two properties, namely that the size of `p` is of correct size `M.dimension+1` and that its norm is `M.radius`. Luckily, by defining [`representation_size`](@ref) the first check is automatically done already – actually for both points and vectors.
We define

```{julia}
#| output: false
import ManifoldsBase: check_point
function check_point(M::ScaledSphere, p; kwargs...)
    if !isapprox(norm(p), M.radius; kwargs...)
        return DomainError(norm(p), "The norm of $p is not $(M.radius).")
    end
    return nothing
end
```

And we can directly test the function. To see all 3 failing ones, we switch from errors to warnings in the check

```{julia}
is_point(M, [1.5, 0.0], error=:warn) # wrong size
is_point(M, [1.0, 0.0, 0.0], error=:warn) # wrong norm
is_point(M, [1.5, 0.0, 0.0], error=:warn) # on the manifold, returns true
```

similarly for vectors, we just have to implement the orthogonality check.

```{julia}
#| output: false
import ManifoldsBase: check_vector
function check_vector(M::ScaledSphere, p, X; kwargs...)
    if !isapprox(dot(p,X), 0.0; kwargs...)
        return DomainError(
            dot(p,X),
            "The tangent vector $X is not orthogonal to $p."
        )
    end
    return nothing
end
```

and again, the high level interface can be used to display warnings for vectors not fulfilling the criterion, but we can also
activate a check for the point using the last positional argument

```{julia}
is_vector(M, [1.5, 0.0, 0.0], [0.0, 1.0]; error=:warn) # wrong size
is_vector(M, [1.5, 0.0, 0.0], [1.0, 1.0, 0.0]; error=:warn) # not orthogonal norm
is_vector(M, [1.0, 0.0, 0.0], [0.0, 1.0, 0.0], true; error=:warn) # point not valid
is_vector(M, [1.5, 0.0, 0.0], [0.0, 1.0, 0.0], true; error=:warn) # returns true
```


## Functions on Manifolds III: The exponential map and a retraction.

For the final group of functions, we want to implement the [`exp`](@ref)onential map and a [`retract`](@ref)ion. Both are ways to “move around” on the manifold, that is, given a point $p$ and a
tangent vector indicating a “walking direction”, the two functions we define will return a new point $q$ on the manifold.

For functions that compute a new point or tangent vector, `ManifoldsBase.jl` always provides two variants: One that allocates new memory, and one that allows to provide the memory the result should be returned in to spare memory allocations.

Let's first take a look at what the exponential map is defined like. We follow the shortest curves, that is great arcs, on the sphere. Formally we have

````math
\exp_p X =
\cos\Bigl(\frac{1}{r}\lVert X \rVert\Bigr)p +
\sin\Bigl(\frac{1}{r}\lVert X \rVert\Bigr)\frac{X}{\lVert X \rVert}.
````

In fact, from the two functions above, [`exp`](@ref)`(M, p, X)`, and [`exp!`](@ref)`(M, q, p, X)` that works in place of `q`, we only have to implement the second.
The first one, `exp` by default falls back to allocating memory and calling the second. So `exp` should only be defined, if there is a special reason for.
Furthermore, we usually do not verify/check inputs to spare time. If a user feels insecure, they could for example use the [`ValidationManifold`](@ref) wrapper which adds explicit checks of inputs and outputs.

We define

```{julia}
#| output: false
import ManifoldsBase: exp!
function exp!(M::ScaledSphere, q, p, X)
    nX = norm(X)
    if nX == 0
        q .= p
    else
        q .= cos(nX/M.radius)*p + M.radius*sin(nX/M.radius) .* (1/nX) .* X
    end
    return q
end
```

and we can directly test our function starting in the north pole and “walking down” to the equator

```{julia}
q = exp(M, [0.0, 0.0, 1.5], [0.75π, 0.0, 0.0])
```

but we also get the other variants for free, for example

```{julia}
q2 = zero(q)
exp!(M, q2, [0.0, 0.0, 1.5], [0.75π, 0.0, 0.0])
q2
```

or the one that shortens or elongates the path by a factor,
for example, if we walk twice the distance, we reach the opposite point

```{julia}
ManifoldsBase.exp_fused!(M, q2, [0.0, 0.0, 1.5], [0.75π, 0.0, 0.0], 2.0)
q2
```

Of course we can easily check that both points we computed still lie on the sphere

```{julia}
all([is_point(M, q), is_point(M, q2)])
```

Since the exponential map might in general be expensive, we can do a similar implementation with the [`ProjectionRetraction`](@ref).
Here, we really have to take into account, that the interface is ``[designed with 3 levels](@ref Design)``{=commonmark} in mind:
While the actual function we would call in the end is `retract(M, p, X, ProjectionRetraction())` (or its `!` variant), we actually have to implement `retract_project!(M, q, p, X, t)` for technical details, that are a bit beyond this introductory tutorial. In short this split avoids ambiguity errors for decorators of the manifolds. We define

```{julia}
function ManifoldsBase.retract_project!(M::ScaledSphere, q, p, X)
    q .= (p + X) .* (M.radius/norm(p + X))
    return q
end
```

And to test also this function, and avoiding allocations at the same time, we call

```{julia}
retract!(M, q, [0.0, 0.0, 1.5], [0.75π, 0.0, 0.0], ProjectionRetraction())
```

Finally, there is [`default_retraction_method`](@ref) to specify which is the default retraction to use. By default this is

```{julia}
default_retraction_method(M)
```

But we can easily specify this for our manifold as well, for example defining

```{julia}
import ManifoldsBase: default_retraction_method
default_retraction_method(::ScaledSphere) = ProjectionRetraction()
```

Then

```{julia}
default_retraction_method(M)
```

and retract without a method specified would always fall back to using the projection retraction instead of the exponential map.
Note that for compatibility there is the [`AbstractRetractionMethod`](@ref) called [`ExponentialRetraction`](@ref) which makes [`retract`](@ref) fall back to calling [`exp`](@ref).

## Technical Details

This notebook was rendered with the following environment

```{julia}
Pkg.status()
```

## [Retractions and inverse Retractions](@id sec-retractions)

The [exponential and logarithmic map](@ref exp-and-log) might be too expensive to evaluate or not be available in a very stable numerical way on certain manifolds ``\mathcal M``.
Retractions provide a possibly cheap, fast and stable alternative.

A _retraction_ ``\operatorname{retr}_p: T_p\mathcal M → \mathcal M`` is a smooth map that fulfils (for all ``p∈\mathcal M``) that

1. ``\operatorname{retr}_p(0) = p``
2. ``D\operatorname{retr}_p(0): T_p\mathcal M \to T_p\mathcal M`` is the identity map,
i.e. ``D\operatorname{retr}_p(0)[X]=X`` holds for all ``X∈ T_p\mathcal M``,

where ``D\operatorname{retr}_p`` denotes the differential of the retraction.

A retraction ``\operatorname{retr}_p`` can be interpreted as a first order approximation to the exponential map ``\exp_p``.

The retraction is called of second order if for all ``X`` the curves ``c(t) = R_p(tX)``
have a zero acceleration at ``t=0``, i.e. ``c''(0) = 0``.

The following figure compares the exponential map [`exp`](@ref)`(M, p, X)` on the [Circle](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/circle.html) `(ℂ)` (or [`Sphere`](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/sphere.html)`(1)` embedded in ``ℝ^2`` with one possible retraction, the one based on projections.
Note especially that ``\operatorname{dist}(p,q)=\lVert X\rVert_p`` while this is not the case for the result ``\operatorname{retr}_p(X) = q'``.

![A comparison of the exponential map and a retraction on the Circle.](assets/images/retraction_illustration_600.png)

Similar to the [`exp`](@ref)onential map the [`retract`](@ref)ion might not be globally invertible, but locally it is.
So locally one can define the inverse retraction ``\operatorname{retr}_p^{-1}\colon \mathcal M \to T_p\mathcal M``, which
can be seen as a first order approximation to the [`log`](@ref)arithmic map. Within the `ManifoldsBase.jl` interface the inverse retraction is called [`inverse_retract`](@ref).

The general interface looks as follows.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["retractions.jl", "shooting.jl"]
Order = [:function]
Private = false
Public = true
```

## Types of Retractions

To distinguish different types of retractions, the last argument of the retraction as well as its inverse
specifies a type. The following ones are available.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["retractions.jl", "shooting.jl"]
Order = [:type]
```

## The functions on layer 3

While you should always add your documentation to [`retract`](@ref) or [`retract!`](@ref) when implementing new manifolds, the actual implementation happens on the following functions on [layer III](@ref design-layer3).

```@autodocs
Modules = [ManifoldsBase]
Pages = ["retractions.jl", "shooting.jl"]
Order = [:function]
Public = false
Private = true
```

# Functions on manifolds

This page collects several basic functions on manifolds.

## [The exponential map, the logarithmic map, and geodesics](@id exp-and-log)

Geodesics are the generalizations of a straight line to manifolds, i.e. their intrinsic acceleration is zero.
Together with geodesics one also obtains the exponential map and its inverse, the logarithmic map.
Informally speaking, the exponential map takes a vector (think of a direction and a length) at one point and returns another point,
which lies towards this direction at distance of the specified length. The logarithmic map does the inverse, i.e. given two points, it tells which vector “points towards” the other point.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["exp_log_geo.jl"]
Order = [:function]
```

## [Parallel transport](@id subsec-parallel-transport)

While moving vectors from one base point to another is the identity in the Euclidean space – or in other words all tangent spaces (directions one can “walk” into) are the same. This is different on a manifold.

If we have two points ``p,q ∈ \mathcal M``, we take a ``c: [0,1] → \mathcal M`` connecting the two points, i.e. ``c(0) = p`` and ``c(1) = q``. this could be a (or the) geodesic.
If we further consider a vector field ``X: [0,1] → T\mathcal M``, i.e. where ``X(t) ∈ T_{c(t)}\mathcal M``.
Then the vector field is called _parallel_ if its covariant derivative ``\frac{\mathrm{D}}{\mathrm{d}t}X(t) = 0`` for all ``t∈ |0,1]``.

If we now impose a value for ``X=X(0) ∈ T_p\mathcal M``, we obtain an ODE with an initial condition.
The resulting value ``X(1) ∈ T_q\mathcal M`` is called the _parallel transport_ of `X` along ``c``
or in case of a geodesic the _parallel transport of `X` from `p` to `q`.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["parallel_transport.jl"]
Order = [:function]
```

## Further functions on manifolds

### General functions provided by the interface

```@autodocs
Modules = [ManifoldsBase]
Pages = ["ManifoldsBase.jl"]
Order = [:type, :function]
Public=true
Private=false
```

### Internal functions

While you should always add your documentation to functions from the last section, some of the functions dispatch onto functions on [layer III](@ref design-layer3). These are the ones
you usually implement for your manifold – unless there is no lower level function called, like for the [`manifold_dimension`](@ref).

```@autodocs
Modules = [ManifoldsBase]
Pages = ["ManifoldsBase.jl"]
Order = [:function]
Public=false
Private=true
```

## Approximation Methods

```@autodocs
Modules = [ManifoldsBase]
Pages = ["approximation_methods.jl"]
Order = [:type, :function]
```

## Error Messages

This interface introduces a small set of own error messages.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["errors.jl"]
Order = [:type]
```

# Manifolds

While the interface `ManifoldsBase.jl` does not cover concrete manifolds, it provides a few
helpers to build or create manifolds based on existing manifolds

## A default manifold

[`DefaultManifold`](@ref ManifoldsBase.DefaultManifold) is a simplified version of [`Euclidean`](@extref `Manifolds.Euclidean`) and demonstrates a basic interface implementation.
It can be used to perform simple tests.
Since when using `Manifolds.jl` the [`Euclidean`](@extref `Manifolds.Euclidean`) is available, the [`DefaultManifold`](@ref ManifoldsBase.DefaultManifold) itself is not exported.

```@docs
ManifoldsBase.DefaultManifold
```

## [Embedded manifold](@id sec-embedded-manifold)

The embedded manifold is a manifold ``\mathcal M`` which is modelled _explicitly_ specifying its embedding ``\mathcal N`` in which the points and tangent vectors are represented.
Most prominently [`is_point`](@ref) and [`is_vector`](@ref) of an embedded manifold are implemented to check whether the point is a valid point in the embedding. This can of course still be extended by further tests.
`ManifoldsBase.jl` provides two possibilities of easily introducing this in order to dispatch some functions to the embedding.

### [Implicit case: the decorator Trait](@id subsec-implicit-embedded)

For the implicit case, your manifold has to be a subtype of the [`AbstractDecoratorManifold`](@ref) and specifying the [`get_embedding_type`](@ref) makes that manifold an embedded manifold. You just have to also define [`get_embedding`](@ref) so that appropriate functions are passed on to that embedding. Which are passed on also depends on the [`AbstractForwardingType`](@ref) you specify.
This is the implicit case, since the manifold type itself does not carry any information about the embedding, just the trait and the function definition do.

### [Explicit case: the `EmbeddedManifold`](@id subsec-explicit-embedded)

The [`EmbeddedManifold`](@ref) itself is an [`AbstractDecoratorManifold`](@ref) so it is a case of the implicit embedding itself, but internally stores both the original manifold and the embedding.
They are also parameters of the type.
This way, an additional embedding of one manifold in another can be modelled. That is, if the manifold is implemented using the implicit embedding approach from before but can also be implemented using a _different_ embedding, then this method should be chosen, since you can dispatch functions that you want to implement in this embedding then on the type which explicitly has the manifold and its embedding as parameters.

Hence this case should be used for any further embedding after the first or if the default implementation works without an embedding and the alternative needs one.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["EmbeddedManifold.jl"]
Order = [:type, :macro, :function]
```

## Connections

Most connection-related functionality previously defined in [`Manifolds.jl`](https://juliamanifolds.github.io/Manifolds.jl/latest/) is currently available here.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["connection.jl"]
Order = [:type, :function]
```

## Metrics

Most metric-related functionality is available here. A few additional functions are defined in [`Manifolds.jl`](https://juliamanifolds.github.io/Manifolds.jl/latest/).

```@autodocs
Modules = [ManifoldsBase]
Pages = ["metric.jl"]
Order = [:type, :function]
```

## A manifold for validation

[`ValidationManifold`](@ref) is a simple decorator using the [`AbstractDecoratorManifold`](@ref) that “decorates” a manifold with tests that all involved points and vectors are valid for the wrapped manifold.
For example involved input and output parameters are checked before and after running a function, respectively.
This is done by calling [`is_point`](@ref) or [`is_vector`](@ref) whenever applicable.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["ValidationManifold.jl"]
Order = [:macro, :type, :function]
```

# The Manifold interface

## The `AbstractManifold`

The main type is the [`AbstractManifold`](@ref). It represents the manifold per se.
Throughout the documentation of `ManifoldsBase.jl` we might use the [Euclidean Space](@extref `Manifolds.Euclidean`) and the [Sphere](@extref `Manifolds.Sphere`) (both implemented in [Manifolds.jl](https://github.com/JuliaManifolds/Manifolds.jl)) as easy examples to illustrate properties and features of this interface on concrete examples.

```@docs
AbstractManifold
```

which should store information about the manifold, for example parameters inherent to the manifold.

In order of parameters for any subtype of [`AbstractManifold`](@ref) it would be good if the first parameter is the number type that the abstract type has as well, if it is not fixed to a specific one.
The second one should be the type of field type for size information. This might be the dimension of the manifold, like for the [`Sphere`](@extref `Manifolds.Sphere`) or any other number(s) determining the manifolds representation or dimension, like the matrix size for the [`SymmetricPositiveDefinite`](@extref `Manifolds.SymmetricPositiveDefinite`) manifold.

## Points on a manifold

Points do not necessarily have to be typed.
Usually one can just use any type. When a manifold has multiple representations, these should be distinguished by point and vector types.

```@docs
AbstractManifoldPoint
```

Converting points between different representations can be performed using the `convert` function with either two or three arguments (`convert(T, M, p)` or `convert(T, p)`). For some manifolds providing `M` may be necessary. The first variant falls back to the second variant.

## Tangent and Cotangent spaces

```@autodocs
Modules = [ManifoldsBase]
Pages = ["vector_spaces.jl"]
Order = [:type, :function]
```

This interface also covers a large variety how to [model bases in tangent spaces](@ref bases).

Converting tangent vectors between different representations can be performed using the `convert` function with either three or four arguments (`convert(T, M, p, X)` or `convert(T, p, X)`). For some manifolds providing `M` may be necessary. The first variant falls back to the second variant.

## Macros for automatic forwards for simple points/tangent vectors

When distinguishing different representations of points or tangent vectors on one manifold,
it might happen that both a subtype of [`AbstractManifoldPoint`](@ref) and a subtype of [`AbstractTangentVector`](@ref)
are just encapsulating a value

This is taken into account by the following macros, that forward several actions just to this field. Most prominently vector operations for the tangent vectors.
If there is still a default case, a macro sets this type to be equivalent to calling the manifold functions just with the types field that carries the value.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["point_vector_fallbacks.jl"]
Order = [:type, :function, :macro]
```

## [Number Systems](@id number-system)

The [`AbstractManifold`](@ref) has one parameter to distinguish the number system a manifold is based on.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["numbers.jl"]
Order = [:type, :function]
```

## [Type Parameter](@id type-parameter)

Concrete [`AbstractManifold`](@ref)s usually correspond to families of manifolds that are parameterized by some numbers, for example determining their [`manifold_dimension`](@ref). Those numbers can either be stored in a field or as a type parameter of the structure. The [`TypeParameter`](@ref ManifoldsBase.TypeParameter) offers the flexibility
to have this parameter either as type parameter or a field.

```@docs
ManifoldsBase.TypeParameter
ManifoldsBase.wrap_type_parameter
```

# Meta Manifolds

While the interface does not provide concrete manifolds itself, it does provide several manifolds that can be build based on a given [`AbstractManifold`](@ref) instance.

## [(Abstract) power manifold](@id sec-power-manifold)

A power manifold is constructed like higher dimensional vector spaces are formed from the real line, just that for every point ``p = (p_1,\ldots,p_n) ∈ \mathcal M^n`` on the power manifold ``\mathcal M^n`` the entries of ``p`` are points ``p_1,\ldots,p_n ∈ \mathcal M`` on some manifold ``\mathcal M``. Note that ``n`` can also be replaced by multiple values, such that ``p`` is not a vector but a matrix or a multi-index array of points.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["src/PowerManifold.jl"]
Order = [:macro, :type, :function]
```

## [Product Manifold](@id ProductManifold)

```@autodocs
Modules = [ManifoldsBase]
Pages = ["src/ProductManifold.jl"]
Order = [:macro, :type, :function]
```

## Quotient manifolds

A manifold ``\mathcal M`` is then a a quotient manifold of another manifold ``\mathcal N``,
i.e. for an [equivalence relation](https://en.wikipedia.org/wiki/Equivalence_relation) ``∼``
on ``\mathcal N`` we have

```math
    \mathcal M = \mathcal N / ∼ = \bigl\{ [p] : p ∈ \mathcal N \bigr\},
```

where ``[p] ≔ \{ q ∈ \mathcal N : q ∼ p\}`` denotes the equivalence class containing ``p``.
For more details see Subsection 3.4.1 [AbsilMahonySepulchre:2008](@cite).

This manifold type models an explicit quotient structure.
This should be done if either the default implementation of ``\mathcal M``
uses another representation different from the quotient structure or if
it provides a (default) quotient structure that is different from the one introduced here.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["quotientmanifold.jl"]
Order = [:macro, :type, :function]
```

## Fiber

```@autodocs
Modules = [ManifoldsBase]
Pages = ["Fiber.jl"]
Order = [:macro, :type, :function]
```

## Tangent Space

```@autodocs
Modules = [ManifoldsBase]
Pages = ["TangentSpace.jl"]
Order = [:macro, :type, :function]
```

## Vector transport

Similar to the [exponential and logarithmic map](@ref exp-and-log) also the [parallel transport](@ref subsec-parallel-transport) might be costly to compute, especially when there is no closed form solution known and it has to be approximated with numerical methods.
Similar to the [retraction and its inverse](@ref sec-retractions), the generalisation of the parallel transport can be phrased as follows

A _vector transport_ is a way to transport a vector between two tangent spaces.
Let ``p,q ∈ \mathcal M`` be given, ``c`` the curve along which we want to transport (cf. [parallel transport](@ref subsec-parallel-transport), for example a geodesic or curve given by a retraction.
We can specify the geodesic or curve a retraction realises for example by a direction ``d``.

More precisely using [AbsilMahonySepulchre:2008](@cite), Def. 8.1.1, a vector transport
``T_{p,d}: T_p\mathcal M \to T_q\mathcal M``, ``p∈ \mathcal M``, ``Y∈ T_p\mathcal M`` is a smooth mapping
associated to a retraction ``\operatorname{retr}_p(Y) = q`` such that

1. (associated retraction) ``\mathcal T_{p,d}X ∈ T_q\mathcal M`` if and only if ``q = \operatorname{retr}_p(d)``,
2. (consistency) ``\mathcal T_{p,0_p}X = X`` for all ``X∈T_p\mathcal M``,
3. (linearity) ``\mathcal T_{p,d}(αX+βY) = \mathcal αT_{p,d}X + \mathcal βT_{p,d}Y`` for all ``α, β ∈ 𝔽``,

hold.

Currently the following methods for vector transport are defined in `ManifoldsBase.jl`.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["vector_transport.jl"]
Order = [:function]
Public=true
Private=false
```

## Types of vector transports

To distinguish different types of vector transport we introduce the [`AbstractVectorTransportMethod`](@ref). The following concrete types are available.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["vector_transport.jl"]
Order = [:type]
```

## Functions to implement (on Layer III)

While you should always add your documentation to the first layer vector transport methods above when implementing new manifolds, the actual implementation happens on the following functions on [layer III](@ref design-layer3).

```@autodocs
Modules = [ManifoldsBase]
Pages = ["vector_transport.jl"]
Order = [:function]
Public = false
Private = true
```

# A Decorator for manifolds

Several properties of a manifold are often implicitly assumed, for example the choice of the (Riemannian) metric or the embedding. The latter shall serve as an example how to either implicitly or explicitly specify the embedding to avoid re-implementations and/or distinguish different embeddings.

## The abstract decorator

When first implementing a manifold, it might be beneficial to dispatch certain computations to already existing manifolds.
For an embedded manifold that is isometrically embedded this might be the [`inner`](@ref) the manifold inherits in each tangent space from its embedding.

This means we would like to dispatch the default implementation of a function to some other manifold.
We refer to this as implicit decoration, since one can not “see” explicitly that a certain manifold inherits this property.
As an example consider the [Sphere](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/sphere.html). At each point the tangent space can be identified with a subspace of the tangent space in the embedding, the [Euclidean](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/euclidean.html) manifold which the unit vectors of the sphere belong to. Thus every tangent space inherits its metric from the embedding.
Since in the default implementation in [Manifolds.jl](https://juliamanifolds.github.io/Manifolds.jl/stable/) points are represented by unit vectors and tangent vectors at a point as vectors orthogonal to that point, we can just dispatch the inner product to the embedding without having to re-implement this.
The manifold using such an implicit dispatch just has to be a subtype of [`AbstractDecoratorManifold`](@ref).

## Traits with an inheritance hierarchy

The properties mentioned above might form a hierarchy.
For embedded manifolds, again, we might have just a manifold whose points are represented in some embedding.
If the manifold is even isometrically embedded, it is embedded but also inherits the Riemannian metric by restricting the metric from the embedding to the corresponding tangent space under consideration.
But it also inherits the functions defined for the plain embedding, for example checking some conditions for the validity of points and vectors.
If it is even a submanifold, also further functions are inherited like the [`shortest_geodesic`](@ref).

We use a variation of [Tim Holy's Traits Trick](https://github.com/JuliaLang/julia/issues/2345#issuecomment-54537633) (THTT) which takes into account kind of traits.

To be precise we have a generic [`AbstractForwardingType`](@ref) to indicate that on the decorator manifold
we want to (or not want to) forward a certain function.
To add more semantics one can use subtypes of this type like [`AbstractEmbeddedForwardingType`](@ref) to indicate how to forward certain functions for the embedding type.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["nested_trait.jl"]
Order = [:type, :macro, :function]
```

## The Manifold decorator

The idea of the decorator for a manifold is to allow to exchange certain functionality by
a dispatch layer. For example that for an embedded manifold some functions are passed to the embedding,
or that for a metric manifold decorator, all functions unrelated to the metric are passed to the original manifold. The following types, functions, and macros introduce the decorator trait which allows to decorate an arbitrary `<: `[`AbstractDecoratorManifold`](@ref) with further features.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["decorator_trait.jl"]
Order = [:type, :macro, :function]
```

For an example see the [(implicit) embedded manifold](@ref subsec-implicit-embedded).

# [Bases for tangent spaces](@id bases)

The following functions and types provide support for bases of the tangent space of different manifolds.
Moreover, bases of the cotangent space are also supported, though this description focuses on the tangent space.
An orthonormal basis of the tangent space ``T_p \mathcal M`` of (real) dimension ``n`` has a real-coefficient basis ``e_1, e_2, …, e_n`` if ``\mathrm{Re}(g_p(e_i, e_j)) = δ_{ij}`` for each ``i,j ∈ \{1, 2, …, n\}`` where ``g_p`` is the Riemannian metric at point ``p``.
A vector ``X`` from the tangent space ``T_p \mathcal M`` can be expressed in Einstein notation as a sum ``X = X^i e_i``, where (real) coefficients ``X^i`` are calculated as ``X^i = \mathrm{Re}(g_p(X, e_i))``.

The main types are:

* [`DefaultOrthonormalBasis`](@ref), which is designed to work when no special properties of the tangent space basis are required.
   It is designed to make [`get_coordinates`](@ref) and [`get_vector`](@ref) fast.
* [`DiagonalizingOrthonormalBasis`](@ref), which diagonalizes the curvature tensor and makes the curvature in the selected direction equal to 0.
* [`ProjectedOrthonormalBasis`](@ref), which projects a basis of the ambient space and orthonormalizes projections to obtain a basis in a generic way.
* [`CachedBasis`](@ref), which stores (explicitly or implicitly) a precomputed basis at a certain point.

The main functions are:

* [`get_basis`](@ref) precomputes a basis at a certain point.
* [`get_coordinates`](@ref) returns coordinates of a tangent vector.
* [`get_vector`](@ref) returns a vector for the specified coordinates.
* [`get_vectors`](@ref) returns a vector of basis vectors. Calling it should be avoided for high-dimensional manifolds.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["bases.jl"]
Order = [:type, :function]
```

# [Main Design Principles](@id Design)

The interface for a manifold is defined to be as generic as possible, such that applications can be implemented as independently as possible from an actual manifold.
This way, algorithms like those from [`Manopt.jl`](https://manoptjl.org) can be implemented on _arbitrary_ manifolds.

The main design criteria for the interface are:

* Aims to also provide _efficient_ _global state-free_, both _in-place_ and _out-of-place_ computations whenever possible.
* Provide a high level interface that is easy to use.

Therefore this interface has 3 main features, that we will explain using two (related)
concepts, the [exponential map](https://en.wikipedia.org/wiki/Exponential_map_(Riemannian_geometry)) that maps a tangent vector ``X`` at a point ``p`` to a point ``q`` or mathematically ``\exp_p:T_p\mathcal M \to \mathcal M`` and its generalization, a [`retract`](@ref)ion ``\operatorname{retr}_p`` with the same domain and range.

You do not need to know their exact definition at this point, just that there is _one_ exponential map on a Riemannian manifold, and several retractions, where one of them is the exponential map (called [`ExponentialRetraction`](@ref) for completeness). Every retraction has its own subtype of the [`AbstractRetractionMethod`](@ref) that uniquely defines it.

The following three design patterns aim to fulfil the criteria from above, while
also avoiding ambiguities in multiple dispatch using the [dispatch on one argument at a time](https://docs.julialang.org/en/v1/manual/methods/#Dispatch-on-one-argument-at-a-time) approach.

## General order of parameters

Since the central element for functions on a manifold is the manifold itself, it should always be the first parameter, even for in-place functions. Then the classical parameters of a function (for example a point and a tangent vector for the retraction) follow and the final part are parameters to further dispatch on, which usually have their defaults.

Besides this order the functions follow the scheme “allocate early”, i.e. to switch to the
mutating variant when reasonable, cf. [Mutating and allocating functions](@ref inplace-and-noninplace). Usually this is done after handling the decorator trait, cf. [A Decorator for manifolds](decorator.md), which still acts on the first layer.

## A 3-Layer architecture for dispatch

The general architecture consists of three layers

* The high level interface for ease of use – and to dispatch on other manifolds.
* The intermediate layer to dispatch on different parameters in the last section, e.g. type of retraction or vector transport.
* The lowest layer for specific manifolds to dispatch on different types of points and tangent vectors. Usually this layer with a specific manifold and no optional parameters.

These three layers are described in more detail in the following.
The main motivation to introduce these layers is, that it reduces method ambiguities.
It also provides a good structure where to implement extensions to this interface.

### [Layer I: The high level interface and ease of use](@id design-layer1)

The highest layer for convenience of decorators.
A usual scheme is, that a manifold might assume several things implicitly, for example the default implementation of the sphere $\mathbb S^n$ using unit vectors in $\mathbb R^{n+1}$.
The embedding can be explicitly used to avoid re-implementations – the inner product can be “passed on” to its embedding.

To do so, we “decorate” the manifold by making it an [`AbstractDecoratorManifold`](@ref) and activating the right traits see the tutorial [How to Implement a Manifold](tutorials/implement-a-manifold.md).

The explicit case of the [`EmbeddedManifold`](@ref) can be used to distinguish different embeddings of a manifold, but also their dispatch (onto the manifold or its embedding, depending on the type of embedding) happens here.

Note that all other parameters of a function should be as least typed as possible for all parameters besides the manifold.
With respect to the [dispatch on one argument at a time](https://docs.julialang.org/en/v1/manual/methods/#Dispatch-on-one-argument-at-a-time) paradigm, this layer dispatches the _manifold first_.
We also stay as abstract as possible, for example on the [`AbstractManifold`](@ref) level if possible.

If a function has optional positional arguments, (like [`retract`](@ref)) their default values might be filled/provided on this layer.
This layer ends usually in calling the same functions like [`retract`](@ref) but prefixed with a `_` to enter [Layer II](@ref design-layer2).

!!! note
    Usually only functions from this layer are exported from the interface, since these are the ones one should use for generic implementations.
    If you implement your own manifold, `import` the necessary lower layer functions as needed.

### [Layer II: An internal dispatch interface for parameters](@id design-layer2)

This layer is an interims layer to dispatch on the (optional/default) parameters of a function.
For example the last parameter of retraction: [`retract`](@ref) determines the type (variant) to be used.
The last function in the previous layer calls `_retract`, which is an internal function.
These parameters are usually the last parameters of a function.

On this layer, e.g. for `_retract` only these last parameters should be typed, the manifold should stay at the [`AbstractManifold`](@ref) level.
The layer dispatches on different functions per existing parameter type (and might pass this one further on, if it has fields).
Function definitions on this layer should only be extended when introducing new such parameter types, for example when introducing a new type of a retraction.

The functions from this layer should never be called directly, are hence also not exported and carry the `_` prefix.
They should only be called as the final step in the previous layer.

If the default parameters are not dispatched per type, using `_` might be skipped.
The same holds for functions that do not have these parameters.

When there is no dispatch for different types of the optional parameter (here `t`), the `_` might be skipped.
One could hence see the last code line as a definition on Layer I that passes directly to Layer III, since there are not parameter to dispatch on.

To close this section, let‘s look at an example.
The high level (or [Layer I](@ref design-layer1)) definition of the retraction is given by

```julia
retract!(M::AbstractManifold, q, p, X, m::AbstractRetractionMethod=default_retraction_method(M, typeof(p))) = _retract!(M, q, p, X, m)
```

Note that the convenience function `retract(M, q, p, X, m)` first allocates a `q` before calling this function as well.

This level now dispatches on different retraction types `m`.
It usually passes to specific functions implemented in [Layer III](@ref design-layer3), here for example

```julia
_retract!(M::AbstractManifold, q, p, X, m::Exponentialretraction) = exp(M, q, p, X)
_retract!(M::AbstractManifold, q, p, X, m::PolarRetraction) = retract_polar(M, q, p, X)
```

where the [`ExponentialRetraction`](@ref) is resolved by again calling a function on [Layer I](@ref design-layer1) (to fill further default values if these exist). The [`PolarRetraction`](@ref) is dispatched to [`retract_polar!`](@ref ManifoldsBase.retract_polar!), a function on [Layer III](@ref design-layer3).

For further details and dispatches, see [retractions and inverse retractions](@ref sec-retractions) for an overview.

!!! note
    The documentation should be attached to the high level functions, since this again fosters ease of use.
    If you implement a polar retraction, you should write a method of function [`retract_polar!`](@ref ManifoldsBase.retract_polar!) but the doc string should be attached to `retract(::M, ::P, ::V, ::PolarRetraction)` for your types `::M, ::P, ::V` of the manifold, points and vectors, respectively.

To summarize, with respect to the [dispatch on one argument at a time](https://docs.julialang.org/en/v1/manual/methods/#Dispatch-on-one-argument-at-a-time) paradigm, this layer dispatches the (optional) _parameters second_.

### [Layer III: The base layer with focus on implementations](@id design-layer3)

This lower level aims for the actual implementation of the function avoiding ambiguities.
It should have as few as possible optional parameters and as concrete as possible types for these.

This means

* the function name should be similar to its high level parent (for example [`retract!`](@ref) and [`retract_polar!`](@ref ManifoldsBase.retract_polar!)  above)
* The manifold type in method signature should always be as narrow as possible.
* The points/vectors should either be untyped (for the default representation or if there is only one implementation) or provide all type bounds (for second representations or when using [`AbstractManifoldPoint`](@ref) and [`AbstractTangentVector`](@ref AbstractTangentVector), respectively).

The first step that often happens on this level is memory allocation and calling the in-place function. If faster, it might also implement the function at hand itself.

Usually functions from this layer are not exported, when they have an analogue on the first layer. For example the function [`retract_polar!`](@ref ManifoldsBase.retract_polar!)`(M, q, p, X)` is not exported, since when using the interface one would use the [`PolarRetraction`](@ref) or to be precise call [`retract!`](@ref)`(M, q, p, X, PolarRetraction())`.
When implementing your own manifold, you have to import functions like these anyway.

To summarize, with respect to the [dispatch on one argument at a time](https://docs.julialang.org/en/v1/manual/methods/#Dispatch-on-one-argument-at-a-time) paradigm, this layer dispatches the _concrete manifold and point/vector types last_.

## [Mutating and allocating functions](@id inplace-and-noninplace)

Every function, where this is applicable, should provide an in-place and an allocating variant.
For example for the exponential map `exp(M, p, X)` returns a _new_ point `q` where the result is computed in.
On the other hand `exp!(M, q, p, X)` computes the result in place of `q`, where the design of the implementation
should keep in mind that also `exp!(M, p, p, X)` should correctly overwrite `p`.

The interface provides a way to determine the allocation type and a result to compute/allocate
the resulting memory, such that the default implementation allocating functions, like [`exp`](@ref) is to allocate the resulting memory and call [`exp!`](@ref).

!!! note
    It might be useful to provide two distinct implementations, for example when using AD schemes.
    The default is meant for ease of use (concerning implementation), since then one has to just implement the in-place variants.

Non-mutating functions in `ManifoldsBase.jl` are typically implemented using in-place variants after a suitable allocation of memory.

Not that this allocation usually takes place only on [Layer III](@ref design-layer3) when dispatching on points.
Both [Layer I](@ref design-layer1) and [Layer II](@ref design-layer1) are usually implemented for both variants in parallel.

### Allocation of new points and vectors

The [`allocate`](@ref) function behaves like `similar` for simple representations of points and vectors (for example `Array{Float64}`).
For more complex types, such as nested representations of [`PowerManifold`](@ref) (see [`NestedPowerRepresentation`](@ref)), checked types like [`ValidationMPoint`](@ref) and more it operates differently.
While `similar` only concerns itself with the higher level of nested structures, `allocate` maps itself through all levels of nesting until a simple array of numbers is reached and then calls `similar`.
The difference can be most easily seen in the following example:

```julia
julia> x = similar([[1.0], [2.0]])
2-element Array{Array{Float64,1},1}:
 #undef
 #undef

julia> y = allocate([[1.0], [2.0]])
2-element Array{Array{Float64,1},1}:
 [6.90031725726027e-310]
 [6.9003678131654e-310]

julia> x[1]
ERROR: UndefRefError: access to undefined reference
Stacktrace:
 [1] getindex(::Array{Array{Float64,1},1}, ::Int64) at ./array.jl:744
 [2] top-level scope at REPL[12]:1

julia> y[1]
1-element Array{Float64,1}:
 6.90031725726027e-310
```

The function [`allocate_result`](@ref ManifoldsBase.allocate_result) allocates a correct return value. It takes into account the possibility that different arguments may have different numeric [`number_eltype`](@ref) types thorough the [`allocate_result_type`](@ref ManifoldsBase.allocate_result_type) function.
The most prominent example of the usage of this function is the logarithmic function [`log`](@ref) when used with typed points.
Lets assume on a manifold `M` the have points of type `P` and corresponding tangent vector types `V`.
then the logarithmic map has the signature

```julia
log(::M, ::P, ::P)
```

but the return type would be ``V``, whose internal sizes (fields/arrays) will depend on the concrete type of one of the points. This is accomplished by implementing a method `allocate_result(::M, ::typeof(log), ::P, ::P)` that returns the concrete variable for the result. This way, even with specific types, one just has to implement `log!` and the one line for the allocation.

!!! note
    This dispatch from the allocating to the in-place variant happens in Layer I (which changed in ManifoldsBase.jl 0.15), that is, functions like `exp` or [`retract`](@ref) allocate their result
    and call the in-place variant [`exp!`](@ref) and [`retract!`](@ref ManifoldsBase.retract!) afterwards, where the ladder passes down to layer III to reach [`retract_polar!`](@ref ManifoldsBase.retract_polar!).

# ManifoldsBase.jl

```@docs
ManifoldsBase.ManifoldsBase
```

This packages has two main purposes.
You can add it as a dependency if you plan to work on manifolds (generically) or if you plan to
define own manifolds in a package.
For a package that (only) depends on `ManifoldsBase.jl`, see [Manopt.jl](https://manoptjl.org/stable/),
which implements optimization algorithms on manifolds using this interface.
These optimisation algorithms can hence be used with any manifold implemented based on `ManifoldsBase.jl`.

For a library of manifolds implemented using this interface [Manifolds.jl](https://juliamanifolds.github.io/Manifolds.jl/stable/).

Your package is using `ManifoldsBase`?
We would like to add that here as well. Either [write an issue](https://github.com/JuliaManifolds/ManifoldsBase.jl/issues/new)
or add yourself by forking, editing this file and [opening a PR](https://github.com/JuliaManifolds/ManifoldsBase.jl/compare).

## Citation

If you use `ManifoldsBase.jl` in your work, please cite the following paper,
which covers both the basic interface as well as the performance for `Manifolds.jl`.

```biblatex
@article{AxenBaranBergmannRzecki:2023,
    AUTHOR    = {Axen, Seth D. and Baran, Mateusz and Bergmann, Ronny and Rzecki, Krzysztof},
    ARTICLENO = {33},
    DOI       = {10.1145/3618296},
    JOURNAL   = {ACM Transactions on Mathematical Software},
    MONTH     = {dec},
    NUMBER    = {4},
    TITLE     = {Manifolds.Jl: An Extensible Julia Framework for Data Analysis on Manifolds},
    VOLUME    = {49},
    YEAR      = {2023}
}
```

Note that the citation is in [BibLaTeX](https://ctan.org/pkg/biblatex) format.

### Projections

A manifold might be embedded in some space.
Often this is implicitly assumed, for example the complex [Circle](https://juliamanifolds.github.io/Manifolds.jl/latest/manifolds/circle.html) is embedded in the complex plane.
Let‘s keep the circle in mind in the following as a simple example.
For the general case of explicitly stating an embedding and/or to distinguish several, different embeddings, see [Embedded Manifolds](@ref sec-embedded-manifold) below.

To make this a little more concrete, let‘s assume we have a manifold ``\mathcal M`` which is embedded in some manifold ``\mathcal N`` and the image ``i(\mathcal M)`` of the embedding function ``i`` is a closed set (with respect to the topology on ``\mathcal N``).
Then we can do two kinds of projections.

To make this concrete in an example for the Circle ``\mathcal M=\mathcal C := \{ p ∈ ℂ | |p| = 1\}``
the embedding can be chosen to be the manifold ``\mathcal N = ℂ`` and due to our representation of ``\mathcal C`` as complex numbers already, we have ``i(p) = p``, that is the identity as the embedding function.

The first projection we can consider is for a given a point ``p∈\mathcal N`` in the embedding we can look for the closest point on the manifold ``\mathcal M``, i.e.

```math
  \operatorname*{arg\,min}_{q∈ \mathcal M}\ d_{\mathcal N}(i(q),p)
```

And this resulting ``q`` we call the projection of ``p`` onto the manifold ``\mathcal M``.

The second projection we can look at is for a given a point ``p∈\mathcal M`` and a vector in ``X∈ T_{i(p)}\mathcal N`` in the embedding,
where we can similarly look for the closest tangent vector ``Y∈ T_p\mathcal M``, which we have to embed itself before itself.
Embedding a tangent vector is usually the same as using the pushforward ``\mathrm{d}i_p`` of the embedding (at ``p``).
We obtain

```math
  \operatorname*{arg\,min}_{Y∈ T_p\mathcal M}\ \bigl\lVert \mathrm{d}i(p)[Y] - X \bigr\rVert_{i(p)}
```

And we call the resulting ``Y`` the projection of ``X`` onto the tangent space ``T_p\mathcal M`` at ``p``.

Let‘s look at the little more concrete example of the complex circle again.
Here, the closest point of ``p ∈ ℂ`` is just the projection onto the circle, or in other words ``q = \frac{p}{\lvert p \rvert}``, as long as ``p\neq 0``. For ``p=0`` the projection is not defined.
A tangent space ``T_p\mathcal C`` in the embedding is the line through the origin that is orthogonal to a point ``p∈\mathcal C``.
This can be better visualized by looking at ``p+T_p\mathcal C`` which is actually the line tangent to ``p`` on the unit circle.
Note that this shift does not change the resulting projection relative to the origin of the tangent space.

Here the projection can be computed as the classical projection onto the line, i.e.  ``Y = X - ⟨X,p⟩X``.

Both projections onto ``\mathcal C`` and onto ``T_p\mathcal C`` are illustrated in the following figure.

![An example illustrating the two kinds of projections on the Circle.](assets/images/projection_illustration_600.png)

The functions provided in this interface are the following.

```@autodocs
Modules = [ManifoldsBase]
Pages = ["projections.jl"]
Order = [:function]
```
